/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !shift_count_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_V1QImode:
      return pattern9 (x1, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern9 (x1, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern9 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern9 (x1, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern9 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern9 (x1, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern9 (x1, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern9 (x1, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern9 (x1, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (!register_operand (x2, E_V1SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1SImode)
        return -1;
      return 9;

    case E_V2SImode:
      if (!register_operand (x2, E_V2SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V2SImode)
        return -1;
      return 10;

    case E_V4SImode:
      if (!register_operand (x2, E_V4SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V4SImode)
        return -1;
      return 11;

    case E_V1DImode:
      if (!register_operand (x2, E_V1DImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1DImode)
        return -1;
      return 12;

    case E_V2DImode:
      if (!register_operand (x2, E_V2DImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V2DImode)
        return -1;
      return 13;

    case E_V1TImode:
      operands[0] = x2;
      if (!register_operand (operands[0], E_V1TImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1TImode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_V1TImode:
          if (!register_operand (operands[1], E_V1TImode)
              || !register_operand (operands[2], E_V1TImode))
            return -1;
          return 14;

        case E_V1TFmode:
          if (!register_operand (operands[1], E_V1TFmode)
              || !register_operand (operands[2], E_V1TFmode))
            return -1;
          return 15;

        case E_TFmode:
          if (!register_operand (operands[1], E_TFmode)
              || !register_operand (operands[2], E_TFmode))
            return -1;
          return 16;

        default:
          return -1;
        }

    case E_TImode:
      if (pattern10 (x1, 
E_TImode) != 0)
        return -1;
      return 17;

    default:
      return -1;
    }
}

int
pattern39 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 33
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern42 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  return pattern41 (x3); /* [-1, 0] */
}

int
pattern46 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern53 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2
      || !register_operand (operands[0], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern59 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!const_mask_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      return pattern17 (x1, 
E_V4SFmode); /* [-1, 0] */

    case E_V2DFmode:
      if (pattern17 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 1;

    case E_V1TFmode:
      if (pattern17 (x1, 
E_V1TFmode) != 0)
        return -1;
      return 2;

    case E_TFmode:
      if (pattern17 (x1, 
E_TFmode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern65 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      return pattern3 (x1, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern3 (x1, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern3 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern3 (x1, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern3 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern3 (x1, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern3 (x1, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern3 (x1, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern3 (x1, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (pattern3 (x1, 
E_V1SImode) != 0)
        return -1;
      return 9;

    case E_V2SImode:
      if (pattern3 (x1, 
E_V2SImode) != 0)
        return -1;
      return 10;

    case E_V4SImode:
      if (pattern3 (x1, 
E_V4SImode) != 0)
        return -1;
      return 11;

    case E_V1DImode:
      if (pattern3 (x1, 
E_V1DImode) != 0)
        return -1;
      return 12;

    case E_V2DImode:
      if (pattern3 (x1, 
E_V2DImode) != 0)
        return -1;
      return 13;

    case E_V1SFmode:
      if (pattern3 (x1, 
E_V1SFmode) != 0)
        return -1;
      return 14;

    case E_V2SFmode:
      if (pattern3 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 15;

    case E_V4SFmode:
      if (pattern3 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 16;

    case E_V1DFmode:
      if (pattern3 (x1, 
E_V1DFmode) != 0)
        return -1;
      return 17;

    case E_V2DFmode:
      if (pattern3 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 18;

    case E_V1TFmode:
      if (pattern3 (x1, 
E_V1TFmode) != 0)
        return -1;
      return 19;

    case E_V1TImode:
      if (pattern3 (x1, 
E_V1TImode) != 0)
        return -1;
      return 20;

    case E_TImode:
      if (pattern3 (x1, 
E_TImode) != 0)
        return -1;
      return 21;

    case E_DImode:
      if (pnum_clobbers == NULL
          || pattern64 (x1, 
E_DImode) != 0)
        return -1;
      return 22;

    case E_HImode:
      if (pnum_clobbers == NULL
          || pattern64 (x1, 
E_HImode) != 0)
        return -1;
      return 23;

    case E_QImode:
      if (pnum_clobbers == NULL
          || pattern64 (x1, 
E_QImode) != 0)
        return -1;
      return 24;

    default:
      return -1;
    }
}

int
pattern100 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      return pattern98 (x1, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern98 (x1, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern98 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern98 (x1, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern98 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern98 (x1, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern98 (x1, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern98 (x1, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern98 (x1, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (pattern98 (x1, 
E_V1SImode) != 0)
        return -1;
      return 9;

    case E_V2SImode:
      if (pattern98 (x1, 
E_V2SImode) != 0)
        return -1;
      return 10;

    case E_V4SImode:
      if (pattern98 (x1, 
E_V4SImode) != 0)
        return -1;
      return 11;

    case E_V1DImode:
      if (pattern98 (x1, 
E_V1DImode) != 0)
        return -1;
      return 12;

    case E_V2DImode:
      if (pattern98 (x1, 
E_V2DImode) != 0)
        return -1;
      return 13;

    case E_V1SFmode:
      if (pattern99 (x1, 
E_V1SFmode, 
E_V1SImode) != 0)
        return -1;
      return 14;

    case E_V2SFmode:
      if (pattern99 (x1, 
E_V2SFmode, 
E_V2SImode) != 0)
        return -1;
      return 15;

    case E_V4SFmode:
      if (pattern99 (x1, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      return 16;

    case E_V1DFmode:
      if (pattern99 (x1, 
E_V1DFmode, 
E_V1DImode) != 0)
        return -1;
      return 17;

    case E_V2DFmode:
      if (pattern99 (x1, 
E_V2DFmode, 
E_V2DImode) != 0)
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern132 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (x1))
        {
        case E_DImode:
          if (GET_MODE (x2) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !register_operand (operands[2], E_DImode))
            return -1;
          return 0;

        case E_SImode:
          if (GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_SImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      switch (GET_MODE (x1))
        {
        case E_DImode:
          if (pattern131 (x1, 
E_DImode) != 0)
            return -1;
          return 2;

        case E_SImode:
          if (pattern131 (x1, 
E_SImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern149 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x4) != E_DImode
      || !immediate_operand (operands[2], E_DImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      return 0;

    case E_TFmode:
      if (!register_operand (operands[1], E_TFmode))
        return -1;
      return 1;

    case E_FPRX2mode:
      if (!register_operand (operands[1], E_FPRX2mode))
        return -1;
      return 2;

    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 3;

    case E_TDmode:
      if (!register_operand (operands[1], E_TDmode))
        return -1;
      return 4;

    case E_DDmode:
      if (!register_operand (operands[1], E_DDmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern158 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern166 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V1TFmode:
      if (!register_operand (operands[1], E_V1TFmode)
          || !register_operand (operands[2], E_V1TFmode))
        return -1;
      return 0;

    case E_TFmode:
      if (!register_operand (operands[1], E_TFmode)
          || !register_operand (operands[2], E_TFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern172 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != LABEL_REF)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  return pattern170 (); /* [-1, 1] */
}

int
pattern178 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern183 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !memory_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern187 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern192 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern198 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !contiguous_bitmask_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !const_int_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern206 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern216 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern215 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern215 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern226 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern235 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern239 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern246 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern253 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  if (!const0_operand (operands[3], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern264 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!nonimmediate_operand (operands[0], E_V8HImode))
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!nonimmediate_operand (operands[1], E_V8HImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_V2DImode))
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_V4SImode))
    return -1;
  return 0;
}

int
pattern276 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !nonsym_memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern283 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i1)
      || pattern282 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern291 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 4
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  x11 = XVECEXP (x10, 0, 0);
  operands[1] = x11;
  if (!register_operand (operands[1], E_CCUmode))
    return -1;
  return 0;
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern27 (x1))
    {
    case 0:
      if (!
#line 1580 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1071; /* vec_widen_umult_odd_v1qi */

    case 1:
      if (!
#line 1580 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1072; /* vec_widen_umult_odd_v2qi */

    case 2:
      if (!
#line 1580 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1073; /* vec_widen_umult_odd_v4qi */

    case 3:
      if (!
#line 1580 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1074; /* vec_widen_umult_odd_v8qi */

    case 4:
      if (!
#line 1580 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1075; /* vec_widen_umult_odd_v16qi */

    case 5:
      if (!
#line 1580 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1076; /* vec_widen_umult_odd_v1hi */

    case 6:
      if (!
#line 1580 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1077; /* vec_widen_umult_odd_v2hi */

    case 7:
      if (!
#line 1580 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1078; /* vec_widen_umult_odd_v4hi */

    case 8:
      if (!
#line 1580 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1079; /* vec_widen_umult_odd_v8hi */

    case 9:
      if (!
#line 1580 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1080; /* vec_widen_umult_odd_v1si */

    case 10:
      if (!
#line 1580 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1081; /* vec_widen_umult_odd_v2si */

    case 11:
      if (!
#line 1580 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1082; /* vec_widen_umult_odd_v4si */

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern22 (x1))
    {
    case 0:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 180; /* vec_sllv16qiv16qi */

    case 1:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 184; /* vec_sllv16qiv8hi */

    case 2:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 188; /* vec_sllv16qiv4si */

    case 3:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 181; /* vec_sllv8hiv16qi */

    case 4:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 185; /* vec_sllv8hiv8hi */

    case 5:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 189; /* vec_sllv8hiv4si */

    case 6:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 182; /* vec_sllv4siv16qi */

    case 7:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 186; /* vec_sllv4siv8hi */

    case 8:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 190; /* vec_sllv4siv4si */

    case 9:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 183; /* vec_sllv2div16qi */

    case 10:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 187; /* vec_sllv2div8hi */

    case 11:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 191; /* vec_sllv2div4si */

    default:
      return -1;
    }
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  switch (GET_CODE (operands[1]))
    {
    case REG:
    case SUBREG:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x1, 0);
      switch (GET_MODE (x4))
        {
        case E_CCVEQmode:
          if (GET_MODE (x2) != E_CCVEQmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || !register_operand (operands[1], E_V16QImode)
                  || !
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 332; /* *vec_cmpeqv16qi_cconly */

            case E_V8HImode:
              if (!register_operand (operands[0], E_V8HImode)
                  || !register_operand (operands[1], E_V8HImode)
                  || !
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 333; /* *vec_cmpeqv8hi_cconly */

            case E_V4SImode:
              if (!register_operand (operands[0], E_V4SImode)
                  || !register_operand (operands[1], E_V4SImode)
                  || !
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 334; /* *vec_cmpeqv4si_cconly */

            case E_V2DImode:
              if (!register_operand (operands[0], E_V2DImode)
                  || !register_operand (operands[1], E_V2DImode)
                  || !
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 335; /* *vec_cmpeqv2di_cconly */

            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || !register_operand (operands[1], E_V4SFmode)
                  || !(
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 356; /* *vec_cmpeqv4sf_cconly */

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || !register_operand (operands[1], E_V2DFmode)
                  || !
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 357; /* *vec_cmpeqv2df_cconly */

            case E_V1TFmode:
              if (!register_operand (operands[0], E_V1TFmode)
                  || !register_operand (operands[1], E_V1TFmode)
                  || !(
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 358; /* *vec_cmpeqv1tf_cconly */

            case E_TFmode:
              if (!register_operand (operands[0], E_TFmode)
                  || !register_operand (operands[1], E_TFmode)
                  || !(
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 359; /* *vec_cmpeqtf_cconly */

            default:
              return -1;
            }

        case E_CCVIHmode:
          switch (pattern185 (x2, 
E_CCVIHmode))
            {
            case 0:
              if (!
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 336; /* *vec_cmphv16qi_cconly */

            case 1:
              if (!
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 337; /* *vec_cmphv8hi_cconly */

            case 2:
              if (!
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 338; /* *vec_cmphv4si_cconly */

            case 3:
              if (!
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 339; /* *vec_cmphv2di_cconly */

            default:
              return -1;
            }

        case E_CCVIHUmode:
          switch (pattern185 (x2, 
E_CCVIHUmode))
            {
            case 0:
              if (!
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 340; /* *vec_cmphlv16qi_cconly */

            case 1:
              if (!
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 341; /* *vec_cmphlv8hi_cconly */

            case 2:
              if (!
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 342; /* *vec_cmphlv4si_cconly */

            case 3:
              if (!
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 343; /* *vec_cmphlv2di_cconly */

            default:
              return -1;
            }

        case E_CCVFHmode:
          switch (pattern186 (x2, 
E_CCVFHmode))
            {
            case 0:
              if (!(
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 360; /* *vec_cmphv4sf_cconly */

            case 1:
              if (!
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 361; /* *vec_cmphv2df_cconly */

            case 2:
              if (!(
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 362; /* *vec_cmphv1tf_cconly */

            case 3:
              if (!(
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 363; /* *vec_cmphtf_cconly */

            default:
              return -1;
            }

        case E_CCVFHEmode:
          switch (pattern186 (x2, 
E_CCVFHEmode))
            {
            case 0:
              if (!(
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 364; /* *vec_cmphev4sf_cconly */

            case 1:
              if (!
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 365; /* *vec_cmphev2df_cconly */

            case 2:
              if (!(
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 366; /* *vec_cmphev1tf_cconly */

            case 3:
              if (!(
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 367; /* *vec_cmphetf_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (register_operand (operands[0], E_HImode)
              && immediate_operand (operands[1], E_HImode)
              && 
#line 965 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, s390_tm_ccmode (constm1_rtx, operands[1], true))))
            return 1426; /* *tmhi_full */
          if (pnum_clobbers != NULL
              && nonimmediate_operand (operands[0], E_HImode)
              && const0_operand (operands[1], E_HImode)
              && 
#line 1118 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
            {
              *pnum_clobbers = 1;
              return 1441; /* *tsthiCCT_cconly */
            }
          if (!s_operand (operands[0], E_HImode))
            return -1;
          if (pnum_clobbers != NULL
              && const0_operand (operands[1], E_HImode)
              && 
#line 1159 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
            {
              *pnum_clobbers = 1;
              return 1445; /* *tsthi_cconly */
            }
          if (!immediate_operand (operands[1], E_HImode)
              || !
#line 1238 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_Z10))
            return -1;
          return 1451; /* *cmphi_ccs_z10 */

        case E_QImode:
          if (register_operand (operands[0], E_QImode)
              && immediate_operand (operands[1], E_QImode)
              && 
#line 965 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, s390_tm_ccmode (constm1_rtx, operands[1], true))))
            return 1427; /* *tmqi_full */
          if (!const0_operand (operands[1], E_QImode))
            return -1;
          if (nonimmediate_operand (operands[0], E_QImode)
              && 
#line 1131 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
            return 1442; /* *tstqiCCT_cconly */
          if (pnum_clobbers == NULL
              || !s_operand (operands[0], E_QImode)
              || !
#line 1159 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
            return -1;
          *pnum_clobbers = 1;
          return 1446; /* *tstqi_cconly */

        case E_DImode:
          if (pnum_clobbers != NULL
              && nonimmediate_operand (operands[0], E_DImode)
              && const0_operand (operands[1], E_DImode)
              && (
#line 1030 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_EXTIMM) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            {
              *pnum_clobbers = 1;
              return 1431; /* *tstdi_cconly_extimm */
            }
          if (!register_operand (operands[0], E_DImode)
              || !const0_operand (operands[1], E_DImode))
            return -1;
          if (
#line 1081 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && !TARGET_ZARCH))
            return 1436; /* *tstdi_cconly_31 */
          if (!(
#line 1091 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1437; /* *tstdi_cconly2 */

        case E_SImode:
          if (pnum_clobbers != NULL
              && nonimmediate_operand (operands[0], E_SImode)
              && const0_operand (operands[1], E_SImode))
            {
              if (
#line 1030 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_EXTIMM))
                {
                  *pnum_clobbers = 1;
                  return 1432; /* *tstsi_cconly_extimm */
                }
              if (
#line 1068 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                {
                  *pnum_clobbers = 1;
                  return 1435; /* *tstsi_cconly */
                }
            }
          if (!register_operand (operands[0], E_SImode)
              || !const0_operand (operands[1], E_SImode)
              || !
#line 1091 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
            return -1;
          return 1438; /* *tstsi_cconly2 */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || !const0_operand (operands[1], E_TFmode)
              || !(
#line 1474 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode)
   && TARGET_HARD_FLOAT
   && !flag_trapping_math
   && !flag_signaling_nans) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 1471; /* *cmptf_ccs_0_fastmath */

        case E_FPRX2mode:
          if (!register_operand (operands[0], E_FPRX2mode)
              || !const0_operand (operands[1], E_FPRX2mode)
              || !(
#line 1474 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode)
   && TARGET_HARD_FLOAT
   && !flag_trapping_math
   && !flag_signaling_nans) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 1472; /* *cmpfprx2_ccs_0_fastmath */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || !const0_operand (operands[1], E_DFmode)
              || !
#line 1474 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode)
   && TARGET_HARD_FLOAT
   && !flag_trapping_math
   && !flag_signaling_nans))
            return -1;
          return 1473; /* *cmpdf_ccs_0_fastmath */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || !const0_operand (operands[1], E_SFmode)
              || !
#line 1474 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode)
   && TARGET_HARD_FLOAT
   && !flag_trapping_math
   && !flag_signaling_nans))
            return -1;
          return 1474; /* *cmpsf_ccs_0_fastmath */

        case E_TDmode:
          if (!register_operand (operands[0], E_TDmode)
              || !const0_operand (operands[1], E_TDmode)
              || !(
#line 1474 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode)
   && TARGET_HARD_FLOAT
   && !flag_trapping_math
   && !flag_signaling_nans) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1475; /* *cmptd_ccs_0_fastmath */

        case E_DDmode:
          if (!register_operand (operands[0], E_DDmode)
              || !const0_operand (operands[1], E_DDmode)
              || !(
#line 1474 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode)
   && TARGET_HARD_FLOAT
   && !flag_trapping_math
   && !flag_signaling_nans) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1476; /* *cmpdd_ccs_0_fastmath */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_32 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (pattern11 (x1))
    {
    case 0:
      if (!
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1151; /* *vec_cmpgtv1qiv1qi_nocc */

    case 1:
      if (!
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1154; /* *vec_cmpgtv2qiv2qi_nocc */

    case 2:
      if (!
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1157; /* *vec_cmpgtv4qiv4qi_nocc */

    case 3:
      if (!
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1160; /* *vec_cmpgtv8qiv8qi_nocc */

    case 4:
      if (!
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1163; /* *vec_cmpgtv16qiv16qi_nocc */

    case 5:
      if (!
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1166; /* *vec_cmpgtv1hiv1hi_nocc */

    case 6:
      if (!
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1169; /* *vec_cmpgtv2hiv2hi_nocc */

    case 7:
      if (!
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1172; /* *vec_cmpgtv4hiv4hi_nocc */

    case 8:
      if (!
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1175; /* *vec_cmpgtv8hiv8hi_nocc */

    case 9:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V1SImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V1SImode)
              && 
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1178; /* *vec_cmpgtv1siv1si_nocc */
        }
      operands[0] = x2;
      operands[1] = x4;
      if (!register_operand (operands[1], E_V1SFmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V1SFmode))
        return -1;
      if (
#line 2110 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1226; /* *vec_cmpgtv1sf_signaling_nocc */
      if (!(
#line 2118 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1233; /* *vec_cmpgtv1sf_signaling_finite_nocc */

    case 10:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V2SImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V2SImode)
              && 
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1181; /* *vec_cmpgtv2siv2si_nocc */
        }
      operands[0] = x2;
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V2SFmode))
        return -1;
      if (
#line 2110 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1227; /* *vec_cmpgtv2sf_signaling_nocc */
      if (!(
#line 2118 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1234; /* *vec_cmpgtv2sf_signaling_finite_nocc */

    case 11:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V4SImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V4SImode)
              && 
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1184; /* *vec_cmpgtv4siv4si_nocc */
        }
      operands[0] = x2;
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V4SFmode))
        return -1;
      if (
#line 2110 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1228; /* *vec_cmpgtv4sf_signaling_nocc */
      if (!(
#line 2118 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1235; /* *vec_cmpgtv4sf_signaling_finite_nocc */

    case 12:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V1DImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V1DImode)
              && 
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1187; /* *vec_cmpgtv1div1di_nocc */
        }
      operands[0] = x2;
      operands[1] = x4;
      if (!register_operand (operands[1], E_V1DFmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V1DFmode))
        return -1;
      if (
#line 2110 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1229; /* *vec_cmpgtv1df_signaling_nocc */
      if (!
#line 2118 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK))
        return -1;
      return 1236; /* *vec_cmpgtv1df_signaling_finite_nocc */

    case 13:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V2DImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V2DImode)
              && 
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1190; /* *vec_cmpgtv2div2di_nocc */
        }
      operands[0] = x2;
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2DFmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V2DFmode))
        return -1;
      if (
#line 2110 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1230; /* *vec_cmpgtv2df_signaling_nocc */
      if (!
#line 2118 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK))
        return -1;
      return 1237; /* *vec_cmpgtv2df_signaling_finite_nocc */

    case 14:
      if (!
#line 1983 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1194; /* *vec_cmpgtv1tiv1ti_nocc_emu */

    case 15:
      if (
#line 2110 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1231; /* *vec_cmpgtv1tf_signaling_nocc */
      if (!(
#line 2118 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 61 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1238; /* *vec_cmpgtv1tf_signaling_finite_nocc */

    case 16:
      if (
#line 2110 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1232; /* *vec_cmpgttf_signaling_nocc */
      if (!(
#line 2118 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 61 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1239; /* *vec_cmpgttf_signaling_finite_nocc */

    case 17:
      if (!
#line 1983 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1195; /* *vec_cmpgttiti_nocc_emu */

    default:
      return -1;
    }
}

 int
recog_45 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode
              || !register_operand (operands[1], E_V2QImode)
              || !
#line 2471 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1351; /* extendv2qiv2hi2 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2HImode)
              || !
#line 2471 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1353; /* extendv2hiv2si2 */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 2471 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1355; /* extendv2siv2di2 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4QImode)
              || !
#line 2471 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1357; /* extendv4qiv4hi2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 2471 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1359; /* extendv4hiv4si2 */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern111 (x3))
        {
        case 0:
          if (!
#line 2503 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1361; /* vec_unpacks_hi_v16qi */

        case 1:
          if (!
#line 2514 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1362; /* vec_unpacks_lo_v16qi */

        case 2:
          if (!
#line 2552 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1365; /* vec_unpacks_hi_v8hi */

        case 3:
          if (!
#line 2562 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1366; /* vec_unpacks_lo_v8hi */

        case 4:
          if (!
#line 2598 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1369; /* vec_unpacks_hi_v4si */

        case 5:
          if (!
#line 2608 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1370; /* vec_unpacks_lo_v4si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_48 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      operands[1] = x3;
      if (address_operand (operands[1], E_QImode))
        {
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) == CONST_INT
              && XWINT (x4, 0) == 2147483647L
              && register_operand (operands[0], E_SImode)
              && GET_MODE (x2) == E_SImode)
            {
              if (
#line 2373 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return 1510; /* *la_31_and */
              if (pnum_clobbers != NULL
                  && 
#line 2387 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                {
                  *pnum_clobbers = 1;
                  return 1511; /* *la_31_and_cc */
                }
            }
        }
      if (GET_CODE (x3) == SUBREG)
        {
          res = recog_47 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) == CONST_INT
          && XWINT (x4, 0) == 2147483647L)
        {
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (register_operand (operands[0], E_SImode)
                  && GET_MODE (x2) == E_SImode
                  && nonimmediate_operand (operands[1], E_SImode)
                  && 
#line 4957 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return 1680; /* *llgt_sisi */
              break;

            case E_DImode:
              if (register_operand (operands[0], E_DImode)
                  && GET_MODE (x2) == E_DImode
                  && nonimmediate_operand (operands[1], E_DImode)
                  && 
#line 4968 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return 1681; /* *llgt_didi */
              break;

            default:
              break;
            }
        }
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern157 (x2))
        {
        case 0:
          if (!
#line 7729 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          *pnum_clobbers = 1;
          return 2000; /* *anddi3 */

        case 1:
          if (
#line 7858 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2011; /* *andsi3_zarch */
            }
          if (!
#line 7892 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          *pnum_clobbers = 1;
          return 2012; /* *andsi3_esa */

        default:
          return -1;
        }

    case ROTATE:
      if (pattern66 (x2, 
E_DImode) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[3] = x4;
      if (!contiguous_bitmask_operand (operands[3], E_DImode))
        return -1;
      if (
#line 4199 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12))
        return 1604; /* *risbgn_di_and_rot */
      if (pnum_clobbers == NULL
          || !
#line 4199 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
        return -1;
      *pnum_clobbers = 1;
      return 1605; /* *risbg_di_and_rot */

    case LSHIFTRT:
      switch (pattern113 (x2))
        {
        case 0:
          if ((
#line 7779 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   /* Note that even for the SImode pattern, the rotate is always DImode.  */
   && s390_extzv_shift_ok (64, -INTVAL (operands[2]),
			   INTVAL (operands[3]))) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return 2001; /* *extzv_di_srl_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 7779 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   /* Note that even for the SImode pattern, the rotate is always DImode.  */
   && s390_extzv_shift_ok (64, -INTVAL (operands[2]),
			   INTVAL (operands[3]))) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2002; /* *extzv_di_srl_clobbercc */

        case 1:
          if (
#line 7779 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   /* Note that even for the SImode pattern, the rotate is always DImode.  */
   && s390_extzv_shift_ok (32, -INTVAL (operands[2]),
			   INTVAL (operands[3]))))
            return 2003; /* *extzv_si_srl_nocc */
          if (pnum_clobbers == NULL
              || !
#line 7779 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   /* Note that even for the SImode pattern, the rotate is always DImode.  */
   && s390_extzv_shift_ok (32, -INTVAL (operands[2]),
			   INTVAL (operands[3]))))
            return -1;
          *pnum_clobbers = 1;
          return 2004; /* *extzv_si_srl_clobbercc */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern113 (x2))
        {
        case 0:
          if ((
#line 7793 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && s390_extzv_shift_ok (64, INTVAL (operands[2]),
			   INTVAL (operands[3]))) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return 2005; /* *extzv_di_sll_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 7793 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && s390_extzv_shift_ok (64, INTVAL (operands[2]),
			   INTVAL (operands[3]))) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2006; /* *extzv_di_sll_clobbercc */

        case 1:
          if (
#line 7793 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && s390_extzv_shift_ok (32, INTVAL (operands[2]),
			   INTVAL (operands[3]))))
            return 2007; /* *extzv_si_sll_nocc */
          if (pnum_clobbers == NULL
              || !
#line 7793 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && s390_extzv_shift_ok (32, INTVAL (operands[2]),
			   INTVAL (operands[3]))))
            return -1;
          *pnum_clobbers = 1;
          return 2008; /* *extzv_si_sll_clobbercc */

        default:
          return -1;
        }

    case NOT:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (GET_MODE (x2) != E_DImode
                  || GET_MODE (x3) != E_DImode)
                return -1;
              if (nonimmediate_operand (operands[0], E_DImode)
                  && nonimmediate_operand (operands[1], E_DImode)
                  && general_operand (operands[2], E_DImode)
                  && (
#line 8001 "../../gcc/config/s390/s390.md"
(!TARGET_Z15
   && ! reload_completed
   && (GET_CODE (operands[0]) != MEM
      /* Ensure that s390_logical_operator_ok_p will succeed even
	 on the split xor if (b & a) is stored into a pseudo.  */
       || rtx_equal_p (operands[0], operands[2]))) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                {
                  *pnum_clobbers = 1;
                  return 2017; /* *andc_split_di */
                }
              if (!register_operand (operands[0], E_DImode)
                  || !register_operand (operands[1], E_DImode)
                  || !register_operand (operands[2], E_DImode)
                  || !(
#line 8380 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2039; /* *andcdi */

            case E_SImode:
              if (GET_MODE (x2) != E_SImode
                  || GET_MODE (x3) != E_SImode)
                return -1;
              if (nonimmediate_operand (operands[0], E_SImode)
                  && nonimmediate_operand (operands[1], E_SImode)
                  && general_operand (operands[2], E_SImode)
                  && 
#line 8001 "../../gcc/config/s390/s390.md"
(!TARGET_Z15
   && ! reload_completed
   && (GET_CODE (operands[0]) != MEM
      /* Ensure that s390_logical_operator_ok_p will succeed even
	 on the split xor if (b & a) is stored into a pseudo.  */
       || rtx_equal_p (operands[0], operands[2]))))
                {
                  *pnum_clobbers = 1;
                  return 2018; /* *andc_split_si */
                }
              if (!register_operand (operands[0], E_SImode)
                  || !register_operand (operands[1], E_SImode)
                  || !register_operand (operands[2], E_SImode)
                  || !
#line 8380 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              *pnum_clobbers = 1;
              return 2041; /* *andcsi */

            default:
              return -1;
            }

        case NOT:
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern128 (x2, 
E_DImode) != 0
                  || !(
#line 8420 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2051; /* *nordi */

            case E_SImode:
              if (pattern128 (x2, 
E_SImode) != 0
                  || !
#line 8420 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              *pnum_clobbers = 1;
              return 2053; /* *norsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_58 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern2 (x1))
    {
    case 0:
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1QImode)) - 1)
  ))
        return 863; /* *ashlv1qi3 */
      if (!register_operand (operands[2], E_V1QImode)
          || !
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 919; /* vashlv1qi3 */

    case 1:
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2QImode)) - 1)
  ))
        return 867; /* *ashlv2qi3 */
      if (!register_operand (operands[2], E_V2QImode)
          || !
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 920; /* vashlv2qi3 */

    case 2:
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4QImode)) - 1)
  ))
        return 871; /* *ashlv4qi3 */
      if (!register_operand (operands[2], E_V4QImode)
          || !
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 921; /* vashlv4qi3 */

    case 3:
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8QImode)) - 1)
  ))
        return 875; /* *ashlv8qi3 */
      if (!register_operand (operands[2], E_V8QImode)
          || !
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 922; /* vashlv8qi3 */

    case 4:
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V16QImode)) - 1)
  ))
        return 879; /* *ashlv16qi3 */
      if (!register_operand (operands[2], E_V16QImode)
          || !
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 923; /* vashlv16qi3 */

    case 5:
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1HImode)) - 1)
  ))
        return 883; /* *ashlv1hi3 */
      if (!register_operand (operands[2], E_V1HImode)
          || !
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 924; /* vashlv1hi3 */

    case 6:
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2HImode)) - 1)
  ))
        return 887; /* *ashlv2hi3 */
      if (!register_operand (operands[2], E_V2HImode)
          || !
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 925; /* vashlv2hi3 */

    case 7:
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4HImode)) - 1)
  ))
        return 891; /* *ashlv4hi3 */
      if (!register_operand (operands[2], E_V4HImode)
          || !
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 926; /* vashlv4hi3 */

    case 8:
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8HImode)) - 1)
  ))
        return 895; /* *ashlv8hi3 */
      if (!register_operand (operands[2], E_V8HImode)
          || !
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 927; /* vashlv8hi3 */

    case 9:
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1SImode)) - 1)
  ))
        return 899; /* *ashlv1si3 */
      if (!register_operand (operands[2], E_V1SImode)
          || !
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 928; /* vashlv1si3 */

    case 10:
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2SImode)) - 1)
  ))
        return 903; /* *ashlv2si3 */
      if (!register_operand (operands[2], E_V2SImode)
          || !
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 929; /* vashlv2si3 */

    case 11:
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4SImode)) - 1)
  ))
        return 907; /* *ashlv4si3 */
      if (!register_operand (operands[2], E_V4SImode)
          || !
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 930; /* vashlv4si3 */

    case 12:
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1DImode)) - 1)
  ))
        return 911; /* *ashlv1di3 */
      if (!register_operand (operands[2], E_V1DImode)
          || !
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 931; /* vashlv1di3 */

    case 13:
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2DImode)) - 1)
  ))
        return 915; /* *ashlv2di3 */
      if (!register_operand (operands[2], E_V2DImode)
          || !
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 932; /* vashlv2di3 */

    case 14:
      if (
#line 9416 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
        return 2160; /* *ashldi3_31 */
      if (!
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 2162; /* *ashldi3 */

    case 15:
      return 2164; /* *ashlsi3 */

    default:
      return -1;
    }
}

 int
recog_64 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (XVECLEN (x5, 0))
        {
        case 2:
          x7 = XVECEXP (x5, 0, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x8 = XVECEXP (x5, 0, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
              || pattern140 (x3, 
E_V4SFmode, 
E_V2SFmode, 
E_V2DFmode) != 0
              || !
#line 2643 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1373; /* *vec_extendv4sf */

        case 1:
          x7 = XVECEXP (x5, 0, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern140 (x3, 
E_V2DFmode, 
E_V1DFmode, 
E_V1TFmode) != 0
              || !
#line 2687 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1374; /* *vec_extendv2df */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DFmode:
              if (register_operand (operands[1], E_DFmode)
                  && 
#line 3010 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
                return 1408; /* extenddftf2_vr */
              if (!nonimmediate_operand (operands[1], E_DFmode)
                  || !(
#line 5556 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (TFmode) > GET_MODE_SIZE (DFmode)
   && (!TARGET_VX || TFmode != DFmode || DFmode != SFmode)) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 1754; /* *extenddftf2 */

            case E_SFmode:
              if (!nonimmediate_operand (operands[1], E_SFmode)
                  || !(
#line 5556 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (TFmode) > GET_MODE_SIZE (SFmode)
   && (!TARGET_VX || TFmode != DFmode || SFmode != SFmode)) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 1758; /* *extendsftf2 */

            default:
              return -1;
            }

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!nonimmediate_operand (operands[1], E_SFmode))
                return -1;
              if (
#line 5544 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
                return 1753; /* *extendsfdf2_z13 */
              if (!
#line 5556 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (DFmode) > GET_MODE_SIZE (SFmode)
   && (!TARGET_VX || DFmode != DFmode || SFmode != SFmode)))
                return -1;
              return 1760; /* *extendsfdf2 */

            case E_DFmode:
              if (!nonimmediate_operand (operands[1], E_DFmode)
                  || !
#line 5556 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (DFmode) > GET_MODE_SIZE (DFmode)
   && (!TARGET_VX || DFmode != DFmode || DFmode != SFmode)))
                return -1;
              return 1756; /* *extenddfdf2 */

            default:
              return -1;
            }

        case E_FPRX2mode:
          switch (pattern86 (x3, 
E_FPRX2mode))
            {
            case 0:
              if (!(
#line 5556 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (FPRX2mode) > GET_MODE_SIZE (DFmode)
   && (!TARGET_VX || FPRX2mode != DFmode || DFmode != SFmode)) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 1755; /* *extenddffprx22 */

            case 1:
              if (!(
#line 5556 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (FPRX2mode) > GET_MODE_SIZE (SFmode)
   && (!TARGET_VX || FPRX2mode != DFmode || SFmode != SFmode)) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 1759; /* *extendsffprx22 */

            default:
              return -1;
            }

        case E_SFmode:
          switch (pattern86 (x3, 
E_SFmode))
            {
            case 0:
              if (!
#line 5556 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (SFmode) > GET_MODE_SIZE (DFmode)
   && (!TARGET_VX || SFmode != DFmode || DFmode != SFmode)))
                return -1;
              return 1757; /* *extenddfsf2 */

            case 1:
              if (!
#line 5556 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (SFmode) > GET_MODE_SIZE (SFmode)
   && (!TARGET_VX || SFmode != DFmode || SFmode != SFmode)))
                return -1;
              return 1761; /* *extendsfsf2 */

            default:
              return -1;
            }

        case E_TDmode:
          if (!register_operand (operands[0], E_TDmode)
              || GET_MODE (x3) != E_TDmode
              || !register_operand (operands[1], E_DDmode)
              || !
#line 5578 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 1762; /* extendddtd2 */

        case E_DDmode:
          if (!register_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !register_operand (operands[1], E_SDmode)
              || !
#line 5586 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 1763; /* extendsddd2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_74 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x3, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  x7 = XVECEXP (x1, 0, 0);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) == E_CCL1mode)
    {
      x9 = XEXP (x7, 1);
      if (GET_MODE (x9) == E_CCL1mode)
        {
          x10 = XEXP (x9, 1);
          if (rtx_equal_p (x10, operands[1]))
            {
              x11 = XEXP (x9, 0);
              switch (GET_MODE (x11))
                {
                case E_DImode:
                  if (pattern272 (x3, 
E_DImode) == 0
                      && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return 1857; /* adddi3_carry1_cc */
                  break;

                case E_SImode:
                  if (pattern272 (x3, 
E_SImode) == 0)
                    return 1858; /* addsi3_carry1_cc */
                  break;

                default:
                  break;
                }
            }
        }
    }
  x9 = XEXP (x7, 1);
  x11 = XEXP (x9, 0);
  switch (GET_MODE (x11))
    {
    case E_DImode:
      if (pattern252 (x1, 
E_DImode) != 0
          || !(
#line 6051 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      return 1861; /* *adddi3_carry2_cc */

    case E_SImode:
      if (pattern252 (x1, 
E_SImode) != 0
          || !
#line 6051 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
        return -1;
      return 1862; /* *addsi3_carry2_cc */

    case E_TFmode:
      if (pattern253 (x1, 
E_TFmode) != 0
          || !(
#line 6278 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      return 1884; /* *addtf3_cc */

    case E_FPRX2mode:
      if (pattern253 (x1, 
E_FPRX2mode) != 0
          || !(
#line 6278 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      return 1885; /* *addfprx23_cc */

    case E_DFmode:
      if (pattern253 (x1, 
E_DFmode) != 0
          || !
#line 6278 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
        return -1;
      return 1886; /* *adddf3_cc */

    case E_SFmode:
      if (pattern253 (x1, 
E_SFmode) != 0
          || !
#line 6278 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
        return -1;
      return 1887; /* *addsf3_cc */

    case E_TDmode:
      if (pattern253 (x1, 
E_TDmode) != 0
          || !(
#line 6278 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 1888; /* *addtd3_cc */

    case E_DDmode:
      if (pattern253 (x1, 
E_DDmode) != 0
          || !(
#line 6278 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 1889; /* *adddd3_cc */

    default:
      return -1;
    }
}

 int
recog_88 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
          if (XWINT (x5, 0) == 2147483647L
              && pattern38 (x1) == 0
              && register_operand (operands[0], E_SImode)
              && GET_MODE (x3) == E_SImode)
            {
              operands[1] = x4;
              if (address_operand (operands[1], E_QImode)
                  && 
#line 2387 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return 1511; /* *la_31_and_cc */
            }
          break;

        case REG:
        case SUBREG:
        case MEM:
          res = recog_85 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      operands[1] = x4;
      res = recog_86 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 33
          || GET_MODE (x7) != E_CCmode)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      if (GET_CODE (x4) == SUBREG)
        {
          res = recog_87 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x4;
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern118 (x3, 
E_DImode) != 0
              || !
#line 7729 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2000; /* *anddi3 */

        case E_SImode:
          if (pattern118 (x3, 
E_SImode) != 0)
            return -1;
          if (
#line 7858 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return 2011; /* *andsi3_zarch */
          if (!
#line 7892 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2012; /* *andsi3_esa */

        default:
          return -1;
        }

    case ROTATE:
      if (GET_MODE (x4) != E_DImode
          || pattern38 (x1) != 0
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (!contiguous_bitmask_operand (operands[3], E_DImode)
          || !
#line 4199 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
        return -1;
      return 1605; /* *risbg_di_and_rot */

    case LSHIFTRT:
      x6 = XVECEXP (x1, 0, 1);
      if (pattern88 (x6) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[4] = x5;
          if (!nonimmediate_operand (operands[4], E_DImode))
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_CODE (x8) != ZERO_EXTRACT
              || GET_MODE (x8) != E_DImode)
            return -1;
          x11 = XEXP (x8, 0);
          operands[0] = x11;
          if (!nonimmediate_operand (operands[0], E_DImode))
            return -1;
          x12 = XEXP (x8, 1);
          operands[1] = x12;
          if (!const_int_operand (operands[1], E_VOIDmode))
            return -1;
          x13 = XEXP (x8, 2);
          operands[2] = x13;
          if (!const_int_operand (operands[2], E_VOIDmode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x10 = XEXP (x4, 1);
          operands[3] = x10;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          x9 = XEXP (x4, 0);
          if (!rtx_equal_p (x9, operands[0])
              || !
#line 4645 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && INTVAL (operands[3]) == 64 - INTVAL (operands[1]) - INTVAL (operands[2])))
            return -1;
          return 1659; /* *insv_rnsbg_srl */

        case CONST_INT:
          operands[3] = x5;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          x9 = XEXP (x4, 0);
          operands[1] = x9;
          x10 = XEXP (x4, 1);
          operands[2] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern244 (x3, 
E_DImode) != 0
                  || !(
#line 7779 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   /* Note that even for the SImode pattern, the rotate is always DImode.  */
   && s390_extzv_shift_ok (64, -INTVAL (operands[2]),
			   INTVAL (operands[3]))) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2002; /* *extzv_di_srl_clobbercc */

            case E_SImode:
              if (pattern244 (x3, 
E_SImode) != 0
                  || !
#line 7779 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   /* Note that even for the SImode pattern, the rotate is always DImode.  */
   && s390_extzv_shift_ok (32, -INTVAL (operands[2]),
			   INTVAL (operands[3]))))
                return -1;
              return 2004; /* *extzv_si_srl_clobbercc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      x6 = XVECEXP (x1, 0, 1);
      if (pattern39 (x6) != 0)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern244 (x3, 
E_DImode) != 0
              || !(
#line 7793 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && s390_extzv_shift_ok (64, INTVAL (operands[2]),
			   INTVAL (operands[3]))) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2006; /* *extzv_di_sll_clobbercc */

        case E_SImode:
          if (pattern244 (x3, 
E_SImode) != 0
              || !
#line 7793 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && s390_extzv_shift_ok (32, INTVAL (operands[2]),
			   INTVAL (operands[3]))))
            return -1;
          return 2008; /* *extzv_si_sll_clobbercc */

        default:
          return -1;
        }

    case NOT:
      x6 = XVECEXP (x1, 0, 1);
      if (pattern39 (x6) != 0)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (GET_MODE (x3) != E_DImode
                  || GET_MODE (x4) != E_DImode)
                return -1;
              if (nonimmediate_operand (operands[0], E_DImode)
                  && nonimmediate_operand (operands[1], E_DImode)
                  && general_operand (operands[2], E_DImode)
                  && (
#line 8001 "../../gcc/config/s390/s390.md"
(!TARGET_Z15
   && ! reload_completed
   && (GET_CODE (operands[0]) != MEM
      /* Ensure that s390_logical_operator_ok_p will succeed even
	 on the split xor if (b & a) is stored into a pseudo.  */
       || rtx_equal_p (operands[0], operands[2]))) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 2017; /* *andc_split_di */
              if (!register_operand (operands[0], E_DImode)
                  || !register_operand (operands[1], E_DImode)
                  || !register_operand (operands[2], E_DImode)
                  || !(
#line 8380 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2039; /* *andcdi */

            case E_SImode:
              if (GET_MODE (x3) != E_SImode
                  || GET_MODE (x4) != E_SImode)
                return -1;
              if (nonimmediate_operand (operands[0], E_SImode)
                  && nonimmediate_operand (operands[1], E_SImode)
                  && general_operand (operands[2], E_SImode)
                  && 
#line 8001 "../../gcc/config/s390/s390.md"
(!TARGET_Z15
   && ! reload_completed
   && (GET_CODE (operands[0]) != MEM
      /* Ensure that s390_logical_operator_ok_p will succeed even
	 on the split xor if (b & a) is stored into a pseudo.  */
       || rtx_equal_p (operands[0], operands[2]))))
                return 2018; /* *andc_split_si */
              if (!register_operand (operands[0], E_SImode)
                  || !register_operand (operands[1], E_SImode)
                  || !register_operand (operands[2], E_SImode)
                  || !
#line 8380 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2041; /* *andcsi */

            default:
              return -1;
            }

        case NOT:
          switch (pattern214 (x3))
            {
            case 0:
              if (!(
#line 8420 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2051; /* *nordi */

            case 1:
              if (!
#line 8420 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2053; /* *norsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_100 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case AND:
      switch (pattern92 (x1))
        {
        case 0:
          x6 = XEXP (x4, 1);
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern248 (x4, 
E_DImode) != 0
                  || !(
#line 4480 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 1635; /* *rxsbg_di_noshift */

            case E_SImode:
              if (pattern248 (x4, 
E_SImode) != 0
                  || !
#line 4480 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                return -1;
              return 1637; /* *rxsbg_si_noshift */

            default:
              return -1;
            }

        case 1:
          if (!
#line 4495 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 1639; /* *rxsbg_di_rotl */

        case 2:
          if (!(
#line 4510 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1641; /* *rxsbg_di_srl_bitmask */

        case 3:
          if (!
#line 4510 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          return 1643; /* *rxsbg_si_srl_bitmask */

        case 4:
          if (!(
#line 4530 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1645; /* *rxsbg_di_sll_bitmask */

        case 5:
          if (!
#line 4530 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          return 1647; /* *rxsbg_si_sll_bitmask */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern95 (x1))
        {
        case 0:
          if (!(
#line 4548 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1649; /* *rxsbg_di_sll */

        case 1:
          if (!
#line 4548 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 1651; /* *rxsbg_si_sll */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern95 (x1))
        {
        case 0:
          if (!(
#line 4567 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1653; /* *rxsbg_di_srl */

        case 1:
          if (!
#line 4567 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 1655; /* *rxsbg_si_srl */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      if (GET_CODE (x5) == SUBREG
          && pattern116 (x1) == 0
          && 
#line 4587 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
        return 1657; /* *rxsbg_sidi_srl */
      if (pnum_clobbers != NULL
          && pattern117 (x1) == 0
          && 
#line 8716 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        {
          *pnum_clobbers = 1;
          return 2066; /* *xc */
        }
      operands[1] = x5;
      switch (pattern119 (x1))
        {
        case 0:
          if (!
#line 8560 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2060; /* *xordi3 */

        case 1:
          if (!
#line 8630 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            return -1;
          return 2063; /* *xorsi3 */

        case 2:
          if (!
#line 8663 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            return -1;
          return 2064; /* *xorhi3 */

        case 3:
          if (!
#line 8693 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            return -1;
          return 2065; /* *xorqi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_107 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != MEM
      || pattern97 (x4) != 0)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != USE)
    return -1;
  x7 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x7) != USE)
    return -1;
  x8 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 33
      || GET_MODE (x9) != E_CCmode)
    return -1;
  x10 = XEXP (x2, 0);
  operands[0] = x10;
  x11 = XEXP (x3, 0);
  operands[1] = x11;
  switch (pattern256 (x1))
    {
    case 0:
      if (!(
#line 3496 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        return -1;
      return 1548; /* *cpymem_long */

    case 1:
      if (!(
#line 3496 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      return 1549; /* *cpymem_long */

    case 2:
      if (!
#line 3509 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
        return -1;
      return 1550; /* *cpymem_long_31z */

    default:
      return -1;
    }
}

 int
recog_108 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case CLOBBER:
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != CLOBBER)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x5) != USE)
        return -1;
      x6 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x6) != USE)
        return -1;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      x9 = XEXP (x4, 1);
      switch (GET_CODE (x9))
        {
        case MEM:
          if (pnum_clobbers == NULL
              || pattern97 (x4) != 0)
            return -1;
          switch (pattern256 (x1))
            {
            case 0:
              if (!(
#line 3496 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1548; /* *cpymem_long */

            case 1:
              if (!(
#line 3496 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1549; /* *cpymem_long */

            case 2:
              if (!
#line 3509 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 1550; /* *cpymem_long_31z */

            default:
              return -1;
            }

        case COMPARE:
          if (GET_MODE (x9) != E_CCUmode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) != MEM
              || GET_MODE (x10) != E_BLKmode)
            return -1;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != SUBREG)
            return -1;
          x12 = XEXP (x9, 1);
          if (GET_CODE (x12) != MEM
              || GET_MODE (x12) != E_BLKmode)
            return -1;
          x13 = XEXP (x12, 0);
          if (GET_CODE (x13) != SUBREG)
            return -1;
          x14 = XEXP (x4, 0);
          if (GET_CODE (x14) != REG
              || REGNO (x14) != 33
              || GET_MODE (x14) != E_CCUmode)
            return -1;
          x15 = XEXP (x11, 0);
          operands[2] = x15;
          x16 = XEXP (x13, 0);
          operands[3] = x16;
          x17 = XEXP (x5, 0);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          x18 = XEXP (x6, 0);
          if (!rtx_equal_p (x18, operands[3]))
            return -1;
          switch (SUBREG_BYTE (x11))
            {
            case 0:
              if (maybe_ne (SUBREG_BYTE (x13), 0))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_TImode:
                  if (pattern293 (x9, 
E_TImode, 
E_DImode) != 0
                      || !(
#line 3946 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                    return -1;
                  return 1570; /* *cmpmem_long */

                case E_DImode:
                  if (pattern293 (x9, 
E_DImode, 
E_SImode) != 0
                      || !(
#line 3946 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                    return -1;
                  return 1571; /* *cmpmem_long */

                default:
                  return -1;
                }

            case 4:
              if (GET_MODE (x11) != E_SImode
                  || maybe_ne (SUBREG_BYTE (x13), 4)
                  || GET_MODE (x13) != E_SImode
                  || !register_operand (operands[0], E_TImode)
                  || !register_operand (operands[1], E_TImode)
                  || !register_operand (operands[2], E_TImode)
                  || !register_operand (operands[3], E_TImode)
                  || !
#line 3959 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
                return -1;
              return 1572; /* *cmpmem_long_31z */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != USE)
        return -1;
      x19 = XEXP (x2, 1);
      switch (GET_CODE (x19))
        {
        case CONST_INT:
          if (XWINT (x19, 0) != 0L)
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != USE
              || pattern102 (x1) != 0
              || !nonmemory_operand (operands[1], E_VOIDmode))
            return -1;
          x14 = XEXP (x4, 0);
          operands[2] = x14;
          if (!immediate_operand (operands[2], E_VOIDmode))
            return -1;
          x5 = XVECEXP (x1, 0, 3);
          x17 = XEXP (x5, 0);
          operands[3] = x17;
          switch (GET_MODE (operands[3]))
            {
            case E_DImode:
              if (!scratch_operand (operands[3], E_DImode)
                  || !(
#line 3644 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[1]) == Pmode || GET_MODE (operands[1]) == VOIDmode)) && 
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1560; /* *clrmem_short */

            case E_SImode:
              if (!scratch_operand (operands[3], E_SImode)
                  || !(
#line 3644 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[1]) == Pmode || GET_MODE (operands[1]) == VOIDmode)) && 
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1561; /* *clrmem_short */

            default:
              return -1;
            }

        case LABEL_REF:
          if (pattern79 (x1) != 0)
            return -1;
          x20 = XEXP (x19, 0);
          operands[2] = x20;
          switch (pattern269 (x1))
            {
            case 0:
              if (!
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              return 2317; /* split_stack_calldi */

            case 1:
              if (!
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              return 2318; /* split_stack_callsi */

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          x21 = XEXP (x19, 1);
          if (GET_CODE (x21) != LABEL_REF)
            return -1;
          x22 = XEXP (x19, 2);
          if (GET_CODE (x22) != PC
              || pattern79 (x1) != 0)
            return -1;
          x20 = XEXP (x19, 0);
          operands[5] = x20;
          x23 = XEXP (x21, 0);
          operands[2] = x23;
          switch (pattern269 (x1))
            {
            case 0:
              if (!
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              return 2319; /* split_stack_cond_calldi */

            case 1:
              if (!
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              return 2320; /* split_stack_cond_callsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_4 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case VEC_SELECT:
      switch (pattern36 (x1))
        {
        case 0:
          if (!(
#line 990 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 995 "../../gcc/config/s390/vector.md"
( reload_completed && REG_P (operands[0]) && REG_P (operands[1]))))
            return NULL;
          return gen_split_44 (insn, operands);

        case 1:
          if (!(
#line 1060 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 1065 "../../gcc/config/s390/vector.md"
( reload_completed && REG_P (operands[0]) && REG_P (operands[1]))))
            return NULL;
          return gen_split_46 (insn, operands);

        case 2:
          if (!(
#line 1060 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 1065 "../../gcc/config/s390/vector.md"
( reload_completed && REG_P (operands[0]) && REG_P (operands[1]))))
            return NULL;
          return gen_split_47 (insn, operands);

        default:
          return NULL;
        }

    case BSWAP:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return NULL;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!permute_pattern_operand (operands[2], E_V16QImode))
        return NULL;
      switch (pattern163 (x3))
        {
        case 0:
          if (!(
#line 3189 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3194 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], V8HImode)
   && !memory_operand (operands[1], V8HImode))))
            return NULL;
          return gen_split_132 (insn, operands);

        case 1:
          if (!(
#line 3189 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3194 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], V4SImode)
   && !memory_operand (operands[1], V4SImode))))
            return NULL;
          return gen_split_133 (insn, operands);

        case 2:
          if (!(
#line 3189 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3194 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], V4SFmode)
   && !memory_operand (operands[1], V4SFmode))))
            return NULL;
          return gen_split_134 (insn, operands);

        case 3:
          if (!(
#line 3189 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3194 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], V2DImode)
   && !memory_operand (operands[1], V2DImode))))
            return NULL;
          return gen_split_135 (insn, operands);

        case 4:
          if (!(
#line 3189 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3194 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], V2DFmode)
   && !memory_operand (operands[1], V2DFmode))))
            return NULL;
          return gen_split_136 (insn, operands);

        case 5:
          if (!(
#line 3189 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3194 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], V1TImode)
   && !memory_operand (operands[1], V1TImode))))
            return NULL;
          return gen_split_137 (insn, operands);

        case 6:
          if (!(
#line 3189 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3194 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], V1TFmode)
   && !memory_operand (operands[1], V1TFmode))))
            return NULL;
          return gen_split_138 (insn, operands);

        case 7:
          if (!(
#line 3189 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3194 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], TImode)
   && !memory_operand (operands[1], TImode))))
            return NULL;
          return gen_split_139 (insn, operands);

        case 8:
          if (!(
#line 3189 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3194 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], TFmode)
   && !memory_operand (operands[1], TFmode))))
            return NULL;
          return gen_split_140 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      if (pattern38 (x1) != 0)
        return NULL;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case PLUS:
        case MINUS:
        case MULT:
        case AND:
        case SIGN_EXTEND:
        case ZERO_EXTEND:
        case HIGH:
          x8 = XEXP (x3, 1);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              if (GET_CODE (x8) == CONST_INT
                  && XWINT (x8, 0) == 2147483647L
                  && register_operand (operands[0], E_SImode)
                  && GET_MODE (x3) == E_SImode)
                {
                  operands[1] = x6;
                  if (address_operand (operands[1], E_QImode)
                      && (
#line 2387 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT) && 
#line 2389 "../../gcc/config/s390/s390.md"
( reload_completed)))
                    return gen_split_154 (insn, operands);
                  if (nonimmediate_operand (operands[1], E_SImode)
                      && 
#line 4980 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed))
                    return gen_split_206 (insn, operands);
                }
              operands[1] = x8;
              if (rtx_equal_p (x6, operands[0]))
                {
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (s_operand (operands[0], E_SImode)
                          && GET_MODE (x3) == E_SImode
                          && immediate_operand (operands[1], E_SImode)
                          && 
#line 7906 "../../gcc/config/s390/s390.md"
(reload_completed))
                        return gen_split_222 (insn, operands);
                      break;

                    case E_HImode:
                      if (s_operand (operands[0], E_HImode)
                          && GET_MODE (x3) == E_HImode
                          && immediate_operand (operands[1], E_HImode)
                          && 
#line 7951 "../../gcc/config/s390/s390.md"
(reload_completed))
                        return gen_split_223 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              break;

            case SUBREG:
            case MEM:
              operands[1] = x8;
              if (memory_operand (operands[1], E_VOIDmode)
                  && memory_operand (operands[0], E_VOIDmode)
                  && rtx_equal_p (x6, operands[0])
                  && 
#line 8043 "../../gcc/config/s390/s390.md"
(reload_completed
   && GET_MODE (operands[0]) == GET_MODE (operands[1])
   && GET_MODE_SIZE (GET_MODE (operands[0])) > 0))
                return gen_split_226 (insn, operands);
              break;

            default:
              break;
            }
          if (GET_CODE (x8) == CONST_INT
              && XWINT (x8, 0) == 2147483647L
              && register_operand (operands[0], E_DImode)
              && GET_MODE (x3) == E_DImode)
            {
              if (GET_CODE (x6) == SUBREG
                  && known_eq (SUBREG_BYTE (x6), 0)
                  && GET_MODE (x6) == E_DImode)
                {
                  x9 = XEXP (x6, 0);
                  operands[1] = x9;
                  if (memory_operand (operands[1], E_SImode)
                      && (
#line 4945 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 4947 "../../gcc/config/s390/s390.md"
( reload_completed)))
                    return gen_split_204 (insn, operands);
                }
              operands[1] = x6;
              if (nonimmediate_operand (operands[1], E_DImode)
                  && 
#line 4980 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed))
                return gen_split_205 (insn, operands);
            }
          if (!rtx_equal_p (x6, operands[0])
              || !s_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return NULL;
          operands[1] = x8;
          if (!immediate_operand (operands[1], E_DImode)
              || !
#line 7766 "../../gcc/config/s390/s390.md"
(reload_completed))
            return NULL;
          return gen_split_221 (insn, operands);

        case NOT:
          x9 = XEXP (x6, 0);
          operands[1] = x9;
          x8 = XEXP (x3, 1);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern229 (x3, 
E_DImode) != 0
                  || !((
#line 8001 "../../gcc/config/s390/s390.md"
(!TARGET_Z15
   && ! reload_completed
   && (GET_CODE (operands[0]) != MEM
      /* Ensure that s390_logical_operator_ok_p will succeed even
	 on the split xor if (b & a) is stored into a pseudo.  */
       || rtx_equal_p (operands[0], operands[2]))) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 8008 "../../gcc/config/s390/s390.md"
( 1)))
                return NULL;
              return gen_split_224 (insn, operands);

            case E_SImode:
              if (pattern229 (x3, 
E_SImode) != 0
                  || !(
#line 8001 "../../gcc/config/s390/s390.md"
(!TARGET_Z15
   && ! reload_completed
   && (GET_CODE (operands[0]) != MEM
      /* Ensure that s390_logical_operator_ok_p will succeed even
	 on the split xor if (b & a) is stored into a pseudo.  */
       || rtx_equal_p (operands[0], operands[2]))) && 
#line 8008 "../../gcc/config/s390/s390.md"
( 1)))
                return NULL;
              return gen_split_225 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case UNSPEC:
      if (XVECLEN (x3, 0) != 1
          || XINT (x3, 1) != 4
          || pattern101 (x1) != 0)
        return NULL;
      x10 = XVECEXP (x3, 0, 0);
      operands[1] = x10;
      if (!register_operand (operands[1], E_CCUmode)
          || !
#line 3975 "../../gcc/config/s390/s390.md"
(reload_completed))
        return NULL;
      return gen_split_190 (insn, operands);

    case COMPARE:
      x8 = XEXP (x3, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 33)
        return NULL;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return NULL;
      x7 = XEXP (x4, 0);
      operands[0] = x7;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case UNSPEC:
          if (XVECLEN (x6, 0) != 1
              || XINT (x6, 1) != 4
              || GET_MODE (x6) != E_SImode
              || pattern210 (x1) != 0
              || !register_operand (operands[0], E_SImode))
            return NULL;
          x11 = XEXP (x4, 1);
          x12 = XVECEXP (x11, 0, 0);
          if (!rtx_equal_p (x12, operands[1])
              || !(
#line 3988 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode)) && 
#line 3990 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_191 (insn, operands);

        case ASHIFTRT:
          if (GET_MODE (x6) != E_DImode)
            return NULL;
          x9 = XEXP (x6, 0);
          if (GET_CODE (x9) != ASHIFT
              || GET_MODE (x9) != E_DImode)
            return NULL;
          x13 = XEXP (x9, 0);
          if (GET_CODE (x13) != SUBREG
              || maybe_ne (SUBREG_BYTE (x13), 0)
              || GET_MODE (x13) != E_DImode)
            return NULL;
          x14 = XEXP (x13, 0);
          if (GET_CODE (x14) != UNSPEC
              || XVECLEN (x14, 0) != 1
              || XINT (x14, 1) != 4
              || GET_MODE (x14) != E_SImode)
            return NULL;
          x15 = XEXP (x9, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return NULL;
          x16 = XEXP (x6, 1);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return NULL;
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != SIGN_EXTEND
              || GET_MODE (x11) != E_DImode
              || pattern291 (x1) != 0
              || !register_operand (operands[0], E_DImode))
            return NULL;
          x17 = XEXP (x11, 0);
          x18 = XVECEXP (x17, 0, 0);
          if (!rtx_equal_p (x18, operands[1])
              || !(
#line 4023 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_ZARCH) && 
#line 4025 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_193 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTRACT:
      x19 = XEXP (x3, 2);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      switch (pattern72 (x1))
        {
        case 0:
          if (!((
#line 4210 "../../gcc/config/s390/s390.md"
(!TARGET_Z10) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 4212 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_194 (insn, operands);

        case 1:
          if (!(
#line 4210 "../../gcc/config/s390/s390.md"
(!TARGET_Z10) && 
#line 4212 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_195 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTRACT:
      x19 = XEXP (x3, 2);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      switch (pattern72 (x1))
        {
        case 0:
          if (!(
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 4237 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_196 (insn, operands);

        case 1:
          if (!
#line 4237 "../../gcc/config/s390/s390.md"
( reload_completed))
            return NULL;
          return gen_split_197 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      if (pattern38 (x1) != 0)
        return NULL;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case LSHIFTRT:
          x8 = XEXP (x3, 1);
          if (GET_CODE (x8) != ASHIFT)
            return NULL;
          x9 = XEXP (x6, 0);
          operands[1] = x9;
          x16 = XEXP (x6, 1);
          operands[2] = x16;
          x20 = XEXP (x8, 0);
          operands[3] = x20;
          x21 = XEXP (x8, 1);
          operands[4] = x21;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern257 (x3, 
E_DImode) != 0
                  || !(
#line 4452 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_ZEC12 && UINTVAL (operands[2]) + UINTVAL (operands[4]) >= 64) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return NULL;
              return gen_split_200 (insn, operands);

            case E_SImode:
              if (pattern257 (x3, 
E_SImode) != 0
                  || !
#line 4452 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_ZEC12 && UINTVAL (operands[2]) + UINTVAL (operands[4]) >= 32))
                return NULL;
              return gen_split_201 (insn, operands);

            default:
              return NULL;
            }

        case SUBREG:
        case MEM:
          if (!rtx_equal_p (x6, operands[0]))
            return NULL;
          x8 = XEXP (x3, 1);
          operands[1] = x8;
          switch (pattern194 (x3))
            {
            case 0:
              if (!
#line 8169 "../../gcc/config/s390/s390.md"
(reload_completed))
                return NULL;
              return gen_split_227 (insn, operands);

            case 1:
              if (!
#line 8260 "../../gcc/config/s390/s390.md"
(reload_completed))
                return NULL;
              return gen_split_228 (insn, operands);

            case 2:
              if (!
#line 8303 "../../gcc/config/s390/s390.md"
(reload_completed))
                return NULL;
              return gen_split_229 (insn, operands);

            case 3:
              if (!
#line 8453 "../../gcc/config/s390/s390.md"
(reload_completed
   && GET_MODE (operands[0]) == GET_MODE (operands[1])
   && GET_MODE_SIZE (GET_MODE (operands[0])) > 0))
                return NULL;
              return gen_split_230 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PLUS:
      switch (pattern46 (x1))
        {
        case 0:
          if (pattern212 (x3, 
E_TImode) != 0
              || !(
#line 5840 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 5842 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_210 (insn, operands);

        case 1:
          if (pattern118 (x3, 
E_DImode) != 0
              || !(
#line 5931 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 5933 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_211 (insn, operands);

        default:
          return NULL;
        }

    case MINUS:
      switch (pattern46 (x1))
        {
        case 0:
          if (pattern217 (x3, 
E_TImode) != 0
              || !(
#line 6387 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 6389 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_212 (insn, operands);

        case 1:
          if (pattern217 (x3, 
E_DImode) != 0
              || !(
#line 6478 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 6480 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_213 (insn, operands);

        default:
          return NULL;
        }

    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
      if (pattern38 (x1) != 0)
        return NULL;
      switch (GET_CODE (x3))
        {
        case SIGN_EXTEND:
          switch (pattern182 (x3))
            {
            case 0:
              if ((
#line 4006 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 4008 "../../gcc/config/s390/s390.md"
( reload_completed)))
                return gen_split_192 (insn, operands);
              break;

            case 1:
              if (((
#line 4880 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && !TARGET_LONG_DISPLACEMENT) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 4882 "../../gcc/config/s390/s390.md"
( reload_completed)))
                return gen_split_202 (insn, operands);
              break;

            case 2:
              if ((
#line 4880 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && !TARGET_LONG_DISPLACEMENT) && 
#line 4882 "../../gcc/config/s390/s390.md"
( reload_completed)))
                return gen_split_203 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case ZERO_EXTEND:
          if (GET_MODE (x3) == E_SImode
              && register_operand (operands[0], E_SImode))
            {
              x6 = XEXP (x3, 0);
              operands[1] = x6;
              if (s_operand (operands[1], E_HImode)
                  && (
#line 5065 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 5067 "../../gcc/config/s390/s390.md"
( reload_completed)))
                return gen_split_207 (insn, operands);
            }
          break;

        default:
          break;
        }
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode))
            return NULL;
          if (s390_alc_comparison (operands[1], E_DImode)
              && (
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 6972 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return gen_split_214 (insn, operands);
          if (!s390_slb_comparison (operands[1], E_DImode)
              || !(
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 6986 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_216 (insn, operands);

        case E_SImode:
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          if (s390_alc_comparison (operands[1], E_SImode)
              && 
#line 6972 "../../gcc/config/s390/s390.md"
( reload_completed))
            return gen_split_215 (insn, operands);
          if (!s390_slb_comparison (operands[1], E_SImode)
              || !
#line 6986 "../../gcc/config/s390/s390.md"
( reload_completed))
            return NULL;
          return gen_split_217 (insn, operands);

        default:
          return NULL;
        }

    case NE:
      if (GET_MODE (x3) != E_SImode)
        return NULL;
      x8 = XEXP (x3, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x4 = XVECEXP (x1, 0, 1);
      if (pattern39 (x4) != 0)
        return NULL;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_SImode))
        return NULL;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_CCZ1mode)
          || !
#line 7044 "../../gcc/config/s390/s390.md"
(reload_completed))
        return NULL;
      return gen_split_218 (insn, operands);

    case XOR:
      if (pattern38 (x1) != 0)
        return NULL;
      x8 = XEXP (x3, 1);
      operands[1] = x8;
      x6 = XEXP (x3, 0);
      if (!rtx_equal_p (x6, operands[0]))
        return NULL;
      switch (pattern194 (x3))
        {
        case 0:
          if (!
#line 8578 "../../gcc/config/s390/s390.md"
(reload_completed))
            return NULL;
          return gen_split_235 (insn, operands);

        case 1:
          if (!
#line 8648 "../../gcc/config/s390/s390.md"
(reload_completed))
            return NULL;
          return gen_split_236 (insn, operands);

        case 2:
          if (!
#line 8678 "../../gcc/config/s390/s390.md"
(reload_completed))
            return NULL;
          return gen_split_237 (insn, operands);

        case 3:
          if (!
#line 8725 "../../gcc/config/s390/s390.md"
(reload_completed
   && GET_MODE (operands[0]) == GET_MODE (operands[1])
   && GET_MODE_SIZE (GET_MODE (operands[0])) > 0))
            return NULL;
          return gen_split_238 (insn, operands);

        default:
          return NULL;
        }

    case NEG:
      if (pattern40 (x1) != 0)
        return NULL;
      if (
#line 8926 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH
   && reload_completed
   && ((REG_P (operands[0]) && REG_P (operands[1])
       && REGNO (operands[0]) == REGNO (operands[1]))
      || s390_split_ok_p (operands[0], operands[1], DImode, 0))))
        return gen_split_239 (insn, operands);
      if (!
#line 8959 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH
   && s390_split_ok_p (operands[0], operands[1], DImode, 1)
   && reload_completed))
        return NULL;
      return gen_split_240 (insn, operands);

    case IF_THEN_ELSE:
      x6 = XEXP (x3, 0);
      if (!s390_eqne_operator (x6, E_VOIDmode))
        return NULL;
      operands[0] = x6;
      x9 = XEXP (x6, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 33
          || GET_MODE (x9) != E_CCRAWmode)
        return NULL;
      x8 = XEXP (x3, 1);
      if (GET_CODE (x8) != LABEL_REF)
        return NULL;
      x19 = XEXP (x3, 2);
      if (GET_CODE (x19) != PC)
        return NULL;
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != PC)
        return NULL;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET
          || pattern230 (x1) != 0)
        return NULL;
      return gen_split_249 (insn, operands);

    default:
      return NULL;
    }
}
