/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || GET_MODE (x3) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode))
        return -1;
      return 0;

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x3) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode))
        return -1;
      return 1;

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x3) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode))
        return -1;
      return 2;

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 3;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 4;

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x3) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode))
        return -1;
      return 5;

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x3) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      return 6;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 7;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 8;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x3) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode))
        return -1;
      return 9;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 10;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 11;

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x3) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode))
        return -1;
      return 12;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 13;

    case E_DImode:
      if (pattern1 (x3, 
E_DImode) != 0)
        return -1;
      return 14;

    case E_SImode:
      if (pattern1 (x3, 
E_SImode) != 0)
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern40 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 33
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  return 0;
}

int
pattern47 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern54 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern61 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[3], i1)
      || !contiguous_bitmask_nowrap_operand (operands[2], i1)
      || !nonimmediate_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern64 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern70 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 16)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != USE)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 0
      || GET_MODE (x7) != E_SImode)
    return -1;
  return pattern69 (x2); /* [-1, 23] */
}

int
pattern77 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || GET_MODE (x1) != i1
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern82 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern85 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern89 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  return 0;
}

int
pattern94 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern93 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern93 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern103 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern108 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern115 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  x9 = XEXP (x5, 1);
  switch (GET_CODE (x9))
    {
    case LABEL_REF:
      x10 = XEXP (x5, 2);
      if (GET_CODE (x10) != PC)
        return -1;
      x11 = XEXP (x9, 0);
      operands[3] = x11;
      return pattern114 (); /* [-1, 1] */

    case PC:
      x10 = XEXP (x5, 2);
      if (GET_CODE (x10) != LABEL_REF)
        return -1;
      x12 = XEXP (x10, 0);
      operands[3] = x12;
      res = pattern114 ();
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern125 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != 2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 33
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!nonmemory_operand (operands[2], i1))
    return -1;
  x7 = XEXP (x3, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = XEXP (x2, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  return 0;
}

int
pattern138 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern145 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern151 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern149 (x1); /* [-1, 5] */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode
          || GET_MODE (x6) != E_SImode
          || !immediate_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode))
            return -1;
          return 6;

        case E_TFmode:
          if (!register_operand (operands[1], E_TFmode))
            return -1;
          return 7;

        case E_FPRX2mode:
          if (!register_operand (operands[1], E_FPRX2mode))
            return -1;
          return 8;

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern163 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!nonimmediate_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !nonimmediate_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!nonimmediate_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !nonimmediate_operand (operands[1], E_V4SImode))
        return -1;
      return 1;

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !nonimmediate_operand (operands[1], E_V4SFmode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!nonimmediate_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !nonimmediate_operand (operands[1], E_V2DImode))
        return -1;
      return 3;

    case E_V2DFmode:
      if (!nonimmediate_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !nonimmediate_operand (operands[1], E_V2DFmode))
        return -1;
      return 4;

    case E_V1TImode:
      if (!nonimmediate_operand (operands[0], E_V1TImode)
          || GET_MODE (x1) != E_V1TImode
          || !nonimmediate_operand (operands[1], E_V1TImode))
        return -1;
      return 5;

    case E_V1TFmode:
      if (!nonimmediate_operand (operands[0], E_V1TFmode)
          || GET_MODE (x1) != E_V1TFmode
          || !nonimmediate_operand (operands[1], E_V1TFmode))
        return -1;
      return 6;

    case E_TImode:
      if (!nonimmediate_operand (operands[0], E_TImode)
          || GET_MODE (x1) != E_TImode
          || !nonimmediate_operand (operands[1], E_TImode))
        return -1;
      return 7;

    case E_TFmode:
      if (!nonimmediate_operand (operands[0], E_TFmode)
          || GET_MODE (x1) != E_TFmode
          || !nonimmediate_operand (operands[1], E_TFmode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern189 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !memory_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern194 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (operands[1]))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!s_operand (operands[0], E_DImode)
              || GET_MODE (x1) != E_DImode
              || !immediate_operand (operands[1], E_DImode))
            return -1;
          return 0;

        case E_SImode:
          if (!s_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || !immediate_operand (operands[1], E_SImode))
            return -1;
          return 1;

        case E_HImode:
          if (!s_operand (operands[0], E_HImode)
              || GET_MODE (x1) != E_HImode
              || !immediate_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case SUBREG:
    case MEM:
      if (!memory_operand (operands[1], E_VOIDmode)
          || !memory_operand (operands[0], E_VOIDmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern214 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern213 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern213 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern225 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern234 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = XEXP (x6, 1);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  return 0;
}

int
pattern240 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !const0_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern245 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern255 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern265 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern273 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !const0_operand (operands[3], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern280 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2
      || !general_operand (operands[2], i1)
      || pattern279 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern290 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  x7 = XEXP (x3, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = PATTERN (peep2_next_insn (1));
  x9 = XVECEXP (x8, 0, 0);
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != i1
      || GET_MODE (x10) != E_BLKmode)
    return -1;
  x11 = XEXP (x9, 0);
  operands[3] = x11;
  x12 = XEXP (x10, 1);
  operands[4] = x12;
  if (!memory_operand (operands[4], E_BLKmode))
    return -1;
  x13 = XVECEXP (x8, 0, 1);
  x14 = XEXP (x13, 0);
  operands[5] = x14;
  x15 = XEXP (x10, 0);
  if (!rtx_equal_p (x15, operands[3]))
    return -1;
  return 0;
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern27 (x1))
    {
    case 0:
      if (!
#line 1560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1047; /* vec_widen_umult_even_v1qi */

    case 1:
      if (!
#line 1560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1048; /* vec_widen_umult_even_v2qi */

    case 2:
      if (!
#line 1560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1049; /* vec_widen_umult_even_v4qi */

    case 3:
      if (!
#line 1560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1050; /* vec_widen_umult_even_v8qi */

    case 4:
      if (!
#line 1560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1051; /* vec_widen_umult_even_v16qi */

    case 5:
      if (!
#line 1560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1052; /* vec_widen_umult_even_v1hi */

    case 6:
      if (!
#line 1560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1053; /* vec_widen_umult_even_v2hi */

    case 7:
      if (!
#line 1560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1054; /* vec_widen_umult_even_v4hi */

    case 8:
      if (!
#line 1560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1055; /* vec_widen_umult_even_v8hi */

    case 9:
      if (!
#line 1560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1056; /* vec_widen_umult_even_v1si */

    case 10:
      if (!
#line 1560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1057; /* vec_widen_umult_even_v2si */

    case 11:
      if (!
#line 1560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1058; /* vec_widen_umult_even_v4si */

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XINT (x3, 1))
    {
    case 60:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !memory_operand (operands[1], E_QImode)
              || !
#line 179 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 5; /* vec_insert_and_zerov16qi */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !memory_operand (operands[1], E_HImode)
              || !
#line 179 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 6; /* vec_insert_and_zerov8hi */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !memory_operand (operands[1], E_SImode)
              || !
#line 179 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 7; /* vec_insert_and_zerov4si */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !memory_operand (operands[1], E_DImode)
              || !
#line 179 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 8; /* vec_insert_and_zerov2di */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !memory_operand (operands[1], E_DFmode)
              || !
#line 179 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 9; /* vec_insert_and_zerov2df */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !memory_operand (operands[1], E_SFmode)
              || !(
#line 179 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 27 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE)))
            return -1;
          return 10; /* vec_insert_and_zerov4sf */

        default:
          return -1;
        }

    case 72:
      switch (pattern47 (x3))
        {
        case 0:
          if (!
#line 553 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 70; /* vec_extendv16qi */

        case 1:
          if (!
#line 553 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 71; /* vec_extendv8hi */

        case 2:
          if (!
#line 553 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 72; /* vec_extendv4si */

        default:
          return -1;
        }

    case 76:
      switch (pattern48 (x3))
        {
        case 0:
          if (!
#line 620 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 94; /* vec_unpackhv16qi */

        case 1:
          if (!
#line 620 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 95; /* vec_unpackhv8hi */

        case 2:
          if (!
#line 620 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 96; /* vec_unpackhv4si */

        default:
          return -1;
        }

    case 77:
      switch (pattern48 (x3))
        {
        case 0:
          if (!
#line 629 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 97; /* vec_unpackh_lv16qi */

        case 1:
          if (!
#line 629 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 98; /* vec_unpackh_lv8hi */

        case 2:
          if (!
#line 629 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 99; /* vec_unpackh_lv4si */

        default:
          return -1;
        }

    case 78:
      switch (pattern48 (x3))
        {
        case 0:
          if (!
#line 641 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 100; /* vec_unpacklv16qi */

        case 1:
          if (!
#line 641 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 101; /* vec_unpacklv8hi */

        case 2:
          if (!
#line 641 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 102; /* vec_unpacklv4si */

        default:
          return -1;
        }

    case 79:
      switch (pattern48 (x3))
        {
        case 0:
          if (!
#line 650 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 103; /* vec_unpackl_lv16qi */

        case 1:
          if (!
#line 650 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 104; /* vec_unpackl_lv8hi */

        case 2:
          if (!
#line 650 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 105; /* vec_unpackl_lv4si */

        default:
          return -1;
        }

    case 114:
      switch (pattern47 (x3))
        {
        case 0:
          if (!
#line 1508 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 296; /* vistrv16qi */

        case 1:
          if (!
#line 1508 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 297; /* vistrv8hi */

        case 2:
          if (!
#line 1508 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 298; /* vistrv4si */

        default:
          return -1;
        }

    case 125:
      if (GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[0], E_V2DFmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode)
          || !
#line 1860 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 322; /* vflls */

    case 132:
      if (GET_MODE (x3) != E_FPRX2mode
          || !register_operand (operands[0], E_FPRX2mode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!general_operand (operands[1], E_TFmode)
          || !
#line 914 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return -1;
      return 569; /* tf_to_fprx2 */

    case 37:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !register_operand (operands[1], E_V16QImode))
            return -1;
          if (
#line 1266 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return 806; /* popcountv16qi2_vxe */
          if (!
#line 1274 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE))
            return -1;
          return 810; /* popcountv16qi2_vx */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 1266 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 807; /* popcountv8hi2_vxe */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 1266 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 808; /* popcountv4si2_vxe */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 1266 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 809; /* popcountv2di2_vxe */

        case E_DImode:
          if (pattern103 (x3, pnum_clobbers, 
E_DImode) != 0
              || !(
#line 11843 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 702 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2293; /* *popcountdi_z196 */

        case E_SImode:
          if (pattern103 (x3, pnum_clobbers, 
E_SImode) != 0
              || !
#line 11843 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          *pnum_clobbers = 1;
          return 2294; /* *popcountsi_z196 */

        case E_HImode:
          if (pattern103 (x3, pnum_clobbers, 
E_HImode) != 0
              || !
#line 11843 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          *pnum_clobbers = 1;
          return 2295; /* *popcounthi_z196 */

        case E_QImode:
          if (pattern103 (x3, pnum_clobbers, 
E_QImode) != 0
              || !
#line 11843 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          *pnum_clobbers = 1;
          return 2296; /* *popcountqi_z196 */

        default:
          return -1;
        }

    case 38:
      switch (pattern49 (x3))
        {
        case 0:
          if (!(
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1383; /* floorv4sf2 */

        case 1:
          if (!
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1388; /* floorv2df2 */

        case 2:
          if (!(
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1393; /* floorv1tf2 */

        case 3:
          if ((
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1398; /* floortf2_vr */
          if (!(
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 1764; /* floortf2_fpr */

        case 4:
          if (!(
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 1769; /* floorfprx22 */

        case 5:
          if (!
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 1774; /* floordf2 */

        case 6:
          if (!
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 1779; /* floorsf2 */

        case 7:
          if (!
#line 5637 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 1788; /* floortd2 */

        case 8:
          if (!
#line 5637 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 1793; /* floordd2 */

        default:
          return -1;
        }

    case 39:
      switch (pattern49 (x3))
        {
        case 0:
          if (!(
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1384; /* btruncv4sf2 */

        case 1:
          if (!
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1389; /* btruncv2df2 */

        case 2:
          if (!(
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1394; /* btruncv1tf2 */

        case 3:
          if ((
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1399; /* btrunctf2_vr */
          if (!(
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 1765; /* btrunctf2_fpr */

        case 4:
          if (!(
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 1770; /* btruncfprx22 */

        case 5:
          if (!
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 1775; /* btruncdf2 */

        case 6:
          if (!
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 1780; /* btruncsf2 */

        case 7:
          if (!
#line 5637 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 1789; /* btrunctd2 */

        case 8:
          if (!
#line 5637 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 1794; /* btruncdd2 */

        default:
          return -1;
        }

    case 40:
      switch (pattern49 (x3))
        {
        case 0:
          if (!(
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1385; /* roundv4sf2 */

        case 1:
          if (!
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1390; /* roundv2df2 */

        case 2:
          if (!(
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1395; /* roundv1tf2 */

        case 3:
          if ((
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1400; /* roundtf2_vr */
          if (!(
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 1766; /* roundtf2_fpr */

        case 4:
          if (!(
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 1771; /* roundfprx22 */

        case 5:
          if (!
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 1776; /* rounddf2 */

        case 6:
          if (!
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 1781; /* roundsf2 */

        case 7:
          if (!
#line 5637 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 1790; /* roundtd2 */

        case 8:
          if (!
#line 5637 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 1795; /* rounddd2 */

        default:
          return -1;
        }

    case 41:
      switch (pattern49 (x3))
        {
        case 0:
          if (!(
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1386; /* ceilv4sf2 */

        case 1:
          if (!
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1391; /* ceilv2df2 */

        case 2:
          if (!(
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1396; /* ceilv1tf2 */

        case 3:
          if ((
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1401; /* ceiltf2_vr */
          if (!(
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 1767; /* ceiltf2_fpr */

        case 4:
          if (!(
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 1772; /* ceilfprx22 */

        case 5:
          if (!
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 1777; /* ceildf2 */

        case 6:
          if (!
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 1782; /* ceilsf2 */

        case 7:
          if (!
#line 5637 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 1791; /* ceiltd2 */

        case 8:
          if (!
#line 5637 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 1796; /* ceildd2 */

        default:
          return -1;
        }

    case 42:
      switch (pattern49 (x3))
        {
        case 0:
          if (!(
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1387; /* nearbyintv4sf2 */

        case 1:
          if (!
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1392; /* nearbyintv2df2 */

        case 2:
          if (!(
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1397; /* nearbyintv1tf2 */

        case 3:
          if ((
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1402; /* nearbyinttf2_vr */
          if (!(
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 1768; /* nearbyinttf2_fpr */

        case 4:
          if (!(
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 1773; /* nearbyintfprx22 */

        case 5:
          if (!
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 1778; /* nearbyintdf2 */

        case 6:
          if (!
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 1783; /* nearbyintsf2 */

        case 7:
          if (!
#line 5637 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 1792; /* nearbyinttd2 */

        case 8:
          if (!
#line 5637 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 1797; /* nearbyintdd2 */

        default:
          return -1;
        }

    case 43:
      switch (pattern49 (x3))
        {
        case 0:
          if (!(
#line 2915 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1403; /* rintv4sf2 */

        case 1:
          if (!
#line 2915 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1404; /* rintv2df2 */

        case 2:
          if (!(
#line 2915 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1405; /* rintv1tf2 */

        case 3:
          if ((
#line 2915 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1406; /* rinttf2_vr */
          if (!
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE))
            return -1;
          return 1784; /* rinttf2_fpr */

        case 4:
          if (!
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE))
            return -1;
          return 1785; /* rintfprx22 */

        case 5:
          return 1786; /* rintdf2 */

        case 6:
          return 1787; /* rintsf2 */

        case 7:
          if (!
#line 5647 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 1798; /* rinttd2 */

        case 8:
          if (!
#line 5647 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 1799; /* rintdd2 */

        default:
          return -1;
        }

    case 30:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (pattern80 (x3))
        {
        case 0:
          return 1502; /* *get_tp_31 */

        case 1:
          if (!
#line 1976 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 1503; /* *get_tp_64 */

        default:
          return -1;
        }

    case 5:
      if (GET_MODE (x3) != E_SImode
          || !nonimmediate_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_VOIDmode))
        return -1;
      return 1552; /* *cc_to_int */

    case 4:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_CCUmode))
        return -1;
      *pnum_clobbers = 1;
      return 1573; /* cmpint */

    case 20:
      if (GET_MODE (x3) != E_BLKmode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      return 2242; /* mem_thread_fence_1 */

    case 21:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (GET_MODE (x3) != E_DImode)
            return -1;
          if (register_operand (operands[0], E_DImode)
              && memory_operand (operands[1], E_DImode)
              && 
#line 10955 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return 2243; /* atomic_loaddi_1 */
          if (!memory_operand (operands[0], E_DImode)
              || !register_operand (operands[1], E_DImode)
              || !
#line 11002 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          return 2245; /* atomic_storedi_1 */

        case E_TImode:
          if (GET_MODE (x3) != E_TImode)
            return -1;
          if (register_operand (operands[0], E_TImode)
              && memory_operand (operands[1], E_TImode)
              && 
#line 10969 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return 2244; /* atomic_loadti_1 */
          if (!memory_operand (operands[0], E_TImode)
              || !register_operand (operands[1], E_TImode)
              || !
#line 11016 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2246; /* atomic_storeti_1 */

        default:
          return -1;
        }

    case 15:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x4) != LABEL_REF
          || !register_operand (operands[0], E_VOIDmode))
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!
#line 11467 "../../gcc/config/s390/s390.md"
(GET_MODE (operands[0]) == Pmode))
        return -1;
      return 2269; /* main_base_64 */

    case 14:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x4) != LABEL_REF
          || !register_operand (operands[0], E_VOIDmode))
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!
#line 11487 "../../gcc/config/s390/s390.md"
(GET_MODE (operands[0]) == Pmode))
        return -1;
      return 2271; /* reload_base_64 */

    case 33:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!memory_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !memory_operand (operands[1], E_DImode))
            return -1;
          return 2279; /* stack_protect_setdi */

        case E_SImode:
          if (!memory_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !memory_operand (operands[1], E_SImode))
            return -1;
          return 2280; /* stack_protect_setsi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern3 (x3, 
E_V1QImode) != 0
              || !
#line 1129 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 608; /* mulv1qi3 */

        case E_V2QImode:
          if (pattern3 (x3, 
E_V2QImode) != 0
              || !
#line 1129 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 609; /* mulv2qi3 */

        case E_V4QImode:
          if (pattern3 (x3, 
E_V4QImode) != 0
              || !
#line 1129 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 610; /* mulv4qi3 */

        case E_V8QImode:
          if (pattern3 (x3, 
E_V8QImode) != 0
              || !
#line 1129 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 611; /* mulv8qi3 */

        case E_V16QImode:
          if (pattern3 (x3, 
E_V16QImode) != 0
              || !
#line 1129 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 612; /* mulv16qi3 */

        case E_V1HImode:
          if (pattern3 (x3, 
E_V1HImode) != 0
              || !
#line 1129 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 613; /* mulv1hi3 */

        case E_V2HImode:
          if (pattern3 (x3, 
E_V2HImode) != 0
              || !
#line 1129 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 614; /* mulv2hi3 */

        case E_V4HImode:
          if (pattern3 (x3, 
E_V4HImode) != 0
              || !
#line 1129 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 615; /* mulv4hi3 */

        case E_V8HImode:
          if (pattern3 (x3, 
E_V8HImode) != 0
              || !
#line 1129 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 616; /* mulv8hi3 */

        case E_V1SImode:
          if (pattern3 (x3, 
E_V1SImode) != 0
              || !
#line 1129 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 617; /* mulv1si3 */

        case E_V2SImode:
          if (pattern3 (x3, 
E_V2SImode) != 0
              || !
#line 1129 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 618; /* mulv2si3 */

        case E_V4SImode:
          if (pattern3 (x3, 
E_V4SImode) != 0
              || !
#line 1129 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 619; /* mulv4si3 */

        case E_V4SFmode:
          if (pattern3 (x3, 
E_V4SFmode) != 0
              || !(
#line 1718 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1091; /* mulv4sf3 */

        case E_V2DFmode:
          if (pattern3 (x3, 
E_V2DFmode) != 0
              || !
#line 1718 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1092; /* mulv2df3 */

        case E_V1TFmode:
          if (pattern3 (x3, 
E_V1TFmode) != 0
              || !(
#line 1718 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1093; /* mulv1tf3 */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode)
            return -1;
          if (register_operand (operands[1], E_TFmode)
              && register_operand (operands[2], E_TFmode)
              && (
#line 1718 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1094; /* multf3_vr */
          if (!nonimmediate_operand (operands[1], E_TFmode)
              || !general_operand (operands[2], E_TFmode)
              || !(
#line 7348 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 1977; /* multf3_fpr */

        case E_FPRX2mode:
          if (pattern174 (x3, 
E_FPRX2mode) != 0
              || !(
#line 7348 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 1978; /* mulfprx23 */

        case E_DFmode:
          if (pattern174 (x3, 
E_DFmode) != 0
              || !
#line 7348 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 1979; /* muldf3 */

        case E_SFmode:
          if (pattern174 (x3, 
E_SFmode) != 0
              || !
#line 7348 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 1980; /* mulsf3 */

        case E_TDmode:
          if (pattern174 (x3, 
E_TDmode) != 0
              || !(
#line 7348 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1981; /* multd3 */

        case E_DDmode:
          if (pattern174 (x3, 
E_DDmode) != 0
              || !(
#line 7348 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1982; /* muldd3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x4) != E_TImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != SIGN_EXTEND
          || GET_MODE (x5) != E_TImode
          || !register_operand (operands[0], E_TImode)
          || GET_MODE (x3) != E_TImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (nonimmediate_operand (operands[2], E_DImode)
          && register_operand (operands[1], E_DImode)
          && 
#line 7201 "../../gcc/config/s390/s390.md"
(TARGET_Z14))
        return 1967; /* mulditi3 */
      if (!register_operand (operands[2], E_DImode)
          || !nonimmediate_operand (operands[1], E_DImode)
          || !
#line 7214 "../../gcc/config/s390/s390.md"
(TARGET_Z14))
        return -1;
      return 1968; /* mulditi3_2 */

    case ZERO_EXTEND:
      if (pattern110 (x3, 
E_DImode, 
E_TImode) != 0
          || !
#line 689 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 1975; /* umulditi3 */

    default:
      return -1;
    }
}

 int
recog_53 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern33 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 620; /* negv1qi2 */

        case 1:
          if (!
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 621; /* negv2qi2 */

        case 2:
          if (!
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 622; /* negv4qi2 */

        case 3:
          if (!
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 623; /* negv8qi2 */

        case 4:
          if (!
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 624; /* negv16qi2 */

        case 5:
          if (!
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 625; /* negv1hi2 */

        case 6:
          if (!
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 626; /* negv2hi2 */

        case 7:
          if (!
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 627; /* negv4hi2 */

        case 8:
          if (!
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 628; /* negv8hi2 */

        case 9:
          if (!
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 629; /* negv1si2 */

        case 10:
          if (!
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 630; /* negv2si2 */

        case 11:
          if (!
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 631; /* negv4si2 */

        case 12:
          if (!
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 632; /* negv1di2 */

        case 13:
          if (!
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 633; /* negv2di2 */

        case 14:
          if (!(
#line 1805 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1119; /* negv1sf2 */

        case 15:
          if (!(
#line 1805 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1120; /* negv2sf2 */

        case 16:
          if (!(
#line 1805 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1121; /* negv4sf2 */

        case 17:
          if (!
#line 1805 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1122; /* negv1df2 */

        case 18:
          if (!
#line 1805 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1123; /* negv2df2 */

        case 19:
          if (!(
#line 1805 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 61 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1124; /* negv1tf2 */

        case 20:
          if ((
#line 1805 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 61 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1125; /* negtf2_vr */
          if ((
#line 9024 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return 2091; /* *negtf2_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 9036 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2097; /* *negtf2 */

        case 21:
          if (
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            {
              *pnum_clobbers = 1;
              return 2080; /* *negdi2 */
            }
          if (!
#line 8913 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2082; /* *negdi2_31 */

        case 22:
          *pnum_clobbers = 1;
          return 2081; /* *negsi2 */

        case 23:
          if ((
#line 9024 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return 2092; /* *negfprx22_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 9036 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2098; /* *negfprx22 */

        case 24:
          if (
#line 9024 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
            return 2093; /* *negdf2_nocc */
          if (pnum_clobbers == NULL
              || !
#line 9036 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2099; /* *negdf2 */

        case 25:
          if (
#line 9024 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
            return 2094; /* *negsf2_nocc */
          if (pnum_clobbers == NULL
              || !
#line 9036 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2100; /* *negsf2 */

        case 26:
          if (!(
#line 9024 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2095; /* *negtd2_nocc */

        case 27:
          if (!(
#line 9024 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2096; /* *negdd2_nocc */

        default:
          return -1;
        }

    case FMA:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x4, 2);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern155 (x3, 
E_V4SFmode) != 0
                  || !(
#line 1786 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V4SFmode)) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1111; /* neg_fmav4sf4 */

            case E_V2DFmode:
              if (pattern155 (x3, 
E_V2DFmode) != 0
                  || !
#line 1786 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V2DFmode)))
                return -1;
              return 1112; /* neg_fmav2df4 */

            case E_V1TFmode:
              if (pattern155 (x3, 
E_V1TFmode) != 0
                  || !(
#line 1786 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V1TFmode)) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1113; /* neg_fmav1tf4 */

            case E_TFmode:
              if (pattern155 (x3, 
E_TFmode) != 0
                  || !(
#line 1786 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (TFmode)) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1114; /* neg_fmatf4 */

            default:
              return -1;
            }

        case NEG:
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern156 (x3, 
E_V4SFmode) != 0
                  || !(
#line 1797 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V4SFmode)) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1115; /* neg_fmsv4sf4 */

            case E_V2DFmode:
              if (pattern156 (x3, 
E_V2DFmode) != 0
                  || !
#line 1797 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V2DFmode)))
                return -1;
              return 1116; /* neg_fmsv2df4 */

            case E_V1TFmode:
              if (pattern156 (x3, 
E_V1TFmode) != 0
                  || !(
#line 1797 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V1TFmode)) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1117; /* neg_fmsv1tf4 */

            case E_TFmode:
              if (pattern156 (x3, 
E_TFmode) != 0
                  || !(
#line 1797 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (TFmode)) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1118; /* neg_fmstf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ABS:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V1SFmode:
              if (pattern108 (x3, 
E_V1SFmode) != 0
                  || !(
#line 1833 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1133; /* negabsv1sf2 */

            case E_V2SFmode:
              if (pattern108 (x3, 
E_V2SFmode) != 0
                  || !(
#line 1833 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1134; /* negabsv2sf2 */

            case E_V4SFmode:
              if (pattern108 (x3, 
E_V4SFmode) != 0
                  || !(
#line 1833 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1135; /* negabsv4sf2 */

            case E_V1DFmode:
              if (pattern108 (x3, 
E_V1DFmode) != 0
                  || !
#line 1833 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1136; /* negabsv1df2 */

            case E_V2DFmode:
              if (pattern108 (x3, 
E_V2DFmode) != 0
                  || !
#line 1833 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1137; /* negabsv2df2 */

            case E_V1TFmode:
              if (pattern108 (x3, 
E_V1TFmode) != 0
                  || !(
#line 1833 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 61 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1138; /* negabsv1tf2 */

            case E_TFmode:
              if (pattern108 (x3, 
E_TFmode) != 0)
                return -1;
              if ((
#line 1833 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 61 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1139; /* negabstf2 */
              if ((
#line 9265 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return 2143; /* *negabstf2_nocc */
              if (pnum_clobbers == NULL
                  || !(
#line 9276 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2149; /* *negabstf2 */

            case E_DImode:
              if (pnum_clobbers == NULL
                  || pattern108 (x3, 
E_DImode) != 0
                  || !
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2133; /* *negabsdi2 */

            case E_SImode:
              if (pnum_clobbers == NULL
                  || pattern108 (x3, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 2134; /* *negabssi2 */

            case E_FPRX2mode:
              if (pattern108 (x3, 
E_FPRX2mode) != 0)
                return -1;
              if ((
#line 9265 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return 2144; /* *negabsfprx22_nocc */
              if (pnum_clobbers == NULL
                  || !(
#line 9276 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2150; /* *negabsfprx22 */

            case E_DFmode:
              if (pattern108 (x3, 
E_DFmode) != 0)
                return -1;
              if (
#line 9265 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
                return 2145; /* *negabsdf2_nocc */
              if (pnum_clobbers == NULL
                  || !
#line 9276 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2151; /* *negabsdf2 */

            case E_SFmode:
              if (pattern108 (x3, 
E_SFmode) != 0)
                return -1;
              if (
#line 9265 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
                return 2146; /* *negabssf2_nocc */
              if (pnum_clobbers == NULL
                  || !
#line 9276 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2152; /* *negabssf2 */

            case E_TDmode:
              if (pattern108 (x3, 
E_TDmode) != 0
                  || !(
#line 9265 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 2147; /* *negabstd2_nocc */

            case E_DDmode:
              if (pattern108 (x3, 
E_DDmode) != 0
                  || !(
#line 9265 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 2148; /* *negabsdd2_nocc */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pnum_clobbers == NULL
              || GET_MODE (x5) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x9 = XEXP (x5, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 9196 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2128; /* *negabsdi2_sign */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pnum_clobbers == NULL
          || pattern66 (x3, 
E_SImode) != 0
          || !
#line 8871 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2075; /* *negdi2_sign */

    default:
      return -1;
    }
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 2805 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1377; /* floatunsv2div2df2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SImode)
          || !(
#line 2805 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 84 "../../gcc/config/s390/vector.md"
(TARGET_VXE2)))
        return -1;
      return 1378; /* floatunsv4siv4sf2 */

    case E_DFmode:
      switch (pattern67 (x3, 
E_DFmode))
        {
        case 0:
          if (
#line 5439 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
            return 1734; /* *floatunsdidf2_z13 */
          if (!(
#line 5451 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || DFmode != DFmode || DImode != DImode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1740; /* *floatunsdidf2 */

        case 1:
          if (!
#line 5451 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || DFmode != DFmode || SImode != DImode)))
            return -1;
          return 1741; /* *floatunssidf2 */

        default:
          return -1;
        }

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          if ((
#line 5439 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT) && 
#line 674 "../../gcc/config/s390/s390.md"
(TARGET_VXE2)))
            return 1735; /* *floatunssisf2_z13 */
          if (!
#line 5451 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || SFmode != DFmode || SImode != DImode)))
            return -1;
          return 1743; /* *floatunssisf2 */

        case E_DImode:
          if (!register_operand (operands[1], E_DImode)
              || !(
#line 5451 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || SFmode != DFmode || DImode != DImode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1742; /* *floatunsdisf2 */

        default:
          return -1;
        }

    case E_TFmode:
      switch (pattern67 (x3, 
E_TFmode))
        {
        case 0:
          if (!(
#line 5451 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || TFmode != DFmode || DImode != DImode)) && (
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 1736; /* *floatunsditf2 */

        case 1:
          if (!(
#line 5451 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || TFmode != DFmode || SImode != DImode)) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 1737; /* *floatunssitf2 */

        default:
          return -1;
        }

    case E_FPRX2mode:
      switch (pattern67 (x3, 
E_FPRX2mode))
        {
        case 0:
          if (!(
#line 5451 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || FPRX2mode != DFmode || DImode != DImode)) && (
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 1738; /* *floatunsdifprx22 */

        case 1:
          if (!(
#line 5451 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || FPRX2mode != DFmode || SImode != DImode)) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 1739; /* *floatunssifprx22 */

        default:
          return -1;
        }

    case E_TDmode:
      switch (pattern67 (x3, 
E_TDmode))
        {
        case 0:
          if (!(
#line 5451 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || TDmode != DFmode || DImode != DImode)) && (
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 1744; /* *floatunsditd2 */

        case 1:
          if (!(
#line 5451 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || TDmode != DFmode || SImode != DImode)) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1745; /* *floatunssitd2 */

        default:
          return -1;
        }

    case E_DDmode:
      switch (pattern67 (x3, 
E_DDmode))
        {
        case 0:
          if (!(
#line 5451 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || DDmode != DFmode || DImode != DImode)) && (
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 1746; /* *floatunsdidd2 */

        case 1:
          if (!(
#line 5451 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || DDmode != DFmode || SImode != DImode)) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1747; /* *floatunssidd2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_78 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_MODE (x4) != E_DImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (!general_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x4, 1);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case SET:
          x10 = XEXP (x9, 1);
          if (pattern251 (x10, 
ZERO_EXTEND, 
PLUS) != 0)
            return -1;
          x11 = XEXP (x9, 0);
          operands[0] = x11;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x12 = XEXP (x10, 0);
          x13 = XEXP (x12, 0);
          if (!rtx_equal_p (x13, operands[2]))
            return -1;
          x14 = XEXP (x10, 1);
          if (!rtx_equal_p (x14, operands[1])
              || !
#line 5894 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
            return -1;
          return 1850; /* *adddi3_zero_cc */

        case CLOBBER:
          x11 = XEXP (x9, 0);
          operands[0] = x11;
          if (!scratch_operand (operands[0], E_DImode)
              || !
#line 5907 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
            return -1;
          return 1851; /* *adddi3_zero_cconly */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case SET:
          res = recog_74 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case CLOBBER:
          x11 = XEXP (x9, 0);
          operands[0] = x11;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (nonimmediate_operand (operands[1], E_DImode)
                  && general_operand (operands[2], E_DImode)
                  && scratch_operand (operands[0], E_DImode))
                {
                  x6 = XEXP (x3, 1);
                  if (rtx_equal_p (x6, operands[1])
                      && (
#line 6033 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 1859; /* *adddi3_carry1_cconly */
                  if (rtx_equal_p (x6, operands[2])
                      && (
#line 6073 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 1863; /* *adddi3_carry2_cconly */
                }
              break;

            case E_SImode:
              if (nonimmediate_operand (operands[1], E_SImode)
                  && general_operand (operands[2], E_SImode)
                  && scratch_operand (operands[0], E_SImode))
                {
                  x6 = XEXP (x3, 1);
                  if (rtx_equal_p (x6, operands[1])
                      && 
#line 6033 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                    return 1860; /* *addsi3_carry1_cconly */
                  if (rtx_equal_p (x6, operands[2])
                      && 
#line 6073 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                    return 1864; /* *addsi3_carry2_cconly */
                }
              break;

            case E_TFmode:
              x6 = XEXP (x3, 1);
              if (pattern223 (x6, 
E_TFmode) == 0
                  && (
#line 6294 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return 1890; /* *addtf3_cconly */
              break;

            case E_FPRX2mode:
              x6 = XEXP (x3, 1);
              if (pattern223 (x6, 
E_FPRX2mode) == 0
                  && (
#line 6294 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return 1891; /* *addfprx23_cconly */
              break;

            case E_DFmode:
              x6 = XEXP (x3, 1);
              if (pattern223 (x6, 
E_DFmode) == 0
                  && 
#line 6294 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return 1892; /* *adddf3_cconly */
              break;

            case E_SFmode:
              x6 = XEXP (x3, 1);
              if (pattern223 (x6, 
E_SFmode) == 0
                  && 
#line 6294 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return 1893; /* *addsf3_cconly */
              break;

            case E_TDmode:
              x6 = XEXP (x3, 1);
              if (pattern223 (x6, 
E_TDmode) == 0
                  && (
#line 6294 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return 1894; /* *addtd3_cconly */
              break;

            case E_DDmode:
              x6 = XEXP (x3, 1);
              if (pattern223 (x6, 
E_DDmode) == 0
                  && (
#line 6294 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return 1895; /* *adddd3_cconly */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (GET_CODE (x9))
        {
        case SET:
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != PLUS)
            return -1;
          x11 = XEXP (x9, 0);
          operands[0] = x11;
          x12 = XEXP (x10, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          x14 = XEXP (x10, 1);
          if (!rtx_equal_p (x14, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (!nonimmediate_operand (operands[1], E_DImode)
                  || !nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x10) != E_DImode)
                return -1;
              if (general_operand (operands[2], E_DImode)
                  && (
#line 6091 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 1865; /* *adddi3_cc */
              if (!const_int_operand (operands[2], E_DImode)
                  || !(
#line 6147 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)
   && (CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'K', "K")
       || (CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'O', "Os")
           /* Avoid INT32_MIN on 32 bit.  */
           && (!TARGET_ZARCH || INTVAL (operands[2]) != -0x7fffffff - 1)))) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 1871; /* *adddi3_imm_cc */

            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !nonimmediate_operand (operands[0], E_SImode)
                  || GET_MODE (x10) != E_SImode)
                return -1;
              if (general_operand (operands[2], E_SImode)
                  && 
#line 6091 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                return 1866; /* *addsi3_cc */
              if (!const_int_operand (operands[2], E_SImode)
                  || !
#line 6147 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)
   && (CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'K', "K")
       || (CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'O', "Os")
           /* Avoid INT32_MIN on 32 bit.  */
           && (!TARGET_ZARCH || INTVAL (operands[2]) != -0x7fffffff - 1)))))
                return -1;
              return 1872; /* *addsi3_imm_cc */

            default:
              return -1;
            }

        case CLOBBER:
          switch (pattern146 (x1))
            {
            case 0:
              if (!(
#line 6113 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 1867; /* *adddi3_cconly */

            case 1:
              if (!
#line 6113 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                return -1;
              return 1868; /* *addsi3_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != SIGN_EXTEND)
        return -1;
      x15 = XEXP (x6, 0);
      if (GET_CODE (x15) != PLUS)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PLUS)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x11 = XEXP (x9, 0);
      operands[0] = x11;
      x16 = XEXP (x15, 0);
      if (!rtx_equal_p (x16, operands[1]))
        return -1;
      x12 = XEXP (x10, 0);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      x8 = XEXP (x4, 1);
      switch (GET_CODE (x8))
        {
        case SIGN_EXTEND:
          x17 = XEXP (x8, 0);
          operands[2] = x17;
          x18 = XEXP (x15, 1);
          if (!rtx_equal_p (x18, operands[2]))
            return -1;
          x14 = XEXP (x10, 1);
          if (!rtx_equal_p (x14, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_TImode:
              if (pattern280 (x1, 
E_DImode, 
E_TImode) != 0
                  || !(
#line 6214 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 1874; /* *addvdi3_ccoverflow */

            case E_DImode:
              if (pattern280 (x1, 
E_SImode, 
E_DImode) != 0
                  || !
#line 6214 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)))
                return -1;
              return 1875; /* *addvsi3_ccoverflow */

            default:
              return -1;
            }

        case CONST_INT:
          operands[2] = x8;
          x18 = XEXP (x15, 1);
          if (!rtx_equal_p (x18, operands[2]))
            return -1;
          x14 = XEXP (x10, 1);
          if (!rtx_equal_p (x14, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_TImode:
              if (pattern281 (x1, 
E_DImode, 
E_TImode) != 0
                  || !(
#line 6237 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 1876; /* *addvdi3_ccoverflow_const */

            case E_DImode:
              if (pattern281 (x1, 
E_SImode, 
E_DImode) != 0
                  || !
#line 6237 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)))
                return -1;
              return 1877; /* *addvsi3_ccoverflow_const */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      x7 = XEXP (x5, 0);
      operands[3] = x7;
      x19 = XEXP (x5, 1);
      operands[1] = x19;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case SET:
          res = recog_75 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case CLOBBER:
          x11 = XEXP (x9, 0);
          operands[0] = x11;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern235 (x5, 
E_DImode) == 0)
                {
                  x6 = XEXP (x3, 1);
                  if (rtx_equal_p (x6, operands[1])
                      && (
#line 6809 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 1940; /* *adddi3_alc_carry1_cconly */
                  if (rtx_equal_p (x6, operands[2])
                      && (
#line 6843 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 1944; /* *adddi3_alc_carry2_cconly */
                }
              break;

            case E_SImode:
              if (pattern235 (x5, 
E_SImode) == 0)
                {
                  x6 = XEXP (x3, 1);
                  if (rtx_equal_p (x6, operands[1])
                      && 
#line 6809 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                    return 1941; /* *addsi3_alc_carry1_cconly */
                  if (rtx_equal_p (x6, operands[2])
                      && 
#line 6843 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                    return 1945; /* *addsi3_alc_carry2_cconly */
                }
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_CODE (x9) != SET
          || pattern211 (x9) != 0)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_DImode:
          if (pattern274 (x1, 
E_DImode) != 0
              || !(
#line 6859 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1946; /* *adddi3_alc_cc */

        case E_SImode:
          if (pattern274 (x1, 
E_SImode) != 0
              || !
#line 6859 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
            return -1;
          return 1947; /* *addsi3_alc_cc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_103 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_VOIDmode))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 1)
    return -1;
  switch (GET_MODE (x3))
    {
    case E_DImode:
      if (!(
#line 10772 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode) && 
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        return -1;
      return 2234; /* *basr_r_via_thunk */

    case E_SImode:
      if (!(
#line 10772 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode) && 
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      return 2235; /* *basr_r_via_thunk */

    default:
      return -1;
    }
}

 int
recog_106 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case CLOBBER:
      x3 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x3))
        {
        case CLOBBER:
          x4 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x4) != SET)
            return -1;
          x5 = XEXP (x4, 1);
          if (GET_CODE (x5) != COMPARE
              || GET_MODE (x5) != E_CCUmode)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != MEM
              || GET_MODE (x6) != E_BLKmode)
            return -1;
          x7 = XEXP (x5, 1);
          if (GET_CODE (x7) != MEM
              || GET_MODE (x7) != E_BLKmode)
            return -1;
          x8 = XEXP (x4, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 33
              || GET_MODE (x8) != E_CCUmode)
            return -1;
          x9 = XVECEXP (x1, 0, 3);
          if (pattern96 (x9, 
E_SImode, 
0, 
USE) != 0)
            return -1;
          x10 = XEXP (x2, 0);
          operands[0] = x10;
          x11 = XEXP (x3, 0);
          operands[1] = x11;
          x12 = XEXP (x6, 0);
          operands[2] = x12;
          x13 = XEXP (x7, 0);
          operands[3] = x13;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern289 (
E_DImode) != 0
                  || !
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              return 1542; /* *cmpstrdi */

            case E_SImode:
              if (pattern289 (
E_SImode) != 0
                  || !
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              return 1543; /* *cmpstrsi */

            default:
              return -1;
            }

        case SET:
          x11 = XEXP (x3, 0);
          if (GET_CODE (x11) != MEM
              || GET_MODE (x11) != E_BLKmode)
            return -1;
          x9 = XVECEXP (x1, 0, 3);
          if (pattern96 (x9, 
E_CCmode, 
33, 
CLOBBER) != 0)
            return -1;
          switch (pattern123 (x1))
            {
            case 0:
              if (!
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              return 1544; /* *movstr */

            case 1:
              if (!
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              return 1545; /* *movstr */

            case 2:
              if (!(
#line 3753 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1562; /* *setmem_long */

            case 3:
              if (!(
#line 3753 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1563; /* *setmem_long */

            case 4:
              if (!
#line 3781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
                return -1;
              return 1566; /* *setmem_long_31z */

            case 5:
              if (!(
#line 3766 "../../gcc/config/s390/s390.md"
((TARGET_64BIT || !TARGET_ZARCH)) && 
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1564; /* *setmem_long_and */

            case 6:
              if (!(
#line 3766 "../../gcc/config/s390/s390.md"
((TARGET_64BIT || !TARGET_ZARCH)) && 
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1565; /* *setmem_long_and */

            case 7:
              if (!
#line 3793 "../../gcc/config/s390/s390.md"
((!TARGET_64BIT && TARGET_ZARCH)))
                return -1;
              return 1567; /* *setmem_long_and_31z */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      x9 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x9) != CLOBBER)
        return -1;
      x14 = XEXP (x2, 1);
      switch (GET_CODE (x14))
        {
        case SUBREG:
        case MEM:
          if (pattern74 (x1) != 0)
            return -1;
          switch (pattern193 (x1))
            {
            case 0:
              if (!(
#line 3392 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1546; /* *cpymem_short */

            case 1:
              if (!(
#line 3392 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1547; /* *cpymem_short */

            default:
              return -1;
            }

        case COMPARE:
          if (pattern73 (x1) != 0)
            return -1;
          switch (pattern193 (x1))
            {
            case 0:
              if (!(
#line 3838 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1568; /* *cmpmem_short */

            case 1:
              if (!(
#line 3838 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1569; /* *cmpmem_short */

            default:
              return -1;
            }

        case FLOAT_TRUNCATE:
          switch (pattern75 (x1))
            {
            case 0:
              if (!(
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 1800; /* *trunctftd2 */

            case 1:
              if (!(
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 1801; /* *truncfprx2td2 */

            case 2:
              if (!
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1802; /* *truncdftd2 */

            case 3:
              if (!
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1803; /* *truncsftd2 */

            case 4:
              if (!(
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 1804; /* *trunctfdd2 */

            case 5:
              if (!(
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 1805; /* *truncfprx2dd2 */

            case 6:
              if (!
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1806; /* *truncdfdd2 */

            case 7:
              if (!
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1807; /* *truncsfdd2 */

            case 8:
              if (!(
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 1808; /* *trunctfsd2 */

            case 9:
              if (!(
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 1809; /* *truncfprx2sd2 */

            case 10:
              if (!
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1810; /* *truncdfsd2 */

            case 11:
              if (!
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1811; /* *truncsfsd2 */

            case 12:
              if (!(
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 1812; /* *trunctdtf2 */

            case 13:
              if (!(
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 1816; /* *truncddtf2 */

            case 14:
              if (!(
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 1820; /* *truncsdtf2 */

            case 15:
              if (!(
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 1813; /* *trunctdfprx22 */

            case 16:
              if (!(
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 1817; /* *truncddfprx22 */

            case 17:
              if (!(
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 1821; /* *truncsdfprx22 */

            case 18:
              if (!
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1814; /* *trunctddf2 */

            case 19:
              if (!
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1818; /* *truncdddf2 */

            case 20:
              if (!
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1822; /* *truncsddf2 */

            case 21:
              if (!
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1815; /* *trunctdsf2 */

            case 22:
              if (!
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1819; /* *truncddsf2 */

            case 23:
              if (!
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1823; /* *truncsdsf2 */

            default:
              return -1;
            }

        case FLOAT_EXTEND:
          switch (pattern75 (x1))
            {
            case 0:
              if (!(
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 1824; /* *extendtftd2 */

            case 1:
              if (!(
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 1825; /* *extendfprx2td2 */

            case 2:
              if (!
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1826; /* *extenddftd2 */

            case 3:
              if (!
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1827; /* *extendsftd2 */

            case 4:
              if (!(
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 1828; /* *extendtfdd2 */

            case 5:
              if (!(
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 1829; /* *extendfprx2dd2 */

            case 6:
              if (!
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1830; /* *extenddfdd2 */

            case 7:
              if (!
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1831; /* *extendsfdd2 */

            case 8:
              if (!(
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 1832; /* *extendtfsd2 */

            case 9:
              if (!(
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 1833; /* *extendfprx2sd2 */

            case 10:
              if (!
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1834; /* *extenddfsd2 */

            case 11:
              if (!
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1835; /* *extendsfsd2 */

            case 12:
              if (!(
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 1836; /* *extendtdtf2 */

            case 13:
              if (!(
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 1840; /* *extendddtf2 */

            case 14:
              if (!(
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 1844; /* *extendsdtf2 */

            case 15:
              if (!(
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 1837; /* *extendtdfprx22 */

            case 16:
              if (!(
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 1841; /* *extendddfprx22 */

            case 17:
              if (!(
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 1845; /* *extendsdfprx22 */

            case 18:
              if (!
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1838; /* *extendtddf2 */

            case 19:
              if (!
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1842; /* *extenddddf2 */

            case 20:
              if (!
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1846; /* *extendsddf2 */

            case 21:
              if (!
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1839; /* *extendtdsf2 */

            case 22:
              if (!
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1843; /* *extendddsf2 */

            case 23:
              if (!
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1847; /* *extendsdsf2 */

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          switch (pattern78 (x1))
            {
            case 0:
              if (!
#line 9794 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2191; /* *brxg_64bit */

            case 1:
              if (!
#line 9880 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                return -1;
              return 2193; /* *brx_31bit */

            case 2:
              if (!
#line 9837 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2192; /* *brx_64bit */

            case 3:
              return 2194; /* doloop_si64 */

            case 4:
              if (!
#line 9978 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2195; /* doloop_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 1);
      switch (GET_CODE (x2))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x2;
          res = split_1 (x1, insn);
          if (res != NULL_RTX)
            return res;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (nonimmediate_operand (operands[0], E_TFmode))
            {
              if (GET_CODE (x2) == SUBREG
                  && known_eq (SUBREG_BYTE (x2), 0)
                  && GET_MODE (x2) == E_TFmode)
                {
                  x4 = XEXP (x2, 0);
                  operands[1] = x4;
                  if (general_operand (operands[1], E_FPRX2mode)
                      && 
#line 665 "../../gcc/config/s390/vector.md"
(!(MEM_P (operands[0]) && MEM_VOLATILE_P (operands[0]))))
                    return gen_split_37 (insn, operands);
                }
              operands[1] = x2;
              if (general_operand (operands[1], E_TFmode))
                {
                  if ((
#line 2627 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], TFmode)
   && !s_operand (operands[1], TFmode)
   && s390_split_ok_p (operands[0], operands[1], TFmode, 0)) && 
#line 671 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                    return gen_split_155 (insn, operands);
                  if ((
#line 2643 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], TFmode)
   && !s_operand (operands[1], TFmode)
   && s390_split_ok_p (operands[0], operands[1], TFmode, 1)) && 
#line 671 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                    return gen_split_158 (insn, operands);
                }
            }
          operands[1] = x2;
          if (memory_operand (operands[1], E_TFmode)
              && register_operand (operands[0], E_TFmode))
            {
              if ((
#line 2659 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && GENERAL_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)) && 
#line 671 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return gen_split_161 (insn, operands);
              if ((
#line 2675 "../../gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[1])
   && FP_REG_P (operands[0])) && 
#line 671 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return gen_split_164 (insn, operands);
            }
          if (!register_operand (operands[1], E_TFmode)
              || !memory_operand (operands[0], E_TFmode)
              || !(
#line 2691 "../../gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[0])
   && FP_REG_P (operands[1])) && 
#line 671 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return NULL;
          return gen_split_167 (insn, operands);

        case VEC_DUPLICATE:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || GET_MODE (x2) != E_V16QImode
                  || !register_operand (operands[1], E_QImode)
                  || !
#line 696 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
                return NULL;
              return gen_split_38 (insn, operands);

            case E_V8HImode:
              if (!register_operand (operands[0], E_V8HImode)
                  || GET_MODE (x2) != E_V8HImode
                  || !register_operand (operands[1], E_HImode)
                  || !
#line 696 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
                return NULL;
              return gen_split_39 (insn, operands);

            case E_V4SImode:
              if (!register_operand (operands[0], E_V4SImode)
                  || GET_MODE (x2) != E_V4SImode
                  || !register_operand (operands[1], E_SImode)
                  || !
#line 696 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
                return NULL;
              return gen_split_40 (insn, operands);

            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x2) != E_V4SFmode
                  || !register_operand (operands[1], E_SFmode)
                  || !
#line 696 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
                return NULL;
              return gen_split_41 (insn, operands);

            case E_V2DImode:
              if (!register_operand (operands[0], E_V2DImode)
                  || GET_MODE (x2) != E_V2DImode
                  || !register_operand (operands[1], E_DImode)
                  || !
#line 696 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
                return NULL;
              return gen_split_42 (insn, operands);

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x2) != E_V2DFmode
                  || !register_operand (operands[1], E_DFmode)
                  || !
#line 696 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
                return NULL;
              return gen_split_43 (insn, operands);

            default:
              return NULL;
            }

        case SMAX:
          if (pattern8 (x1) != 0
              || !(
#line 1857 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE) && 
#line 1859 "../../gcc/config/s390/vector.md"
( 1)))
            return NULL;
          return gen_split_48 (insn, operands);

        case SMIN:
          if (pattern8 (x1) != 0
              || !(
#line 1893 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE) && 
#line 1895 "../../gcc/config/s390/vector.md"
( 1)))
            return NULL;
          return gen_split_49 (insn, operands);

        case IF_THEN_ELSE:
          return split_3 (x1, insn);

        case COMPARE:
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != REG
              || REGNO (x3) != 33)
            return NULL;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!memory_operand (operands[0], E_VOIDmode))
            return NULL;
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          if (!memory_operand (operands[1], E_VOIDmode)
              || !
#line 1412 "../../gcc/config/s390/s390.md"
(reload_completed
   && s390_match_ccmode (insn, CCUmode)
   && GET_MODE (operands[0]) == GET_MODE (operands[1])
   && GET_MODE_SIZE (GET_MODE (operands[0])) > 0))
            return NULL;
          return gen_split_141 (insn, operands);

        case UNSPEC:
          if (XVECLEN (x2, 0) != 1)
            return NULL;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x6 = XVECEXP (x2, 0, 0);
          operands[1] = x6;
          switch (XINT (x2, 1))
            {
            case 30:
              switch (pattern80 (x2))
                {
                case 0:
                  if (!
#line 1969 "../../gcc/config/s390/s390.md"
( reload_completed))
                    return NULL;
                  return gen_split_146 (insn, operands);

                case 1:
                  if (!(
#line 1976 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 1978 "../../gcc/config/s390/s390.md"
( reload_completed)))
                    return NULL;
                  return gen_split_147 (insn, operands);

                default:
                  return NULL;
                }

            case 5:
              if (GET_MODE (x2) != E_SImode
                  || !nonimmediate_operand (operands[0], E_SImode)
                  || !register_operand (operands[1], E_VOIDmode)
                  || !
#line 3587 "../../gcc/config/s390/s390.md"
(reload_completed))
                return NULL;
              return gen_split_181 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != LSHIFTRT)
            return NULL;
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != ASHIFT)
            return NULL;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          x9 = XEXP (x5, 0);
          operands[3] = x9;
          x10 = XEXP (x5, 1);
          operands[4] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern181 (x2, 
E_DImode) != 0
                  || !(
#line 4426 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12 && UINTVAL (operands[2]) + UINTVAL (operands[4]) >= 64) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return NULL;
              return gen_split_198 (insn, operands);

            case E_SImode:
              if (pattern181 (x2, 
E_SImode) != 0
                  || !
#line 4426 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12 && UINTVAL (operands[2]) + UINTVAL (operands[4]) >= 32))
                return NULL;
              return gen_split_199 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          if (!memory_operand (operands[1], E_QImode))
            return NULL;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !(
#line 5077 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 5079 "../../gcc/config/s390/s390.md"
( reload_completed)))
                return NULL;
              return gen_split_208 (insn, operands);

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !(
#line 5109 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 5111 "../../gcc/config/s390/s390.md"
( reload_completed)))
                return NULL;
              return gen_split_209 (insn, operands);

            default:
              return NULL;
            }

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case LTGT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          switch (GET_CODE (x2))
            {
            case EQ:
              switch (GET_MODE (operands[0]))
                {
                case E_V1TImode:
                  if (pattern3 (x2, 
E_V1TImode) == 0
                      && (
#line 1961 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 1963 "../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                    return gen_split_50 (insn, operands);
                  break;

                case E_TImode:
                  if (pattern3 (x2, 
E_TImode) == 0
                      && (
#line 1961 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 1963 "../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                    return gen_split_51 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case GT:
              switch (GET_MODE (operands[0]))
                {
                case E_V1TImode:
                  if (pattern3 (x2, 
E_V1TImode) == 0
                      && (
#line 1983 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 1985 "../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                    return gen_split_52 (insn, operands);
                  break;

                case E_TImode:
                  if (pattern3 (x2, 
E_TImode) == 0
                      && (
#line 1983 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 1985 "../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                    return gen_split_53 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case GTU:
              switch (GET_MODE (operands[0]))
                {
                case E_V1TImode:
                  if (pattern3 (x2, 
E_V1TImode) == 0
                      && (
#line 2017 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 2019 "../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                    return gen_split_54 (insn, operands);
                  break;

                case E_TImode:
                  if (pattern3 (x2, 
E_TImode) == 0
                      && (
#line 2017 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 2019 "../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                    return gen_split_55 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          operands[1] = x2;
          switch (pattern45 (x2))
            {
            case 0:
              if (!(
#line 7057 "../../gcc/config/s390/s390.md"
(reload_completed) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return NULL;
              return gen_split_219 (insn, operands);

            case 1:
              if (!
#line 7057 "../../gcc/config/s390/s390.md"
(reload_completed))
                return NULL;
              return gen_split_220 (insn, operands);

            default:
              return NULL;
            }

        case NOT:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !nonimmediate_operand (operands[1], E_DImode)
                  || !
#line 702 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return NULL;
              return gen_split_231 (insn, operands);

            case E_SImode:
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !nonimmediate_operand (operands[1], E_SImode))
                return NULL;
              return gen_split_232 (insn, operands);

            case E_HImode:
              if (!nonimmediate_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !nonimmediate_operand (operands[1], E_HImode))
                return NULL;
              return gen_split_233 (insn, operands);

            case E_QImode:
              if (!nonimmediate_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !nonimmediate_operand (operands[1], E_QImode))
                return NULL;
              return gen_split_234 (insn, operands);

            default:
              return NULL;
            }

        case BSWAP:
          if (GET_MODE (x2) != E_HImode)
            return NULL;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_HImode))
            return NULL;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_HImode))
            return NULL;
          return gen_split_248 (insn, operands);

        default:
          return NULL;
        }

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          return split_4 (x1, insn);

        case 3:
          x11 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x11) != SET)
            return NULL;
          x12 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x12) != CLOBBER)
            return NULL;
          x13 = XEXP (x11, 1);
          switch (GET_CODE (x13))
            {
            case VEC_SELECT:
              if (GET_MODE (x13) != E_V8HImode)
                return NULL;
              x14 = XEXP (x13, 1);
              if (GET_CODE (x14) != PARALLEL
                  || XVECLEN (x14, 0) != 8)
                return NULL;
              x15 = XVECEXP (x14, 0, 0);
              if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
                return NULL;
              x16 = XVECEXP (x14, 0, 1);
              if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
                return NULL;
              x17 = XVECEXP (x14, 0, 2);
              if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
                return NULL;
              x18 = XVECEXP (x14, 0, 3);
              if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
                return NULL;
              x19 = XVECEXP (x14, 0, 4);
              if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
                return NULL;
              x20 = XVECEXP (x14, 0, 5);
              if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
                return NULL;
              x21 = XVECEXP (x14, 0, 6);
              if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return NULL;
              x22 = XVECEXP (x14, 0, 7);
              if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x23 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x23) != CLOBBER
                  || pattern264 (x1) != 0
                  || !(
#line 1021 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 1026 "../../gcc/config/s390/vector.md"
( reload_completed && REG_P (operands[0]) && REG_P (operands[1]))))
                return NULL;
              return gen_split_45 (insn, operands);

            case IF_THEN_ELSE:
              x24 = XEXP (x13, 0);
              if (!s390_brx_operator (x24, E_VOIDmode))
                return NULL;
              operands[6] = x24;
              x25 = XEXP (x24, 0);
              if (GET_CODE (x25) != PLUS)
                return NULL;
              x14 = XEXP (x13, 1);
              if (GET_CODE (x14) != LABEL_REF)
                return NULL;
              x26 = XEXP (x13, 2);
              if (GET_CODE (x26) != PC)
                return NULL;
              x27 = XEXP (x11, 0);
              if (GET_CODE (x27) != PC)
                return NULL;
              x23 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x23) != SET)
                return NULL;
              x28 = XEXP (x23, 1);
              if (GET_CODE (x28) != PLUS)
                return NULL;
              switch (pattern228 (x1))
                {
                case 0:
                  if (!(
#line 9756 "../../gcc/config/s390/s390.md"
(!reload_completed && !reload_in_progress) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return NULL;
                  return gen_split_241 (insn, operands);

                case 1:
                  if (!
#line 9756 "../../gcc/config/s390/s390.md"
(!reload_completed && !reload_in_progress))
                    return NULL;
                  return gen_split_242 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 4:
          x11 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x11) != SET)
            return NULL;
          x29 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x29) != CLOBBER)
            return NULL;
          x13 = XEXP (x11, 1);
          switch (GET_CODE (x13))
            {
            case SUBREG:
            case MEM:
              if (pattern74 (x1) != 0)
                return NULL;
              switch (pattern195 (x1))
                {
                case 0:
                  if (!
#line 3403 "../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_177 (insn, operands);

                case 1:
                  if (!
#line 3415 "../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_178 (insn, operands);

                case 2:
                  if (!
#line 3429 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && reload_completed))
                    return NULL;
                  return gen_split_179 (insn, operands);

                case 3:
                  if (!
#line 3443 "../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_180 (insn, operands);

                default:
                  return NULL;
                }

            case COMPARE:
              if (pattern73 (x1) != 0)
                return NULL;
              switch (pattern195 (x1))
                {
                case 0:
                  if (!
#line 3850 "../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_186 (insn, operands);

                case 1:
                  if (!
#line 3863 "../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_187 (insn, operands);

                case 2:
                  if (!
#line 3878 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && reload_completed))
                    return NULL;
                  return gen_split_188 (insn, operands);

                case 3:
                  if (!
#line 3893 "../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_189 (insn, operands);

                default:
                  return NULL;
                }

            case IF_THEN_ELSE:
              switch (pattern78 (x1))
                {
                case 0:
                  if (!(
#line 9794 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 9803 "../../gcc/config/s390/s390.md"
( reload_completed
   && (!REG_P (operands[3])
       || !rtx_equal_p (operands[1], operands[3])))))
                    return NULL;
                  return gen_split_243 (insn, operands);

                case 1:
                  if (!(
#line 9880 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 9889 "../../gcc/config/s390/s390.md"
( reload_completed
   && (!REG_P (operands[3])
       || !rtx_equal_p (operands[1], operands[3])))))
                    return NULL;
                  return gen_split_245 (insn, operands);

                case 2:
                  if (!(
#line 9837 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 9846 "../../gcc/config/s390/s390.md"
( reload_completed
   && (!REG_P (operands[3])
       || !rtx_equal_p (operands[1], operands[3])))))
                    return NULL;
                  return gen_split_244 (insn, operands);

                case 3:
                  if (!
#line 9945 "../../gcc/config/s390/s390.md"
( reload_completed
   && (! REG_P (operands[2])
       || ! rtx_equal_p (operands[1], operands[2]))))
                    return NULL;
                  return gen_split_246 (insn, operands);

                case 4:
                  if (!(
#line 9978 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 9987 "../../gcc/config/s390/s390.md"
( reload_completed
   && (! REG_P (operands[2])
       || ! rtx_equal_p (operands[1], operands[2])))))
                    return NULL;
                  return gen_split_247 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 5:
          x11 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x11) != SET)
            return NULL;
          x13 = XEXP (x11, 1);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x23 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x23) != USE)
            return NULL;
          x12 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x12) != USE
              || pattern102 (x1) != 0)
            return NULL;
          switch (GET_CODE (operands[1]))
            {
            case CONST_INT:
              if (!const_int_operand (operands[1], E_VOIDmode))
                return NULL;
              x29 = XVECEXP (x1, 0, 3);
              x30 = XEXP (x29, 0);
              if (GET_CODE (x30) != SCRATCH)
                return NULL;
              x31 = XEXP (x12, 0);
              operands[2] = x31;
              if (!immediate_operand (operands[2], E_VOIDmode)
                  || !
#line 3656 "../../gcc/config/s390/s390.md"
(reload_completed))
                return NULL;
              return gen_split_182 (insn, operands);

            case REG:
            case SUBREG:
              if (!register_operand (operands[1], E_VOIDmode))
                return NULL;
              x31 = XEXP (x12, 0);
              switch (GET_CODE (x31))
                {
                case SUBREG:
                case MEM:
                  operands[2] = x31;
                  if (!memory_operand (operands[2], E_VOIDmode))
                    return NULL;
                  x29 = XVECEXP (x1, 0, 3);
                  x30 = XEXP (x29, 0);
                  if (GET_CODE (x30) != SCRATCH
                      || !
#line 3670 "../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_183 (insn, operands);

                case CONST:
                  if (GET_MODE (x31) != E_BLKmode)
                    return NULL;
                  x32 = XEXP (x31, 0);
                  if (GET_CODE (x32) != UNSPEC
                      || XVECLEN (x32, 0) != 1
                      || XINT (x32, 1) != 17
                      || GET_MODE (x32) != E_BLKmode)
                    return NULL;
                  x33 = XVECEXP (x32, 0, 0);
                  if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    return NULL;
                  x29 = XVECEXP (x1, 0, 3);
                  x30 = XEXP (x29, 0);
                  switch (GET_CODE (x30))
                    {
                    case SCRATCH:
                      if (!
#line 3686 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && reload_completed))
                        return NULL;
                      return gen_split_184 (insn, operands);

                    case REG:
                    case SUBREG:
                      operands[2] = x30;
                      if (!register_operand (operands[2], E_VOIDmode)
                          || !
#line 3702 "../../gcc/config/s390/s390.md"
(reload_completed))
                        return NULL;
                      return gen_split_185 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
