/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern10 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern14 (x3, 
E_V8HImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern14 (x3, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern14 (x3, 
E_V2DImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern21 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V16QImode:
      if (!register_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern29 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern28 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern28 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern33 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || GET_MODE (x1) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode))
        return -1;
      return 0;

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x1) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode))
        return -1;
      return 1;

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x1) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode))
        return -1;
      return 2;

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 3;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 4;

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x1) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode))
        return -1;
      return 5;

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      return 6;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 7;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 8;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode))
        return -1;
      return 9;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 10;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 11;

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x1) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode))
        return -1;
      return 12;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 13;

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x1) != E_V1SFmode
          || !register_operand (operands[1], E_V1SFmode))
        return -1;
      return 14;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x1) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 15;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 16;

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || GET_MODE (x1) != E_V1DFmode
          || !register_operand (operands[1], E_V1DFmode))
        return -1;
      return 17;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 18;

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || GET_MODE (x1) != E_V1TFmode
          || !register_operand (operands[1], E_V1TFmode))
        return -1;
      return 19;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x1) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 20;

    case E_DImode:
      if (pattern32 (x1, pnum_clobbers, 
E_DImode) != 0)
        return -1;
      return 21;

    case E_SImode:
      if (pattern32 (x1, pnum_clobbers, 
E_SImode) != 0)
        return -1;
      return 22;

    case E_FPRX2mode:
      if (!register_operand (operands[0], E_FPRX2mode)
          || GET_MODE (x1) != E_FPRX2mode
          || !register_operand (operands[1], E_FPRX2mode))
        return -1;
      return 23;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 24;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 25;

    case E_TDmode:
      if (!register_operand (operands[0], E_TDmode)
          || GET_MODE (x1) != E_TDmode
          || !register_operand (operands[1], E_TDmode))
        return -1;
      return 26;

    case E_DDmode:
      if (!register_operand (operands[0], E_DDmode)
          || GET_MODE (x1) != E_DDmode
          || !register_operand (operands[1], E_DDmode))
        return -1;
      return 27;

    default:
      return -1;
    }
}

int
pattern96 (rtx x1, machine_mode i1, unsigned int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern102 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  return 0;
}

int
pattern114 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !nonmemory_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !nonmemory_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern121 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  if (maybe_ne (SUBREG_BYTE (x5), i2)
      || GET_MODE (x5) != i3
      || !register_operand (operands[0], i1)
      || !register_operand (operands[3], i1)
      || !setmem_operand (operands[2], i3)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern126 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern133 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_TFmode:
      if (!register_operand (operands[1], E_TFmode)
          || !const0_operand (operands[2], E_TFmode))
        return -1;
      return 0;

    case E_FPRX2mode:
      if (!register_operand (operands[1], E_FPRX2mode)
          || !const0_operand (operands[2], E_FPRX2mode))
        return -1;
      return 1;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode)
          || !const0_operand (operands[2], E_DFmode))
        return -1;
      return 2;

    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode)
          || !const0_operand (operands[2], E_SFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern143 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCRAWmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCRAWmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 2
      || XINT (x6, 1) != i1)
    return -1;
  x7 = XEXP (x5, 0);
  operands[0] = x7;
  x8 = XVECEXP (x6, 0, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  x9 = XVECEXP (x6, 0, 1);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      return pattern142 (x6, 
E_V16QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern142 (x6, 
E_V8HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern142 (x6, 
E_V4SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern153 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1QImode:
          return 0;

        case E_V2QImode:
          return 1;

        case E_V4QImode:
          return 2;

        case E_V8QImode:
          return 3;

        case E_V16QImode:
          return 4;

        default:
          return -1;
        }

    case E_HImode:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1HImode:
          return 5;

        case E_V2HImode:
          return 6;

        case E_V4HImode:
          return 7;

        case E_V8HImode:
          return 8;

        default:
          return -1;
        }

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1SImode:
          return 9;

        case E_V2SImode:
          return 10;

        case E_V4SImode:
          return 11;

        default:
          return -1;
        }

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1DImode:
          return 12;

        case E_V2DImode:
          return 13;

        default:
          return -1;
        }

    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1SFmode:
          return 14;

        case E_V2SFmode:
          return 15;

        case E_V4SFmode:
          return 16;

        default:
          return -1;
        }

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1DFmode:
          return 17;

        case E_V2DFmode:
          return 18;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern186 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 0;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 1;

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || !register_operand (operands[1], E_V1TFmode))
        return -1;
      return 2;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern197 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern200 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern210 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 4
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_CCUmode))
    return -1;
  return 0;
}

int
pattern220 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern232 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !register_operand (operands[1], E_V16QImode)
          || !scratch_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !register_operand (operands[1], E_V8HImode)
          || !scratch_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !register_operand (operands[1], E_V4SImode)
          || !scratch_operand (operands[2], E_V4SImode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !register_operand (operands[1], E_V2DImode)
          || !scratch_operand (operands[2], E_V2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern251 (rtx x1, rtx_code i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i1
      || GET_MODE (x2) != E_DImode)
    return -1;
  return 0;
}

int
pattern261 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !contiguous_bitmask_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !const_int_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern270 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern274 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern286 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern294 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern27 (x1))
    {
    case 0:
      if (!
#line 1570 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1059; /* vec_widen_smult_odd_v1qi */

    case 1:
      if (!
#line 1570 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1060; /* vec_widen_smult_odd_v2qi */

    case 2:
      if (!
#line 1570 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1061; /* vec_widen_smult_odd_v4qi */

    case 3:
      if (!
#line 1570 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1062; /* vec_widen_smult_odd_v8qi */

    case 4:
      if (!
#line 1570 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1063; /* vec_widen_smult_odd_v16qi */

    case 5:
      if (!
#line 1570 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1064; /* vec_widen_smult_odd_v1hi */

    case 6:
      if (!
#line 1570 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1065; /* vec_widen_smult_odd_v2hi */

    case 7:
      if (!
#line 1570 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1066; /* vec_widen_smult_odd_v4hi */

    case 8:
      if (!
#line 1570 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1067; /* vec_widen_smult_odd_v8hi */

    case 9:
      if (!
#line 1570 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1068; /* vec_widen_smult_odd_v1si */

    case 10:
      if (!
#line 1570 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1069; /* vec_widen_smult_odd_v2si */

    case 11:
      if (!
#line 1570 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1070; /* vec_widen_smult_odd_v4si */

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 61:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_mask_operand (operands[2], E_QImode)
          || !
#line 201 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[2]) < 7))
        return -1;
      return 16; /* vlbb */

    case 63:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[2] = x4;
      if (!memory_operand (operands[2], E_BLKmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[1] = x5;
      if (!nonmemory_operand (operands[1], E_SImode)
          || !
#line 227 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
        return -1;
      return 17; /* *vlrlrv16qi */

    case 64:
      switch (pattern15 (x1))
        {
        case 0:
          if (!
#line 266 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 18; /* vec_packv8hi */

        case 1:
          if (!
#line 266 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 19; /* vec_packv4si */

        case 2:
          if (!
#line 266 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 20; /* vec_packv2di */

        default:
          return -1;
        }

    case 65:
      switch (pattern15 (x1))
        {
        case 0:
          if (!
#line 279 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 21; /* vec_packsv8hi */

        case 1:
          if (!
#line 279 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 22; /* vec_packsv4si */

        case 2:
          if (!
#line 279 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 23; /* vec_packsv2di */

        default:
          return -1;
        }

    case 68:
      switch (pattern15 (x1))
        {
        case 0:
          if (!
#line 325 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 27; /* vec_packsuv8hi */

        case 1:
          if (!
#line 325 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 28; /* vec_packsuv4si */

        case 2:
          if (!
#line 325 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 29; /* vec_packsuv2di */

        default:
          return -1;
        }

    case 73:
      return recog_1 (x1, insn, pnum_clobbers);

    case 74:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[2] = x3;
      if (!memory_operand (operands[2], E_BLKmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[1] = x5;
      if (!nonmemory_operand (operands[1], E_SImode)
          || !
#line 593 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
        return -1;
      return 92; /* *vstrlrv16qi */

    case 75:
      if (pattern16 (x1, 
E_V16QImode, 
E_V2DImode) != 0
          || !
#line 609 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
        return -1;
      return 93; /* vbpermv16qi */

    case 80:
      switch (pattern18 (x1))
        {
        case 0:
          if (!
#line 665 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 106; /* vaccb_v16qi */

        case 1:
          if (!
#line 665 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 107; /* vacch_v8hi */

        case 2:
          if (!
#line 665 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 108; /* vaccf_v4si */

        case 3:
          if (!
#line 665 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 109; /* vaccg_v2di */

        case 4:
          if (!
#line 665 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 110; /* vaccq_v1ti */

        case 5:
          if (!
#line 665 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 111; /* vaccq_ti */

        default:
          return -1;
        }

    case 83:
      switch (pattern19 (x1))
        {
        case 0:
          if (!
#line 717 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 123; /* vec_avgv16qi */

        case 1:
          if (!
#line 717 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 124; /* vec_avgv8hi */

        case 2:
          if (!
#line 717 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 125; /* vec_avgv4si */

        case 3:
          if (!
#line 717 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 126; /* vec_avgv2di */

        default:
          return -1;
        }

    case 84:
      switch (pattern19 (x1))
        {
        case 0:
          if (!
#line 729 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 127; /* vec_avguv16qi */

        case 1:
          if (!
#line 729 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 128; /* vec_avguv8hi */

        case 2:
          if (!
#line 729 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 129; /* vec_avguv4si */

        case 3:
          if (!
#line 729 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 130; /* vec_avguv2di */

        default:
          return -1;
        }

    case 85:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V4SImode)
          || !
#line 741 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 131; /* vec_checksum */

    case 86:
      switch (pattern20 (x1))
        {
        case 0:
          if (!
#line 850 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 132; /* vec_gfmsumv16qi */

        case 1:
          if (!
#line 850 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 133; /* vec_gfmsumv8hi */

        case 2:
          if (!
#line 850 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 134; /* vec_gfmsumv4si */

        default:
          return -1;
        }

    case 87:
      if (pattern16 (x1, 
E_V2DImode, 
E_V16QImode) != 0
          || !
#line 859 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 135; /* vec_gfmsum_128 */

    case 45:
      switch (pattern20 (x1))
        {
        case 0:
          if (!
#line 989 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 161; /* vec_smulhv16qi */

        case 1:
          if (!
#line 989 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 162; /* vec_smulhv8hi */

        case 2:
          if (!
#line 989 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 163; /* vec_smulhv4si */

        default:
          return -1;
        }

    case 46:
      switch (pattern20 (x1))
        {
        case 0:
          if (!
#line 999 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 164; /* vec_umulhv16qi */

        case 1:
          if (!
#line 999 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 165; /* vec_umulhv8hi */

        case 2:
          if (!
#line 999 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 166; /* vec_umulhv4si */

        default:
          return -1;
        }

    case 95:
      return recog_11 (x1, insn, pnum_clobbers);

    case 100:
      return recog_10 (x1, insn, pnum_clobbers);

    case 101:
      return recog_3 (x1, insn, pnum_clobbers);

    case 102:
      return recog_9 (x1, insn, pnum_clobbers);

    case 104:
      switch (pattern18 (x1))
        {
        case 0:
          if (!
#line 1173 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 256; /* vscbib_v16qi */

        case 1:
          if (!
#line 1173 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 257; /* vscbih_v8hi */

        case 2:
          if (!
#line 1173 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 258; /* vscbif_v4si */

        case 3:
          if (!
#line 1173 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 259; /* vscbig_v2di */

        case 4:
          if (!
#line 1173 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 260; /* vscbiq_v1ti */

        case 5:
          if (!
#line 1173 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 261; /* vscbiq_ti */

        default:
          return -1;
        }

    case 92:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SImode:
          if (!register_operand (operands[1], E_V4SImode)
              || !register_operand (operands[2], E_V4SImode)
              || !
#line 1221 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 264; /* vec_sum_u128v4si */

        case E_V2DImode:
          if (!register_operand (operands[1], E_V2DImode)
              || !register_operand (operands[2], E_V2DImode)
              || !
#line 1221 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 265; /* vec_sum_u128v2di */

        default:
          return -1;
        }

    case 107:
      return recog_2 (x1, insn, pnum_clobbers);

    case 128:
      if (pnum_clobbers == NULL
          || pattern35 (x1) != 0)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_HImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SFmode:
          if (!register_operand (operands[1], E_V4SFmode)
              || !(
#line 1933 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 324; /* *vftciv4sf_cconly */

        case E_V2DFmode:
          if (!register_operand (operands[1], E_V2DFmode)
              || !
#line 1933 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")))
            return -1;
          *pnum_clobbers = 1;
          return 325; /* *vftciv2df_cconly */

        case E_V1TFmode:
          if (!register_operand (operands[1], E_V1TFmode)
              || !(
#line 1933 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 326; /* *vftciv1tf_cconly */

        case E_TFmode:
          if (!register_operand (operands[1], E_TFmode)
              || !(
#line 1933 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 327; /* *vftcitf_cconly */

        default:
          return -1;
        }

    case 133:
      if (pattern24 (x1, 
3, 
2, 
1, 
0) != 0
          || !
#line 2230 "../../gcc/config/s390/vx-builtins.md"
(TARGET_NNPA))
        return -1;
      return 408; /* vclfnhs_v8hi */

    case 134:
      if (pattern24 (x1, 
7, 
6, 
5, 
4) != 0
          || !
#line 2241 "../../gcc/config/s390/vx-builtins.md"
(TARGET_NNPA))
        return -1;
      return 409; /* vclfnls_v8hi */

    case 136:
      if (pattern25 (x1) != 0
          || !
#line 2260 "../../gcc/config/s390/vx-builtins.md"
(TARGET_NNPA))
        return -1;
      return 411; /* vcfn_v8hi */

    case 137:
      if (pattern25 (x1) != 0
          || !
#line 2269 "../../gcc/config/s390/vx-builtins.md"
(TARGET_NNPA))
        return -1;
      return 412; /* vcnf_v8hi */

    case 91:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode)
              || !register_operand (operands[2], E_V8HImode)
              || !
#line 1160 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 648; /* *vec_sum2v8hi */

        case E_V4SImode:
          if (!register_operand (operands[1], E_V4SImode)
              || !register_operand (operands[2], E_V4SImode)
              || !
#line 1160 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 649; /* *vec_sum2v4si */

        default:
          return -1;
        }

    case 93:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode)
              || !register_operand (operands[2], E_V16QImode)
              || !
#line 1170 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 650; /* *vec_sum4v16qi */

        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode)
              || !register_operand (operands[2], E_V8HImode)
              || !
#line 1170 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 651; /* *vec_sum4v8hi */

        default:
          return -1;
        }

    case 103:
      switch (pattern26 (x1))
        {
        case 0:
          if (!
#line 1475 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 961; /* *vec_srbv16qi */

        case 1:
          if (!
#line 1475 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 962; /* *vec_srbv8hi */

        case 2:
          if (!
#line 1475 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 963; /* *vec_srbv4si */

        case 3:
          if (!
#line 1475 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 964; /* *vec_srbv4sf */

        case 4:
          if (!
#line 1475 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 965; /* *vec_srbv2di */

        case 5:
          if (!
#line 1475 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 966; /* *vec_srbv2df */

        case 6:
          if (!
#line 1475 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 967; /* *vec_srbv1ti */

        case 7:
          if (!
#line 1475 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 968; /* *vec_srbv1tf */

        case 8:
          if (!(
#line 1475 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 80 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 969; /* *vec_srbtf */

        default:
          return -1;
        }

    case 96:
      switch (pattern26 (x1))
        {
        case 0:
          if (!
#line 1487 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 970; /* *vec_slbv16qi */

        case 1:
          if (!
#line 1487 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 971; /* *vec_slbv8hi */

        case 2:
          if (!
#line 1487 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 972; /* *vec_slbv4si */

        case 3:
          if (!
#line 1487 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 973; /* *vec_slbv4sf */

        case 4:
          if (!
#line 1487 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 974; /* *vec_slbv2di */

        case 5:
          if (!
#line 1487 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 975; /* *vec_slbv2df */

        case 6:
          if (!
#line 1487 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 976; /* *vec_slbv1ti */

        case 7:
          if (!
#line 1487 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 977; /* *vec_slbv1tf */

        case 8:
          if (!(
#line 1487 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 80 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 978; /* *vec_slbtf */

        default:
          return -1;
        }

    case 48:
      return recog_8 (x1, insn, pnum_clobbers);

    case 49:
      return recog_7 (x1, insn, pnum_clobbers);

    case 50:
      return recog_6 (x1, insn, pnum_clobbers);

    case 51:
      return recog_5 (x1, insn, pnum_clobbers);

    case 62:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!memory_operand (operands[2], E_BLKmode)
          || !
#line 2260 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1256; /* vllv16qi */

    case 3:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 0
          || GET_MODE (x5) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!memory_operand (operands[0], E_BLKmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode)
          || !
#line 3536 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
        return -1;
      return 1551; /* *mvcrl */

    case 36:
      return recog_4 (x1, insn, pnum_clobbers);

    case 1:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_operand (operands[1], E_BLKmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          *pnum_clobbers = 1;
          return 1577; /* *sethighpartsi */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          if (
#line 4059 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            {
              *pnum_clobbers = 1;
              return 1578; /* *sethighpartdi_64 */
            }
          if (!
#line 4069 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 1579; /* *sethighpartdi_31 */

        default:
          return -1;
        }

    case 29:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !memory_operand (operands[1], E_DImode)
              || !
#line 10817 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
            return -1;
          return 2237; /* *tls_load_64 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !memory_operand (operands[1], E_SImode)
              || !
#line 10827 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
            return -1;
          return 2238; /* *tls_load_31 */

        default:
          return -1;
        }

    case 34:
      if (pattern23 (x1, 
E_CCZmode) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!memory_operand (operands[0], E_DImode)
              || !memory_operand (operands[1], E_DImode))
            return -1;
          return 2281; /* stack_protect_testdi */

        case E_SImode:
          if (!memory_operand (operands[0], E_SImode)
              || !memory_operand (operands[1], E_SImode))
            return -1;
          return 2282; /* stack_protect_testsi */

        default:
          return -1;
        }

    case 2:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!memory_operand (operands[0], E_BLKmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[1] = x5;
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!register_operand (operands[1], E_DImode)
              || !
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
            return -1;
          return 2283; /* stack_tiedi */

        case E_SImode:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
            return -1;
          return 2284; /* stack_tiesi */

        default:
          return -1;
        }

    case 44:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!address_operand (operands[1], E_VOIDmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!immediate_operand (operands[2], E_SImode)
          || !
#line 12277 "../../gcc/config/s390/s390.md"
(TARGET_Z13))
        return -1;
      *pnum_clobbers = 1;
      return 2316; /* lcbb */

    default:
      return -1;
    }
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (pattern64 (x3, 
E_V1QImode) != 0
          || !
#line 1120 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 592; /* subv1qi3 */

    case E_V2QImode:
      if (pattern64 (x3, 
E_V2QImode) != 0
          || !
#line 1120 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 593; /* subv2qi3 */

    case E_V4QImode:
      if (pattern64 (x3, 
E_V4QImode) != 0
          || !
#line 1120 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 594; /* subv4qi3 */

    case E_V8QImode:
      if (pattern64 (x3, 
E_V8QImode) != 0
          || !
#line 1120 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 595; /* subv8qi3 */

    case E_V16QImode:
      if (pattern64 (x3, 
E_V16QImode) != 0
          || !
#line 1120 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 596; /* subv16qi3 */

    case E_V1HImode:
      if (pattern64 (x3, 
E_V1HImode) != 0
          || !
#line 1120 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 597; /* subv1hi3 */

    case E_V2HImode:
      if (pattern64 (x3, 
E_V2HImode) != 0
          || !
#line 1120 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 598; /* subv2hi3 */

    case E_V4HImode:
      if (pattern64 (x3, 
E_V4HImode) != 0
          || !
#line 1120 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 599; /* subv4hi3 */

    case E_V8HImode:
      if (pattern64 (x3, 
E_V8HImode) != 0
          || !
#line 1120 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 600; /* subv8hi3 */

    case E_V1SImode:
      if (pattern64 (x3, 
E_V1SImode) != 0
          || !
#line 1120 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 601; /* subv1si3 */

    case E_V2SImode:
      if (pattern64 (x3, 
E_V2SImode) != 0
          || !
#line 1120 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 602; /* subv2si3 */

    case E_V4SImode:
      if (pattern64 (x3, 
E_V4SImode) != 0
          || !
#line 1120 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 603; /* subv4si3 */

    case E_V1DImode:
      if (pattern64 (x3, 
E_V1DImode) != 0
          || !
#line 1120 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 604; /* subv1di3 */

    case E_V2DImode:
      if (pattern64 (x3, 
E_V2DImode) != 0
          || !
#line 1120 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 605; /* subv2di3 */

    case E_V1TImode:
      if (pattern64 (x3, 
E_V1TImode) != 0
          || !
#line 1120 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 606; /* subv1ti3 */

    case E_TImode:
      if (GET_MODE (x3) != E_TImode
          || !general_operand (operands[2], E_TImode))
        return -1;
      if (nonimmediate_operand (operands[0], E_TImode)
          && nonimmediate_operand (operands[1], E_TImode)
          && 
#line 1120 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 607; /* *subti3 */
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_TImode)
          || !register_operand (operands[1], E_TImode)
          || !
#line 6387 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 1896; /* *subti3 */

    case E_V4SFmode:
      if (pattern3 (x3, 
E_V4SFmode) != 0
          || !(
#line 1702 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1087; /* subv4sf3 */

    case E_V2DFmode:
      if (pattern3 (x3, 
E_V2DFmode) != 0
          || !
#line 1702 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1088; /* subv2df3 */

    case E_V1TFmode:
      if (pattern3 (x3, 
E_V1TFmode) != 0
          || !(
#line 1702 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1089; /* subv1tf3 */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      if (register_operand (operands[2], E_TFmode)
          && (
#line 1702 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return 1090; /* subtf3_vr */
      if (pnum_clobbers == NULL
          || !general_operand (operands[2], E_TFmode)
          || !(
#line 6703 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      *pnum_clobbers = 1;
      return 1920; /* subtf3_fpr */

    case E_FPRX2mode:
      if (pnum_clobbers == NULL
          || pattern85 (x3, 
E_FPRX2mode) != 0
          || !(
#line 6703 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      *pnum_clobbers = 1;
      return 1921; /* subfprx23 */

    case E_DFmode:
      if (pnum_clobbers == NULL
          || pattern85 (x3, 
E_DFmode) != 0
          || !
#line 6703 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      *pnum_clobbers = 1;
      return 1922; /* subdf3 */

    case E_SFmode:
      if (pnum_clobbers == NULL
          || pattern85 (x3, 
E_SFmode) != 0
          || !
#line 6703 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      *pnum_clobbers = 1;
      return 1923; /* subsf3 */

    case E_TDmode:
      if (pnum_clobbers == NULL
          || pattern85 (x3, 
E_TDmode) != 0
          || !(
#line 6703 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      *pnum_clobbers = 1;
      return 1924; /* subtd3 */

    case E_DDmode:
      if (pnum_clobbers == NULL
          || pattern85 (x3, 
E_DDmode) != 0
          || !(
#line 6703 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      *pnum_clobbers = 1;
      return 1925; /* subdd3 */

    default:
      return -1;
    }
}

 int
recog_52 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case IOR:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern104 (x3, 
E_V16QImode) != 0
              || !
#line 1017 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 167; /* vec_norv16qi3 */

        case E_V8HImode:
          if (pattern104 (x3, 
E_V8HImode) != 0
              || !
#line 1017 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 168; /* vec_norv8hi3 */

        case E_V4SImode:
          if (pattern104 (x3, 
E_V4SImode) != 0
              || !
#line 1017 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 169; /* vec_norv4si3 */

        case E_V2DImode:
          if (pattern104 (x3, 
E_V2DImode) != 0
              || !
#line 1017 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 170; /* vec_norv2di3 */

        case E_V2DFmode:
          if (pattern104 (x3, 
E_V2DFmode) != 0
              || !
#line 1017 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 171; /* vec_norv2df3 */

        case E_V1TImode:
          if (pattern104 (x3, 
E_V1TImode) != 0
              || !
#line 1017 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 172; /* vec_norv1ti3 */

        case E_TImode:
          if (pattern104 (x3, 
E_TImode) != 0
              || !
#line 1017 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 173; /* vec_norti3 */

        case E_V4SFmode:
          if (pattern104 (x3, 
E_V4SFmode) != 0
              || !(
#line 1017 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 38 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 174; /* vec_norv4sf3 */

        case E_V1TFmode:
          if (pattern104 (x3, 
E_V1TFmode) != 0
              || !(
#line 1017 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 38 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 175; /* vec_norv1tf3 */

        default:
          return -1;
        }

    case XOR:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern104 (x3, 
E_V1QImode) != 0
              || !
#line 1234 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 762; /* notxorv1qi3 */

        case E_V2QImode:
          if (pattern104 (x3, 
E_V2QImode) != 0
              || !
#line 1234 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 763; /* notxorv2qi3 */

        case E_V4QImode:
          if (pattern104 (x3, 
E_V4QImode) != 0
              || !
#line 1234 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 764; /* notxorv4qi3 */

        case E_V8QImode:
          if (pattern104 (x3, 
E_V8QImode) != 0
              || !
#line 1234 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 765; /* notxorv8qi3 */

        case E_V16QImode:
          if (pattern104 (x3, 
E_V16QImode) != 0
              || !
#line 1234 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 766; /* notxorv16qi3 */

        case E_V1HImode:
          if (pattern104 (x3, 
E_V1HImode) != 0
              || !
#line 1234 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 767; /* notxorv1hi3 */

        case E_V2HImode:
          if (pattern104 (x3, 
E_V2HImode) != 0
              || !
#line 1234 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 768; /* notxorv2hi3 */

        case E_V4HImode:
          if (pattern104 (x3, 
E_V4HImode) != 0
              || !
#line 1234 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 769; /* notxorv4hi3 */

        case E_V8HImode:
          if (pattern104 (x3, 
E_V8HImode) != 0
              || !
#line 1234 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 770; /* notxorv8hi3 */

        case E_V1SImode:
          if (pattern104 (x3, 
E_V1SImode) != 0
              || !
#line 1234 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 771; /* notxorv1si3 */

        case E_V2SImode:
          if (pattern104 (x3, 
E_V2SImode) != 0
              || !
#line 1234 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 772; /* notxorv2si3 */

        case E_V4SImode:
          if (pattern104 (x3, 
E_V4SImode) != 0
              || !
#line 1234 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 773; /* notxorv4si3 */

        case E_V1DImode:
          if (pattern104 (x3, 
E_V1DImode) != 0
              || !
#line 1234 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 774; /* notxorv1di3 */

        case E_V2DImode:
          if (pattern104 (x3, 
E_V2DImode) != 0
              || !
#line 1234 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 775; /* notxorv2di3 */

        case E_V1SFmode:
          if (pattern104 (x3, 
E_V1SFmode) != 0
              || !
#line 1234 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 776; /* notxorv1sf3 */

        case E_V2SFmode:
          if (pattern104 (x3, 
E_V2SFmode) != 0
              || !
#line 1234 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 777; /* notxorv2sf3 */

        case E_V4SFmode:
          if (pattern104 (x3, 
E_V4SFmode) != 0
              || !
#line 1234 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 778; /* notxorv4sf3 */

        case E_V1DFmode:
          if (pattern104 (x3, 
E_V1DFmode) != 0
              || !
#line 1234 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 779; /* notxorv1df3 */

        case E_V2DFmode:
          if (pattern104 (x3, 
E_V2DFmode) != 0
              || !
#line 1234 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 780; /* notxorv2df3 */

        case E_V1TFmode:
          if (pattern104 (x3, 
E_V1TFmode) != 0
              || !
#line 1234 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 781; /* notxorv1tf3 */

        case E_V1TImode:
          if (pattern104 (x3, 
E_V1TImode) != 0
              || !
#line 1234 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 782; /* notxorv1ti3 */

        case E_TImode:
          if (pattern104 (x3, 
E_TImode) != 0
              || !
#line 1234 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 783; /* notxorti3 */

        case E_DImode:
          if (pnum_clobbers == NULL
              || pattern104 (x3, 
E_DImode) != 0
              || !(
#line 8834 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2072; /* *nxordi */

        case E_SImode:
          if (pnum_clobbers == NULL
              || pattern104 (x3, 
E_SImode) != 0
              || !
#line 8834 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
            return -1;
          *pnum_clobbers = 1;
          return 2073; /* *nxorsi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      return recog_21 (x1, insn, pnum_clobbers);

    case UNGE:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x6 = XEXP (x4, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V1SImode:
          if (pattern105 (x3, 
E_V1SFmode, 
E_V1SImode) != 0
              || !(
#line 2065 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1205; /* vec_cmpgtv1sf_quiet_nocc */

        case E_V2SImode:
          if (pattern105 (x3, 
E_V2SFmode, 
E_V2SImode) != 0
              || !(
#line 2065 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1206; /* vec_cmpgtv2sf_quiet_nocc */

        case E_V4SImode:
          if (pattern105 (x3, 
E_V4SFmode, 
E_V4SImode) != 0
              || !(
#line 2065 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1207; /* vec_cmpgtv4sf_quiet_nocc */

        case E_V1DImode:
          if (pattern105 (x3, 
E_V1DFmode, 
E_V1DImode) != 0
              || !
#line 2065 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1208; /* vec_cmpgtv1df_quiet_nocc */

        case E_V2DImode:
          if (pattern105 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
              || !
#line 2065 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1209; /* vec_cmpgtv2df_quiet_nocc */

        case E_V1TImode:
          if (!register_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || GET_MODE (x4) != E_V1TImode)
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_V1TFmode:
              if (!register_operand (operands[2], E_V1TFmode)
                  || !register_operand (operands[1], E_V1TFmode)
                  || !(
#line 2065 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 61 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1210; /* vec_cmpgtv1tf_quiet_nocc */

            case E_TFmode:
              if (!register_operand (operands[2], E_TFmode)
                  || !register_operand (operands[1], E_TFmode)
                  || !(
#line 2065 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 61 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1211; /* vec_cmpgttf_quiet_nocc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNLT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V1SImode:
          if (pattern106 (x3, 
E_V1SFmode, 
E_V1SImode) != 0
              || !(
#line 2082 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1212; /* vec_cmpgev1sf_quiet_nocc */

        case E_V2SImode:
          if (pattern106 (x3, 
E_V2SFmode, 
E_V2SImode) != 0
              || !(
#line 2082 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1213; /* vec_cmpgev2sf_quiet_nocc */

        case E_V4SImode:
          if (pattern106 (x3, 
E_V4SFmode, 
E_V4SImode) != 0
              || !(
#line 2082 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1214; /* vec_cmpgev4sf_quiet_nocc */

        case E_V1DImode:
          if (pattern106 (x3, 
E_V1DFmode, 
E_V1DImode) != 0
              || !
#line 2082 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1215; /* vec_cmpgev1df_quiet_nocc */

        case E_V2DImode:
          if (pattern106 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
              || !
#line 2082 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1216; /* vec_cmpgev2df_quiet_nocc */

        case E_V1TImode:
          if (!register_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || GET_MODE (x4) != E_V1TImode)
            return -1;
          switch (pattern166 ())
            {
            case 0:
              if (!(
#line 2082 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 61 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1217; /* vec_cmpgev1tf_quiet_nocc */

            case 1:
              if (!(
#line 2082 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 61 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1218; /* vec_cmpgetf_quiet_nocc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_63 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XVECEXP (x5, 0, 0);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern167 (x3, 
E_V8HImode, 
E_HImode) != 0
              || !
#line 2214 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode)))
            return -1;
          return 403; /* *vec_extract_bswap_elemv8hi */

        case E_SImode:
          if (pattern167 (x3, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 2214 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode)))
            return -1;
          return 404; /* *vec_extract_bswap_elemv4si */

        case E_SFmode:
          if (pattern167 (x3, 
E_V4SFmode, 
E_SFmode) != 0
              || !(
#line 2214 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 35 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 405; /* *vec_extract_bswap_elemv4sf */

        case E_DImode:
          if (pattern167 (x3, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 2214 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 406; /* *vec_extract_bswap_elemv2di */

        case E_DFmode:
          if (pattern167 (x3, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 2214 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 407; /* *vec_extract_bswap_elemv2df */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (!memory_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 3209 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1418; /* *vstbrv8hi */

        case E_V4SImode:
          if (!memory_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 3209 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1419; /* *vstbrv4si */

        case E_V2DImode:
          if (!memory_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 3209 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1420; /* *vstbrv2di */

        case E_V1TImode:
          if (!memory_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !register_operand (operands[1], E_V1TImode)
              || !
#line 3209 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1421; /* *vstbrv1ti */

        case E_TImode:
          if (!memory_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !register_operand (operands[1], E_TImode)
              || !
#line 3209 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1422; /* *vstbrti */

        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !nonimmediate_operand (operands[1], E_DImode)
              || !
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2287; /* bswapdi2 */

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !nonimmediate_operand (operands[1], E_SImode))
            return -1;
          return 2288; /* bswapsi2 */

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 2289; /* bswaphi2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_69 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 2775 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1375; /* floatv2div2df2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SImode)
          || !(
#line 2775 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 84 "../../gcc/config/s390/vector.md"
(TARGET_VXE2)))
        return -1;
      return 1376; /* floatv4siv4sf2 */

    case E_TFmode:
      switch (pattern67 (x3, 
E_TFmode))
        {
        case 0:
          if (!(
#line 5401 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 1722; /* floatditf2_fpr */

        case 1:
          if (!(
#line 5414 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 1728; /* floatsitf2_fpr */

        default:
          return -1;
        }

    case E_FPRX2mode:
      switch (pattern67 (x3, 
E_FPRX2mode))
        {
        case 0:
          if (!(
#line 5401 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 1723; /* floatdifprx22 */

        case 1:
          if (!(
#line 5414 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 1729; /* floatsifprx22 */

        default:
          return -1;
        }

    case E_DFmode:
      switch (pattern67 (x3, 
E_DFmode))
        {
        case 0:
          if (!
#line 5401 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_FLOAT))
            return -1;
          return 1724; /* floatdidf2 */

        case 1:
          if (!
#line 5414 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 1730; /* floatsidf2 */

        default:
          return -1;
        }

    case E_SFmode:
      switch (pattern67 (x3, 
E_SFmode))
        {
        case 0:
          if (!
#line 5401 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_FLOAT))
            return -1;
          return 1725; /* floatdisf2 */

        case 1:
          if (!
#line 5414 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 1731; /* floatsisf2 */

        default:
          return -1;
        }

    case E_TDmode:
      switch (pattern67 (x3, 
E_TDmode))
        {
        case 0:
          if (!(
#line 5401 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1726; /* floatditd2 */

        case 1:
          if (!
#line 5427 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT))
            return -1;
          return 1732; /* floatsitd2 */

        default:
          return -1;
        }

    case E_DDmode:
      switch (pattern67 (x3, 
E_DDmode))
        {
        case 0:
          if (!(
#line 5401 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1727; /* floatdidd2 */

        case 1:
          if (!
#line 5427 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT))
            return -1;
          return 1733; /* floatsidd2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_79 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case ZERO_EXTEND:
          if (GET_MODE (x6) != E_DImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || GET_MODE (x4) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          if (!general_operand (operands[2], E_SImode))
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x9))
            {
            case SET:
              x10 = XEXP (x9, 1);
              if (GET_CODE (x10) != MINUS
                  || GET_MODE (x10) != E_DImode)
                return -1;
              x11 = XEXP (x10, 1);
              if (GET_CODE (x11) != ZERO_EXTEND
                  || GET_MODE (x11) != E_DImode)
                return -1;
              x12 = XEXP (x9, 0);
              operands[0] = x12;
              if (!register_operand (operands[0], E_DImode))
                return -1;
              x13 = XEXP (x10, 0);
              if (!rtx_equal_p (x13, operands[1]))
                return -1;
              x14 = XEXP (x11, 0);
              if (!rtx_equal_p (x14, operands[2])
                  || !
#line 6441 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
                return -1;
              return 1898; /* *subdi3_zero_cc */

            case CLOBBER:
              x12 = XEXP (x9, 0);
              operands[0] = x12;
              if (!scratch_operand (operands[0], E_DImode)
                  || !
#line 6454 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
                return -1;
              return 1899; /* *subdi3_zero_cconly */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x6;
          x7 = XEXP (x3, 1);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              if (!rtx_equal_p (x7, operands[1]))
                return -1;
              switch (pattern224 (x1))
                {
                case 0:
                  x15 = XEXP (x2, 0);
                  if (GET_MODE (x15) != E_CCL2mode
                      || GET_MODE (x3) != E_CCL2mode)
                    return -1;
                  switch (pattern243 (x1))
                    {
                    case 0:
                      if (!
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                        return -1;
                      return 1905; /* subdi3_borrow_cc */

                    case 1:
                      return 1906; /* subsi3_borrow_cc */

                    default:
                      return -1;
                    }

                case 1:
                  if (!(
#line 6568 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL2mode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1907; /* *subdi3_borrow_cconly */

                case 2:
                  if (!
#line 6568 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL2mode)))
                    return -1;
                  return 1908; /* *subsi3_borrow_cconly */

                default:
                  return -1;
                }

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
              if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  switch (pattern224 (x1))
                    {
                    case 0:
                      switch (pattern243 (x1))
                        {
                        case 0:
                          if ((
#line 6586 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                            return 1909; /* *subdi3_cc */
                          break;

                        case 1:
                          if (
#line 6586 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                            return 1910; /* *subsi3_cc */
                          break;

                        default:
                          break;
                        }
                      break;

                    case 1:
                      if ((
#line 6620 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return 1913; /* *subdi3_cconly */
                      break;

                    case 2:
                      if (
#line 6620 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                        return 1914; /* *subsi3_cconly */
                      break;

                    default:
                      break;
                    }
                }
              operands[3] = x7;
              x9 = XVECEXP (x1, 0, 1);
              switch (GET_CODE (x9))
                {
                case SET:
                  x10 = XEXP (x9, 1);
                  if (GET_CODE (x10) != MINUS)
                    return -1;
                  x12 = XEXP (x9, 0);
                  operands[0] = x12;
                  x13 = XEXP (x10, 0);
                  if (!rtx_equal_p (x13, operands[1]))
                    return -1;
                  x11 = XEXP (x10, 1);
                  if (!rtx_equal_p (x11, operands[2]))
                    return -1;
                  switch (GET_MODE (x4))
                    {
                    case E_TFmode:
                      if (pattern273 (x10, 
E_TFmode) != 0
                          || !(
#line 6723 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                        return -1;
                      return 1926; /* *subtf3_cc */

                    case E_FPRX2mode:
                      if (pattern273 (x10, 
E_FPRX2mode) != 0
                          || !(
#line 6723 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                        return -1;
                      return 1927; /* *subfprx23_cc */

                    case E_DFmode:
                      if (pattern273 (x10, 
E_DFmode) != 0
                          || !
#line 6723 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                        return -1;
                      return 1928; /* *subdf3_cc */

                    case E_SFmode:
                      if (pattern273 (x10, 
E_SFmode) != 0
                          || !
#line 6723 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                        return -1;
                      return 1929; /* *subsf3_cc */

                    case E_TDmode:
                      if (pattern273 (x10, 
E_TDmode) != 0
                          || !(
#line 6723 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                        return -1;
                      return 1930; /* *subtd3_cc */

                    case E_DDmode:
                      if (pattern273 (x10, 
E_DDmode) != 0
                          || !(
#line 6723 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                        return -1;
                      return 1931; /* *subdd3_cc */

                    default:
                      return -1;
                    }

                case CLOBBER:
                  x12 = XEXP (x9, 0);
                  operands[0] = x12;
                  switch (GET_MODE (x4))
                    {
                    case E_TFmode:
                      if (pattern254 (
E_TFmode) != 0
                          || !(
#line 6739 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                        return -1;
                      return 1932; /* *subtf3_cconly */

                    case E_FPRX2mode:
                      if (pattern254 (
E_FPRX2mode) != 0
                          || !(
#line 6739 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                        return -1;
                      return 1933; /* *subfprx23_cconly */

                    case E_DFmode:
                      if (pattern254 (
E_DFmode) != 0
                          || !
#line 6739 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                        return -1;
                      return 1934; /* *subdf3_cconly */

                    case E_SFmode:
                      if (pattern254 (
E_SFmode) != 0
                          || !
#line 6739 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                        return -1;
                      return 1935; /* *subsf3_cconly */

                    case E_TDmode:
                      if (pattern254 (
E_TDmode) != 0
                          || !(
#line 6739 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                        return -1;
                      return 1936; /* *subtd3_cconly */

                    case E_DDmode:
                      if (pattern254 (
E_DDmode) != 0
                          || !(
#line 6739 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                        return -1;
                      return 1937; /* *subdd3_cconly */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern144 (x1, 
MINUS))
        {
        case 0:
          if (pattern283 (x1, 
E_DImode, 
E_TImode) != 0
              || !(
#line 6681 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1918; /* *subvdi3_ccoverflow */

        case 1:
          if (pattern283 (x1, 
E_SImode, 
E_DImode) != 0
              || !
#line 6681 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)))
            return -1;
          return 1919; /* *subvsi3_ccoverflow */

        default:
          return -1;
        }

    case MINUS:
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != MINUS)
        return -1;
      x13 = XEXP (x10, 0);
      if (GET_CODE (x13) != MINUS)
        return -1;
      x16 = XEXP (x5, 0);
      operands[1] = x16;
      x17 = XEXP (x5, 1);
      operands[2] = x17;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x12 = XEXP (x9, 0);
      operands[0] = x12;
      x18 = XEXP (x13, 0);
      if (!rtx_equal_p (x18, operands[1]))
        return -1;
      x19 = XEXP (x13, 1);
      if (!rtx_equal_p (x19, operands[2]))
        return -1;
      x11 = XEXP (x10, 1);
      if (!rtx_equal_p (x11, operands[3]))
        return -1;
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
          if (XWINT (x7, 0) != 0L)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern284 (x1, 
E_DImode) != 0
                  || !(
#line 6913 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 1950; /* *subdi3_slb_cc */

            case E_SImode:
              if (pattern284 (x1, 
E_SImode) != 0
                  || !
#line 6913 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                return -1;
              return 1951; /* *subsi3_slb_cc */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          if (!rtx_equal_p (x7, operands[1]))
            return -1;
          x15 = XEXP (x2, 0);
          if (GET_MODE (x15) != E_CCL2mode
              || GET_MODE (x3) != E_CCL2mode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern284 (x1, 
E_DImode) != 0
                  || !
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 1954; /* subdi3_slb_borrow1_cc */

            case E_SImode:
              if (pattern284 (x1, 
E_SImode) != 0)
                return -1;
              return 1955; /* subsi3_slb_borrow1_cc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_101 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case BSWAP:
      return recog_97 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_95 (x1, insn, pnum_clobbers);

    case COMPARE:
      return recog_94 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      switch (pattern36 (x1))
        {
        case 0:
          if (!
#line 990 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 570; /* *eltswapv16qi */

        case 1:
          if (!
#line 1060 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 572; /* eltswapv4si */

        case 2:
          if (!
#line 1060 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 573; /* eltswapv4sf */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      res = recog_81 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern70 (x1))
        {
        case 0:
          if (!(
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 1800; /* *trunctftd2 */

        case 1:
          if (!(
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 1801; /* *truncfprx2td2 */

        case 2:
          if (!
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 1802; /* *truncdftd2 */

        case 3:
          if (!
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 1803; /* *truncsftd2 */

        case 4:
          if (!(
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 1804; /* *trunctfdd2 */

        case 5:
          if (!(
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 1805; /* *truncfprx2dd2 */

        case 6:
          if (!
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 1806; /* *truncdfdd2 */

        case 7:
          if (!
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 1807; /* *truncsfdd2 */

        case 8:
          if (!(
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 1808; /* *trunctfsd2 */

        case 9:
          if (!(
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 1809; /* *truncfprx2sd2 */

        case 10:
          if (!
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 1810; /* *truncdfsd2 */

        case 11:
          if (!
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 1811; /* *truncsfsd2 */

        case 12:
          if (!(
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 1812; /* *trunctdtf2 */

        case 13:
          if (!(
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 1816; /* *truncddtf2 */

        case 14:
          if (!(
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 1820; /* *truncsdtf2 */

        case 15:
          if (!(
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 1813; /* *trunctdfprx22 */

        case 16:
          if (!(
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 1817; /* *truncddfprx22 */

        case 17:
          if (!(
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 1821; /* *truncsdfprx22 */

        case 18:
          if (!
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 1814; /* *trunctddf2 */

        case 19:
          if (!
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 1818; /* *truncdddf2 */

        case 20:
          if (!
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 1822; /* *truncsddf2 */

        case 21:
          if (!
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 1815; /* *trunctdsf2 */

        case 22:
          if (!
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 1819; /* *truncddsf2 */

        case 23:
          if (!
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 1823; /* *truncsdsf2 */

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != PC)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
          res = recog_84 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (!s390_unsigned_integer_comparison (x5, E_VOIDmode))
        return -1;
      operands[0] = x5;
      switch (pattern115 (x1))
        {
        case 0:
          if (!(
#line 1575 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1493; /* *cmp_and_br_unsigned_di */

        case 1:
          if (!
#line 1575 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return -1;
          return 1494; /* *cmp_and_br_unsigned_si */

        case 2:
          if (!(
#line 1633 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1497; /* *icmp_and_br_unsigned_di */

        case 3:
          if (!
#line 1633 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return -1;
          return 1498; /* *icmp_and_br_unsigned_si */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      return recog_98 (x1, insn, pnum_clobbers);

    case ZERO_EXTRACT:
      x6 = XEXP (x3, 2);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      operands[3] = x6;
      if (const_int_operand (operands[3], E_VOIDmode))
        {
          res = recog_93 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XWINT (x6, 0) != 0L)
        return -1;
      switch (pattern72 (x1))
        {
        case 0:
          if (!(
#line 4210 "../../gcc/config/s390/s390.md"
(!TARGET_Z10) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1606; /* *pre_z10_extzvdi */

        case 1:
          if (!
#line 4210 "../../gcc/config/s390/s390.md"
(!TARGET_Z10))
            return -1;
          return 1607; /* *pre_z10_extzvsi */

        default:
          return -1;
        }

    case LSHIFTRT:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != ZERO_EXTRACT
          || GET_MODE (x4) != E_DImode
          || pattern89 (x1) != 0
          || !register_operand (operands[0], E_DImode))
        return -1;
      x7 = XEXP (x4, 1);
      operands[1] = x7;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x8 = XEXP (x4, 2);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 0);
      operands[3] = x5;
      if (!register_operand (operands[3], E_DImode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[4] = x9;
      if (!nonzero_shift_count_operand (operands[4], E_DImode)
          || !
#line 4129 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && 64 - UINTVAL (operands[4]) >= UINTVAL (operands[1])))
        return -1;
      return 1585; /* *extzvdi_clobbercc_lshiftrt */

    case IOR:
      return recog_96 (x1, insn, pnum_clobbers);

    case NE:
      x9 = XEXP (x3, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern38 (x1) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTRACT:
          if (GET_MODE (x5) != E_DImode)
            return -1;
          x10 = XEXP (x5, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          x11 = XEXP (x5, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x12 = XEXP (x5, 2);
          operands[2] = x12;
          if (!const_int_operand (operands[2], E_VOIDmode)
              || !
#line 4162 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (1, INTVAL (operands[2]), 64)))
            return -1;
          return 1591; /* *extract1bitdi_clobbercc */

        case REG:
        case SUBREG:
          operands[1] = x5;
          if (!register_operand (operands[1], E_CCZ1mode)
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          return 1960; /* sne */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      x6 = XEXP (x3, 2);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (pattern72 (x1))
        {
        case 0:
          if (!
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 1608; /* *pre_z10_extvdi */

        case 1:
          return 1609; /* *pre_z10_extvsi */

        default:
          return -1;
        }

    case XOR:
      return recog_100 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      x13 = XVECEXP (x1, 0, 1);
      if (pattern37 (x13, pnum_clobbers) != 0)
        return -1;
      switch (pattern150 (x1))
        {
        case 0:
          if (
#line 5289 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
            {
              *pnum_clobbers = 1;
              return 1696; /* *fixuns_truncdfdi2_z13 */
            }
          if (!(
#line 5304 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DFmode != DFmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1702; /* *fixuns_truncdfdi2_z196 */

        case 1:
          if (!(
#line 5304 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TFmode != DFmode)) && (((
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 1698; /* *fixuns_trunctfdi2_z196 */

        case 2:
          if (!(
#line 5304 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || FPRX2mode != DFmode)) && (((
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 1700; /* *fixuns_truncfprx2di2_z196 */

        case 3:
          if (!(
#line 5304 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || SFmode != DFmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1704; /* *fixuns_truncsfdi2_z196 */

        case 4:
          if (!(
#line 5304 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TDmode != DFmode)) && (((
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 1706; /* *fixuns_trunctddi2_z196 */

        case 5:
          if (!(
#line 5304 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DDmode != DFmode)) && (((
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 1708; /* *fixuns_truncdddi2_z196 */

        case 6:
          if (!(
#line 5289 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT) && 
#line 674 "../../gcc/config/s390/s390.md"
(TARGET_VXE2)))
            return -1;
          *pnum_clobbers = 1;
          return 1697; /* *fixuns_truncsfsi2_z13 */

        case 7:
          if (!
#line 5304 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || SFmode != DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 1705; /* *fixuns_truncsfsi2_z196 */

        case 8:
          if (!(
#line 5304 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TFmode != DFmode)) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 1699; /* *fixuns_trunctfsi2_z196 */

        case 9:
          if (!(
#line 5304 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || FPRX2mode != DFmode)) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 1701; /* *fixuns_truncfprx2si2_z196 */

        case 10:
          if (!
#line 5304 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DFmode != DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 1703; /* *fixuns_truncdfsi2_z196 */

        case 11:
          if (!(
#line 5304 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TDmode != DFmode)) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          *pnum_clobbers = 1;
          return 1707; /* *fixuns_trunctdsi2_z196 */

        case 12:
          if (!(
#line 5304 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DDmode != DFmode)) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          *pnum_clobbers = 1;
          return 1709; /* *fixuns_truncddsi2_z196 */

        default:
          return -1;
        }

    case FIX:
      x13 = XVECEXP (x1, 0, 1);
      if (pattern37 (x13, pnum_clobbers) != 0)
        return -1;
      switch (pattern151 (x1))
        {
        case 0:
          if (
#line 5327 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
            {
              *pnum_clobbers = 1;
              return 1710; /* *fix_truncdfdi2_bfp_z13 */
            }
          if (!(
#line 5340 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DFmode != DFmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1716; /* *fix_truncdfdi2_bfp */

        case 1:
          if (!(
#line 5340 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TFmode != DFmode)) && (((
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 1712; /* *fix_trunctfdi2_bfp */

        case 2:
          if (!(
#line 5340 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || FPRX2mode != DFmode)) && (((
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 1714; /* *fix_truncfprx2di2_bfp */

        case 3:
          if (!(
#line 5340 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || SFmode != DFmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1718; /* *fix_truncsfdi2_bfp */

        case 4:
          if (!
#line 5374 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 1;
          return 1720; /* fix_trunctddi2_dfp */

        case 5:
          if (!
#line 5374 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 1;
          return 1721; /* fix_truncdddi2_dfp */

        case 6:
          if ((
#line 5327 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT) && 
#line 674 "../../gcc/config/s390/s390.md"
(TARGET_VXE2)))
            {
              *pnum_clobbers = 1;
              return 1711; /* *fix_truncsfsi2_bfp_z13 */
            }
          if (!
#line 5340 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || SFmode != DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 1719; /* *fix_truncsfsi2_bfp */

        case 7:
          if (!(
#line 5340 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TFmode != DFmode)) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 1713; /* *fix_trunctfsi2_bfp */

        case 8:
          if (!(
#line 5340 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || FPRX2mode != DFmode)) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 1715; /* *fix_truncfprx2si2_bfp */

        case 9:
          if (!
#line 5340 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DFmode != DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 1717; /* *fix_truncdfsi2_bfp */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern70 (x1))
        {
        case 0:
          if (!(
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 1824; /* *extendtftd2 */

        case 1:
          if (!(
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 1825; /* *extendfprx2td2 */

        case 2:
          if (!
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 1826; /* *extenddftd2 */

        case 3:
          if (!
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 1827; /* *extendsftd2 */

        case 4:
          if (!(
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 1828; /* *extendtfdd2 */

        case 5:
          if (!(
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 1829; /* *extendfprx2dd2 */

        case 6:
          if (!
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 1830; /* *extenddfdd2 */

        case 7:
          if (!
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 1831; /* *extendsfdd2 */

        case 8:
          if (!(
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 1832; /* *extendtfsd2 */

        case 9:
          if (!(
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 1833; /* *extendfprx2sd2 */

        case 10:
          if (!
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 1834; /* *extenddfsd2 */

        case 11:
          if (!
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 1835; /* *extendsfsd2 */

        case 12:
          if (!(
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 1836; /* *extendtdtf2 */

        case 13:
          if (!(
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 1840; /* *extendddtf2 */

        case 14:
          if (!(
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 1844; /* *extendsdtf2 */

        case 15:
          if (!(
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 1837; /* *extendtdfprx22 */

        case 16:
          if (!(
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 1841; /* *extendddfprx22 */

        case 17:
          if (!(
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 1845; /* *extendsdfprx22 */

        case 18:
          if (!
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 1838; /* *extendtddf2 */

        case 19:
          if (!
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 1842; /* *extenddddf2 */

        case 20:
          if (!
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 1846; /* *extendsddf2 */

        case 21:
          if (!
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 1839; /* *extendtdsf2 */

        case 22:
          if (!
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 1843; /* *extendddsf2 */

        case 23:
          if (!
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 1847; /* *extendsdsf2 */

        default:
          return -1;
        }

    case NOT:
      if (pattern38 (x1) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          switch (pattern192 (x3))
            {
            case 0:
              if (!(
#line 8429 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2055; /* *notdi */

            case 1:
              if (!
#line 8429 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2056; /* *notsi */

            default:
              return -1;
            }

        case XOR:
          x11 = XEXP (x5, 0);
          operands[1] = x11;
          x10 = XEXP (x5, 1);
          operands[2] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern225 (x3, 
E_DImode) != 0
                  || !(
#line 8834 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2072; /* *nxordi */

            case E_SImode:
              if (pattern225 (x3, 
E_SImode) != 0
                  || !
#line 8834 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2073; /* *nxorsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      return recog_99 (x1, insn, pnum_clobbers);

    case ABS:
      if (pattern38 (x1) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          if (pattern178 (x3) != 0
              || !
#line 9072 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2102; /* *absdi2_sign */

        case REG:
        case SUBREG:
          switch (pattern179 (x3))
            {
            case 0:
              if (!
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2107; /* absdi2 */

            case 1:
              return 2108; /* abssi2 */

            case 2:
              if (!(
#line 9160 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2123; /* *abstf2 */

            case 3:
              if (!(
#line 9160 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2124; /* *absfprx22 */

            case 4:
              if (!
#line 9160 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2125; /* *absdf2 */

            case 5:
              if (!
#line 9160 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2126; /* *abssf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      x13 = XVECEXP (x1, 0, 1);
      if (pattern39 (x13) != 0)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      if (!shift_count_operand (operands[2], E_QImode))
        return -1;
      switch (pattern192 (x3))
        {
        case 0:
          if (
#line 9457 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return 2166; /* *ashrdi3_31 */
          if (!
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2169; /* *ashrdi3 */

        case 1:
          return 2172; /* *ashrsi3 */

        default:
          return -1;
        }

    case CALL:
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != MEM
          || GET_MODE (x5) != E_QImode)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x11 = XEXP (x5, 0);
      operands[1] = x11;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      x14 = XEXP (x13, 0);
      operands[3] = x14;
      if (!register_operand (operands[3], E_VOIDmode))
        return -1;
      if (bras_sym_operand (operands[1], E_VOIDmode))
        {
          if (const_int_operand (operands[2], E_SImode)
              && 
#line 10698 "../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn)
   && TARGET_SMALL_EXEC
   && GET_MODE (operands[3]) == Pmode))
            return 2230; /* *bras_r */
          if (const_int_operand (operands[2], E_VOIDmode)
              && 
#line 10711 "../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn)

   && GET_MODE (operands[3]) == Pmode))
            return 2231; /* *brasl_r */
        }
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      if (address_operand (operands[1], E_VOIDmode)
          && 
#line 10725 "../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode))
        return 2232; /* *basr_r */
      if (!register_operand (operands[1], E_VOIDmode))
        return -1;
      if (
#line 10749 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode))
        return 2233; /* *basr_r_via_thunk_z10 */
      if (pnum_clobbers == NULL)
        return -1;
      if ((
#line 10772 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode) && 
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        {
          *pnum_clobbers = 1;
          return 2234; /* *basr_r_via_thunk */
        }
      if (!(
#line 10772 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode) && 
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 2235; /* *basr_r_via_thunk */

    case POPCOUNT:
      if (pattern40 (x1) != 0
          || !
#line 11833 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
        return -1;
      return 2292; /* *popcountdi_z15 */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x3, 0) != 1
          || XINT (x3, 1) != 16
          || GET_MODE (x3) != E_CCRAWmode)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 33
          || GET_MODE (x4) != E_CCRAWmode)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != SET)
        return -1;
      x15 = XEXP (x13, 1);
      if (pattern152 (x15, 
E_BLKmode, 
17, 
UNSPEC_VOLATILE, 
1) != 0)
        return -1;
      x16 = XVECEXP (x3, 0, 0);
      operands[0] = x16;
      if (!const_int_operand (operands[0], E_VOIDmode))
        return -1;
      x14 = XEXP (x13, 0);
      operands[1] = x14;
      if (!memory_operand (operands[1], E_BLKmode))
        return -1;
      x17 = XVECEXP (x15, 0, 0);
      if (!rtx_equal_p (x17, operands[0]))
        return -1;
      if (pnum_clobbers != NULL)
        {
          if (
#line 12107 "../../gcc/config/s390/s390.md"
(TARGET_VX && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
            {
              *pnum_clobbers = 32;
              return 2304; /* tbegin_1_z13 */
            }
          if (
#line 12135 "../../gcc/config/s390/s390.md"
(TARGET_HTM && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
            {
              *pnum_clobbers = 16;
              return 2305; /* tbegin_1 */
            }
        }
      if (!
#line 12146 "../../gcc/config/s390/s390.md"
(TARGET_HTM && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
        return -1;
      return 2306; /* tbegin_nofloat_1 */

    default:
      return -1;
    }
}
