/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      return pattern3 (x3, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern3 (x3, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern3 (x3, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern3 (x3, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern3 (x3, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern3 (x3, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern3 (x3, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern3 (x3, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern3 (x3, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (pattern3 (x3, 
E_V1SImode) != 0)
        return -1;
      return 9;

    case E_V2SImode:
      if (pattern3 (x3, 
E_V2SImode) != 0)
        return -1;
      return 10;

    case E_V4SImode:
      if (pattern3 (x3, 
E_V4SImode) != 0)
        return -1;
      return 11;

    case E_V1DImode:
      if (pattern3 (x3, 
E_V1DImode) != 0)
        return -1;
      return 12;

    case E_V2DImode:
      if (pattern3 (x3, 
E_V2DImode) != 0)
        return -1;
      return 13;

    case E_V4SFmode:
      if (pattern3 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 14;

    case E_V2DFmode:
      if (pattern3 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 15;

    case E_V1TFmode:
      if (pattern3 (x3, 
E_V1TFmode) != 0)
        return -1;
      return 16;

    case E_TFmode:
      if (pattern3 (x3, 
E_TFmode) != 0)
        return -1;
      return 17;

    default:
      return -1;
    }
}

int
pattern25 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V8HImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V8HImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V8HImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!const_mask_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern32 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern35 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCRAWmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCRAWmode)
    return -1;
  return 0;
}

int
pattern37 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != 0)
    return -1;
  return 0;
}

int
pattern41 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 33
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern45 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  if (!cc_reg_operand (operands[2], E_VOIDmode))
    return -1;
  x3 = XEXP (x1, 1);
  operands[3] = x3;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !s390_comparison (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !s390_comparison (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern51 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern58 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], i2))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!const_mask_operand (operands[2], E_QImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!const_mask_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern63 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  x6 = XEXP (x2, 1);
  operands[2] = x6;
  return pattern62 (x1); /* [-1, 1] */
}

int
pattern68 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != i1
      || GET_MODE (x3) != E_CCRAWmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCRAWmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XVECEXP (x7, 0, 0);
  operands[1] = x8;
  x9 = XVECEXP (x7, 0, 1);
  operands[2] = x9;
  x10 = XVECEXP (x7, 0, 2);
  operands[3] = x10;
  return 0;
}

int
pattern75 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 16)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != USE)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 0
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 33
      || GET_MODE (x9) != E_CCmode)
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 1
      || GET_MODE (x11) != E_SImode)
    return -1;
  return pattern69 (x2); /* [-1, 23] */
}

int
pattern87 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          return 1;

        case E_QImode:
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern95 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  return pattern94 (x5); /* [-1, 1] */
}

int
pattern101 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 33
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

int
pattern111 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  switch (XVECLEN (x3, 0))
    {
    case 8:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XVECEXP (x3, 0, 4);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x10 = XVECEXP (x3, 0, 5);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x11 = XVECEXP (x3, 0, 6);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      x12 = XVECEXP (x3, 0, 7);
      if (GET_CODE (x12) != CONST_INT
          || !register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || GET_MODE (x2) != E_V8QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      switch (XWINT (x5, 0))
        {
        case 0L:
          if (XWINT (x6, 0) != 1L
              || XWINT (x7, 0) != 2L
              || XWINT (x8, 0) != 3L
              || XWINT (x9, 0) != 4L
              || XWINT (x10, 0) != 5L
              || XWINT (x11, 0) != 6L
              || XWINT (x12, 0) != 7L)
            return -1;
          return 0;

        case 8L:
          if (XWINT (x6, 0) != 9L
              || XWINT (x7, 0) != 10L
              || XWINT (x8, 0) != 11L
              || XWINT (x9, 0) != 12L
              || XWINT (x10, 0) != 13L
              || XWINT (x11, 0) != 14L
              || XWINT (x12, 0) != 15L)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 4:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x8) != CONST_INT
          || !register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      switch (XWINT (x5, 0))
        {
        case 0L:
          if (XWINT (x6, 0) != 1L
              || XWINT (x7, 0) != 2L
              || XWINT (x8, 0) != 3L)
            return -1;
          return 2;

        case 4L:
          if (XWINT (x6, 0) != 5L
              || XWINT (x7, 0) != 6L
              || XWINT (x8, 0) != 7L)
            return -1;
          return 3;

        default:
          return -1;
        }

    case 2:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT
          || !register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || GET_MODE (x2) != E_V2SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      switch (XWINT (x5, 0))
        {
        case 0L:
          if (XWINT (x6, 0) != 1L)
            return -1;
          return 4;

        case 2L:
          if (XWINT (x6, 0) != 3L)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern154 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_DImode:
      if (!nonimmediate_operand (operands[1], E_DImode)
          || !general_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !general_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern159 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern165 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern169 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern174 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern180 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33)
    return -1;
  return 0;
}

int
pattern184 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern191 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_MODE (x6))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !scratch_operand (operands[0], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !scratch_operand (operands[0], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern199 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !immediate_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern207 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern217 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern223 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  operands[3] = x1;
  if (!const0_operand (operands[3], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern230 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 5
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCRAWmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  operands[1] = x8;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  x9 = XEXP (x6, 1);
  x10 = XEXP (x9, 0);
  operands[2] = x10;
  x11 = XEXP (x2, 0);
  operands[3] = x11;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern244 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[2], i1)
      || !contiguous_bitmask_nowrap_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern254 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !const0_operand (operands[3], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern262 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !immediate_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern271 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i2)
      || GET_MODE (x1) != i2)
    return -1;
  return 0;
}

int
pattern277 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern282 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

int
pattern296 (rtx x1, unsigned int i1, machine_mode i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 9);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i5
      || GET_MODE (x5) != i2)
    return -1;
  x6 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i4
      || GET_MODE (x7) != i2)
    return -1;
  x8 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != i3
      || GET_MODE (x9) != i2)
    return -1;
  x10 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i1)
    return -1;
  return 0;
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern22 (x1))
    {
    case 0:
      if (!
#line 1145 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 244; /* vec_srlv16qiv16qi */

    case 1:
      if (!
#line 1145 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 248; /* vec_srlv16qiv8hi */

    case 2:
      if (!
#line 1145 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 252; /* vec_srlv16qiv4si */

    case 3:
      if (!
#line 1145 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 245; /* vec_srlv8hiv16qi */

    case 4:
      if (!
#line 1145 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 249; /* vec_srlv8hiv8hi */

    case 5:
      if (!
#line 1145 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 253; /* vec_srlv8hiv4si */

    case 6:
      if (!
#line 1145 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 246; /* vec_srlv4siv16qi */

    case 7:
      if (!
#line 1145 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 250; /* vec_srlv4siv8hi */

    case 8:
      if (!
#line 1145 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 254; /* vec_srlv4siv4si */

    case 9:
      if (!
#line 1145 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 247; /* vec_srlv2div16qi */

    case 10:
      if (!
#line 1145 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 251; /* vec_srlv2div8hi */

    case 11:
      if (!
#line 1145 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 255; /* vec_srlv2div4si */

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case ZERO_EXTEND:
      if (pattern164 (x1, 
E_V4SImode, 
E_DImode, 
E_SImode) != 0)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_SImode:
          if (GET_MODE (x5) != E_SImode
              || !register_operand (operands[0], E_V4SImode)
              || !
#line 450 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && TARGET_64BIT && UINTVAL (operands[3]) < 4))
            return -1;
          return 38; /* vec_scatter_elementv4si_DI */

        case E_SFmode:
          if (GET_MODE (x5) != E_SFmode
              || !register_operand (operands[0], E_V4SFmode)
              || !
#line 450 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && TARGET_64BIT && UINTVAL (operands[3]) < 4))
            return -1;
          return 39; /* vec_scatter_elementv4sf_DI */

        default:
          return -1;
        }

    case SUBREG:
      if (maybe_ne (SUBREG_BYTE (x7), 4)
          || pattern164 (x1, 
E_V2DImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_DImode:
          if (GET_MODE (x5) != E_DImode
              || !register_operand (operands[0], E_V2DImode)
              || !
#line 466 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && !TARGET_64BIT && UINTVAL (operands[3]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 40; /* vec_scatter_elementv2di_SI */

        case E_DFmode:
          if (GET_MODE (x5) != E_DFmode
              || !register_operand (operands[0], E_V2DFmode)
              || !
#line 466 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && !TARGET_64BIT && UINTVAL (operands[3]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 41; /* vec_scatter_elementv2df_SI */

        default:
          return -1;
        }

    case VEC_SELECT:
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != PARALLEL
          || XVECLEN (x8, 0) != 1)
        return -1;
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      x10 = XVECEXP (x8, 0, 0);
      operands[3] = x10;
      if (!const_mask_operand (operands[3], E_QImode)
          || !address_operand (operands[2], E_DImode))
        return -1;
      x11 = XEXP (x5, 1);
      x12 = XVECEXP (x11, 0, 0);
      if (!rtx_equal_p (x12, operands[3]))
        return -1;
      switch (GET_MODE (x2))
        {
        case E_SImode:
          if (pattern265 (x1, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 482 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) < GET_MODE_NUNITS (V4SImode)))
            return -1;
          return 42; /* vec_scatter_elementv4si_SI */

        case E_DImode:
          if (pattern265 (x1, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 482 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 43; /* vec_scatter_elementv2di_DI */

        case E_DFmode:
          if (pattern266 (x1, 
E_V2DFmode, 
E_DFmode, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 482 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 44; /* vec_scatter_elementv2df_DI */

        case E_SFmode:
          if (pattern266 (x1, 
E_V4SFmode, 
E_SFmode, 
E_V4SImode, 
E_SImode) != 0
              || !(
#line 482 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 23 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE)))
            return -1;
          return 45; /* vec_scatter_elementv4sf_SI */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      res = recog_22 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      switch (GET_MODE (x4))
        {
        case E_DImode:
          if (!general_operand (x3, E_DImode))
            return -1;
          operands[1] = x3;
          operands[0] = x4;
          if (nonimmediate_operand (operands[0], E_DImode))
            {
              if (
#line 1174 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCTmode) && TARGET_ZARCH))
                return 1447; /* *cmpdi_cct */
              if ((
#line 1262 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 1454; /* *cmpdi_ccs */
              if (
#line 1327 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode) && TARGET_ZARCH))
                return 1460; /* *cmpdi_ccu */
            }
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x3;
          operands[1] = x4;
          if (!register_operand (operands[1], E_DImode)
              || !(
#line 6637 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL3mode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1915; /* *subdi3_cconly2 */

        case E_SImode:
          if (!general_operand (x3, E_SImode))
            return -1;
          operands[1] = x3;
          operands[0] = x4;
          if (nonimmediate_operand (operands[0], E_SImode))
            {
              if (
#line 1188 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCTmode)))
                return 1448; /* *cmpsi_cct */
              if (
#line 1262 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                return 1455; /* *cmpsi_ccs */
              if (
#line 1346 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode)))
                return 1461; /* *cmpsi_ccu */
            }
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x3;
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 6637 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL3mode)))
            return -1;
          *pnum_clobbers = 1;
          return 1916; /* *subsi3_cconly2 */

        case E_HImode:
          operands[0] = x4;
          if (!nonimmediate_operand (operands[0], E_HImode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_HImode)
              || !
#line 1366 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode)
   && !register_operand (operands[1], HImode)))
            return -1;
          return 1462; /* *cmphi_ccu */

        case E_QImode:
          operands[0] = x4;
          if (!nonimmediate_operand (operands[0], E_QImode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_QImode)
              || !
#line 1382 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode)
   && !register_operand (operands[1], QImode)))
            return -1;
          return 1463; /* *cmpqi_ccu */

        case E_TFmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_TFmode))
            return -1;
          operands[1] = x3;
          if (general_operand (operands[1], E_TFmode)
              && (
#line 1488 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return 1477; /* *cmptf_ccs */
          if (register_operand (operands[1], E_TFmode)
              && 
#line 1503 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_VXE))
            return 1483; /* *cmptf_ccs */
          if (general_operand (operands[1], E_TFmode)
              && (
#line 1514 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return 1484; /* *cmptf_ccsfps */
          if (!register_operand (operands[1], E_TFmode)
              || !
#line 1529 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_VXE))
            return -1;
          return 1490; /* *cmptf_ccsfps */

        case E_FPRX2mode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_FPRX2mode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_FPRX2mode))
            return -1;
          if ((
#line 1488 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return 1478; /* *cmpfprx2_ccs */
          if (!(
#line 1514 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 1485; /* *cmpfprx2_ccsfps */

        case E_DFmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_DFmode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_DFmode))
            return -1;
          if (
#line 1488 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT))
            return 1479; /* *cmpdf_ccs */
          if (!
#line 1514 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 1486; /* *cmpdf_ccsfps */

        case E_SFmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_SFmode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_SFmode))
            return -1;
          if (
#line 1488 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT))
            return 1480; /* *cmpsf_ccs */
          if (!
#line 1514 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 1487; /* *cmpsf_ccsfps */

        case E_TDmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_TDmode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_TDmode))
            return -1;
          if ((
#line 1488 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return 1481; /* *cmptd_ccs */
          if (!(
#line 1514 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1488; /* *cmptd_ccsfps */

        case E_DDmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_DDmode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_DDmode))
            return -1;
          if ((
#line 1488 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return 1482; /* *cmpdd_ccs */
          if (!(
#line 1514 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1489; /* *cmpdd_ccsfps */

        default:
          return -1;
        }

    case NEG:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!nonimmediate_operand (operands[1], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !general_operand (operands[2], E_DImode)
              || !(
#line 6129 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCLmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1869; /* *adddi3_cconly2 */

        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !general_operand (operands[2], E_SImode)
              || !
#line 6129 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCLmode)))
            return -1;
          *pnum_clobbers = 1;
          return 1870; /* *addsi3_cconly2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[4] = x5;
  x6 = XEXP (x3, 1);
  operands[1] = x6;
  x7 = XEXP (x3, 2);
  operands[2] = x7;
  x8 = XEXP (x4, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[3] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern202 (x3, 
E_V1QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1QImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1263; /* *vec_sel0v1qi */
          if (!all_ones_operand (operands[4], E_V1QImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1304; /* *vec_sel1v1qi */

        case E_V2QImode:
          if (pattern202 (x3, 
E_V2QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2QImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1264; /* *vec_sel0v2qi */
          if (!all_ones_operand (operands[4], E_V2QImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1305; /* *vec_sel1v2qi */

        case E_V4QImode:
          if (pattern202 (x3, 
E_V4QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4QImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1265; /* *vec_sel0v4qi */
          if (!all_ones_operand (operands[4], E_V4QImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1306; /* *vec_sel1v4qi */

        case E_V8QImode:
          if (pattern202 (x3, 
E_V8QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V8QImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1266; /* *vec_sel0v8qi */
          if (!all_ones_operand (operands[4], E_V8QImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1307; /* *vec_sel1v8qi */

        case E_V16QImode:
          if (pattern202 (x3, 
E_V16QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V16QImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1267; /* *vec_sel0v16qi */
          if (!all_ones_operand (operands[4], E_V16QImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1308; /* *vec_sel1v16qi */

        case E_V1HImode:
          if (pattern202 (x3, 
E_V1HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1HImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1268; /* *vec_sel0v1hi */
          if (!all_ones_operand (operands[4], E_V1HImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1309; /* *vec_sel1v1hi */

        case E_V2HImode:
          if (pattern202 (x3, 
E_V2HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2HImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1269; /* *vec_sel0v2hi */
          if (!all_ones_operand (operands[4], E_V2HImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1310; /* *vec_sel1v2hi */

        case E_V4HImode:
          if (pattern202 (x3, 
E_V4HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4HImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1270; /* *vec_sel0v4hi */
          if (!all_ones_operand (operands[4], E_V4HImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1311; /* *vec_sel1v4hi */

        case E_V8HImode:
          if (pattern202 (x3, 
E_V8HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V8HImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1271; /* *vec_sel0v8hi */
          if (!all_ones_operand (operands[4], E_V8HImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1312; /* *vec_sel1v8hi */

        case E_V1SImode:
          if (pattern202 (x3, 
E_V1SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1SImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1272; /* *vec_sel0v1si */
          if (!all_ones_operand (operands[4], E_V1SImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1313; /* *vec_sel1v1si */

        case E_V2SImode:
          if (pattern202 (x3, 
E_V2SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2SImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1273; /* *vec_sel0v2si */
          if (!all_ones_operand (operands[4], E_V2SImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1314; /* *vec_sel1v2si */

        case E_V4SImode:
          if (pattern202 (x3, 
E_V4SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4SImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1274; /* *vec_sel0v4si */
          if (!all_ones_operand (operands[4], E_V4SImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1315; /* *vec_sel1v4si */

        case E_V1DImode:
          if (pattern202 (x3, 
E_V1DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1DImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1275; /* *vec_sel0v1di */
          if (!all_ones_operand (operands[4], E_V1DImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1316; /* *vec_sel1v1di */

        case E_V2DImode:
          if (pattern202 (x3, 
E_V2DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2DImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1276; /* *vec_sel0v2di */
          if (!all_ones_operand (operands[4], E_V2DImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1317; /* *vec_sel1v2di */

        case E_V1SFmode:
          if (pattern203 (x3, 
E_V1SFmode, 
E_V1SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1SImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1277; /* *vec_sel0v1sf */
          if (!all_ones_operand (operands[4], E_V1SImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1318; /* *vec_sel1v1sf */

        case E_V2SFmode:
          if (pattern203 (x3, 
E_V2SFmode, 
E_V2SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2SImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1278; /* *vec_sel0v2sf */
          if (!all_ones_operand (operands[4], E_V2SImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1319; /* *vec_sel1v2sf */

        case E_V4SFmode:
          if (pattern203 (x3, 
E_V4SFmode, 
E_V4SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4SImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1279; /* *vec_sel0v4sf */
          if (!all_ones_operand (operands[4], E_V4SImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1320; /* *vec_sel1v4sf */

        case E_V1DFmode:
          if (pattern203 (x3, 
E_V1DFmode, 
E_V1DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1DImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1280; /* *vec_sel0v1df */
          if (!all_ones_operand (operands[4], E_V1DImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1321; /* *vec_sel1v1df */

        case E_V2DFmode:
          if (pattern203 (x3, 
E_V2DFmode, 
E_V2DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2DImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1281; /* *vec_sel0v2df */
          if (!all_ones_operand (operands[4], E_V2DImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1322; /* *vec_sel1v2df */

        case E_V1TFmode:
          if (pattern204 (x3, 
E_V1TFmode) != 0
              || !
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1282; /* *vec_sel0v1tf */

        case E_V1TImode:
          if (pattern204 (x3, 
E_V1TImode) != 0
              || !
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1283; /* *vec_sel0v1ti */

        case E_TImode:
          if (pattern204 (x3, 
E_TImode) != 0
              || !
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1284; /* *vec_sel0ti */

        default:
          return -1;
        }

    case NOT:
      x9 = XEXP (x8, 0);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern205 (x3, 
E_V1QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1QImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1285; /* *vec_sel0v1qi */
          if (!all_ones_operand (operands[4], E_V1QImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1323; /* *vec_sel1v1qi */

        case E_V2QImode:
          if (pattern205 (x3, 
E_V2QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2QImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1286; /* *vec_sel0v2qi */
          if (!all_ones_operand (operands[4], E_V2QImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1324; /* *vec_sel1v2qi */

        case E_V4QImode:
          if (pattern205 (x3, 
E_V4QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4QImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1287; /* *vec_sel0v4qi */
          if (!all_ones_operand (operands[4], E_V4QImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1325; /* *vec_sel1v4qi */

        case E_V8QImode:
          if (pattern205 (x3, 
E_V8QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V8QImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1288; /* *vec_sel0v8qi */
          if (!all_ones_operand (operands[4], E_V8QImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1326; /* *vec_sel1v8qi */

        case E_V16QImode:
          if (pattern205 (x3, 
E_V16QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V16QImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1289; /* *vec_sel0v16qi */
          if (!all_ones_operand (operands[4], E_V16QImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1327; /* *vec_sel1v16qi */

        case E_V1HImode:
          if (pattern205 (x3, 
E_V1HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1HImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1290; /* *vec_sel0v1hi */
          if (!all_ones_operand (operands[4], E_V1HImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1328; /* *vec_sel1v1hi */

        case E_V2HImode:
          if (pattern205 (x3, 
E_V2HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2HImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1291; /* *vec_sel0v2hi */
          if (!all_ones_operand (operands[4], E_V2HImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1329; /* *vec_sel1v2hi */

        case E_V4HImode:
          if (pattern205 (x3, 
E_V4HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4HImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1292; /* *vec_sel0v4hi */
          if (!all_ones_operand (operands[4], E_V4HImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1330; /* *vec_sel1v4hi */

        case E_V8HImode:
          if (pattern205 (x3, 
E_V8HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V8HImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1293; /* *vec_sel0v8hi */
          if (!all_ones_operand (operands[4], E_V8HImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1331; /* *vec_sel1v8hi */

        case E_V1SImode:
          if (pattern205 (x3, 
E_V1SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1SImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1294; /* *vec_sel0v1si */
          if (!all_ones_operand (operands[4], E_V1SImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1332; /* *vec_sel1v1si */

        case E_V2SImode:
          if (pattern205 (x3, 
E_V2SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2SImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1295; /* *vec_sel0v2si */
          if (!all_ones_operand (operands[4], E_V2SImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1333; /* *vec_sel1v2si */

        case E_V4SImode:
          if (pattern205 (x3, 
E_V4SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4SImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1296; /* *vec_sel0v4si */
          if (!all_ones_operand (operands[4], E_V4SImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1334; /* *vec_sel1v4si */

        case E_V1DImode:
          if (pattern205 (x3, 
E_V1DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1DImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1297; /* *vec_sel0v1di */
          if (!all_ones_operand (operands[4], E_V1DImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1335; /* *vec_sel1v1di */

        case E_V2DImode:
          if (pattern205 (x3, 
E_V2DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2DImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1298; /* *vec_sel0v2di */
          if (!all_ones_operand (operands[4], E_V2DImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1336; /* *vec_sel1v2di */

        case E_V1SFmode:
          if (pattern206 (x3, 
E_V1SFmode, 
E_V1SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1SImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1299; /* *vec_sel0v1sf */
          if (!all_ones_operand (operands[4], E_V1SImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1337; /* *vec_sel1v1sf */

        case E_V2SFmode:
          if (pattern206 (x3, 
E_V2SFmode, 
E_V2SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2SImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1300; /* *vec_sel0v2sf */
          if (!all_ones_operand (operands[4], E_V2SImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1338; /* *vec_sel1v2sf */

        case E_V4SFmode:
          if (pattern206 (x3, 
E_V4SFmode, 
E_V4SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4SImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1301; /* *vec_sel0v4sf */
          if (!all_ones_operand (operands[4], E_V4SImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1339; /* *vec_sel1v4sf */

        case E_V1DFmode:
          if (pattern206 (x3, 
E_V1DFmode, 
E_V1DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1DImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1302; /* *vec_sel0v1df */
          if (!all_ones_operand (operands[4], E_V1DImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1340; /* *vec_sel1v1df */

        case E_V2DFmode:
          if (pattern206 (x3, 
E_V2DFmode, 
E_V2DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2DImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1303; /* *vec_sel0v2df */
          if (!all_ones_operand (operands[4], E_V2DImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1341; /* *vec_sel1v2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_55 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || GET_MODE (x3) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1QImode)) - 1)
  ))
        return 864; /* *ashrv1qi3 */
      if (!register_operand (operands[2], E_V1QImode)
          || !
#line 1454 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 933; /* vashrv1qi3 */

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x3) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2QImode)) - 1)
  ))
        return 868; /* *ashrv2qi3 */
      if (!register_operand (operands[2], E_V2QImode)
          || !
#line 1454 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 934; /* vashrv2qi3 */

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x3) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4QImode)) - 1)
  ))
        return 872; /* *ashrv4qi3 */
      if (!register_operand (operands[2], E_V4QImode)
          || !
#line 1454 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 935; /* vashrv4qi3 */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8QImode)) - 1)
  ))
        return 876; /* *ashrv8qi3 */
      if (!register_operand (operands[2], E_V8QImode)
          || !
#line 1454 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 936; /* vashrv8qi3 */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V16QImode)) - 1)
  ))
        return 880; /* *ashrv16qi3 */
      if (!register_operand (operands[2], E_V16QImode)
          || !
#line 1454 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 937; /* vashrv16qi3 */

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x3) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1HImode)) - 1)
  ))
        return 884; /* *ashrv1hi3 */
      if (!register_operand (operands[2], E_V1HImode)
          || !
#line 1454 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 938; /* vashrv1hi3 */

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x3) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2HImode)) - 1)
  ))
        return 888; /* *ashrv2hi3 */
      if (!register_operand (operands[2], E_V2HImode)
          || !
#line 1454 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 939; /* vashrv2hi3 */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4HImode)) - 1)
  ))
        return 892; /* *ashrv4hi3 */
      if (!register_operand (operands[2], E_V4HImode)
          || !
#line 1454 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 940; /* vashrv4hi3 */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8HImode)) - 1)
  ))
        return 896; /* *ashrv8hi3 */
      if (!register_operand (operands[2], E_V8HImode)
          || !
#line 1454 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 941; /* vashrv8hi3 */

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x3) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1SImode)) - 1)
  ))
        return 900; /* *ashrv1si3 */
      if (!register_operand (operands[2], E_V1SImode)
          || !
#line 1454 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 942; /* vashrv1si3 */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2SImode)) - 1)
  ))
        return 904; /* *ashrv2si3 */
      if (!register_operand (operands[2], E_V2SImode)
          || !
#line 1454 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 943; /* vashrv2si3 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4SImode)) - 1)
  ))
        return 908; /* *ashrv4si3 */
      if (!register_operand (operands[2], E_V4SImode)
          || !
#line 1454 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 944; /* vashrv4si3 */

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x3) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1DImode)) - 1)
  ))
        return 912; /* *ashrv1di3 */
      if (!register_operand (operands[2], E_V1DImode)
          || !
#line 1454 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 945; /* vashrv1di3 */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2DImode)) - 1)
  ))
        return 916; /* *ashrv2di3 */
      if (!register_operand (operands[2], E_V2DImode)
          || !
#line 1454 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 946; /* vashrv2di3 */

    case E_DImode:
      if (pnum_clobbers == NULL
          || pattern1 (x3, 
E_DImode) != 0)
        return -1;
      if (
#line 9457 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
        {
          *pnum_clobbers = 1;
          return 2166; /* *ashrdi3_31 */
        }
      if (!
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2169; /* *ashrdi3 */

    case E_SImode:
      if (pnum_clobbers == NULL
          || pattern1 (x3, 
E_SImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 2172; /* *ashrsi3 */

    default:
      return -1;
    }
}

 int
recog_62 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case EQ:
      switch (pattern11 (x1))
        {
        case 0:
          if (
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1150; /* *vec_cmpeqv1qiv1qi_nocc */
          break;

        case 1:
          if (
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1153; /* *vec_cmpeqv2qiv2qi_nocc */
          break;

        case 2:
          if (
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1156; /* *vec_cmpeqv4qiv4qi_nocc */
          break;

        case 3:
          if (
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1159; /* *vec_cmpeqv8qiv8qi_nocc */
          break;

        case 4:
          if (
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1162; /* *vec_cmpeqv16qiv16qi_nocc */
          break;

        case 5:
          if (
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1165; /* *vec_cmpeqv1hiv1hi_nocc */
          break;

        case 6:
          if (
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1168; /* *vec_cmpeqv2hiv2hi_nocc */
          break;

        case 7:
          if (
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1171; /* *vec_cmpeqv4hiv4hi_nocc */
          break;

        case 8:
          if (
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1174; /* *vec_cmpeqv8hiv8hi_nocc */
          break;

        case 9:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V1SImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V1SImode)
                  && 
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1177; /* *vec_cmpeqv1siv1si_nocc */
            }
          operands[0] = x3;
          operands[1] = x4;
          if (register_operand (operands[1], E_V1SFmode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_V1SFmode)
                  && (
#line 2055 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1198; /* *vec_cmpeqv1sf_quiet_nocc */
            }
          break;

        case 10:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V2SImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V2SImode)
                  && 
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1180; /* *vec_cmpeqv2siv2si_nocc */
            }
          operands[0] = x3;
          operands[1] = x4;
          if (register_operand (operands[1], E_V2SFmode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_V2SFmode)
                  && (
#line 2055 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1199; /* *vec_cmpeqv2sf_quiet_nocc */
            }
          break;

        case 11:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V4SImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V4SImode)
                  && 
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1183; /* *vec_cmpeqv4siv4si_nocc */
            }
          operands[0] = x3;
          operands[1] = x4;
          if (register_operand (operands[1], E_V4SFmode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_V4SFmode)
                  && (
#line 2055 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1200; /* *vec_cmpeqv4sf_quiet_nocc */
            }
          break;

        case 12:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V1DImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V1DImode)
                  && 
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1186; /* *vec_cmpeqv1div1di_nocc */
            }
          operands[0] = x3;
          operands[1] = x4;
          if (register_operand (operands[1], E_V1DFmode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_V1DFmode)
                  && 
#line 2055 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1201; /* *vec_cmpeqv1df_quiet_nocc */
            }
          break;

        case 13:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V2DImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V2DImode)
                  && 
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1189; /* *vec_cmpeqv2div2di_nocc */
            }
          operands[0] = x3;
          operands[1] = x4;
          if (register_operand (operands[1], E_V2DFmode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_V2DFmode)
                  && 
#line 2055 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1202; /* *vec_cmpeqv2df_quiet_nocc */
            }
          break;

        case 14:
          if (
#line 1961 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1192; /* *vec_cmpeqv1tiv1ti_nocc_emu */
          break;

        case 15:
          if ((
#line 2055 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 61 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1203; /* *vec_cmpeqv1tf_quiet_nocc */
          break;

        case 16:
          if ((
#line 2055 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 61 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1204; /* *vec_cmpeqtf_quiet_nocc */
          break;

        case 17:
          if (
#line 1961 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1193; /* *vec_cmpeqtiti_nocc_emu */
          break;

        default:
          break;
        }
      break;

    case GT:
      res = recog_32 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case GE:
      res = recog_33 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case NE:
      res = recog_34 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      res = recog_50 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  switch (GET_CODE (x2))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern45 (x2))
        {
        case 0:
          if (!(
#line 7055 "../../gcc/config/s390/s390.md"
(TARGET_Z13) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1961; /* *cstoreccdi_z13 */

        case 1:
          if (!
#line 7055 "../../gcc/config/s390/s390.md"
(TARGET_Z13))
            return -1;
          return 1962; /* *cstoreccsi_z13 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_76 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != NEG)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      switch (pattern237 (x1))
        {
        case 0:
          if (!(
#line 8883 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2076; /* *negdi2_cc */

        case 1:
          if (!
#line 8883 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
            return -1;
          return 2077; /* *negsi2_cc */

        default:
          return -1;
        }

    case CLOBBER:
      switch (pattern191 (x1))
        {
        case 0:
          if (!(
#line 8894 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2078; /* *negdi2_cconly */

        case 1:
          if (!
#line 8894 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
            return -1;
          return 2079; /* *negsi2_cconly */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_81 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x5))
    {
    case UNSPEC:
      if (XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 0)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !register_operand (operands[1], E_TFmode)
              || GET_MODE (x5) != E_DFmode
              || !const_int_operand (operands[2], E_VOIDmode)
              || !
#line 2933 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1407; /* *trunctfdf2_vr */

        case E_DDmode:
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !register_operand (operands[1], E_TDmode)
              || GET_MODE (x5) != E_DImode
              || !const_mask_operand (operands[2], E_DImode)
              || !
#line 5510 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 1;
          return 1751; /* *trunctddd2 */

        default:
          return -1;
        }

    case CLOBBER:
      if (!register_operand (operands[1], E_TFmode))
        return -1;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (!scratch_operand (operands[2], E_TFmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !
#line 5487 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 1749; /* trunctfdf2_fpr */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !
#line 5487 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 1750; /* trunctfsf2_fpr */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_89 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case STRICT_LOW_PART:
      if (pattern89 (x1) != 0
          || !subreg_register_operand (operands[0], E_HImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_HImode))
        return -1;
      return 1516; /* movstricthi */

    case SUBREG:
    case MEM:
      operands[0] = x3;
      if (!memory_operand (operands[0], E_BLKmode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != USE)
        return -1;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode))
        return -1;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (!const_int_operand (operands[2], E_VOIDmode)
          || !
#line 2911 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      return 1533; /* *mvc */

    case ZERO_EXTRACT:
      if (pattern89 (x1) != 0)
        return -1;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x8 = XEXP (x3, 2);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[3] = x4;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode)
              || !nonimmediate_operand (operands[3], E_DImode)
              || !(
#line 4281 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (DImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 64) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1611; /* *insvdi_clobbercc */

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || !nonimmediate_operand (operands[3], E_SImode)
              || !
#line 4281 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (SImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 32))
            return -1;
          return 1613; /* *insvsi_clobbercc */

        default:
          return -1;
        }

    case PC:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 1)
        return -1;
      x4 = XEXP (x2, 1);
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x6) != E_DImode
              || !(
#line 10142 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          return 2200; /* indirect_jump_via_thunkdi */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x6) != E_SImode
              || !(
#line 10142 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2201; /* indirect_jump_via_thunksi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_93 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  switch (pattern192 (x6))
    {
    case 0:
      if (!(
#line 4115 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (DImode))) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      return 1581; /* *extzvdi_clobbercc */

    case 1:
      if (!
#line 4115 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (SImode))))
        return -1;
      return 1583; /* *extzvsi_clobbercc */

    default:
      return -1;
    }
}

 int
recog_96 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case AND:
      switch (pattern92 (x1))
        {
        case 0:
          x6 = XEXP (x4, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTRACT:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              if (!const_int_operand (operands[4], E_VOIDmode))
                return -1;
              x9 = XEXP (x6, 2);
              operands[5] = x9;
              if (!const_int_operand (operands[5], E_VOIDmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern275 (x4, 
E_DImode) != 0
                      || !
#line 4147 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[4]), INTVAL (operands[5]), 64)
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_M1U << UINTVAL (operands[4]))))
                    return -1;
                  return 1587; /* *risbg_ior_and_sr_zedi */

                case E_SImode:
                  if (pattern275 (x4, 
E_SImode) != 0
                      || !
#line 4147 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[4]), INTVAL (operands[5]), 32)
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_M1U << UINTVAL (operands[4]))))
                    return -1;
                  return 1589; /* *risbg_ior_and_sr_zesi */

                default:
                  return -1;
                }

            case AND:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern261 (x4, 
E_DImode) != 0
                      || !(
#line 4297 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && INTVAL (operands[2]) == ~INTVAL (operands[4])) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1615; /* *insvdi_clobbercc_noshift */

                case E_SImode:
                  if (pattern261 (x4, 
E_SImode) != 0
                      || !
#line 4297 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && INTVAL (operands[2]) == ~INTVAL (operands[4])))
                    return -1;
                  return 1617; /* *insvsi_clobbercc_noshift */

                default:
                  return -1;
                }

            case ASHIFT:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern262 (x4, 
E_DImode) != 0
                      || !(
#line 4351 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_1U << UINTVAL (operands[4])) - 1) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1621; /* *insvdi_clobbercc_appendbitsleft */

                case E_SImode:
                  if (pattern262 (x4, 
E_SImode) != 0
                      || !
#line 4351 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_1U << UINTVAL (operands[4])) - 1))
                    return -1;
                  return 1623; /* *insvsi_clobbercc_appendbitsleft */

                default:
                  return -1;
                }

            case LSHIFTRT:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern263 (x4, 
E_DImode) != 0
                      || !(
#line 4366 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && UINTVAL (operands[2])
   == (HOST_WIDE_INT_M1U
       << (GET_MODE_BITSIZE (DImode) - UINTVAL (operands[4])))) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1625; /* *risbg_di_ior_and_lshiftrt */

                case E_SImode:
                  if (pattern263 (x4, 
E_SImode) != 0
                      || !
#line 4366 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && UINTVAL (operands[2])
   == (HOST_WIDE_INT_M1U
       << (GET_MODE_BITSIZE (SImode) - UINTVAL (operands[4])))))
                    return -1;
                  return 1627; /* *risbg_si_ior_and_lshiftrt */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
            case MEM:
              if (GET_CODE (x6) == SUBREG
                  && known_eq (SUBREG_BYTE (x6), 4)
                  && GET_MODE (x6) == E_SImode)
                {
                  x7 = XEXP (x6, 0);
                  if (GET_CODE (x7) == LSHIFTRT
                      && GET_MODE (x7) == E_DImode
                      && pattern226 (x4, 
E_SImode) == 0
                      && const_int_operand (operands[2], E_SImode))
                    {
                      x10 = XEXP (x7, 0);
                      operands[3] = x10;
                      if (register_operand (operands[3], E_DImode))
                        {
                          x11 = XEXP (x7, 1);
                          operands[4] = x11;
                          if (nonzero_shift_count_operand (operands[4], E_DImode)
                              && 
#line 4383 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && UINTVAL (operands[2]) == ~(HOST_WIDE_INT_M1U >> UINTVAL (operands[4]))))
                            return 1629; /* *risbg_sidi_ior_and_lshiftrt */
                        }
                    }
                }
              operands[3] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern248 (x4, 
E_DImode) != 0
                      || !(
#line 4480 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1634; /* *rosbg_di_noshift */

                case E_SImode:
                  if (pattern248 (x4, 
E_SImode) != 0
                      || !
#line 4480 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                    return -1;
                  return 1636; /* *rosbg_si_noshift */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 1:
          if (!
#line 4495 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 1638; /* *rosbg_di_rotl */

        case 2:
          if (!(
#line 4510 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1640; /* *rosbg_di_srl_bitmask */

        case 3:
          if (!
#line 4510 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          return 1642; /* *rosbg_si_srl_bitmask */

        case 4:
          if (!(
#line 4530 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1644; /* *rosbg_di_sll_bitmask */

        case 5:
          if (!
#line 4530 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          return 1646; /* *rosbg_si_sll_bitmask */

        default:
          return -1;
        }

    case ASHIFT:
      x12 = XVECEXP (x1, 0, 1);
      if (pattern88 (x12) != 0)
        return -1;
      x13 = XEXP (x5, 0);
      switch (GET_CODE (x13))
        {
        case REG:
        case SUBREG:
        case MEM:
          switch (pattern94 (x4))
            {
            case 0:
              if (!(
#line 4548 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 1648; /* *rosbg_di_sll */

            case 1:
              if (!
#line 4548 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                return -1;
              return 1650; /* *rosbg_si_sll */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (GET_MODE (x13) != E_TImode)
            return -1;
          x14 = XEXP (x13, 0);
          if (GET_CODE (x14) != CLZ
              || GET_MODE (x14) != E_DImode)
            return -1;
          x15 = XEXP (x5, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
            return -1;
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != ZERO_EXTEND
              || GET_MODE (x6) != E_TImode)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != XOR
              || GET_MODE (x7) != E_DImode)
            return -1;
          x11 = XEXP (x7, 1);
          if (GET_CODE (x11) != LSHIFTRT)
            return -1;
          x16 = XEXP (x11, 1);
          if (GET_CODE (x16) != SUBREG
              || maybe_ne (SUBREG_BYTE (x16), 4)
              || GET_MODE (x16) != E_SImode)
            return -1;
          x17 = XEXP (x16, 0);
          if (GET_CODE (x17) != CLZ
              || GET_MODE (x17) != E_DImode
              || !register_operand (operands[0], E_TImode)
              || GET_MODE (x4) != E_TImode
              || GET_MODE (x5) != E_TImode)
            return -1;
          x18 = XEXP (x14, 0);
          operands[1] = x18;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x19 = XEXP (x11, 0);
          operands[2] = x19;
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          x10 = XEXP (x7, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          x20 = XEXP (x17, 0);
          if (!rtx_equal_p (x20, operands[1])
              || !
#line 9362 "../../gcc/config/s390/s390.md"
(UINTVAL (operands[2]) == HOST_WIDE_INT_1U << 63
   && TARGET_EXTIMM && TARGET_ZARCH))
            return -1;
          return 2157; /* clztidi2 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern95 (x1))
        {
        case 0:
          if (!(
#line 4567 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1652; /* *rosbg_di_srl */

        case 1:
          if (!
#line 4567 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 1654; /* *rosbg_si_srl */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      if (GET_CODE (x5) == SUBREG
          && pattern116 (x1) == 0
          && 
#line 4587 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
        return 1656; /* *rosbg_sidi_srl */
      if (pnum_clobbers != NULL
          && pattern117 (x1) == 0
          && 
#line 8443 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        {
          *pnum_clobbers = 1;
          return 2057; /* *oc */
        }
      operands[1] = x5;
      switch (pattern119 (x1))
        {
        case 0:
          if (!
#line 8138 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2022; /* *iordi3 */

        case 1:
          if (
#line 8219 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return 2025; /* *iorsi3_zarch */
          if (!
#line 8247 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2026; /* *iorsi3_esa */

        case 2:
          if (
#line 8275 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return 2027; /* *iorhi3_zarch */
          if (!
#line 8291 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2028; /* *iorhi3_esa */

        case 3:
          if (
#line 8318 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return 2029; /* *iorqi3_zarch */
          if (!
#line 8336 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2030; /* *iorqi3_esa */

        default:
          return -1;
        }

    case NOT:
      x12 = XVECEXP (x1, 0, 1);
      if (pattern88 (x12) != 0)
        return -1;
      x13 = XEXP (x5, 0);
      operands[1] = x13;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern239 (x4, 
E_DImode) != 0
                  || !(
#line 8380 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2040; /* *orcdi */

            case E_SImode:
              if (pattern239 (x4, 
E_SImode) != 0
                  || !
#line 8380 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2042; /* *orcsi */

            default:
              return -1;
            }

        case NOT:
          switch (pattern214 (x4))
            {
            case 0:
              if (!(
#line 8420 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2052; /* *nanddi */

            case 1:
              if (!
#line 8420 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2054; /* *nandsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_110 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (load_multiple_operation (operands[0], E_VOIDmode))
        {
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (register_operand (operands[1], E_DImode)
                  && s_operand (operands[2], E_DImode)
                  && 
#line 3044 "../../gcc/config/s390/s390.md"
(reload_completed && TARGET_ZARCH))
                return 1534; /* *load_multiple_di */
              break;

            case E_SImode:
              if (register_operand (operands[1], E_SImode)
                  && s_operand (operands[2], E_SImode)
                  && 
#line 3057 "../../gcc/config/s390/s390.md"
(reload_completed))
                return 1535; /* *load_multiple_si */
              break;

            default:
              break;
            }
        }
      if (!store_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!s_operand (operands[1], E_DImode)
              || !register_operand (operands[2], E_DImode)
              || !
#line 3136 "../../gcc/config/s390/s390.md"
(reload_completed && TARGET_ZARCH))
            return -1;
          return 1536; /* *store_multiple_di */

        case E_SImode:
          if (!s_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_SImode)
              || !
#line 3150 "../../gcc/config/s390/s390.md"
(reload_completed))
            return -1;
          return 1537; /* *store_multiple_si */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x2, 0) != 3
          || XINT (x2, 1) != 18
          || !execute_operation (operands[0], E_VOIDmode))
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_VOIDmode))
        return -1;
      x6 = XVECEXP (x2, 0, 1);
      operands[2] = x6;
      x7 = XVECEXP (x2, 0, 2);
      operands[3] = x7;
      if (larl_operand (operands[3], E_SImode)
          && 
#line 3169 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_INT
   && GET_MODE_SIZE (GET_MODE (operands[1])) <= UNITS_PER_WORD))
        return 1538; /* *execute_rl */
      if (!memory_operand (operands[2], E_BLKmode)
          || !
#line 3181 "../../gcc/config/s390/s390.md"
(GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_INT
   && GET_MODE_SIZE (GET_MODE (operands[1])) <= UNITS_PER_WORD))
        return -1;
      return 1539; /* *execute */

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (register_operand (operands[0], E_V16QImode)
          && register_operand (operands[1], E_V16QImode)
          && 
#line 276 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_1 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V16QImode)
          && general_operand (operands[1], E_V16QImode))
        {
          if (
#line 296 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V16QImode, 0)))
            return gen_split_10 (insn, operands);
          if (
#line 310 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V16QImode, 1)))
            return gen_split_19 (insn, operands);
        }
      if (!register_operand (operands[0], E_V16QImode)
          || !memory_operand (operands[1], E_V16QImode)
          || !
#line 330 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_28 (insn, operands);

    case E_V8HImode:
      if (register_operand (operands[0], E_V8HImode)
          && register_operand (operands[1], E_V8HImode)
          && 
#line 276 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_2 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V8HImode)
          && general_operand (operands[1], E_V8HImode))
        {
          if (
#line 296 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V8HImode, 0)))
            return gen_split_11 (insn, operands);
          if (
#line 310 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V8HImode, 1)))
            return gen_split_20 (insn, operands);
        }
      if (!register_operand (operands[0], E_V8HImode)
          || !memory_operand (operands[1], E_V8HImode)
          || !
#line 330 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_29 (insn, operands);

    case E_V4SImode:
      if (register_operand (operands[0], E_V4SImode)
          && register_operand (operands[1], E_V4SImode)
          && 
#line 276 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_3 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V4SImode)
          && general_operand (operands[1], E_V4SImode))
        {
          if (
#line 296 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V4SImode, 0)))
            return gen_split_12 (insn, operands);
          if (
#line 310 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V4SImode, 1)))
            return gen_split_21 (insn, operands);
        }
      if (!register_operand (operands[0], E_V4SImode)
          || !memory_operand (operands[1], E_V4SImode)
          || !
#line 330 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_30 (insn, operands);

    case E_V4SFmode:
      if (register_operand (operands[0], E_V4SFmode)
          && register_operand (operands[1], E_V4SFmode)
          && 
#line 276 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_4 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V4SFmode)
          && general_operand (operands[1], E_V4SFmode))
        {
          if (
#line 296 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V4SFmode, 0)))
            return gen_split_13 (insn, operands);
          if (
#line 310 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V4SFmode, 1)))
            return gen_split_22 (insn, operands);
        }
      if (!register_operand (operands[0], E_V4SFmode)
          || !memory_operand (operands[1], E_V4SFmode)
          || !
#line 330 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_31 (insn, operands);

    case E_V2DImode:
      if (register_operand (operands[0], E_V2DImode)
          && register_operand (operands[1], E_V2DImode)
          && 
#line 276 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_5 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V2DImode)
          && general_operand (operands[1], E_V2DImode))
        {
          if (
#line 296 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V2DImode, 0)))
            return gen_split_14 (insn, operands);
          if (
#line 310 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V2DImode, 1)))
            return gen_split_23 (insn, operands);
        }
      if (!register_operand (operands[0], E_V2DImode)
          || !memory_operand (operands[1], E_V2DImode)
          || !
#line 330 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_32 (insn, operands);

    case E_V2DFmode:
      if (register_operand (operands[0], E_V2DFmode)
          && register_operand (operands[1], E_V2DFmode)
          && 
#line 276 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_6 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V2DFmode)
          && general_operand (operands[1], E_V2DFmode))
        {
          if (
#line 296 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V2DFmode, 0)))
            return gen_split_15 (insn, operands);
          if (
#line 310 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V2DFmode, 1)))
            return gen_split_24 (insn, operands);
        }
      if (!register_operand (operands[0], E_V2DFmode)
          || !memory_operand (operands[1], E_V2DFmode)
          || !
#line 330 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_33 (insn, operands);

    case E_V1TImode:
      if (register_operand (operands[0], E_V1TImode)
          && register_operand (operands[1], E_V1TImode)
          && 
#line 276 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_7 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V1TImode)
          && general_operand (operands[1], E_V1TImode))
        {
          if (
#line 296 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V1TImode, 0)))
            return gen_split_16 (insn, operands);
          if (
#line 310 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V1TImode, 1)))
            return gen_split_25 (insn, operands);
        }
      if (!register_operand (operands[0], E_V1TImode)
          || !memory_operand (operands[1], E_V1TImode)
          || !
#line 330 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_34 (insn, operands);

    case E_V1TFmode:
      if (register_operand (operands[0], E_V1TFmode)
          && register_operand (operands[1], E_V1TFmode)
          && 
#line 276 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_8 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V1TFmode)
          && general_operand (operands[1], E_V1TFmode))
        {
          if (
#line 296 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V1TFmode, 0)))
            return gen_split_17 (insn, operands);
          if (
#line 310 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V1TFmode, 1)))
            return gen_split_26 (insn, operands);
        }
      if (!register_operand (operands[0], E_V1TFmode)
          || !memory_operand (operands[1], E_V1TFmode)
          || !
#line 330 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_35 (insn, operands);

    case E_TFmode:
      if (register_operand (operands[0], E_TFmode)
          && register_operand (operands[1], E_TFmode)
          && (
#line 276 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])) && 
#line 80 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return gen_split_9 (insn, operands);
      if (nonimmediate_operand (operands[0], E_TFmode)
          && general_operand (operands[1], E_TFmode))
        {
          if ((
#line 296 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], TFmode, 0)) && 
#line 80 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return gen_split_18 (insn, operands);
          if ((
#line 310 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], TFmode, 1)) && 
#line 80 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return gen_split_27 (insn, operands);
        }
      if (!register_operand (operands[0], E_TFmode)
          || !memory_operand (operands[1], E_TFmode)
          || !(
#line 330 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)) && 
#line 80 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return NULL;
      return gen_split_36 (insn, operands);

    case E_TImode:
      if (nonimmediate_operand (operands[0], E_TImode)
          && general_operand (operands[1], E_TImode))
        {
          if (
#line 1699 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && s390_split_ok_p (operands[0], operands[1], TImode, 0)))
            return gen_split_142 (insn, operands);
          if (
#line 1713 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && s390_split_ok_p (operands[0], operands[1], TImode, 1)))
            return gen_split_143 (insn, operands);
        }
      if (!register_operand (operands[0], E_TImode))
        return NULL;
      if (memory_operand (operands[1], E_TImode)
          && 
#line 1730 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return gen_split_144 (insn, operands);
      if (!register_operand (operands[1], E_TImode)
          || !
#line 1748 "../../gcc/config/s390/s390.md"
(TARGET_VX && reload_completed
   && GENERAL_REG_P (operands[0])
   && VECTOR_REG_P (operands[1])))
        return NULL;
      return gen_split_145 (insn, operands);

    case E_DImode:
      if (register_operand (operands[0], E_DImode))
        {
          if (register_operand (operands[1], E_DImode))
            {
              if (
#line 1990 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && ACCESS_REG_P (operands[0]) && reload_completed
   && dead_or_set_p (insn, operands[1])))
                return gen_split_148 (insn, operands);
              if (
#line 2001 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && ACCESS_REG_P (operands[0]) && reload_completed
   && !dead_or_set_p (insn, operands[1])))
                return gen_split_149 (insn, operands);
            }
          if (memory_operand (operands[1], E_DImode)
              && 
#line 2039 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed && TARGET_Z10
   && larl_operand (XEXP (operands[1], 0), SImode)))
            return gen_split_150 (insn, operands);
        }
      if (nonimmediate_operand (operands[0], E_DImode)
          && general_operand (operands[1], E_DImode))
        {
          if (
#line 2052 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DImode)
   && !s_operand (operands[1], DImode)
   && s390_split_ok_p (operands[0], operands[1], DImode, 0)))
            return gen_split_151 (insn, operands);
          if (
#line 2068 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DImode)
   && !s_operand (operands[1], DImode)
   && s390_split_ok_p (operands[0], operands[1], DImode, 1)))
            return gen_split_152 (insn, operands);
        }
      if (!register_operand (operands[0], E_DImode)
          || !memory_operand (operands[1], E_DImode)
          || !
#line 2084 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !FP_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_153 (insn, operands);

    case E_FPRX2mode:
      if (nonimmediate_operand (operands[0], E_FPRX2mode)
          && general_operand (operands[1], E_FPRX2mode))
        {
          if ((
#line 2627 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], FPRX2mode)
   && !s_operand (operands[1], FPRX2mode)
   && s390_split_ok_p (operands[0], operands[1], FPRX2mode, 0)) && 
#line 671 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return gen_split_156 (insn, operands);
          if ((
#line 2643 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], FPRX2mode)
   && !s_operand (operands[1], FPRX2mode)
   && s390_split_ok_p (operands[0], operands[1], FPRX2mode, 1)) && 
#line 671 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return gen_split_159 (insn, operands);
        }
      if (register_operand (operands[0], E_FPRX2mode)
          && memory_operand (operands[1], E_FPRX2mode))
        {
          if ((
#line 2659 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && GENERAL_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)) && 
#line 671 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return gen_split_162 (insn, operands);
          if ((
#line 2675 "../../gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[1])
   && FP_REG_P (operands[0])) && 
#line 671 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return gen_split_165 (insn, operands);
        }
      if (!memory_operand (operands[0], E_FPRX2mode)
          || !register_operand (operands[1], E_FPRX2mode)
          || !(
#line 2691 "../../gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[0])
   && FP_REG_P (operands[1])) && 
#line 671 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return NULL;
      return gen_split_168 (insn, operands);

    case E_TDmode:
      if (nonimmediate_operand (operands[0], E_TDmode)
          && general_operand (operands[1], E_TDmode))
        {
          if (
#line 2627 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], TDmode)
   && !s_operand (operands[1], TDmode)
   && s390_split_ok_p (operands[0], operands[1], TDmode, 0)))
            return gen_split_157 (insn, operands);
          if (
#line 2643 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], TDmode)
   && !s_operand (operands[1], TDmode)
   && s390_split_ok_p (operands[0], operands[1], TDmode, 1)))
            return gen_split_160 (insn, operands);
        }
      if (register_operand (operands[0], E_TDmode)
          && memory_operand (operands[1], E_TDmode))
        {
          if (
#line 2659 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && GENERAL_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
            return gen_split_163 (insn, operands);
          if (
#line 2675 "../../gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[1])
   && FP_REG_P (operands[0])))
            return gen_split_166 (insn, operands);
        }
      if (!memory_operand (operands[0], E_TDmode)
          || !register_operand (operands[1], E_TDmode)
          || !
#line 2691 "../../gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[0])
   && FP_REG_P (operands[1])))
        return NULL;
      return gen_split_169 (insn, operands);

    case E_DFmode:
      if (nonimmediate_operand (operands[0], E_DFmode)
          && general_operand (operands[1], E_DFmode))
        {
          if (
#line 2799 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DFmode)
   && !s_operand (operands[1], DFmode)
   && s390_split_ok_p (operands[0], operands[1], DFmode, 0)))
            return gen_split_170 (insn, operands);
          if (
#line 2815 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DFmode)
   && !s_operand (operands[1], DFmode)
   && s390_split_ok_p (operands[0], operands[1], DFmode, 1)))
            return gen_split_172 (insn, operands);
        }
      if (!register_operand (operands[0], E_DFmode)
          || !memory_operand (operands[1], E_DFmode)
          || !
#line 2831 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !FP_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_174 (insn, operands);

    case E_DDmode:
      if (nonimmediate_operand (operands[0], E_DDmode)
          && general_operand (operands[1], E_DDmode))
        {
          if (
#line 2799 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DDmode)
   && !s_operand (operands[1], DDmode)
   && s390_split_ok_p (operands[0], operands[1], DDmode, 0)))
            return gen_split_171 (insn, operands);
          if (
#line 2815 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DDmode)
   && !s_operand (operands[1], DDmode)
   && s390_split_ok_p (operands[0], operands[1], DDmode, 1)))
            return gen_split_173 (insn, operands);
        }
      if (!register_operand (operands[0], E_DDmode)
          || !memory_operand (operands[1], E_DDmode)
          || !
#line 2831 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !FP_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_175 (insn, operands);

    case E_QImode:
      if (!memory_operand (operands[0], E_QImode)
          || !memory_operand (operands[1], E_QImode)
          || !
#line 2921 "../../gcc/config/s390/s390.md"
(reload_completed))
        return NULL;
      return gen_split_176 (insn, operands);

    default:
      return NULL;
    }
}
