/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      return pattern3 (x3, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern3 (x3, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern3 (x3, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern3 (x3, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern3 (x3, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern3 (x3, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern3 (x3, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern3 (x3, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern3 (x3, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (pattern3 (x3, 
E_V1SImode) != 0)
        return -1;
      return 9;

    case E_V2SImode:
      if (pattern3 (x3, 
E_V2SImode) != 0)
        return -1;
      return 10;

    case E_V4SImode:
      if (pattern3 (x3, 
E_V4SImode) != 0)
        return -1;
      return 11;

    case E_V1DImode:
      if (pattern3 (x3, 
E_V1DImode) != 0)
        return -1;
      return 12;

    case E_V2DImode:
      if (pattern3 (x3, 
E_V2DImode) != 0)
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern23 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[1] = x5;
  return 0;
}

int
pattern28 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern31 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern30 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern30 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern30 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern38 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  return 0;
}

int
pattern44 (rtx x1, int i1, int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i3
      || XVECLEN (x2, 0) != i2
      || XINT (x2, 1) != i1)
    return -1;
  return 0;
}

int
pattern48 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern56 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern17 (x1, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern17 (x1, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern17 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern17 (x1, 
E_V2DImode) != 0)
        return -1;
      return 3;

    case E_V1TImode:
      if (pattern17 (x1, 
E_V1TImode) != 0)
        return -1;
      return 4;

    case E_TImode:
      if (pattern17 (x1, 
E_TImode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern17 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V4SFmode:
      if (pattern17 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 7;

    case E_V1TFmode:
      if (pattern17 (x1, 
E_V1TFmode) != 0)
        return -1;
      return 8;

    case E_TFmode:
      if (pattern17 (x1, 
E_TFmode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern73 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCUmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCUmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != USE)
    return -1;
  x7 = XEXP (x3, 0);
  operands[0] = x7;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[1] = x8;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  return 0;
}

int
pattern80 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern84 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !memory_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern90 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[3], i1)
      || !contiguous_bitmask_nowrap_operand (operands[2], i1)
      || !nonimmediate_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern97 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SUBREG)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_BLKmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SUBREG)
    return -1;
  return 0;
}

int
pattern107 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern110 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != ZERO_EXTEND
      || GET_MODE (x3) != i2
      || !register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  if (!nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern120 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern124 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[2], i1)
      || GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33)
    return -1;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  if (!const0_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  return 0;
}

int
pattern131 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern136 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern140 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern148 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != ASHIFT
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != SUBREG
      || maybe_ne (SUBREG_BYTE (x7), 0)
      || GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XEXP (x6, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x9 = XEXP (x5, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x10 = XEXP (x3, 1);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x11 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x11) != SET)
    return -1;
  x12 = XEXP (x11, 1);
  if (GET_CODE (x12) != i1
      || GET_MODE (x12) != E_DImode)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != SIGN_EXTEND
      || GET_MODE (x13) != E_DImode
      || GET_MODE (x4) != E_DImode)
    return -1;
  x14 = XEXP (x7, 0);
  operands[1] = x14;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x15 = XEXP (x11, 0);
  operands[0] = x15;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x16 = XEXP (x13, 0);
  if (!rtx_equal_p (x16, operands[1]))
    return -1;
  return 0;
}

int
pattern160 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern170 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !nonmemory_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !nonmemory_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern179 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x1) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 2;

    case E_FPRX2mode:
      if (!register_operand (operands[0], E_FPRX2mode)
          || GET_MODE (x1) != E_FPRX2mode
          || !register_operand (operands[1], E_FPRX2mode))
        return -1;
      return 3;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 4;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern195 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_CODE (operands[2]))
    {
    case CONST_INT:
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x4 = XVECEXP (x1, 0, 3);
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != SCRATCH)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      if (!immediate_operand (operands[3], E_VOIDmode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      if (!register_operand (operands[2], E_VOIDmode))
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 0);
      switch (GET_CODE (x7))
        {
        case SUBREG:
        case MEM:
          operands[3] = x7;
          if (!memory_operand (operands[3], E_VOIDmode))
            return -1;
          x4 = XVECEXP (x1, 0, 3);
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != SCRATCH)
            return -1;
          return 1;

        case CONST:
          if (GET_MODE (x7) != E_BLKmode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != UNSPEC
              || XVECLEN (x8, 0) != 1
              || XINT (x8, 1) != 17
              || GET_MODE (x8) != E_BLKmode)
            return -1;
          x9 = XVECEXP (x8, 0, 0);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XVECEXP (x1, 0, 3);
          x5 = XEXP (x4, 0);
          switch (GET_CODE (x5))
            {
            case SCRATCH:
              return 2;

            case REG:
            case SUBREG:
              operands[3] = x5;
              if (!register_operand (operands[3], E_VOIDmode))
                return -1;
              return 3;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern233 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode)
          || !scratch_operand (operands[2], E_V4SImode))
        return -1;
      return 0;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !register_operand (operands[1], E_V2DFmode)
          || !scratch_operand (operands[2], E_V2DImode))
        return -1;
      return 1;

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || !register_operand (operands[1], E_V1TFmode)
          || !scratch_operand (operands[2], E_V1TImode))
        return -1;
      return 2;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || !register_operand (operands[1], E_TFmode)
          || !scratch_operand (operands[2], E_V1TImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern252 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  return 0;
}

int
pattern263 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern272 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern278 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (XINT (x3, 1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      return pattern277 (x5, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern277 (x5, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern277 (x5, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern293 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pattern23 (x1, 
E_CCZmode) != 0
      || !const_int_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || !(
#line 3600 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 655 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      return 1553; /* *TDC_insn_tf */

    case E_FPRX2mode:
      if (!register_operand (operands[0], E_FPRX2mode)
          || !(
#line 3600 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 655 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      return 1554; /* *TDC_insn_fprx2 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || !
#line 3600 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 1555; /* *TDC_insn_df */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || !
#line 3600 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 1556; /* *TDC_insn_sf */

    case E_TDmode:
      if (!register_operand (operands[0], E_TDmode)
          || !(
#line 3600 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 656 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 1557; /* *TDC_insn_td */

    case E_DDmode:
      if (!register_operand (operands[0], E_DDmode)
          || !(
#line 3600 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 656 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 1558; /* *TDC_insn_dd */

    case E_SDmode:
      if (!register_operand (operands[0], E_SDmode)
          || !(
#line 3600 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 657 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 1559; /* *TDC_insn_sd */

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  operands[3] = x3;
  x4 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x4))
    {
    case BSWAP:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XVECEXP (x2, 0, 1);
      operands[2] = x6;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern183 (x2, 
E_V8HImode, 
E_HImode) != 0
              || !
#line 2175 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode)))
            return -1;
          return 388; /* *vec_set_bswap_elemv8hi */

        case E_V4SImode:
          if (pattern183 (x2, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 2175 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode)))
            return -1;
          return 389; /* *vec_set_bswap_elemv4si */

        case E_V4SFmode:
          if (pattern183 (x2, 
E_V4SFmode, 
E_SFmode) != 0
              || !(
#line 2175 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 35 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 390; /* *vec_set_bswap_elemv4sf */

        case E_V2DImode:
          if (pattern183 (x2, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 2175 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 391; /* *vec_set_bswap_elemv2di */

        case E_V2DFmode:
          if (pattern183 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 2175 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 392; /* *vec_set_bswap_elemv2df */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      x6 = XVECEXP (x2, 0, 1);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x6;
          if (!nonmemory_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V1QImode:
              if (pattern197 (x2, 
E_V1QImode, 
E_QImode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1QImode))))
                return -1;
              return 435; /* *vec_setv1qi */

            case E_V2QImode:
              if (pattern197 (x2, 
E_V2QImode, 
E_QImode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2QImode))))
                return -1;
              return 436; /* *vec_setv2qi */

            case E_V4QImode:
              if (pattern197 (x2, 
E_V4QImode, 
E_QImode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V4QImode))))
                return -1;
              return 437; /* *vec_setv4qi */

            case E_V8QImode:
              if (pattern197 (x2, 
E_V8QImode, 
E_QImode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V8QImode))))
                return -1;
              return 438; /* *vec_setv8qi */

            case E_V16QImode:
              if (pattern197 (x2, 
E_V16QImode, 
E_QImode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V16QImode))))
                return -1;
              return 439; /* *vec_setv16qi */

            case E_V1HImode:
              if (pattern197 (x2, 
E_V1HImode, 
E_HImode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1HImode))))
                return -1;
              return 440; /* *vec_setv1hi */

            case E_V2HImode:
              if (pattern197 (x2, 
E_V2HImode, 
E_HImode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2HImode))))
                return -1;
              return 441; /* *vec_setv2hi */

            case E_V4HImode:
              if (pattern197 (x2, 
E_V4HImode, 
E_HImode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V4HImode))))
                return -1;
              return 442; /* *vec_setv4hi */

            case E_V8HImode:
              if (pattern197 (x2, 
E_V8HImode, 
E_HImode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode))))
                return -1;
              return 443; /* *vec_setv8hi */

            case E_V1SImode:
              if (pattern197 (x2, 
E_V1SImode, 
E_SImode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1SImode))))
                return -1;
              return 444; /* *vec_setv1si */

            case E_V2SImode:
              if (pattern197 (x2, 
E_V2SImode, 
E_SImode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2SImode))))
                return -1;
              return 445; /* *vec_setv2si */

            case E_V4SImode:
              if (pattern197 (x2, 
E_V4SImode, 
E_SImode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode))))
                return -1;
              return 446; /* *vec_setv4si */

            case E_V1DImode:
              if (pattern197 (x2, 
E_V1DImode, 
E_DImode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1DImode))))
                return -1;
              return 447; /* *vec_setv1di */

            case E_V2DImode:
              if (pattern197 (x2, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode))))
                return -1;
              return 448; /* *vec_setv2di */

            case E_V1SFmode:
              if (pattern197 (x2, 
E_V1SFmode, 
E_SFmode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1SFmode))))
                return -1;
              return 449; /* *vec_setv1sf */

            case E_V2SFmode:
              if (pattern197 (x2, 
E_V2SFmode, 
E_SFmode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2SFmode))))
                return -1;
              return 450; /* *vec_setv2sf */

            case E_V4SFmode:
              if (pattern197 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode))))
                return -1;
              return 451; /* *vec_setv4sf */

            case E_V1DFmode:
              if (pattern197 (x2, 
E_V1DFmode, 
E_DFmode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1DFmode))))
                return -1;
              return 452; /* *vec_setv1df */

            case E_V2DFmode:
              if (pattern197 (x2, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode))))
                return -1;
              return 453; /* *vec_setv2df */

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x6, 1);
          operands[4] = x8;
          if (!const_int_operand (operands[4], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V1QImode:
              if (pattern197 (x2, 
E_V1QImode, 
E_QImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 454; /* *vec_setv1qi_plus */

            case E_V2QImode:
              if (pattern197 (x2, 
E_V2QImode, 
E_QImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 455; /* *vec_setv2qi_plus */

            case E_V4QImode:
              if (pattern197 (x2, 
E_V4QImode, 
E_QImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 456; /* *vec_setv4qi_plus */

            case E_V8QImode:
              if (pattern197 (x2, 
E_V8QImode, 
E_QImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 457; /* *vec_setv8qi_plus */

            case E_V16QImode:
              if (pattern197 (x2, 
E_V16QImode, 
E_QImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 458; /* *vec_setv16qi_plus */

            case E_V1HImode:
              if (pattern197 (x2, 
E_V1HImode, 
E_HImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 459; /* *vec_setv1hi_plus */

            case E_V2HImode:
              if (pattern197 (x2, 
E_V2HImode, 
E_HImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 460; /* *vec_setv2hi_plus */

            case E_V4HImode:
              if (pattern197 (x2, 
E_V4HImode, 
E_HImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 461; /* *vec_setv4hi_plus */

            case E_V8HImode:
              if (pattern197 (x2, 
E_V8HImode, 
E_HImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 462; /* *vec_setv8hi_plus */

            case E_V1SImode:
              if (pattern197 (x2, 
E_V1SImode, 
E_SImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 463; /* *vec_setv1si_plus */

            case E_V2SImode:
              if (pattern197 (x2, 
E_V2SImode, 
E_SImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 464; /* *vec_setv2si_plus */

            case E_V4SImode:
              if (pattern197 (x2, 
E_V4SImode, 
E_SImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 465; /* *vec_setv4si_plus */

            case E_V1DImode:
              if (pattern197 (x2, 
E_V1DImode, 
E_DImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 466; /* *vec_setv1di_plus */

            case E_V2DImode:
              if (pattern197 (x2, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 467; /* *vec_setv2di_plus */

            case E_V1SFmode:
              if (pattern197 (x2, 
E_V1SFmode, 
E_SFmode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 468; /* *vec_setv1sf_plus */

            case E_V2SFmode:
              if (pattern197 (x2, 
E_V2SFmode, 
E_SFmode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 469; /* *vec_setv2sf_plus */

            case E_V4SFmode:
              if (pattern197 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 470; /* *vec_setv4sf_plus */

            case E_V1DFmode:
              if (pattern197 (x2, 
E_V1DFmode, 
E_DFmode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 471; /* *vec_setv1df_plus */

            case E_V2DFmode:
              if (pattern197 (x2, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 472; /* *vec_setv2df_plus */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == EQ)
    {
      res = recog_27 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[0] = x3;
  if (!s390_signed_integer_comparison (operands[0], E_VOIDmode))
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  x7 = XEXP (x2, 1);
  if (GET_CODE (x7) == PC)
    {
      x8 = XEXP (x2, 2);
      switch (pattern172 (x8))
        {
        case 0:
          if ((
#line 1605 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            {
              *pnum_clobbers = 1;
              return 1495; /* *icmp_and_br_signed_di */
            }
          break;

        case 1:
          if (
#line 1605 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            {
              *pnum_clobbers = 1;
              return 1496; /* *icmp_and_br_signed_si */
            }
          break;

        default:
          break;
        }
    }
  if (GET_CODE (x7) != LABEL_REF)
    return -1;
  switch (pattern171 (x2))
    {
    case 0:
      if (!(
#line 1547 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      *pnum_clobbers = 1;
      return 1491; /* *cmp_and_br_signed_di */

    case 1:
      if (!
#line 1547 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
        return -1;
      *pnum_clobbers = 1;
      return 1492; /* *cmp_and_br_signed_si */

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      if ((
#line 4115 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (DImode))) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return 1580; /* *extzvdi_nocc */
      if (pnum_clobbers == NULL
          || !(
#line 4115 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (DImode))) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      *pnum_clobbers = 1;
      return 1581; /* *extzvdi_clobbercc */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      if (
#line 4115 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (SImode))))
        return 1582; /* *extzvsi_nocc */
      if (pnum_clobbers == NULL
          || !
#line 4115 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (SImode))))
        return -1;
      *pnum_clobbers = 1;
      return 1583; /* *extzvsi_clobbercc */

    default:
      return -1;
    }
}

 int
recog_35 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NOT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern173 (x2, 
E_V16QImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 114; /* vec_andcv16qi3 */

        case E_V8HImode:
          if (pattern173 (x2, 
E_V8HImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 115; /* vec_andcv8hi3 */

        case E_V4SImode:
          if (pattern173 (x2, 
E_V4SImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 116; /* vec_andcv4si3 */

        case E_V2DImode:
          if (pattern173 (x2, 
E_V2DImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 117; /* vec_andcv2di3 */

        case E_V2DFmode:
          if (pattern173 (x2, 
E_V2DFmode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 118; /* vec_andcv2df3 */

        case E_V1TImode:
          if (pattern173 (x2, 
E_V1TImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 119; /* vec_andcv1ti3 */

        case E_TImode:
          if (pattern173 (x2, 
E_TImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 120; /* vec_andcti3 */

        case E_V4SFmode:
          if (pattern173 (x2, 
E_V4SFmode) != 0
              || !(
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 38 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 121; /* vec_andcv4sf3 */

        case E_V1TFmode:
          if (pattern173 (x2, 
E_V1TFmode) != 0
              || !(
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 38 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 122; /* vec_andcv1tf3 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      x4 = XEXP (x1, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x4;
          operands[1] = x3;
          x6 = XEXP (x2, 1);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V1QImode:
              if (pattern3 (x2, 
E_V1QImode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 652; /* andv1qi3 */

            case E_V2QImode:
              if (pattern3 (x2, 
E_V2QImode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 653; /* andv2qi3 */

            case E_V4QImode:
              if (pattern3 (x2, 
E_V4QImode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 654; /* andv4qi3 */

            case E_V8QImode:
              if (pattern3 (x2, 
E_V8QImode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 655; /* andv8qi3 */

            case E_V16QImode:
              if (pattern3 (x2, 
E_V16QImode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 656; /* andv16qi3 */

            case E_V1HImode:
              if (pattern3 (x2, 
E_V1HImode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 657; /* andv1hi3 */

            case E_V2HImode:
              if (pattern3 (x2, 
E_V2HImode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 658; /* andv2hi3 */

            case E_V4HImode:
              if (pattern3 (x2, 
E_V4HImode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 659; /* andv4hi3 */

            case E_V8HImode:
              if (pattern3 (x2, 
E_V8HImode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 660; /* andv8hi3 */

            case E_V1SImode:
              if (pattern3 (x2, 
E_V1SImode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 661; /* andv1si3 */

            case E_V2SImode:
              if (pattern3 (x2, 
E_V2SImode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 662; /* andv2si3 */

            case E_V4SImode:
              if (pattern3 (x2, 
E_V4SImode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 663; /* andv4si3 */

            case E_V1DImode:
              if (pattern3 (x2, 
E_V1DImode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 664; /* andv1di3 */

            case E_V2DImode:
              if (pattern3 (x2, 
E_V2DImode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 665; /* andv2di3 */

            case E_V1SFmode:
              if (pattern3 (x2, 
E_V1SFmode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 666; /* andv1sf3 */

            case E_V2SFmode:
              if (pattern3 (x2, 
E_V2SFmode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 667; /* andv2sf3 */

            case E_V4SFmode:
              if (pattern3 (x2, 
E_V4SFmode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 668; /* andv4sf3 */

            case E_V1DFmode:
              if (pattern3 (x2, 
E_V1DFmode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 669; /* andv1df3 */

            case E_V2DFmode:
              if (pattern3 (x2, 
E_V2DFmode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 670; /* andv2df3 */

            case E_V1TFmode:
              if (pattern3 (x2, 
E_V1TFmode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 671; /* andv1tf3 */

            case E_V1TImode:
              if (pattern3 (x2, 
E_V1TImode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 672; /* andv1ti3 */

            case E_TImode:
              if (pattern3 (x2, 
E_TImode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 673; /* andti3 */

            case E_HImode:
              if (pnum_clobbers == NULL
                  || pattern64 (x2, 
E_HImode) != 0)
                return -1;
              if (
#line 7921 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
                {
                  *pnum_clobbers = 1;
                  return 2013; /* *andhi3_zarch */
                }
              if (!
#line 7938 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
                return -1;
              *pnum_clobbers = 1;
              return 2014; /* *andhi3_esa */

            case E_QImode:
              if (pnum_clobbers == NULL
                  || pattern64 (x2, 
E_QImode) != 0)
                return -1;
              if (
#line 7966 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
                {
                  *pnum_clobbers = 1;
                  return 2015; /* *andqi3_zarch */
                }
              if (!
#line 7983 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
                return -1;
              *pnum_clobbers = 1;
              return 2016; /* *andqi3_esa */

            default:
              return -1;
            }

        case ZERO_EXTRACT:
          if (pnum_clobbers == NULL
              || pattern141 (x1) != 0)
            return -1;
          x6 = XEXP (x2, 1);
          operands[3] = x6;
          if (!nonimmediate_operand (operands[3], E_DImode)
              || !rtx_equal_p (x3, operands[0])
              || !
#line 4628 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && INTVAL (operands[1]) + INTVAL (operands[2]) == 64))
            return -1;
          *pnum_clobbers = 1;
          return 1658; /* *insv_rnsbg_noshift */

        default:
          return -1;
        }

    case GE:
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != GE)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      x8 = XEXP (x6, 0);
      if (!rtx_equal_p (x8, operands[2]))
        return -1;
      x9 = XEXP (x6, 1);
      if (!rtx_equal_p (x9, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V1SImode:
          if (pattern220 (x2, 
E_V1SImode, 
E_V1SFmode) != 0
              || !
#line 2101 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1219; /* *vec_cmpeqv1sf_signaling_nocc */

        case E_V2SImode:
          if (pattern220 (x2, 
E_V2SImode, 
E_V2SFmode) != 0
              || !
#line 2101 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1220; /* *vec_cmpeqv2sf_signaling_nocc */

        case E_V4SImode:
          if (pattern220 (x2, 
E_V4SImode, 
E_V4SFmode) != 0
              || !
#line 2101 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1221; /* *vec_cmpeqv4sf_signaling_nocc */

        case E_V1DImode:
          if (pattern220 (x2, 
E_V1DImode, 
E_V1DFmode) != 0
              || !
#line 2101 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1222; /* *vec_cmpeqv1df_signaling_nocc */

        case E_V2DImode:
          if (pattern220 (x2, 
E_V2DImode, 
E_V2DFmode) != 0
              || !
#line 2101 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1223; /* *vec_cmpeqv2df_signaling_nocc */

        case E_V1TImode:
          if (!register_operand (operands[0], E_V1TImode)
              || GET_MODE (x2) != E_V1TImode
              || GET_MODE (x3) != E_V1TImode
              || GET_MODE (x6) != E_V1TImode)
            return -1;
          switch (pattern166 ())
            {
            case 0:
              if (!
#line 2101 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
                return -1;
              return 1224; /* *vec_cmpeqv1tf_signaling_nocc */

            case 1:
              if (!
#line 2101 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
                return -1;
              return 1225; /* *vec_cmpeqtf_signaling_nocc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != ZERO_EXTRACT
          || pattern141 (x1) != 0)
        return -1;
      x7 = XEXP (x3, 1);
      operands[3] = x7;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[4] = x6;
      if (!nonimmediate_operand (operands[4], E_DImode))
        return -1;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[0])
          || !
#line 4645 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && INTVAL (operands[3]) == 64 - INTVAL (operands[1]) - INTVAL (operands[2])))
        return -1;
      *pnum_clobbers = 1;
      return 1659; /* *insv_rnsbg_srl */

    default:
      return -1;
    }
}

 int
recog_54 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      return recog_19 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_20 (x1, insn, pnum_clobbers);

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (pattern65 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 696; /* iorv1qi3 */
          break;

        case 1:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 697; /* iorv2qi3 */
          break;

        case 2:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 698; /* iorv4qi3 */
          break;

        case 3:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 699; /* iorv8qi3 */
          break;

        case 4:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 700; /* iorv16qi3 */
          break;

        case 5:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 701; /* iorv1hi3 */
          break;

        case 6:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 702; /* iorv2hi3 */
          break;

        case 7:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 703; /* iorv4hi3 */
          break;

        case 8:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 704; /* iorv8hi3 */
          break;

        case 9:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 705; /* iorv1si3 */
          break;

        case 10:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 706; /* iorv2si3 */
          break;

        case 11:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 707; /* iorv4si3 */
          break;

        case 12:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 708; /* iorv1di3 */
          break;

        case 13:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 709; /* iorv2di3 */
          break;

        case 14:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 710; /* iorv1sf3 */
          break;

        case 15:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 711; /* iorv2sf3 */
          break;

        case 16:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 712; /* iorv4sf3 */
          break;

        case 17:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 713; /* iorv1df3 */
          break;

        case 18:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 714; /* iorv2df3 */
          break;

        case 19:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 715; /* iorv1tf3 */
          break;

        case 20:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 716; /* iorv1ti3 */
          break;

        case 21:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 717; /* iorti3 */
          break;

        case 22:
          if (
#line 8138 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2022; /* *iordi3 */
            }
          break;

        case 23:
          if (
#line 8275 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2027; /* *iorhi3_zarch */
            }
          if (
#line 8291 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2028; /* *iorhi3_esa */
            }
          break;

        case 24:
          if (
#line 8318 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2029; /* *iorqi3_zarch */
            }
          if (
#line 8336 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2030; /* *iorqi3_esa */
            }
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      if (GET_CODE (x4) == SUBREG
          && pattern129 (x3) == 0
          && 
#line 4587 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
        {
          *pnum_clobbers = 1;
          return 1656; /* *rosbg_sidi_srl */
        }
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!general_operand (operands[2], E_SImode))
        return -1;
      if (
#line 8219 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        {
          *pnum_clobbers = 1;
          return 2025; /* *iorsi3_zarch */
        }
      if (!
#line 8247 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        return -1;
      *pnum_clobbers = 1;
      return 2026; /* *iorsi3_esa */

    case ASHIFT:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
        case MEM:
          switch (pattern29 (x3, pnum_clobbers))
            {
            case 0:
              if (!(
#line 4548 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 1648; /* *rosbg_di_sll */

            case 1:
              if (!
#line 4548 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                return -1;
              *pnum_clobbers = 1;
              return 1650; /* *rosbg_si_sll */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x7 = XEXP (x4, 1);
          if (GET_CODE (x7) != CONST_INT)
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != ZERO_EXTEND)
            return -1;
          x8 = XEXP (x6, 0);
          switch (GET_CODE (x8))
            {
            case MOD:
              if (pattern130 (x3, 
DIV) != 0
                  || pattern201 (x3) != 0)
                return -1;
              x9 = XEXP (x5, 0);
              x10 = XEXP (x9, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              x11 = XEXP (x8, 1);
              switch (GET_CODE (x11))
                {
                case CONST_INT:
                case CONST_WIDE_INT:
                case CONST_POLY_INT:
                case CONST_FIXED:
                case CONST_DOUBLE:
                case CONST_VECTOR:
                case CONST:
                case REG:
                case SUBREG:
                case MEM:
                case LABEL_REF:
                case SYMBOL_REF:
                case HIGH:
                  operands[2] = x11;
                  if (!general_operand (operands[2], E_DImode))
                    return -1;
                  x12 = XEXP (x9, 1);
                  if (!rtx_equal_p (x12, operands[2])
                      || !
#line 7438 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return -1;
                  return 1987; /* divmodtidi3 */

                case SIGN_EXTEND:
                  if (GET_MODE (x11) != E_DImode)
                    return -1;
                  x12 = XEXP (x9, 1);
                  if (GET_CODE (x12) != SIGN_EXTEND
                      || GET_MODE (x12) != E_DImode)
                    return -1;
                  x13 = XEXP (x11, 0);
                  operands[2] = x13;
                  if (!nonimmediate_operand (operands[2], E_SImode))
                    return -1;
                  x14 = XEXP (x12, 0);
                  if (!rtx_equal_p (x14, operands[2])
                      || !
#line 7456 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return -1;
                  return 1988; /* divmodtisi3 */

                default:
                  return -1;
                }

            case TRUNCATE:
              x9 = XEXP (x5, 0);
              if (GET_CODE (x9) != TRUNCATE)
                return -1;
              x15 = XEXP (x8, 0);
              switch (GET_CODE (x15))
                {
                case UMOD:
                  x16 = XEXP (x15, 1);
                  if (GET_CODE (x16) != ZERO_EXTEND)
                    return -1;
                  x10 = XEXP (x9, 0);
                  if (GET_CODE (x10) != UDIV)
                    return -1;
                  x17 = XEXP (x10, 1);
                  if (GET_CODE (x17) != ZERO_EXTEND)
                    return -1;
                  x18 = XEXP (x15, 0);
                  operands[1] = x18;
                  x19 = XEXP (x16, 0);
                  operands[2] = x19;
                  x20 = XEXP (x10, 0);
                  if (!rtx_equal_p (x20, operands[1]))
                    return -1;
                  x21 = XEXP (x17, 0);
                  if (!rtx_equal_p (x21, operands[2]))
                    return -1;
                  switch (XWINT (x7, 0))
                    {
                    case 64L:
                      if (pattern267 (x3, 
E_TImode, 
E_DImode) != 0
                          || !
#line 7517 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                        return -1;
                      return 1989; /* udivmodtidi3 */

                    case 32L:
                      if (pattern267 (x3, 
E_DImode, 
E_SImode) != 0
                          || !
#line 7637 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                        return -1;
                      return 1991; /* udivmoddisi3 */

                    default:
                      return -1;
                    }

                case MOD:
                  if (GET_MODE (x15) != E_DImode)
                    return -1;
                  x16 = XEXP (x15, 1);
                  if (GET_CODE (x16) != SIGN_EXTEND
                      || GET_MODE (x16) != E_DImode
                      || XWINT (x7, 0) != 32L)
                    return -1;
                  x10 = XEXP (x9, 0);
                  if (GET_CODE (x10) != DIV
                      || GET_MODE (x10) != E_DImode)
                    return -1;
                  x17 = XEXP (x10, 1);
                  if (GET_CODE (x17) != SIGN_EXTEND
                      || GET_MODE (x17) != E_DImode
                      || !register_operand (operands[0], E_DImode)
                      || GET_MODE (x3) != E_DImode
                      || GET_MODE (x4) != E_DImode
                      || GET_MODE (x6) != E_DImode
                      || GET_MODE (x8) != E_SImode)
                    return -1;
                  x18 = XEXP (x15, 0);
                  operands[1] = x18;
                  if (!register_operand (operands[1], E_DImode))
                    return -1;
                  x19 = XEXP (x16, 0);
                  operands[2] = x19;
                  if (!nonimmediate_operand (operands[2], E_SImode)
                      || GET_MODE (x5) != E_DImode
                      || GET_MODE (x9) != E_SImode)
                    return -1;
                  x20 = XEXP (x10, 0);
                  if (!rtx_equal_p (x20, operands[1]))
                    return -1;
                  x21 = XEXP (x17, 0);
                  if (!rtx_equal_p (x21, operands[2])
                      || !
#line 7576 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                    return -1;
                  return 1990; /* divmoddisi3 */

                default:
                  return -1;
                }

            case CLZ:
              if (pnum_clobbers == NULL
                  || pattern130 (x3, 
XOR) != 0)
                return -1;
              x9 = XEXP (x5, 0);
              x12 = XEXP (x9, 1);
              if (GET_CODE (x12) != LSHIFTRT)
                return -1;
              x22 = XEXP (x12, 1);
              if (GET_CODE (x22) != SUBREG
                  || maybe_ne (SUBREG_BYTE (x22), 4)
                  || GET_MODE (x22) != E_SImode)
                return -1;
              x23 = XEXP (x22, 0);
              if (GET_CODE (x23) != CLZ
                  || GET_MODE (x23) != E_DImode
                  || pattern201 (x3) != 0)
                return -1;
              x14 = XEXP (x12, 0);
              operands[2] = x14;
              if (!const_int_operand (operands[2], E_DImode))
                return -1;
              x10 = XEXP (x9, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              x24 = XEXP (x23, 0);
              if (!rtx_equal_p (x24, operands[1])
                  || !
#line 9362 "../../gcc/config/s390/s390.md"
(UINTVAL (operands[2]) == HOST_WIDE_INT_1U << 63
   && TARGET_EXTIMM && TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2157; /* clztidi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern29 (x3, pnum_clobbers))
        {
        case 0:
          if (!(
#line 4567 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1652; /* *rosbg_di_srl */

        case 1:
          if (!
#line 4567 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 1654; /* *rosbg_si_srl */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_65 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern33 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 634; /* absv1qi2 */

        case 1:
          if (!
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 635; /* absv2qi2 */

        case 2:
          if (!
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 636; /* absv4qi2 */

        case 3:
          if (!
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 637; /* absv8qi2 */

        case 4:
          if (!
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 638; /* absv16qi2 */

        case 5:
          if (!
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 639; /* absv1hi2 */

        case 6:
          if (!
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 640; /* absv2hi2 */

        case 7:
          if (!
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 641; /* absv4hi2 */

        case 8:
          if (!
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 642; /* absv8hi2 */

        case 9:
          if (!
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 643; /* absv1si2 */

        case 10:
          if (!
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 644; /* absv2si2 */

        case 11:
          if (!
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 645; /* absv4si2 */

        case 12:
          if (!
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 646; /* absv1di2 */

        case 13:
          if (!
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 647; /* absv2di2 */

        case 14:
          if (!(
#line 1819 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1126; /* absv1sf2 */

        case 15:
          if (!(
#line 1819 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1127; /* absv2sf2 */

        case 16:
          if (!(
#line 1819 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1128; /* absv4sf2 */

        case 17:
          if (!
#line 1819 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1129; /* absv1df2 */

        case 18:
          if (!
#line 1819 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1130; /* absv2df2 */

        case 19:
          if (!(
#line 1819 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 61 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1131; /* absv1tf2 */

        case 20:
          if ((
#line 1819 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 61 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1132; /* abstf2_vr */
          if ((
#line 9149 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return 2117; /* *abstf2_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 9160 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2123; /* *abstf2 */

        case 21:
          if (!
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2107; /* absdi2 */

        case 22:
          *pnum_clobbers = 1;
          return 2108; /* abssi2 */

        case 23:
          if ((
#line 9149 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return 2118; /* *absfprx22_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 9160 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2124; /* *absfprx22 */

        case 24:
          if (
#line 9149 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
            return 2119; /* *absdf2_nocc */
          if (pnum_clobbers == NULL
              || !
#line 9160 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2125; /* *absdf2 */

        case 25:
          if (
#line 9149 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
            return 2120; /* *abssf2_nocc */
          if (pnum_clobbers == NULL
              || !
#line 9160 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2126; /* *abssf2 */

        case 26:
          if (!(
#line 9149 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2121; /* *abstd2_nocc */

        case 27:
          if (!(
#line 9149 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2122; /* *absdd2_nocc */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pnum_clobbers == NULL
          || pattern66 (x3, 
E_SImode) != 0
          || !
#line 9072 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2102; /* *absdi2_sign */

    default:
      return -1;
    }
}

 int
recog_77 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != ABS
          || !register_operand (operands[1], E_DImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      switch (GET_MODE (x8))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !(
#line 9084 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2103; /* *absdi2_cc */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !
#line 9084 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
            return -1;
          return 2104; /* *abssi2_cc */

        default:
          return -1;
        }

    case CLOBBER:
      switch (pattern191 (x1))
        {
        case 0:
          if (!(
#line 9095 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2105; /* *absdi2_cconly */

        case 1:
          if (!
#line 9095 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
            return -1;
          return 2106; /* *abssi2_cconly */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_84 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  if (s390_signed_integer_comparison (operands[0], E_VOIDmode))
    {
      switch (pattern115 (x1))
        {
        case 0:
          if ((
#line 1547 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return 1491; /* *cmp_and_br_signed_di */
          break;

        case 1:
          if (
#line 1547 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return 1492; /* *cmp_and_br_signed_si */
          break;

        case 2:
          if ((
#line 1605 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return 1495; /* *icmp_and_br_signed_di */
          break;

        case 3:
          if (
#line 1605 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return 1496; /* *icmp_and_br_signed_si */
          break;

        default:
          break;
        }
    }
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != LABEL_REF)
    return -1;
  x6 = XEXP (x3, 2);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  switch (GET_CODE (x4))
    {
    case GT:
    case LE:
      if (pnum_clobbers == NULL
          || !s390_brx_operator (x4, E_VOIDmode))
        return -1;
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) != PLUS)
        return -1;
      x9 = XEXP (x7, 1);
      if (GET_CODE (x9) != PLUS)
        return -1;
      x10 = XEXP (x8, 0);
      operands[1] = x10;
      x11 = XEXP (x5, 0);
      operands[0] = x11;
      x12 = XEXP (x9, 0);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      operands[6] = x4;
      res = recog_82 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      x13 = XEXP (x8, 1);
      if (GET_CODE (x13) != SUBREG)
        return -1;
      x14 = XEXP (x4, 1);
      if (GET_CODE (x14) != SUBREG)
        return -1;
      x15 = XEXP (x9, 1);
      if (GET_CODE (x15) != SUBREG)
        return -1;
      operands[5] = x4;
      x16 = XEXP (x13, 0);
      operands[2] = x16;
      x17 = XEXP (x7, 0);
      operands[3] = x17;
      x18 = XEXP (x14, 0);
      if (!rtx_equal_p (x18, operands[2]))
        return -1;
      x19 = XEXP (x15, 0);
      if (!rtx_equal_p (x19, operands[2]))
        return -1;
      switch (SUBREG_BYTE (x13))
        {
        case 0:
          if (maybe_ne (SUBREG_BYTE (x15), 0))
            return -1;
          switch (SUBREG_BYTE (x14))
            {
            case 8:
              if (pattern294 (x1, 
E_DImode, 
E_TImode) != 0
                  || !
#line 9794 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 2;
              return 2191; /* *brxg_64bit */

            case 4:
              if (pattern294 (x1, 
E_SImode, 
E_DImode) != 0
                  || !
#line 9880 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 2;
              return 2193; /* *brx_31bit */

            default:
              return -1;
            }

        case 4:
          if (GET_MODE (x13) != E_SImode
              || maybe_ne (SUBREG_BYTE (x14), 12)
              || GET_MODE (x14) != E_SImode
              || maybe_ne (SUBREG_BYTE (x15), 4)
              || GET_MODE (x15) != E_SImode
              || GET_MODE (x8) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_TImode)
              || !nonimmediate_operand (operands[3], E_SImode)
              || GET_MODE (x9) != E_SImode
              || !
#line 9837 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 2;
          return 2192; /* *brx_64bit */

        default:
          return -1;
        }

    case NE:
    case EQ:
      if (pnum_clobbers != NULL)
        {
          res = recog_83 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[0] = x4;
      if (!s390_eqne_operator (operands[0], E_VOIDmode))
        return -1;
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 33
          || GET_MODE (x8) != E_CCRAWmode
          || pattern230 (x1) != 0)
        return -1;
      return 2303; /* *ccraw_to_int */

    default:
      return -1;
    }
}

 int
recog_92 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  x8 = XEXP (x2, 0);
  operands[3] = x8;
  if (!scratch_operand (operands[3], E_CCmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (pattern212 (x5, 
E_DImode) != 0
          || !
#line 7184 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 1966; /* *muldi3 */

    case E_SImode:
      if (pattern212 (x5, 
E_SImode) != 0)
        return -1;
      return 1971; /* *mulsi3 */

    default:
      return -1;
    }
}

 int
recog_95 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      switch (XINT (x3, 1))
        {
        case 67:
          switch (pattern143 (x1, 
66))
            {
            case 0:
              if (!
#line 312 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 24; /* *vec_packs_ccv8hi */

            case 1:
              if (!
#line 312 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 25; /* *vec_packs_ccv4si */

            case 2:
              if (!
#line 312 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 26; /* *vec_packs_ccv2di */

            default:
              return -1;
            }

        case 70:
          switch (pattern143 (x1, 
69))
            {
            case 0:
              if (!
#line 387 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 30; /* *vec_packsu_ccv8hi */

            case 1:
              if (!
#line 387 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 31; /* *vec_packsu_ccv4si */

            case 2:
              if (!
#line 387 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 32; /* *vec_packsu_ccv2di */

            default:
              return -1;
            }

        case 128:
          if (GET_MODE (x3) != E_CCRAWmode)
            return -1;
          x6 = XEXP (x2, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 33
              || GET_MODE (x6) != E_CCRAWmode)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER
              || !const_int_operand (operands[2], E_HImode))
            return -1;
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SFmode:
              if (!register_operand (operands[1], E_V4SFmode)
                  || !scratch_operand (operands[0], E_V4SImode)
                  || !(
#line 1933 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 324; /* *vftciv4sf_cconly */

            case E_V2DFmode:
              if (!register_operand (operands[1], E_V2DFmode)
                  || !scratch_operand (operands[0], E_V2DImode)
                  || !
#line 1933 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")))
                return -1;
              return 325; /* *vftciv2df_cconly */

            case E_V1TFmode:
              if (!register_operand (operands[1], E_V1TFmode)
                  || !scratch_operand (operands[0], E_V1TImode)
                  || !(
#line 1933 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 326; /* *vftciv1tf_cconly */

            case E_TFmode:
              if (!register_operand (operands[1], E_TFmode)
                  || !scratch_operand (operands[0], E_V1TImode)
                  || !(
#line 1933 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 327; /* *vftcitf_cconly */

            default:
              return -1;
            }

        case 127:
          x7 = XVECEXP (x1, 0, 1);
          if (pattern44 (x7, 
128, 
2, 
UNSPEC) != 0)
            return -1;
          x9 = XEXP (x7, 1);
          if (GET_MODE (x9) != E_CCRAWmode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 33
              || GET_MODE (x8) != E_CCRAWmode)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          if (!const_int_operand (operands[2], E_HImode))
            return -1;
          x10 = XVECEXP (x9, 0, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          x11 = XVECEXP (x9, 0, 1);
          if (!rtx_equal_p (x11, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x3) != E_V4SFmode
                  || !register_operand (operands[1], E_V4SFmode)
                  || !(
#line 1959 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 328; /* vftciv4sf */

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x3) != E_V2DFmode
                  || !register_operand (operands[1], E_V2DFmode)
                  || !
#line 1959 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")))
                return -1;
              return 329; /* vftciv2df */

            case E_V1TFmode:
              if (!register_operand (operands[0], E_V1TFmode)
                  || GET_MODE (x3) != E_V1TFmode
                  || !register_operand (operands[1], E_V1TFmode)
                  || !(
#line 1959 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 330; /* vftciv1tf */

            case E_TFmode:
              if (!register_operand (operands[0], E_TFmode)
                  || GET_MODE (x3) != E_TFmode
                  || !register_operand (operands[1], E_TFmode)
                  || !(
#line 1959 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 331; /* vftcitf */

            default:
              return -1;
            }

        case 1:
          if (pattern38 (x1) != 0
              || !s_operand (operands[1], E_BLKmode)
              || !const_int_operand (operands[2], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              return 1577; /* *sethighpartsi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return -1;
              if (
#line 4059 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return 1578; /* *sethighpartdi_64 */
              if (!
#line 4069 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                return -1;
              return 1579; /* *sethighpartdi_31 */

            default:
              return -1;
            }

        case 44:
          if (pattern101 (x1) != 0
              || !address_operand (operands[1], E_VOIDmode)
              || !immediate_operand (operands[2], E_SImode)
              || !
#line 12277 "../../gcc/config/s390/s390.md"
(TARGET_Z13))
            return -1;
          return 2316; /* lcbb */

        default:
          return -1;
        }

    case 3:
      if (pattern68 (x1, 
3) != 0
          || !const_mask_operand (operands[3], E_QImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x7, 1);
      x10 = XVECEXP (x9, 0, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XVECEXP (x9, 0, 1);
      if (!rtx_equal_p (x11, operands[2]))
        return -1;
      x12 = XVECEXP (x9, 0, 2);
      if (!rtx_equal_p (x12, operands[3]))
        return -1;
      switch (XINT (x3, 1))
        {
        case 108:
          switch (pattern278 (x1, 
109))
            {
            case 0:
              if (!
#line 1317 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 281; /* *vfaesv16qi */

            case 1:
              if (!
#line 1317 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 282; /* *vfaesv8hi */

            case 2:
              if (!
#line 1317 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 283; /* *vfaesv4si */

            default:
              return -1;
            }

        case 110:
          switch (pattern278 (x1, 
111))
            {
            case 0:
              if (!
#line 2277 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1257; /* vec_vfeesv16qi */

            case 1:
              if (!
#line 2277 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1258; /* vec_vfeesv8hi */

            case 2:
              if (!
#line 2277 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1259; /* vec_vfeesv4si */

            default:
              return -1;
            }

        case 112:
          switch (pattern278 (x1, 
113))
            {
            case 0:
              if (!
#line 2303 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1260; /* vec_vfenesv16qi */

            case 1:
              if (!
#line 2303 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1261; /* vec_vfenesv8hi */

            case 2:
              if (!
#line 2303 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1262; /* vec_vfenesv4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (XINT (x3, 1))
        {
        case 114:
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != SET)
            return -1;
          x9 = XEXP (x7, 1);
          if (pattern152 (x9, 
E_CCRAWmode, 
115, 
UNSPEC, 
1) != 0)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 33
              || GET_MODE (x8) != E_CCRAWmode)
            return -1;
          x10 = XVECEXP (x9, 0, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || GET_MODE (x3) != E_V16QImode
                  || !register_operand (operands[1], E_V16QImode)
                  || !
#line 1519 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 299; /* *vistrsv16qi */

            case E_V8HImode:
              if (!register_operand (operands[0], E_V8HImode)
                  || GET_MODE (x3) != E_V8HImode
                  || !register_operand (operands[1], E_V8HImode)
                  || !
#line 1519 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 300; /* *vistrsv8hi */

            case E_V4SImode:
              if (!register_operand (operands[0], E_V4SImode)
                  || GET_MODE (x3) != E_V4SImode
                  || !register_operand (operands[1], E_V4SImode)
                  || !
#line 1519 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 301; /* *vistrsv4si */

            default:
              return -1;
            }

        case 4:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (pattern88 (x7) != 0
              || !register_operand (operands[0], E_SImode)
              || !register_operand (operands[1], E_CCUmode))
            return -1;
          return 1573; /* cmpint */

        case 37:
          x7 = XVECEXP (x1, 0, 1);
          if (pattern88 (x7) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !register_operand (operands[1], E_DImode)
                  || !(
#line 11843 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 702 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2293; /* *popcountdi_z196 */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !register_operand (operands[1], E_SImode)
                  || !
#line 11843 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                return -1;
              return 2294; /* *popcountsi_z196 */

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x3) != E_HImode
                  || !register_operand (operands[1], E_HImode)
                  || !
#line 11843 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                return -1;
              return 2295; /* *popcounthi_z196 */

            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || GET_MODE (x3) != E_QImode
                  || !register_operand (operands[1], E_QImode)
                  || !
#line 11843 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                return -1;
              return 2296; /* *popcountqi_z196 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4:
      if (pattern68 (x1, 
4) != 0)
        return -1;
      x13 = XVECEXP (x3, 0, 3);
      operands[4] = x13;
      if (!const_mask_operand (operands[4], E_QImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x7, 1);
      x10 = XVECEXP (x9, 0, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XVECEXP (x9, 0, 1);
      if (!rtx_equal_p (x11, operands[2]))
        return -1;
      x12 = XVECEXP (x9, 0, 2);
      if (!rtx_equal_p (x12, operands[3]))
        return -1;
      x14 = XVECEXP (x9, 0, 3);
      if (!rtx_equal_p (x14, operands[4]))
        return -1;
      switch (XINT (x3, 1))
        {
        case 116:
          if (XINT (x9, 1) != 117)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern292 (x3, 
E_V16QImode) != 0
                  || !
#line 1576 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 305; /* *vstrcsv16qi */

            case E_V8HImode:
              if (pattern292 (x3, 
E_V8HImode) != 0
                  || !
#line 1576 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 306; /* *vstrcsv8hi */

            case E_V4SImode:
              if (pattern292 (x3, 
E_V4SImode) != 0
                  || !
#line 1576 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 307; /* *vstrcsv4si */

            default:
              return -1;
            }

        case 118:
          if (GET_MODE (x3) != E_V16QImode
              || XINT (x9, 1) != 119
              || !register_operand (operands[0], E_V16QImode)
              || !register_operand (operands[3], E_V16QImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16QImode:
              if (!register_operand (operands[1], E_V16QImode)
                  || !register_operand (operands[2], E_V16QImode)
                  || !
#line 1697 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 308; /* vec_vstrsv16qi */

            case E_V8HImode:
              if (!register_operand (operands[1], E_V8HImode)
                  || !register_operand (operands[2], E_V8HImode)
                  || !
#line 1697 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 309; /* vec_vstrsv8hi */

            case E_V4SImode:
              if (!register_operand (operands[1], E_V4SImode)
                  || !register_operand (operands[2], E_V4SImode)
                  || !
#line 1697 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 310; /* vec_vstrsv4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_112 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case UNSPEC:
      return recog_61 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      return recog_51 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_54 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_52 (x1, insn, pnum_clobbers);

    case COMPARE:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 33)
        return -1;
      return recog_25 (x1, insn, pnum_clobbers);

    case BSWAP:
      return recog_63 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      return recog_71 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      return recog_57 (x1, insn, pnum_clobbers);

    case NEG:
      return recog_53 (x1, insn, pnum_clobbers);

    case ABS:
      return recog_65 (x1, insn, pnum_clobbers);

    case XOR:
      return recog_60 (x1, insn, pnum_clobbers);

    case CLZ:
      switch (pattern0 (x1))
        {
        case 0:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 811; /* clzv1qi2 */

        case 1:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 812; /* clzv2qi2 */

        case 2:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 813; /* clzv4qi2 */

        case 3:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 814; /* clzv8qi2 */

        case 4:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 815; /* clzv16qi2 */

        case 5:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 816; /* clzv1hi2 */

        case 6:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 817; /* clzv2hi2 */

        case 7:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 818; /* clzv4hi2 */

        case 8:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 819; /* clzv8hi2 */

        case 9:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 820; /* clzv1si2 */

        case 10:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 821; /* clzv2si2 */

        case 11:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 822; /* clzv4si2 */

        case 12:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 823; /* clzv1di2 */

        case 13:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 824; /* clzv2di2 */

        case 14:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 825; /* clzv1sf2 */

        case 15:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 826; /* clzv2sf2 */

        case 16:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 827; /* clzv4sf2 */

        case 17:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 828; /* clzv1df2 */

        case 18:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 829; /* clzv2df2 */

        default:
          return -1;
        }

    case CTZ:
      switch (pattern0 (x1))
        {
        case 0:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 830; /* ctzv1qi2 */

        case 1:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 831; /* ctzv2qi2 */

        case 2:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 832; /* ctzv4qi2 */

        case 3:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 833; /* ctzv8qi2 */

        case 4:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 834; /* ctzv16qi2 */

        case 5:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 835; /* ctzv1hi2 */

        case 6:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 836; /* ctzv2hi2 */

        case 7:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 837; /* ctzv4hi2 */

        case 8:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 838; /* ctzv8hi2 */

        case 9:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 839; /* ctzv1si2 */

        case 10:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 840; /* ctzv2si2 */

        case 11:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 841; /* ctzv4si2 */

        case 12:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 842; /* ctzv1di2 */

        case 13:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 843; /* ctzv2di2 */

        case 14:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 844; /* ctzv1sf2 */

        case 15:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 845; /* ctzv2sf2 */

        case 16:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 846; /* ctzv4sf2 */

        case 17:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 847; /* ctzv1df2 */

        case 18:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 848; /* ctzv2df2 */

        default:
          return -1;
        }

    case ROTATE:
      return recog_59 (x1, insn, pnum_clobbers);

    case ASHIFT:
      return recog_58 (x1, insn, pnum_clobbers);

    case ASHIFTRT:
      return recog_55 (x1, insn, pnum_clobbers);

    case LSHIFTRT:
      return recog_56 (x1, insn, pnum_clobbers);

    case SMIN:
      switch (pattern4 (x1))
        {
        case 0:
          if (!
#line 1513 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 979; /* sminv1qi3 */

        case 1:
          if (!
#line 1513 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 980; /* sminv2qi3 */

        case 2:
          if (!
#line 1513 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 981; /* sminv4qi3 */

        case 3:
          if (!
#line 1513 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 982; /* sminv8qi3 */

        case 4:
          if (!
#line 1513 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 983; /* sminv16qi3 */

        case 5:
          if (!
#line 1513 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 984; /* sminv1hi3 */

        case 6:
          if (!
#line 1513 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 985; /* sminv2hi3 */

        case 7:
          if (!
#line 1513 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 986; /* sminv4hi3 */

        case 8:
          if (!
#line 1513 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 987; /* sminv8hi3 */

        case 9:
          if (!
#line 1513 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 988; /* sminv1si3 */

        case 10:
          if (!
#line 1513 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 989; /* sminv2si3 */

        case 11:
          if (!
#line 1513 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 990; /* sminv4si3 */

        case 12:
          if (!
#line 1513 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 991; /* sminv1di3 */

        case 13:
          if (!
#line 1513 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 992; /* sminv2di3 */

        case 14:
          if (!
#line 1884 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1145; /* *sminv4sf3_vxe */

        case 15:
          if (
#line 1884 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return 1146; /* *sminv2df3_vxe */
          if (!
#line 1893 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE))
            return -1;
          return 1149; /* *sminv2df3_vx */

        case 16:
          if (!
#line 1884 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1147; /* *sminv1tf3_vxe */

        case 17:
          if (!
#line 1884 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1148; /* *smintf3_vxe */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern4 (x1))
        {
        case 0:
          if (!
#line 1522 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 993; /* smaxv1qi3 */

        case 1:
          if (!
#line 1522 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 994; /* smaxv2qi3 */

        case 2:
          if (!
#line 1522 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 995; /* smaxv4qi3 */

        case 3:
          if (!
#line 1522 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 996; /* smaxv8qi3 */

        case 4:
          if (!
#line 1522 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 997; /* smaxv16qi3 */

        case 5:
          if (!
#line 1522 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 998; /* smaxv1hi3 */

        case 6:
          if (!
#line 1522 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 999; /* smaxv2hi3 */

        case 7:
          if (!
#line 1522 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1000; /* smaxv4hi3 */

        case 8:
          if (!
#line 1522 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1001; /* smaxv8hi3 */

        case 9:
          if (!
#line 1522 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1002; /* smaxv1si3 */

        case 10:
          if (!
#line 1522 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1003; /* smaxv2si3 */

        case 11:
          if (!
#line 1522 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1004; /* smaxv4si3 */

        case 12:
          if (!
#line 1522 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1005; /* smaxv1di3 */

        case 13:
          if (!
#line 1522 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1006; /* smaxv2di3 */

        case 14:
          if (!
#line 1848 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1140; /* *smaxv4sf3_vxe */

        case 15:
          if (
#line 1848 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return 1141; /* *smaxv2df3_vxe */
          if (!
#line 1857 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE))
            return -1;
          return 1144; /* *smaxv2df3_vx */

        case 16:
          if (!
#line 1848 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1142; /* *smaxv1tf3_vxe */

        case 17:
          if (!
#line 1848 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1143; /* *smaxtf3_vxe */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern5 (x1))
        {
        case 0:
          if (!
#line 1531 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1007; /* uminv1qi3 */

        case 1:
          if (!
#line 1531 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1008; /* uminv2qi3 */

        case 2:
          if (!
#line 1531 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1009; /* uminv4qi3 */

        case 3:
          if (!
#line 1531 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1010; /* uminv8qi3 */

        case 4:
          if (!
#line 1531 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1011; /* uminv16qi3 */

        case 5:
          if (!
#line 1531 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1012; /* uminv1hi3 */

        case 6:
          if (!
#line 1531 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1013; /* uminv2hi3 */

        case 7:
          if (!
#line 1531 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1014; /* uminv4hi3 */

        case 8:
          if (!
#line 1531 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1015; /* uminv8hi3 */

        case 9:
          if (!
#line 1531 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1016; /* uminv1si3 */

        case 10:
          if (!
#line 1531 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1017; /* uminv2si3 */

        case 11:
          if (!
#line 1531 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1018; /* uminv4si3 */

        case 12:
          if (!
#line 1531 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1019; /* uminv1di3 */

        case 13:
          if (!
#line 1531 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1020; /* uminv2di3 */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern5 (x1))
        {
        case 0:
          if (!
#line 1540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1021; /* umaxv1qi3 */

        case 1:
          if (!
#line 1540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1022; /* umaxv2qi3 */

        case 2:
          if (!
#line 1540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1023; /* umaxv4qi3 */

        case 3:
          if (!
#line 1540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1024; /* umaxv8qi3 */

        case 4:
          if (!
#line 1540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1025; /* umaxv16qi3 */

        case 5:
          if (!
#line 1540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1026; /* umaxv1hi3 */

        case 6:
          if (!
#line 1540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1027; /* umaxv2hi3 */

        case 7:
          if (!
#line 1540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1028; /* umaxv4hi3 */

        case 8:
          if (!
#line 1540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1029; /* umaxv8hi3 */

        case 9:
          if (!
#line 1540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1030; /* umaxv1si3 */

        case 10:
          if (!
#line 1540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1031; /* umaxv2si3 */

        case 11:
          if (!
#line 1540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1032; /* umaxv4si3 */

        case 12:
          if (!
#line 1540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1033; /* umaxv1di3 */

        case 13:
          if (!
#line 1540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1034; /* umaxv2di3 */

        default:
          return -1;
        }

    case DIV:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern3 (x2, 
E_V4SFmode) != 0
              || !(
#line 1734 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1095; /* divv4sf3 */

        case E_V2DFmode:
          if (pattern3 (x2, 
E_V2DFmode) != 0
              || !
#line 1734 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1096; /* divv2df3 */

        case E_V1TFmode:
          if (pattern3 (x2, 
E_V1TFmode) != 0
              || !(
#line 1734 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1097; /* divv1tf3 */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x2) != E_TFmode
              || !register_operand (operands[1], E_TFmode))
            return -1;
          if (register_operand (operands[2], E_TFmode)
              && (
#line 1734 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1098; /* divtf3_vr */
          if (!general_operand (operands[2], E_TFmode)
              || !(
#line 7653 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 1992; /* divtf3_fpr */

        case E_FPRX2mode:
          if (pattern85 (x2, 
E_FPRX2mode) != 0
              || !(
#line 7653 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 1993; /* divfprx23 */

        case E_DFmode:
          if (pattern85 (x2, 
E_DFmode) != 0
              || !
#line 7653 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 1994; /* divdf3 */

        case E_SFmode:
          if (pattern85 (x2, 
E_SFmode) != 0
              || !
#line 7653 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 1995; /* divsf3 */

        case E_TDmode:
          if (pattern85 (x2, 
E_TDmode) != 0
              || !(
#line 7653 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1996; /* divtd3 */

        case E_DDmode:
          if (pattern85 (x2, 
E_DDmode) != 0
              || !(
#line 7653 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1997; /* divdd3 */

        default:
          return -1;
        }

    case SQRT:
      return recog_67 (x1, insn, pnum_clobbers);

    case FMA:
      return recog_70 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      return recog_72 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      return recog_64 (x1, insn, pnum_clobbers);

    case FLOAT:
      return recog_69 (x1, insn, pnum_clobbers);

    case UNSIGNED_FLOAT:
      return recog_66 (x1, insn, pnum_clobbers);

    case FIX:
      switch (pattern6 (x1))
        {
        case 0:
          if (!
#line 2835 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1379; /* fix_truncv2dfv2di2 */

        case 1:
          if (!(
#line 2835 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 84 "../../gcc/config/s390/vector.md"
(TARGET_VXE2)))
            return -1;
          return 1380; /* fix_truncv4sfv4si2 */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern6 (x1))
        {
        case 0:
          if (!
#line 2867 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1381; /* fixuns_truncv2dfv2di2 */

        case 1:
          if (!(
#line 2867 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 84 "../../gcc/config/s390/vector.md"
(TARGET_VXE2)))
            return -1;
          return 1382; /* fixuns_truncv4sfv4si2 */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      x6 = XEXP (x2, 2);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      operands[3] = x6;
      if (const_int_operand (operands[3], E_VOIDmode))
        {
          res = recog_31 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (pnum_clobbers == NULL
          || XWINT (x6, 0) != 0L)
        return -1;
      switch (pattern34 (x1))
        {
        case 0:
          if (!(
#line 4210 "../../gcc/config/s390/s390.md"
(!TARGET_Z10) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1606; /* *pre_z10_extzvdi */

        case 1:
          if (!
#line 4210 "../../gcc/config/s390/s390.md"
(!TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 1607; /* *pre_z10_extzvsi */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x2, 2);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (pattern34 (x1))
        {
        case 0:
          if (!
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 1608; /* *pre_z10_extvdi */

        case 1:
          *pnum_clobbers = 1;
          return 1609; /* *pre_z10_extvsi */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DFmode:
              if (!register_operand (operands[1], E_DFmode)
                  || !
#line 5469 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 1748; /* truncdfsf2 */

            case E_TFmode:
              if (pnum_clobbers == NULL
                  || !register_operand (operands[1], E_TFmode)
                  || !
#line 5487 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 1750; /* trunctfsf2_fpr */

            default:
              return -1;
            }

        case E_DFmode:
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !register_operand (operands[1], E_TFmode)
              || !
#line 5487 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 1749; /* trunctfdf2_fpr */

        case E_SDmode:
          if (!register_operand (operands[0], E_SDmode)
              || GET_MODE (x2) != E_SDmode
              || !register_operand (operands[1], E_DDmode)
              || !
#line 5518 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 1752; /* truncddsd2 */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      return recog_62 (x1, insn, pnum_clobbers);

    case CALL:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x5 = XEXP (x2, 1);
      if (!const_int_operand (x5, E_VOIDmode))
        return -1;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
          if (REGNO (x7) != 1)
            return -1;
          operands[1] = x5;
          if (!
#line 10528 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn)
   && GET_MODE (XEXP (XEXP (XEXP (PATTERN (insn), 1), 0), 0)) == Pmode))
            return -1;
          return 2220; /* *sibcall_value_br */

        case CONST:
        case SYMBOL_REF:
          operands[1] = x7;
          if (!bras_sym_operand (operands[1], E_VOIDmode))
            return -1;
          operands[2] = x5;
          if (
#line 10558 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn) && TARGET_SMALL_EXEC))
            return 2221; /* *sibcall_value_brc */
          if (!
#line 10567 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn)))
            return -1;
          return 2222; /* *sibcall_value_brcl */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      return recog_68 (x1, insn, pnum_clobbers);

    case POPCOUNT:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 11833 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
        return -1;
      *pnum_clobbers = 1;
      return 2292; /* *popcountdi_z15 */

    case COPYSIGN:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_TFmode:
          if (pattern3 (x2, 
E_TFmode) != 0
              || !(
#line 12000 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2297; /* copysigntf3_fpr */

        case E_FPRX2mode:
          if (pattern3 (x2, 
E_FPRX2mode) != 0
              || !(
#line 12000 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2298; /* copysignfprx23 */

        case E_DFmode:
          if (pattern3 (x2, 
E_DFmode) != 0
              || !
#line 12000 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2299; /* copysigndf3 */

        case E_SFmode:
          if (pattern3 (x2, 
E_SFmode) != 0
              || !
#line 12000 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2300; /* copysignsf3 */

        case E_TDmode:
          if (pattern3 (x2, 
E_TDmode) != 0
              || !(
#line 12000 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2301; /* copysigntd3 */

        case E_DDmode:
          if (pattern3 (x2, 
E_DDmode) != 0
              || !(
#line 12000 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2302; /* copysigndd3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
