/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern14 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern17 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern17 (x3, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern17 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern17 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern17 (x3, 
E_V2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x3) != E_V1HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1QImode:
          if (!register_operand (operands[1], E_V1QImode)
              || !register_operand (operands[2], E_V1QImode))
            return -1;
          return 0;

        case E_V2QImode:
          if (!register_operand (operands[1], E_V2QImode)
              || !register_operand (operands[2], E_V2QImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V2HImode:
      if (pattern14 (x3, 
E_V4QImode, 
E_V2HImode) != 0)
        return -1;
      return 2;

    case E_V4HImode:
      if (pattern14 (x3, 
E_V8QImode, 
E_V4HImode) != 0)
        return -1;
      return 3;

    case E_V8HImode:
      if (pattern14 (x3, 
E_V16QImode, 
E_V8HImode) != 0)
        return -1;
      return 4;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x3) != E_V1SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1HImode:
          if (!register_operand (operands[1], E_V1HImode)
              || !register_operand (operands[2], E_V1HImode))
            return -1;
          return 5;

        case E_V2HImode:
          if (!register_operand (operands[1], E_V2HImode)
              || !register_operand (operands[2], E_V2HImode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case E_V2SImode:
      if (pattern14 (x3, 
E_V4HImode, 
E_V2SImode) != 0)
        return -1;
      return 7;

    case E_V4SImode:
      if (pattern14 (x3, 
E_V8HImode, 
E_V4SImode) != 0)
        return -1;
      return 8;

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x3) != E_V1DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1SImode:
          if (!register_operand (operands[1], E_V1SImode)
              || !register_operand (operands[2], E_V1SImode))
            return -1;
          return 9;

        case E_V2SImode:
          if (!register_operand (operands[1], E_V2SImode)
              || !register_operand (operands[2], E_V2SImode))
            return -1;
          return 10;

        default:
          return -1;
        }

    case E_V2DImode:
      if (pattern14 (x3, 
E_V4SImode, 
E_V2DImode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern55 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern54 (x1, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern54 (x1, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern54 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern62 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[4] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern61 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern61 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern67 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern74 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  return 0;
}

int
pattern79 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PC)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC_VOLATILE
      || XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != 26)
    return -1;
  x6 = XVECEXP (x5, 0, 1);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 1)
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 1)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != LABEL_REF)
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x10) != USE)
    return -1;
  x11 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x11) != USE)
    return -1;
  return 0;
}

int
pattern88 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 33
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern93 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern99 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i2)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern106 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern113 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern112 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern112 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern119 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern118 (x5, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern118 (x5, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_HImode:
      if (pattern118 (x5, 
E_HImode) != 0)
        return -1;
      return 2;

    case E_QImode:
      if (pattern118 (x5, 
E_QImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern130 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x2, 1);
  if (XWINT (x5, 0) != 64L)
    return -1;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1
      || GET_MODE (x7) != E_DImode)
    return -1;
  return 0;
}

int
pattern135 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[3] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern134 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern134 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern141 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!nonimmediate_operand (operands[0], E_DImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != E_DImode)
    return -1;
  return 0;
}

int
pattern150 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern149 (x1); /* [-1, 5] */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode))
            return -1;
          switch (GET_MODE (x6))
            {
            case E_DImode:
              if (!immediate_operand (operands[2], E_DImode))
                return -1;
              return 6;

            case E_SImode:
              if (!immediate_operand (operands[2], E_SImode))
                return -1;
              return 7;

            default:
              return -1;
            }

        case E_TFmode:
          if (!register_operand (operands[1], E_TFmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 8;

        case E_FPRX2mode:
          if (!register_operand (operands[1], E_FPRX2mode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 9;

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 10;

        case E_TDmode:
          if (!register_operand (operands[1], E_TDmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 11;

        case E_DDmode:
          if (!register_operand (operands[1], E_DDmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 12;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern176 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !const0_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern181 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern188 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !general_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !general_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern193 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!nonmemory_operand (operands[2], E_VOIDmode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!immediate_operand (operands[3], E_VOIDmode))
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  switch (GET_MODE (operands[4]))
    {
    case E_DImode:
      if (!scratch_operand (operands[4], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!scratch_operand (operands[4], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern203 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern209 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !s390_slb_comparison (operands[3], i1))
    return -1;
  return 0;
}

int
pattern218 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern227 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !nonimmediate_operand (operands[4], i1)
      || GET_MODE (x1) != i1
      || !scratch_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern236 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern241 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern249 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern257 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern267 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1
      || !nonimmediate_operand (operands[2], i2))
    return -1;
  x7 = XEXP (x1, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern285 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1)
      || pattern282 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern292 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (pattern17 (x3, 
E_V16QImode) != 0
          || !
#line 1133 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 234; /* vec_srabv16qi */

    case E_V8HImode:
      if (pattern17 (x3, 
E_V8HImode) != 0
          || !
#line 1133 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 235; /* vec_srabv8hi */

    case E_V4SImode:
      if (pattern17 (x3, 
E_V4SImode) != 0
          || !
#line 1133 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 236; /* vec_srabv4si */

    case E_V2DImode:
      if (pattern17 (x3, 
E_V2DImode) != 0
          || !
#line 1133 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 237; /* vec_srabv2di */

    case E_V1TImode:
      if (pattern17 (x3, 
E_V1TImode) != 0
          || !
#line 1133 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 238; /* vec_srabv1ti */

    case E_TImode:
      if (pattern126 (x3, 
E_V1TImode, 
E_TImode) != 0
          || !
#line 1133 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 239; /* vec_srabti */

    case E_V2DFmode:
      if (pattern126 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
          || !
#line 1133 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 240; /* vec_srabv2df */

    case E_V4SFmode:
      if (pattern126 (x3, 
E_V4SImode, 
E_V4SFmode) != 0
          || !(
#line 1133 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 31 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 241; /* vec_srabv4sf */

    case E_V1TFmode:
      if (pattern126 (x3, 
E_V1TImode, 
E_V1TFmode) != 0
          || !(
#line 1133 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 31 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 242; /* vec_srabv1tf */

    case E_TFmode:
      if (pattern126 (x3, 
E_V1TImode, 
E_TFmode) != 0
          || !(
#line 1133 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 32 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 243; /* vec_srabtf */

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XINT (x3, 1))
    {
    case 71:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_V16QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern17 (x3, 
E_V8HImode) != 0
              || !
#line 402 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 33; /* vec_zpermv8hi */

        case E_V4SImode:
          if (pattern17 (x3, 
E_V4SImode) != 0
              || !
#line 402 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 34; /* vec_zpermv4si */

        case E_V4SFmode:
          if (pattern17 (x3, 
E_V4SFmode) != 0
              || !(
#line 402 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 35 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 35; /* vec_zpermv4sf */

        case E_V2DImode:
          if (pattern17 (x3, 
E_V2DImode) != 0
              || !
#line 402 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 36; /* vec_zpermv2di */

        case E_V2DFmode:
          if (pattern17 (x3, 
E_V2DFmode) != 0
              || !
#line 402 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 37; /* vec_zpermv2df */

        case E_V16QImode:
          if (pattern17 (x3, 
E_V16QImode) != 0
              || !
#line 746 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 539; /* vec_permv16qi */

        default:
          return -1;
        }

    case 81:
      if (pattern50 (x3) != 0
          || !
#line 677 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 112; /* vacq */

    case 82:
      if (pattern50 (x3) != 0
          || !
#line 690 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 113; /* vacccq */

    case 88:
      switch (pattern52 (x3))
        {
        case 0:
          if (!
#line 870 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 136; /* vec_gfmsum_accumv16qi */

        case 1:
          if (!
#line 870 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 137; /* vec_gfmsum_accumv8hi */

        case 2:
          if (!
#line 870 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 138; /* vec_gfmsum_accumv4si */

        default:
          return -1;
        }

    case 89:
      if (pattern53 (x3, 
E_V2DImode, 
E_V16QImode) != 0)
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_V16QImode)
          || !
#line 880 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 139; /* vec_gfmsum_accum_128 */

    case 52:
      switch (pattern55 (x3))
        {
        case 0:
          if (!
#line 902 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 140; /* vec_vmalv16qi */

        case 1:
          if (!
#line 902 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 141; /* vec_vmalv8hi */

        case 2:
          if (!
#line 902 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 142; /* vec_vmalv4si */

        default:
          return -1;
        }

    case 53:
      switch (pattern55 (x3))
        {
        case 0:
          if (!
#line 915 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 143; /* vec_vmahv16qi */

        case 1:
          if (!
#line 915 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 144; /* vec_vmahv8hi */

        case 2:
          if (!
#line 915 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 145; /* vec_vmahv4si */

        default:
          return -1;
        }

    case 54:
      switch (pattern55 (x3))
        {
        case 0:
          if (!
#line 926 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 146; /* vec_vmalhv16qi */

        case 1:
          if (!
#line 926 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 147; /* vec_vmalhv8hi */

        case 2:
          if (!
#line 926 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 148; /* vec_vmalhv4si */

        default:
          return -1;
        }

    case 55:
      switch (pattern52 (x3))
        {
        case 0:
          if (!
#line 939 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 149; /* vec_vmaev16qi */

        case 1:
          if (!
#line 939 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 150; /* vec_vmaev8hi */

        case 2:
          if (!
#line 939 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 151; /* vec_vmaev4si */

        default:
          return -1;
        }

    case 56:
      switch (pattern52 (x3))
        {
        case 0:
          if (!
#line 950 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 152; /* vec_vmalev16qi */

        case 1:
          if (!
#line 950 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 153; /* vec_vmalev8hi */

        case 2:
          if (!
#line 950 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 154; /* vec_vmalev4si */

        default:
          return -1;
        }

    case 57:
      switch (pattern52 (x3))
        {
        case 0:
          if (!
#line 963 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 155; /* vec_vmaov16qi */

        case 1:
          if (!
#line 963 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 156; /* vec_vmaov8hi */

        case 2:
          if (!
#line 963 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 157; /* vec_vmaov4si */

        default:
          return -1;
        }

    case 58:
      switch (pattern52 (x3))
        {
        case 0:
          if (!
#line 974 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 158; /* vec_vmalov16qi */

        case 1:
          if (!
#line 974 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 159; /* vec_vmalov8hi */

        case 2:
          if (!
#line 974 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 160; /* vec_vmalov4si */

        default:
          return -1;
        }

    case 97:
      switch (pattern56 (x3))
        {
        case 0:
          if (!
#line 1075 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 192; /* vec_sldv16qi */

        case 1:
          if (!
#line 1075 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 193; /* vec_sldv8hi */

        case 2:
          if (!
#line 1075 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 194; /* vec_sldv4si */

        case 3:
          if (!
#line 1075 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 195; /* vec_sldv2di */

        case 4:
          if (!
#line 1075 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 196; /* vec_sldv1ti */

        case 5:
          if (!
#line 1075 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 197; /* vec_sldti */

        case 6:
          if (!
#line 1075 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 198; /* vec_sldv2df */

        case 7:
          if (!(
#line 1075 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 31 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 199; /* vec_sldv4sf */

        case 8:
          if (!(
#line 1075 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 31 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 200; /* vec_sldv1tf */

        case 9:
          if (!(
#line 1075 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 32 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 201; /* vec_sldtf */

        default:
          return -1;
        }

    case 98:
      switch (pattern56 (x3))
        {
        case 0:
          if (!
#line 1098 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 202; /* vec_sldbv16qi */

        case 1:
          if (!
#line 1098 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 203; /* vec_sldbv8hi */

        case 2:
          if (!
#line 1098 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 204; /* vec_sldbv4si */

        case 3:
          if (!
#line 1098 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 205; /* vec_sldbv2di */

        case 4:
          if (!
#line 1098 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 206; /* vec_sldbv1ti */

        case 5:
          if (!
#line 1098 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 207; /* vec_sldbti */

        case 6:
          if (!
#line 1098 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 208; /* vec_sldbv2df */

        case 7:
          if (!(
#line 1098 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 31 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 209; /* vec_sldbv4sf */

        case 8:
          if (!(
#line 1098 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 31 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 210; /* vec_sldbv1tf */

        case 9:
          if (!(
#line 1098 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 32 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 211; /* vec_sldbtf */

        default:
          return -1;
        }

    case 99:
      switch (pattern56 (x3))
        {
        case 0:
          if (!
#line 1110 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 212; /* vec_srdbv16qi */

        case 1:
          if (!
#line 1110 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 213; /* vec_srdbv8hi */

        case 2:
          if (!
#line 1110 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 214; /* vec_srdbv4si */

        case 3:
          if (!
#line 1110 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 215; /* vec_srdbv2di */

        case 4:
          if (!
#line 1110 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 216; /* vec_srdbv1ti */

        case 5:
          if (!
#line 1110 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 217; /* vec_srdbti */

        case 6:
          if (!
#line 1110 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 218; /* vec_srdbv2df */

        case 7:
          if (!(
#line 1110 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 31 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 219; /* vec_srdbv4sf */

        case 8:
          if (!(
#line 1110 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 31 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 220; /* vec_srdbv1tf */

        case 9:
          if (!(
#line 1110 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 32 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 221; /* vec_srdbtf */

        default:
          return -1;
        }

    case 105:
      if (pattern50 (x3) != 0
          || !
#line 1185 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 262; /* vsbiq */

    case 106:
      if (pattern50 (x3) != 0
          || !
#line 1198 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 263; /* vsbcbiq */

    case 108:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_mask_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern17 (x3, 
E_V16QImode) != 0
              || !
#line 1290 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 278; /* vfaev16qi */

        case E_V8HImode:
          if (pattern17 (x3, 
E_V8HImode) != 0
              || !
#line 1290 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 279; /* vfaev8hi */

        case E_V4SImode:
          if (pattern17 (x3, 
E_V4SImode) != 0
              || !
#line 1290 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 280; /* vfaev4si */

        default:
          return -1;
        }

    case 110:
      switch (pattern57 (x3))
        {
        case 0:
          if (!
#line 1390 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 284; /* vfeev16qi */

        case 1:
          if (!
#line 1390 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 285; /* vfeev8hi */

        case 2:
          if (!
#line 1390 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 286; /* vfeev4si */

        case 3:
          if (!
#line 1401 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 287; /* vfeezv16qi */

        case 4:
          if (!
#line 1401 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 288; /* vfeezv8hi */

        case 5:
          if (!
#line 1401 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 289; /* vfeezv4si */

        default:
          return -1;
        }

    case 112:
      switch (pattern57 (x3))
        {
        case 0:
          if (!
#line 1449 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 290; /* vfenev16qi */

        case 1:
          if (!
#line 1449 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 291; /* vfenev8hi */

        case 2:
          if (!
#line 1449 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 292; /* vfenev4si */

        case 3:
          if (!
#line 1462 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 293; /* vfenezv16qi */

        case 4:
          if (!
#line 1462 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 294; /* vfenezv8hi */

        case 5:
          if (!
#line 1462 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 295; /* vfenezv4si */

        default:
          return -1;
        }

    case 120:
      if (pattern58 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
          || !
#line 1718 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) != 2 && UINTVAL (operands[3]) <= 7))
        return -1;
      return 311; /* vcdgb */

    case 121:
      if (pattern58 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
          || !
#line 1750 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) != 2 && UINTVAL (operands[3]) <= 7))
        return -1;
      return 312; /* vcdlgb */

    case 122:
      if (pattern58 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
          || !
#line 1781 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) != 2 && UINTVAL (operands[3]) <= 7))
        return -1;
      return 313; /* vcgdb */

    case 123:
      if (pattern58 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
          || !
#line 1814 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) != 2 && UINTVAL (operands[3]) <= 7))
        return -1;
      return 314; /* vclgdb */

    case 124:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!const_mask_operand (operands[2], E_QImode))
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_mask_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V1SFmode:
          if (!register_operand (operands[0], E_V1SFmode)
              || GET_MODE (x3) != E_V1SFmode
              || !register_operand (operands[1], E_V1SFmode)
              || !(
#line 1849 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 315; /* vec_fpintv1sf */

        case E_V2SFmode:
          if (!register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !register_operand (operands[1], E_V2SFmode)
              || !(
#line 1849 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 316; /* vec_fpintv2sf */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !register_operand (operands[1], E_V4SFmode)
              || !(
#line 1849 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 317; /* vec_fpintv4sf */

        case E_V1DFmode:
          if (!register_operand (operands[0], E_V1DFmode)
              || GET_MODE (x3) != E_V1DFmode
              || !register_operand (operands[1], E_V1DFmode)
              || !
#line 1849 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 318; /* vec_fpintv1df */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !register_operand (operands[1], E_V2DFmode)
              || !
#line 1849 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 319; /* vec_fpintv2df */

        case E_V1TFmode:
          if (!register_operand (operands[0], E_V1TFmode)
              || GET_MODE (x3) != E_V1TFmode
              || !register_operand (operands[1], E_V1TFmode)
              || !(
#line 1849 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 61 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 320; /* vec_fpintv1tf */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode
              || !register_operand (operands[1], E_TFmode)
              || !(
#line 1849 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 61 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 321; /* vec_fpinttf */

        default:
          return -1;
        }

    case 126:
      if (pattern58 (x3, 
E_V4SFmode, 
E_V2DFmode) != 0
          || !
#line 1895 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 323; /* vflrd */

    case 130:
      switch (pattern59 (x3))
        {
        case 0:
          if (!
#line 2152 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 380; /* vfminv4sf */

        case 1:
          if (!
#line 2152 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 381; /* vfminv2df */

        case 2:
          if (!
#line 2152 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 382; /* vfminv1tf */

        case 3:
          if (!
#line 2152 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 383; /* vfmintf */

        default:
          return -1;
        }

    case 131:
      switch (pattern59 (x3))
        {
        case 0:
          if (!
#line 2162 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 384; /* vfmaxv4sf */

        case 1:
          if (!
#line 2162 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 385; /* vfmaxv2df */

        case 2:
          if (!
#line 2162 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 386; /* vfmaxv1tf */

        case 3:
          if (!
#line 2162 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 387; /* vfmaxtf */

        default:
          return -1;
        }

    case 90:
      return recog_12 (x1, insn, pnum_clobbers);

    case 135:
      if (pattern53 (x3, 
E_V4SFmode, 
E_V8HImode) != 0)
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_mask_operand (operands[3], E_QImode)
          || !
#line 2251 "../../gcc/config/s390/vx-builtins.md"
(TARGET_NNPA))
        return -1;
      return 410; /* vcrnfs_v8hi */

    default:
      return -1;
    }
}

 int
recog_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (maybe_ne (SUBREG_BYTE (x2), 0))
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      if (!general_operand (operands[1], E_FPRX2mode)
          || !nonimmediate_operand (operands[0], E_TFmode)
          || GET_MODE (x2) != E_TFmode
          || !
#line 661 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return -1;
      return 537; /* fprx2_to_tf */

    case UNSPEC:
      if (XVECLEN (x4, 0) != 3
          || XINT (x4, 1) != 71
          || GET_MODE (x4) != E_V16QImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x5) != SUBREG
          || maybe_ne (SUBREG_BYTE (x5), 0)
          || GET_MODE (x5) != E_V16QImode)
        return -1;
      x6 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x6) != SUBREG
          || maybe_ne (SUBREG_BYTE (x6), 0)
          || GET_MODE (x6) != E_V16QImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      x9 = XVECEXP (x4, 0, 2);
      operands[3] = x9;
      if (!register_operand (operands[3], E_V16QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern286 (x2, 
E_V16QImode) != 0
              || !
#line 756 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 540; /* *vec_permv16qi */

        case E_V8HImode:
          if (pattern286 (x2, 
E_V8HImode) != 0
              || !
#line 756 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 541; /* *vec_permv8hi */

        case E_V4SImode:
          if (pattern286 (x2, 
E_V4SImode) != 0
              || !
#line 756 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 542; /* *vec_permv4si */

        case E_V2DImode:
          if (pattern286 (x2, 
E_V2DImode) != 0
              || !
#line 756 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 543; /* *vec_permv2di */

        case E_V2DFmode:
          if (pattern286 (x2, 
E_V2DFmode) != 0
              || !
#line 756 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 544; /* *vec_permv2df */

        case E_V1TImode:
          if (pattern286 (x2, 
E_V1TImode) != 0
              || !
#line 756 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 545; /* *vec_permv1ti */

        case E_TImode:
          if (pattern286 (x2, 
E_TImode) != 0
              || !
#line 756 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 546; /* *vec_permti */

        case E_V4SFmode:
          if (pattern286 (x2, 
E_V4SFmode) != 0
              || !(
#line 756 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 38 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 547; /* *vec_permv4sf */

        case E_V1TFmode:
          if (pattern286 (x2, 
E_V1TFmode) != 0
              || !(
#line 756 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 38 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 548; /* *vec_permv1tf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_47 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (SUBREG_BYTE (x3))
    {
    case 0:
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case ROTATE:
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          if (!contiguous_bitmask_operand (operands[3], E_DImode))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !const_int_operand (operands[2], E_SImode))
                return -1;
              if (
#line 4174 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1592; /* *risbgn_and_subregdi_rotr */
              if (pnum_clobbers != NULL
                  && 
#line 4174 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                {
                  *pnum_clobbers = 1;
                  return 1593; /* *risbg_and_subregdi_rotr */
                }
              if (
#line 4187 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return 1598; /* *risbgn_and_subregdi_rotl */
              if (pnum_clobbers == NULL
                  || !
#line 4187 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              *pnum_clobbers = 1;
              return 1599; /* *risbg_and_subregdi_rotl */

            case E_HImode:
              if (!register_operand (operands[1], E_HImode)
                  || !const_int_operand (operands[2], E_HImode))
                return -1;
              if (
#line 4174 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1594; /* *risbgn_and_subregdi_rotr */
              if (pnum_clobbers != NULL
                  && 
#line 4174 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                {
                  *pnum_clobbers = 1;
                  return 1595; /* *risbg_and_subregdi_rotr */
                }
              if (
#line 4187 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return 1600; /* *risbgn_and_subregdi_rotl */
              if (pnum_clobbers == NULL
                  || !
#line 4187 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              *pnum_clobbers = 1;
              return 1601; /* *risbg_and_subregdi_rotl */

            case E_QImode:
              if (!register_operand (operands[1], E_QImode)
                  || !const_int_operand (operands[2], E_QImode))
                return -1;
              if (
#line 4174 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1596; /* *risbgn_and_subregdi_rotr */
              if (pnum_clobbers != NULL
                  && 
#line 4174 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                {
                  *pnum_clobbers = 1;
                  return 1597; /* *risbg_and_subregdi_rotr */
                }
              if (
#line 4187 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return 1602; /* *risbgn_and_subregdi_rotl */
              if (pnum_clobbers == NULL
                  || !
#line 4187 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              *pnum_clobbers = 1;
              return 1603; /* *risbg_and_subregdi_rotl */

            default:
              return -1;
            }

        case SUBREG:
        case MEM:
          operands[1] = x4;
          if (!memory_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x2, 1);
          if (GET_CODE (x7) != CONST_INT
              || XWINT (x7, 0) != 2147483647L)
            return -1;
          if (
#line 4935 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return 1678; /* *llgt_sidi */
          if (pnum_clobbers == NULL
              || !
#line 4945 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 1679; /* *llgt_sidi_split */

        default:
          return -1;
        }

    case 4:
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x7 = XEXP (x2, 1);
      operands[3] = x7;
      if (!contiguous_bitmask_nowrap_operand (operands[3], E_SImode))
        return -1;
      switch (GET_CODE (x4))
        {
        case LSHIFTRT:
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          if (!nonzero_shift_count_operand (operands[2], E_DImode))
            return -1;
          if (
#line 4397 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12))
            return 1630; /* *trunc_sidi_and_subreg_lshrt_nocc */
          if (pnum_clobbers == NULL
              || !
#line 4397 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
            return -1;
          *pnum_clobbers = 1;
          return 1631; /* *trunc_sidi_and_subreg_lshrt_clobbercc */

        case ZERO_EXTRACT:
          x6 = XEXP (x4, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x8 = XEXP (x4, 2);
          operands[2] = x8;
          if (!nonzero_shift_count_operand (operands[2], E_SImode))
            return -1;
          if (
#line 4411 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12))
            return 1632; /* *trunc_sidi_and_subreg_ze_nocc */
          if (pnum_clobbers == NULL
              || !
#line 4411 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
            return -1;
          *pnum_clobbers = 1;
          return 1633; /* *trunc_sidi_and_subreg_ze_clobbercc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      switch (pattern2 (x1))
        {
        case 0:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1QImode)) - 1)
  ))
            return 865; /* *lshrv1qi3 */
          if (register_operand (operands[2], E_V1QImode)
              && 
#line 1463 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 947; /* vlshrv1qi3 */
          break;

        case 1:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2QImode)) - 1)
  ))
            return 869; /* *lshrv2qi3 */
          if (register_operand (operands[2], E_V2QImode)
              && 
#line 1463 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 948; /* vlshrv2qi3 */
          break;

        case 2:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4QImode)) - 1)
  ))
            return 873; /* *lshrv4qi3 */
          if (register_operand (operands[2], E_V4QImode)
              && 
#line 1463 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 949; /* vlshrv4qi3 */
          break;

        case 3:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8QImode)) - 1)
  ))
            return 877; /* *lshrv8qi3 */
          if (register_operand (operands[2], E_V8QImode)
              && 
#line 1463 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 950; /* vlshrv8qi3 */
          break;

        case 4:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V16QImode)) - 1)
  ))
            return 881; /* *lshrv16qi3 */
          if (register_operand (operands[2], E_V16QImode)
              && 
#line 1463 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 951; /* vlshrv16qi3 */
          break;

        case 5:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1HImode)) - 1)
  ))
            return 885; /* *lshrv1hi3 */
          if (register_operand (operands[2], E_V1HImode)
              && 
#line 1463 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 952; /* vlshrv1hi3 */
          break;

        case 6:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2HImode)) - 1)
  ))
            return 889; /* *lshrv2hi3 */
          if (register_operand (operands[2], E_V2HImode)
              && 
#line 1463 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 953; /* vlshrv2hi3 */
          break;

        case 7:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4HImode)) - 1)
  ))
            return 893; /* *lshrv4hi3 */
          if (register_operand (operands[2], E_V4HImode)
              && 
#line 1463 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 954; /* vlshrv4hi3 */
          break;

        case 8:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8HImode)) - 1)
  ))
            return 897; /* *lshrv8hi3 */
          if (register_operand (operands[2], E_V8HImode)
              && 
#line 1463 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 955; /* vlshrv8hi3 */
          break;

        case 9:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1SImode)) - 1)
  ))
            return 901; /* *lshrv1si3 */
          if (register_operand (operands[2], E_V1SImode)
              && 
#line 1463 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 956; /* vlshrv1si3 */
          break;

        case 10:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2SImode)) - 1)
  ))
            return 905; /* *lshrv2si3 */
          if (register_operand (operands[2], E_V2SImode)
              && 
#line 1463 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 957; /* vlshrv2si3 */
          break;

        case 11:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4SImode)) - 1)
  ))
            return 909; /* *lshrv4si3 */
          if (register_operand (operands[2], E_V4SImode)
              && 
#line 1463 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 958; /* vlshrv4si3 */
          break;

        case 12:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1DImode)) - 1)
  ))
            return 913; /* *lshrv1di3 */
          if (register_operand (operands[2], E_V1DImode)
              && 
#line 1463 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 959; /* vlshrv1di3 */
          break;

        case 13:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2DImode)) - 1)
  ))
            return 917; /* *lshrv2di3 */
          if (register_operand (operands[2], E_V2DImode)
              && 
#line 1463 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 960; /* vlshrv2di3 */
          break;

        case 14:
          if (
#line 9416 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return 2161; /* *lshrdi3_31 */
          if (
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return 2163; /* *lshrdi3 */
          break;

        case 15:
          return 2165; /* *lshrsi3 */

        default:
          break;
        }
      break;

    case ZERO_EXTRACT:
      res = recog_26 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 32]
      || GET_CODE (x2) != ZERO_EXTRACT
      || GET_MODE (x2) != E_DImode)
    return -1;
  x5 = XEXP (x2, 2);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!memory_operand (operands[0], E_QImode))
    return -1;
  x7 = XEXP (x2, 1);
  operands[1] = x7;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  x8 = XEXP (x3, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_DImode)
      || !
#line 4677 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), 0, 64)
   && INTVAL (operands[1]) > 0
   && INTVAL (operands[1]) <= GET_MODE_BITSIZE (SImode)
   && INTVAL (operands[1]) % BITS_PER_UNIT == 0))
    return -1;
  return 1662; /* *insvdi_mem_reghigh */
}

 int
recog_60 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (pattern65 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 740; /* xorv1qi3 */
          break;

        case 1:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 741; /* xorv2qi3 */
          break;

        case 2:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 742; /* xorv4qi3 */
          break;

        case 3:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 743; /* xorv8qi3 */
          break;

        case 4:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 744; /* xorv16qi3 */
          break;

        case 5:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 745; /* xorv1hi3 */
          break;

        case 6:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 746; /* xorv2hi3 */
          break;

        case 7:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 747; /* xorv4hi3 */
          break;

        case 8:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 748; /* xorv8hi3 */
          break;

        case 9:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 749; /* xorv1si3 */
          break;

        case 10:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 750; /* xorv2si3 */
          break;

        case 11:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 751; /* xorv4si3 */
          break;

        case 12:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 752; /* xorv1di3 */
          break;

        case 13:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 753; /* xorv2di3 */
          break;

        case 14:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 754; /* xorv1sf3 */
          break;

        case 15:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 755; /* xorv2sf3 */
          break;

        case 16:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 756; /* xorv4sf3 */
          break;

        case 17:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 757; /* xorv1df3 */
          break;

        case 18:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 758; /* xorv2df3 */
          break;

        case 19:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 759; /* xorv1tf3 */
          break;

        case 20:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 760; /* xorv1ti3 */
          break;

        case 21:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 761; /* xorti3 */
          break;

        case 22:
          if (
#line 8560 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2060; /* *xordi3 */
            }
          break;

        case 23:
          if (
#line 8663 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2064; /* *xorhi3 */
            }
          break;

        case 24:
          if (
#line 8693 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2065; /* *xorqi3 */
            }
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      if (GET_CODE (x4) == SUBREG
          && pattern129 (x3) == 0
          && 
#line 4587 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
        {
          *pnum_clobbers = 1;
          return 1657; /* *rxsbg_sidi_srl */
        }
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!general_operand (operands[2], E_SImode)
          || !
#line 8630 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
        return -1;
      *pnum_clobbers = 1;
      return 2063; /* *xorsi3 */

    case AND:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x7;
          switch (pattern135 (x3))
            {
            case 0:
              if (!(
#line 4480 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 1635; /* *rxsbg_di_noshift */

            case 1:
              if (!
#line 4480 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                return -1;
              *pnum_clobbers = 1;
              return 1637; /* *rxsbg_si_noshift */

            default:
              return -1;
            }

        case ROTATE:
          if (pattern81 (x3) != 0
              || !contiguous_bitmask_operand (operands[2], E_DImode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[4] = x5;
          if (!nonimmediate_operand (operands[4], E_DImode)
              || !
#line 4495 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 1639; /* *rxsbg_di_rotl */

        case LSHIFTRT:
          switch (pattern109 (x3))
            {
            case 0:
              if (!(
#line 4510 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 1641; /* *rxsbg_di_srl_bitmask */

            case 1:
              if (!
#line 4510 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))))
                return -1;
              *pnum_clobbers = 1;
              return 1643; /* *rxsbg_si_srl_bitmask */

            default:
              return -1;
            }

        case ASHIFT:
          switch (pattern109 (x3))
            {
            case 0:
              if (!(
#line 4530 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 1645; /* *rxsbg_di_sll_bitmask */

            case 1:
              if (!
#line 4530 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, INTVAL (operands[3]),
                           INTVAL (operands[2]))))
                return -1;
              *pnum_clobbers = 1;
              return 1647; /* *rxsbg_si_sll_bitmask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern29 (x3, pnum_clobbers))
        {
        case 0:
          if (!(
#line 4548 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1649; /* *rxsbg_di_sll */

        case 1:
          if (!
#line 4548 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 1651; /* *rxsbg_si_sll */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern29 (x3, pnum_clobbers))
        {
        case 0:
          if (!(
#line 4567 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1653; /* *rxsbg_di_srl */

        case 1:
          if (!
#line 4567 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 1655; /* *rxsbg_si_srl */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case REG:
    case SUBREG:
    case MEM:
      x5 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x5))
        {
        case CLOBBER:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          x7 = XEXP (x2, 0);
          switch (GET_MODE (x7))
            {
            case E_CCVEQmode:
              if (GET_MODE (x3) != E_CCVEQmode)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (!register_operand (operands[0], E_V16QImode)
                      || !register_operand (operands[1], E_V16QImode)
                      || !scratch_operand (operands[2], E_V16QImode)
                      || !
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 332; /* *vec_cmpeqv16qi_cconly */

                case E_V8HImode:
                  if (!register_operand (operands[0], E_V8HImode)
                      || !register_operand (operands[1], E_V8HImode)
                      || !scratch_operand (operands[2], E_V8HImode)
                      || !
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 333; /* *vec_cmpeqv8hi_cconly */

                case E_V4SImode:
                  if (!register_operand (operands[0], E_V4SImode)
                      || !register_operand (operands[1], E_V4SImode)
                      || !scratch_operand (operands[2], E_V4SImode)
                      || !
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 334; /* *vec_cmpeqv4si_cconly */

                case E_V2DImode:
                  if (!register_operand (operands[0], E_V2DImode)
                      || !register_operand (operands[1], E_V2DImode)
                      || !scratch_operand (operands[2], E_V2DImode)
                      || !
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 335; /* *vec_cmpeqv2di_cconly */

                case E_V4SFmode:
                  if (!register_operand (operands[0], E_V4SFmode)
                      || !register_operand (operands[1], E_V4SFmode)
                      || !scratch_operand (operands[2], E_V4SImode)
                      || !(
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 356; /* *vec_cmpeqv4sf_cconly */

                case E_V2DFmode:
                  if (!register_operand (operands[0], E_V2DFmode)
                      || !register_operand (operands[1], E_V2DFmode)
                      || !scratch_operand (operands[2], E_V2DImode)
                      || !
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 357; /* *vec_cmpeqv2df_cconly */

                case E_V1TFmode:
                  if (!register_operand (operands[0], E_V1TFmode)
                      || !register_operand (operands[1], E_V1TFmode)
                      || !scratch_operand (operands[2], E_V1TImode)
                      || !(
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 358; /* *vec_cmpeqv1tf_cconly */

                case E_TFmode:
                  if (!register_operand (operands[0], E_TFmode)
                      || !register_operand (operands[1], E_TFmode)
                      || !scratch_operand (operands[2], E_V1TImode)
                      || !(
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 359; /* *vec_cmpeqtf_cconly */

                default:
                  return -1;
                }

            case E_CCVIHmode:
              switch (pattern232 (x3, 
E_CCVIHmode))
                {
                case 0:
                  if (!
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 336; /* *vec_cmphv16qi_cconly */

                case 1:
                  if (!
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 337; /* *vec_cmphv8hi_cconly */

                case 2:
                  if (!
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 338; /* *vec_cmphv4si_cconly */

                case 3:
                  if (!
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 339; /* *vec_cmphv2di_cconly */

                default:
                  return -1;
                }

            case E_CCVIHUmode:
              switch (pattern232 (x3, 
E_CCVIHUmode))
                {
                case 0:
                  if (!
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 340; /* *vec_cmphlv16qi_cconly */

                case 1:
                  if (!
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 341; /* *vec_cmphlv8hi_cconly */

                case 2:
                  if (!
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 342; /* *vec_cmphlv4si_cconly */

                case 3:
                  if (!
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 343; /* *vec_cmphlv2di_cconly */

                default:
                  return -1;
                }

            case E_CCVFHmode:
              switch (pattern233 (x3, 
E_CCVFHmode))
                {
                case 0:
                  if (!(
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 360; /* *vec_cmphv4sf_cconly */

                case 1:
                  if (!
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 361; /* *vec_cmphv2df_cconly */

                case 2:
                  if (!(
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 362; /* *vec_cmphv1tf_cconly */

                case 3:
                  if (!(
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 363; /* *vec_cmphtf_cconly */

                default:
                  return -1;
                }

            case E_CCVFHEmode:
              switch (pattern233 (x3, 
E_CCVFHEmode))
                {
                case 0:
                  if (!(
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 364; /* *vec_cmphev4sf_cconly */

                case 1:
                  if (!
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 365; /* *vec_cmphev2df_cconly */

                case 2:
                  if (!(
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 366; /* *vec_cmphev1tf_cconly */

                case 3:
                  if (!(
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 367; /* *vec_cmphetf_cconly */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case SET:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          x8 = XEXP (x5, 1);
          switch (GET_CODE (x8))
            {
            case EQ:
              if (pattern234 (x1, 
E_CCVEQmode) != 0)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern270 (x8, 
E_V16QImode) != 0
                      || !
#line 2036 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 344; /* *vec_cmpeqv16qi_cc */

                case E_V8HImode:
                  if (pattern270 (x8, 
E_V8HImode) != 0
                      || !
#line 2036 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 345; /* *vec_cmpeqv8hi_cc */

                case E_V4SImode:
                  if (pattern270 (x8, 
E_V4SImode) != 0
                      || !
#line 2036 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 346; /* *vec_cmpeqv4si_cc */

                case E_V2DImode:
                  if (pattern270 (x8, 
E_V2DImode) != 0
                      || !
#line 2036 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 347; /* *vec_cmpeqv2di_cc */

                case E_V4SFmode:
                  if (pattern271 (x8, 
E_V4SFmode, 
E_V4SImode) != 0
                      || !(
#line 2119 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 368; /* *vec_cmpeqv4sf_cc */

                case E_V2DFmode:
                  if (pattern271 (x8, 
E_V2DFmode, 
E_V2DImode) != 0
                      || !
#line 2119 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 369; /* *vec_cmpeqv2df_cc */

                case E_V1TFmode:
                  if (pattern271 (x8, 
E_V1TFmode, 
E_V1TImode) != 0
                      || !(
#line 2119 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 370; /* *vec_cmpeqv1tf_cc */

                case E_TFmode:
                  if (pattern271 (x8, 
E_TFmode, 
E_V1TImode) != 0
                      || !(
#line 2119 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 371; /* *vec_cmpeqtf_cc */

                default:
                  return -1;
                }

            case GT:
              x9 = XEXP (x8, 0);
              if (!rtx_equal_p (x9, operands[0]))
                return -1;
              x10 = XEXP (x8, 1);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              x7 = XEXP (x2, 0);
              switch (GET_MODE (x7))
                {
                case E_CCVIHmode:
                  if (GET_MODE (x3) != E_CCVIHmode)
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V16QImode:
                      if (pattern270 (x8, 
E_V16QImode) != 0
                          || !
#line 2046 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                        return -1;
                      return 348; /* *vec_cmphv16qi_cc */

                    case E_V8HImode:
                      if (pattern270 (x8, 
E_V8HImode) != 0
                          || !
#line 2046 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                        return -1;
                      return 349; /* *vec_cmphv8hi_cc */

                    case E_V4SImode:
                      if (pattern270 (x8, 
E_V4SImode) != 0
                          || !
#line 2046 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                        return -1;
                      return 350; /* *vec_cmphv4si_cc */

                    case E_V2DImode:
                      if (pattern270 (x8, 
E_V2DImode) != 0
                          || !
#line 2046 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                        return -1;
                      return 351; /* *vec_cmphv2di_cc */

                    default:
                      return -1;
                    }

                case E_CCVFHmode:
                  if (GET_MODE (x3) != E_CCVFHmode)
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4SFmode:
                      if (pattern271 (x8, 
E_V4SFmode, 
E_V4SImode) != 0
                          || !(
#line 2130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                        return -1;
                      return 372; /* *vec_cmphv4sf_cc */

                    case E_V2DFmode:
                      if (pattern271 (x8, 
E_V2DFmode, 
E_V2DImode) != 0
                          || !
#line 2130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                        return -1;
                      return 373; /* *vec_cmphv2df_cc */

                    case E_V1TFmode:
                      if (pattern271 (x8, 
E_V1TFmode, 
E_V1TImode) != 0
                          || !(
#line 2130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                        return -1;
                      return 374; /* *vec_cmphv1tf_cc */

                    case E_TFmode:
                      if (pattern271 (x8, 
E_TFmode, 
E_V1TImode) != 0
                          || !(
#line 2130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                        return -1;
                      return 375; /* *vec_cmphtf_cc */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case GTU:
              if (pattern234 (x1, 
E_CCVIHUmode) != 0)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern270 (x8, 
E_V16QImode) != 0
                      || !
#line 2056 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 352; /* *vec_cmphlv16qi_cc */

                case E_V8HImode:
                  if (pattern270 (x8, 
E_V8HImode) != 0
                      || !
#line 2056 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 353; /* *vec_cmphlv8hi_cc */

                case E_V4SImode:
                  if (pattern270 (x8, 
E_V4SImode) != 0
                      || !
#line 2056 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 354; /* *vec_cmphlv4si_cc */

                case E_V2DImode:
                  if (pattern270 (x8, 
E_V2DImode) != 0
                      || !
#line 2056 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 355; /* *vec_cmphlv2di_cc */

                default:
                  return -1;
                }

            case GE:
              if (pattern234 (x1, 
E_CCVFHEmode) != 0)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern271 (x8, 
E_V4SFmode, 
E_V4SImode) != 0
                      || !(
#line 2141 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 376; /* *vec_cmphev4sf_cc */

                case E_V2DFmode:
                  if (pattern271 (x8, 
E_V2DFmode, 
E_V2DImode) != 0
                      || !
#line 2141 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 377; /* *vec_cmphev2df_cc */

                case E_V1TFmode:
                  if (pattern271 (x8, 
E_V1TFmode, 
E_V1TImode) != 0
                      || !(
#line 2141 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 378; /* *vec_cmphev1tf_cc */

                case E_TFmode:
                  if (pattern271 (x8, 
E_TFmode, 
E_V1TImode) != 0
                      || !(
#line 2141 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 379; /* *vec_cmphetf_cc */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case USE:
          if (!memory_operand (operands[0], E_BLKmode)
              || !memory_operand (operands[1], E_BLKmode))
            return -1;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          if (!const_int_operand (operands[2], E_VOIDmode)
              || !
#line 1403 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode)
   && INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
            return -1;
          return 1464; /* *clc */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      x5 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x5))
        {
        case SET:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          x8 = XEXP (x5, 1);
          if (!rtx_equal_p (x8, operands[0]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!const0_operand (operands[1], E_DImode)
                  || !register_operand (operands[2], E_DImode))
                return -1;
              if (nonimmediate_operand (operands[0], E_DImode)
                  && (
#line 1001 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_EXTIMM) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 1429; /* *tstdi_extimm */
              if (!register_operand (operands[0], E_DImode)
                  || !
#line 1043 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_ZARCH && !TARGET_EXTIMM))
                return -1;
              return 1433; /* *tstdi */

            case E_SImode:
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || !const0_operand (operands[1], E_SImode)
                  || !register_operand (operands[2], E_SImode))
                return -1;
              if (
#line 1001 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_EXTIMM))
                return 1430; /* *tstsi_extimm */
              if (!
#line 1054 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && !TARGET_EXTIMM))
                return -1;
              return 1434; /* *tstsi */

            case E_HImode:
              if (!const0_operand (operands[1], E_HImode)
                  || !register_operand (operands[2], E_HImode))
                return -1;
              if (nonimmediate_operand (operands[0], E_HImode)
                  && 
#line 1104 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
                return 1439; /* *tsthiCCT */
              if (!s_operand (operands[0], E_HImode)
                  || !
#line 1146 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                return -1;
              return 1443; /* *tsthi */

            case E_QImode:
              if (!const0_operand (operands[1], E_QImode)
                  || !register_operand (operands[2], E_QImode))
                return -1;
              if (nonimmediate_operand (operands[0], E_QImode)
                  && 
#line 1104 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
                return 1440; /* *tstqiCCT */
              if (!s_operand (operands[0], E_QImode)
                  || !
#line 1146 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                return -1;
              return 1444; /* *tstqi */

            default:
              return -1;
            }

        case CLOBBER:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (nonimmediate_operand (operands[0], E_DImode)
                  && const0_operand (operands[1], E_DImode)
                  && scratch_operand (operands[2], E_DImode)
                  && (
#line 1030 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_EXTIMM) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 1431; /* *tstdi_cconly_extimm */
              break;

            case E_SImode:
              if (nonimmediate_operand (operands[0], E_SImode)
                  && const0_operand (operands[1], E_SImode)
                  && scratch_operand (operands[2], E_SImode))
                {
                  if (
#line 1030 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_EXTIMM))
                    return 1432; /* *tstsi_cconly_extimm */
                  if (
#line 1068 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                    return 1435; /* *tstsi_cconly */
                }
              break;

            case E_HImode:
              if (const0_operand (operands[1], E_HImode)
                  && scratch_operand (operands[2], E_HImode))
                {
                  if (nonimmediate_operand (operands[0], E_HImode)
                      && 
#line 1118 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
                    return 1441; /* *tsthiCCT_cconly */
                  if (s_operand (operands[0], E_HImode)
                      && 
#line 1159 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                    return 1445; /* *tsthi_cconly */
                }
              break;

            case E_QImode:
              if (s_operand (operands[0], E_QImode)
                  && const0_operand (operands[1], E_QImode)
                  && scratch_operand (operands[2], E_QImode)
                  && 
#line 1159 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                return 1446; /* *tstqi_cconly */
              break;

            default:
              break;
            }
          x7 = XEXP (x2, 0);
          if (GET_MODE (x7) != E_CCZmode
              || GET_MODE (x3) != E_CCZmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_TFmode:
              if (!register_operand (operands[0], E_TFmode)
                  || !const0_operand (operands[1], E_TFmode)
                  || !register_operand (operands[2], E_TFmode)
                  || !(
#line 1465 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 1465; /* *cmptf_ccz_0 */

            case E_FPRX2mode:
              if (!register_operand (operands[0], E_FPRX2mode)
                  || !const0_operand (operands[1], E_FPRX2mode)
                  || !register_operand (operands[2], E_FPRX2mode)
                  || !(
#line 1465 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 1466; /* *cmpfprx2_ccz_0 */

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || !const0_operand (operands[1], E_DFmode)
                  || !register_operand (operands[2], E_DFmode)
                  || !
#line 1465 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 1467; /* *cmpdf_ccz_0 */

            case E_SFmode:
              if (!register_operand (operands[0], E_SFmode)
                  || !const0_operand (operands[1], E_SFmode)
                  || !register_operand (operands[2], E_SFmode)
                  || !
#line 1465 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 1468; /* *cmpsf_ccz_0 */

            case E_TDmode:
              if (!register_operand (operands[0], E_TDmode)
                  || !const0_operand (operands[1], E_TDmode)
                  || !register_operand (operands[2], E_TDmode)
                  || !(
#line 1465 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 1469; /* *cmptd_ccz_0 */

            case E_DDmode:
              if (!register_operand (operands[0], E_DDmode)
                  || !const0_operand (operands[1], E_DDmode)
                  || !register_operand (operands[2], E_DDmode)
                  || !(
#line 1465 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 1470; /* *cmpdd_ccz_0 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_112 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_102 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_105 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_106 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 6:
          res = recog_107 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 5:
          res = recog_108 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 34:
          res = recog_109 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 18:
          if (pattern7 (x1, 
19, 
E_DFmode, 
18, 
17) == 0
              && pattern295 (x1, 
23, 
E_DFmode, 
22, 
21, 
20) == 0
              && pattern296 (x1, 
27, 
E_DFmode, 
26, 
25, 
24) == 0
              && pattern297 (x1, 
E_DFmode, 
31, 
30, 
29, 
28) == 0)
            {
              x2 = XVECEXP (x1, 0, 0);
              x3 = XEXP (x2, 1);
              x4 = XVECEXP (x3, 0, 0);
              operands[0] = x4;
              if (const_int_operand (operands[0], E_VOIDmode))
                {
                  x5 = XVECEXP (x1, 0, 1);
                  x6 = XEXP (x5, 0);
                  operands[1] = x6;
                  if (memory_operand (operands[1], E_BLKmode))
                    {
                      x7 = XEXP (x5, 1);
                      x8 = XVECEXP (x7, 0, 0);
                      if (rtx_equal_p (x8, operands[0])
                          && 
#line 12135 "../../gcc/config/s390/s390.md"
(TARGET_HTM && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
                        return 2305; /* tbegin_1 */
                    }
                }
            }
          break;

        default:
          break;
        }
      if (XVECLEN (x1, 0) >= 1)
        {
          operands[0] = x1;
          res = recog_110 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      switch (XVECLEN (x1, 0))
        {
        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          x7 = XEXP (x5, 1);
          if (GET_CODE (x7) != UNSPEC_VOLATILE)
            return -1;
          x9 = XEXP (x2, 0);
          operands[0] = x9;
          x3 = XEXP (x2, 1);
          operands[1] = x3;
          x6 = XEXP (x5, 0);
          if (!rtx_equal_p (x6, operands[1]))
            return -1;
          switch (XVECLEN (x7, 0))
            {
            case 3:
              if (XINT (x7, 1) != 9)
                return -1;
              x10 = XVECEXP (x1, 0, 2);
              if (pattern180 (x10) != 0)
                return -1;
              x11 = XVECEXP (x7, 0, 1);
              operands[2] = x11;
              x12 = XVECEXP (x7, 0, 2);
              operands[3] = x12;
              x8 = XVECEXP (x7, 0, 0);
              if (!rtx_equal_p (x8, operands[1]))
                return -1;
              x13 = XEXP (x10, 1);
              x14 = XEXP (x13, 0);
              if (!rtx_equal_p (x14, operands[1]))
                return -1;
              x15 = XEXP (x13, 1);
              if (!rtx_equal_p (x15, operands[2]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern276 (x7, 
E_DImode) != 0)
                    return -1;
                  if (
#line 11075 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && s390_match_ccmode (insn, CCZ1mode)))
                    return 2248; /* *atomic_compare_and_swapdi_1 */
                  if (!
#line 11093 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH
   && s390_match_ccmode (insn, CCZ1mode)))
                    return -1;
                  return 2249; /* *atomic_compare_and_swapdi_2 */

                case E_SImode:
                  if (pattern276 (x7, 
E_SImode) != 0
                      || !
#line 11114 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCZ1mode)))
                    return -1;
                  return 2250; /* *atomic_compare_and_swapsi_3 */

                default:
                  return -1;
                }

            case 1:
              if (XINT (x7, 1) != 10)
                return -1;
              x10 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x10) != CLOBBER)
                return -1;
              x16 = XEXP (x10, 0);
              if (GET_CODE (x16) != REG
                  || REGNO (x16) != 33
                  || GET_MODE (x16) != E_CCmode)
                return -1;
              x8 = XVECEXP (x7, 0, 0);
              switch (GET_CODE (x8))
                {
                case AND:
                  switch (pattern216 (x7))
                    {
                    case 0:
                      if (!(
#line 11154 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return -1;
                      return 2251; /* atomic_fetch_anddi_iaf */

                    case 1:
                      if (!
#line 11154 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                        return -1;
                      return 2255; /* atomic_fetch_andsi_iaf */

                    default:
                      return -1;
                    }

                case IOR:
                  switch (pattern216 (x7))
                    {
                    case 0:
                      if (!(
#line 11154 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return -1;
                      return 2252; /* atomic_fetch_ordi_iaf */

                    case 1:
                      if (!
#line 11154 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                        return -1;
                      return 2256; /* atomic_fetch_orsi_iaf */

                    default:
                      return -1;
                    }

                case XOR:
                  switch (pattern216 (x7))
                    {
                    case 0:
                      if (!(
#line 11154 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return -1;
                      return 2253; /* atomic_fetch_xordi_iaf */

                    case 1:
                      if (!
#line 11154 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                        return -1;
                      return 2257; /* atomic_fetch_xorsi_iaf */

                    default:
                      return -1;
                    }

                case PLUS:
                  switch (pattern216 (x7))
                    {
                    case 0:
                      if (!(
#line 11154 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return -1;
                      return 2254; /* atomic_fetch_adddi_iaf */

                    case 1:
                      if (!
#line 11154 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                        return -1;
                      return 2258; /* atomic_fetch_addsi_iaf */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return -1;
          if (pnum_clobbers != NULL)
            {
              res = recog_111 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x9 = XEXP (x2, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 15
              || GET_MODE (x9) != E_DImode)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != MEM
              || GET_MODE (x6) != E_BLKmode)
            return -1;
          x17 = XEXP (x6, 0);
          if (GET_CODE (x17) != SCRATCH)
            return -1;
          x3 = XEXP (x2, 1);
          operands[0] = x3;
          if (!register_operand (operands[0], E_DImode)
              || !
#line 11726 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 2285; /* stack_restore_from_fpr */

        default:
          return -1;
        }

    case TRAP_IF:
      x18 = XEXP (x1, 1);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x19 = XEXP (x1, 0);
      switch (GET_CODE (x19))
        {
        case CONST_INT:
          if (XWINT (x19, 0) != 1L)
            return -1;
          return 2181; /* trap */

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case LTGT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          operands[0] = x19;
          if (s390_comparison (operands[0], E_VOIDmode))
            {
              x20 = XEXP (x19, 1);
              if (x20 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  x21 = XEXP (x19, 0);
                  operands[1] = x21;
                  if (cc_reg_operand (operands[1], E_VOIDmode))
                    return 2182; /* condtrap */
                }
            }
          x21 = XEXP (x19, 0);
          operands[1] = x21;
          x20 = XEXP (x19, 1);
          operands[2] = x20;
          if (s390_signed_integer_comparison (operands[0], E_VOIDmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_DImode:
                  if (register_operand (operands[1], E_DImode)
                      && nonmemory_operand (operands[2], E_DImode)
                      && (
#line 9694 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2183; /* *cmp_and_trap_signed_intdi */
                  break;

                case E_SImode:
                  if (register_operand (operands[1], E_SImode)
                      && nonmemory_operand (operands[2], E_SImode)
                      && 
#line 9694 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                    return 2184; /* *cmp_and_trap_signed_intsi */
                  break;

                default:
                  break;
                }
            }
          if (!s390_unsigned_integer_comparison (operands[0], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!register_operand (operands[1], E_DImode)
                  || !general_operand (operands[2], E_DImode)
                  || !(
#line 9708 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2185; /* *cmp_and_trap_unsigned_intdi */

            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !general_operand (operands[2], E_SImode)
                  || !
#line 9708 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                return -1;
              return 2186; /* *cmp_and_trap_unsigned_intsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          switch (XINT (x1, 1))
            {
            case 0:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2216; /* blockage */

            case 11:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2260; /* nop_lr0 */

            case 12:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2261; /* nop_lr1 */

            case 13:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2262; /* nop_2_byte */

            case 14:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2263; /* nop_4_byte */

            case 15:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2264; /* nop_6_byte */

            case 6:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!consttable_operand (operands[0], E_VOIDmode))
                return -1;
              return 2265; /* *pool_entry */

            case 5:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!const_int_operand (operands[0], E_VOIDmode))
                return -1;
              return 2266; /* pool_align */

            case 4:
              x2 = XVECEXP (x1, 0, 0);
              if (GET_CODE (x2) != CONST_INT)
                return -1;
              switch (XWINT (x2, 0))
                {
                case 1L:
                  return 2267; /* pool_section_start */

                case 0L:
                  return 2268; /* pool_section_end */

                default:
                  return -1;
                }

            case 3:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!const_int_operand (operands[0], E_VOIDmode))
                return -1;
              return 2272; /* pool */

            case 20:
              x2 = XVECEXP (x1, 0, 0);
              switch (GET_CODE (x2))
                {
                case CONST_INT:
                case CONST_WIDE_INT:
                case CONST_POLY_INT:
                case CONST_FIXED:
                case CONST_DOUBLE:
                case CONST_VECTOR:
                case CONST:
                case REG:
                case SUBREG:
                case LABEL_REF:
                case SYMBOL_REF:
                case HIGH:
                  operands[0] = x2;
                  if (!nonmemory_operand (operands[0], E_SImode)
                      || !
#line 12204 "../../gcc/config/s390/s390.md"
(TARGET_HTM))
                    return -1;
                  return 2309; /* *tabort_1 */

                case PLUS:
                  if (GET_MODE (x2) != E_SImode)
                    return -1;
                  x9 = XEXP (x2, 0);
                  operands[0] = x9;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  x3 = XEXP (x2, 1);
                  operands[1] = x3;
                  if (!const_int_operand (operands[1], E_SImode)
                      || !
#line 12212 "../../gcc/config/s390/s390.md"
(TARGET_HTM && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[1]), 'J', "J")))
                    return -1;
                  return 2310; /* *tabort_1_plus */

                default:
                  return -1;
                }

            case 24:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!register_operand (operands[0], E_SImode)
                  || !
#line 12260 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2314; /* sfpc */

            case 27:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2321; /* osc_break */

            default:
              return -1;
            }

        case 3:
          if (XINT (x1, 1) != 23)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x10 = XVECEXP (x1, 0, 2);
          operands[2] = x10;
          if (!const_int_operand (operands[2], E_VOIDmode)
              || !
#line 12250 "../../gcc/config/s390/s390.md"
((TARGET_ZEC12 || TARGET_HTM) && INTVAL (operands[2]) < 16))
            return -1;
          return 2313; /* *ppa */

        default:
          return -1;
        }

    case CALL:
      x19 = XEXP (x1, 0);
      if (GET_CODE (x19) != MEM
          || GET_MODE (x19) != E_QImode)
        return -1;
      x18 = XEXP (x1, 1);
      if (!const_int_operand (x18, E_VOIDmode))
        return -1;
      x21 = XEXP (x19, 0);
      switch (GET_CODE (x21))
        {
        case REG:
          if (REGNO (x21) != 1)
            return -1;
          operands[0] = x18;
          if (!
#line 10468 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn)
   && GET_MODE (XEXP (XEXP (PATTERN (insn), 0), 0)) == Pmode))
            return -1;
          return 2217; /* *sibcall_br */

        case CONST:
        case SYMBOL_REF:
          operands[0] = x21;
          if (!bras_sym_operand (operands[0], E_VOIDmode))
            return -1;
          operands[1] = x18;
          if (
#line 10497 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn) && TARGET_SMALL_EXEC))
            return 2218; /* *sibcall_brc */
          if (!
#line 10505 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn)))
            return -1;
          return 2219; /* *sibcall_brcl */

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 2259; /* nop */

    case RETURN:
      if (!
#line 11524 "../../gcc/config/s390/s390.md"
(s390_can_use_return_insn ()))
        return -1;
      return 2273; /* return */

    case SIMPLE_RETURN:
      if (!
#line 11524 "../../gcc/config/s390/s390.md"
(s390_can_use_simple_return_insn ()))
        return -1;
      return 2274; /* simple_return */

    case PREFETCH:
      x19 = XEXP (x1, 0);
      operands[0] = x19;
      if (!address_operand (operands[0], E_VOIDmode))
        return -1;
      x18 = XEXP (x1, 1);
      operands[1] = x18;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      x22 = XEXP (x1, 2);
      operands[2] = x22;
      if (!const_int_operand (operands[2], E_SImode)
          || !
#line 11738 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
        return -1;
      return 2286; /* prefetch */

    default:
      return -1;
    }
}
