/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2DFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V2DFmode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V2DFmode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V2DFmode))
    return -1;
  return 0;
}

int
pattern13 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 1)
    return -1;
  return 0;
}

int
pattern16 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern17 (x3, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern17 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern17 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 3;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 4;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 5;

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || GET_MODE (x3) != E_V1TImode
          || !register_operand (operands[1], E_V1TImode))
        return -1;
      return 6;

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || GET_MODE (x3) != E_V1TFmode
          || !register_operand (operands[1], E_V1TFmode))
        return -1;
      return 7;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern50 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_TImode
      || !register_operand (operands[0], E_TImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_TImode))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], E_TImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!register_operand (operands[3], E_TImode))
    return -1;
  return 0;
}

int
pattern57 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  operands[2] = x4;
  switch (XWINT (x2, 0))
    {
    case 0L:
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          return pattern17 (x1, 
E_V16QImode); /* [-1, 0] */

        case E_V8HImode:
          if (pattern17 (x1, 
E_V8HImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern17 (x1, 
E_V4SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case 2L:
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern17 (x1, 
E_V16QImode) != 0)
            return -1;
          return 3;

        case E_V8HImode:
          if (pattern17 (x1, 
E_V8HImode) != 0)
            return -1;
          return 4;

        case E_V4SImode:
          if (pattern17 (x1, 
E_V4SImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern69 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_TDmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_TDmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TFmode:
          return 0;

        case E_FPRX2mode:
          return 1;

        case E_DFmode:
          return 2;

        case E_SFmode:
          return 3;

        default:
          return -1;
        }

    case E_DDmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DDmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TFmode:
          return 4;

        case E_FPRX2mode:
          return 5;

        case E_DFmode:
          return 6;

        case E_SFmode:
          return 7;

        default:
          return -1;
        }

    case E_SDmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SDmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TFmode:
          return 8;

        case E_FPRX2mode:
          return 9;

        case E_DFmode:
          return 10;

        case E_SFmode:
          return 11;

        default:
          return -1;
        }

    case E_TFmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_TFmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TDmode:
          return 12;

        case E_DDmode:
          return 13;

        case E_SDmode:
          return 14;

        default:
          return -1;
        }

    case E_FPRX2mode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_FPRX2mode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TDmode:
          return 15;

        case E_DDmode:
          return 16;

        case E_SDmode:
          return 17;

        default:
          return -1;
        }

    case E_DFmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DFmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TDmode:
          return 18;

        case E_DDmode:
          return 19;

        case E_SDmode:
          return 20;

        default:
          return -1;
        }

    case E_SFmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SFmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TDmode:
          return 21;

        case E_DDmode:
          return 22;

        case E_SDmode:
          return 23;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern104 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern109 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  return pattern62 (x1); /* [-1, 1] */
}

int
pattern116 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (maybe_ne (SUBREG_BYTE (x4), 4)
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != ZERO_EXTRACT
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 33
      || GET_MODE (x8) != E_CCmode
      || !nonimmediate_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x9 = XEXP (x5, 0);
  operands[1] = x9;
  if (!nonimmediate_operand (operands[1], E_DImode))
    return -1;
  x10 = XEXP (x5, 2);
  operands[2] = x10;
  if (!immediate_operand (operands[2], E_DImode))
    return -1;
  x11 = XEXP (x3, 1);
  operands[3] = x11;
  if (!nonimmediate_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern128 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern134 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !contiguous_bitmask_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern142 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern147 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  x7 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x7))
    {
    case SET:
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != i1)
        return -1;
      x9 = XEXP (x7, 0);
      operands[0] = x9;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XEXP (x8, 1);
      if (!rtx_equal_p (x11, operands[2]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_DImode:
          return pattern145 (x8, 
E_DImode); /* [-1, 0] */

        case E_SImode:
          if (pattern145 (x8, 
E_SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case CLOBBER:
      res = pattern146 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern157 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern64 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern64 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern162 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 1);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[2] = x7;
      x8 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x8))
        {
        case SET:
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != i1)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) != NOT)
            return -1;
          x11 = XEXP (x8, 0);
          operands[0] = x11;
          x12 = XEXP (x10, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          x13 = XEXP (x9, 1);
          if (!rtx_equal_p (x13, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              return pattern158 (x1, 
E_DImode); /* [-1, 0] */

            case E_SImode:
              if (pattern158 (x1, 
E_SImode) != 0)
                return -1;
              return 1;

            default:
              return -1;
            }

        case CLOBBER:
          x11 = XEXP (x8, 0);
          operands[0] = x11;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern159 (x5, 
E_DImode) != 0)
                return -1;
              return 2;

            case E_SImode:
              if (pattern159 (x5, 
E_SImode) != 0)
                return -1;
              return 3;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x14 = XEXP (x7, 0);
      operands[2] = x14;
      x8 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x8))
        {
        case SET:
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != i1)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) != NOT)
            return -1;
          x13 = XEXP (x9, 1);
          if (GET_CODE (x13) != NOT)
            return -1;
          x11 = XEXP (x8, 0);
          operands[0] = x11;
          x12 = XEXP (x10, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          x15 = XEXP (x13, 0);
          if (!rtx_equal_p (x15, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern160 (x1, 
E_DImode) != 0)
                return -1;
              return 4;

            case E_SImode:
              if (pattern160 (x1, 
E_SImode) != 0)
                return -1;
              return 5;

            default:
              return -1;
            }

        case CLOBBER:
          x11 = XEXP (x8, 0);
          operands[0] = x11;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern161 (x4, 
E_DImode) != 0)
                return -1;
              return 6;

            case E_SImode:
              if (pattern161 (x4, 
E_SImode) != 0)
                return -1;
              return 7;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern205 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern213 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern224 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != MINUS)
        return -1;
      return 0;

    case CLOBBER:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XVECEXP (x1, 0, 0);
      x6 = XEXP (x5, 1);
      x7 = XEXP (x6, 0);
      switch (GET_MODE (x7))
        {
        case E_DImode:
          if (!register_operand (operands[1], E_DImode)
              || !general_operand (operands[2], E_DImode)
              || !scratch_operand (operands[0], E_DImode))
            return -1;
          return 1;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode)
              || !general_operand (operands[2], E_SImode)
              || !scratch_operand (operands[0], E_SImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern242 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern248 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !contiguous_bitmask_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern260 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !const0_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern269 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[0] = x4;
  if (!bras_sym_operand (operands[0], E_VOIDmode))
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XVECEXP (x1, 0, 3);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  if (!const_int_operand (operands[4], E_VOIDmode))
    return -1;
  x12 = XEXP (x2, 0);
  switch (GET_MODE (x12))
    {
    case E_DImode:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x13 = XVECEXP (x3, 0, 1);
      if (GET_MODE (x13) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x13 = XVECEXP (x3, 0, 1);
      if (GET_MODE (x13) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern288 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !scratch_operand (operands[1], i1))
    return -1;
  return 0;
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[2] = x3;
  if (!memory_operand (operands[2], E_BLKmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 73; /* vstlv1qi */

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 74; /* vstlv2qi */

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 75; /* vstlv4qi */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 76; /* vstlv8qi */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 77; /* vstlv16qi */

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 78; /* vstlv1hi */

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 79; /* vstlv2hi */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 80; /* vstlv4hi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 81; /* vstlv8hi */

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 82; /* vstlv1si */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 83; /* vstlv2si */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 84; /* vstlv4si */

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 85; /* vstlv1di */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 86; /* vstlv2di */

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 87; /* vstlv1sf */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 88; /* vstlv2sf */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 89; /* vstlv4sf */

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 90; /* vstlv1df */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 91; /* vstlv2df */

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || GET_MODE (x2) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode)
          || !
#line 1242 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 784; /* one_cmplv1qi2 */

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x2) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode)
          || !
#line 1242 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 785; /* one_cmplv2qi2 */

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x2) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode)
          || !
#line 1242 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 786; /* one_cmplv4qi2 */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x2) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !
#line 1242 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 787; /* one_cmplv8qi2 */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x2) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !
#line 1242 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 788; /* one_cmplv16qi2 */

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x2) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode)
          || !
#line 1242 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 789; /* one_cmplv1hi2 */

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x2) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode)
          || !
#line 1242 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 790; /* one_cmplv2hi2 */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode)
          || !
#line 1242 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 791; /* one_cmplv4hi2 */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 1242 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 792; /* one_cmplv8hi2 */

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x2) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode)
          || !
#line 1242 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 793; /* one_cmplv1si2 */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x2) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !
#line 1242 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 794; /* one_cmplv2si2 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x2) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 1242 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 795; /* one_cmplv4si2 */

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x2) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode)
          || !
#line 1242 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 796; /* one_cmplv1di2 */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 1242 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 797; /* one_cmplv2di2 */

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x2) != E_V1SFmode
          || !register_operand (operands[1], E_V1SFmode)
          || !
#line 1242 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 798; /* one_cmplv1sf2 */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x2) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !
#line 1242 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 799; /* one_cmplv2sf2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 1242 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 800; /* one_cmplv4sf2 */

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || GET_MODE (x2) != E_V1DFmode
          || !register_operand (operands[1], E_V1DFmode)
          || !
#line 1242 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 801; /* one_cmplv1df2 */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 1242 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 802; /* one_cmplv2df2 */

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || GET_MODE (x2) != E_V1TFmode
          || !register_operand (operands[1], E_V1TFmode)
          || !
#line 1242 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 803; /* one_cmplv1tf2 */

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || GET_MODE (x2) != E_V1TImode
          || !register_operand (operands[1], E_V1TImode)
          || !
#line 1242 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 804; /* one_cmplv1ti2 */

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || GET_MODE (x2) != E_TImode
          || !register_operand (operands[1], E_TImode)
          || !
#line 1242 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 805; /* one_cmplti2 */

    case E_DImode:
      if (pattern32 (x2, pnum_clobbers, 
E_DImode) != 0
          || !(
#line 8429 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      *pnum_clobbers = 1;
      return 2055; /* *notdi */

    case E_SImode:
      if (pattern32 (x2, pnum_clobbers, 
E_SImode) != 0
          || !
#line 8429 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
        return -1;
      *pnum_clobbers = 1;
      return 2056; /* *notsi */

    default:
      return -1;
    }
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!general_operand (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 5907 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 1851; /* *adddi3_zero_cconly */

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          if (nonimmediate_operand (operands[1], E_DImode)
              && general_operand (operands[2], E_DImode))
            {
              x5 = XEXP (x2, 1);
              if (rtx_equal_p (x5, operands[1])
                  && (
#line 6033 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                {
                  *pnum_clobbers = 1;
                  return 1859; /* *adddi3_carry1_cconly */
                }
              if (rtx_equal_p (x5, operands[2])
                  && (
#line 6073 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                {
                  *pnum_clobbers = 1;
                  return 1863; /* *adddi3_carry2_cconly */
                }
            }
          break;

        case E_SImode:
          if (nonimmediate_operand (operands[1], E_SImode)
              && general_operand (operands[2], E_SImode))
            {
              x5 = XEXP (x2, 1);
              if (rtx_equal_p (x5, operands[1])
                  && 
#line 6033 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                {
                  *pnum_clobbers = 1;
                  return 1860; /* *addsi3_carry1_cconly */
                }
              if (rtx_equal_p (x5, operands[2])
                  && 
#line 6073 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                {
                  *pnum_clobbers = 1;
                  return 1864; /* *addsi3_carry2_cconly */
                }
            }
          break;

        case E_TFmode:
          if (nonimmediate_operand (operands[1], E_TFmode)
              && general_operand (operands[2], E_TFmode))
            {
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (const0_operand (operands[3], E_TFmode)
                  && (
#line 6294 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                {
                  *pnum_clobbers = 1;
                  return 1890; /* *addtf3_cconly */
                }
            }
          break;

        case E_FPRX2mode:
          if (nonimmediate_operand (operands[1], E_FPRX2mode)
              && general_operand (operands[2], E_FPRX2mode))
            {
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (const0_operand (operands[3], E_FPRX2mode)
                  && (
#line 6294 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                {
                  *pnum_clobbers = 1;
                  return 1891; /* *addfprx23_cconly */
                }
            }
          break;

        case E_DFmode:
          if (nonimmediate_operand (operands[1], E_DFmode)
              && general_operand (operands[2], E_DFmode))
            {
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (const0_operand (operands[3], E_DFmode)
                  && 
#line 6294 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                {
                  *pnum_clobbers = 1;
                  return 1892; /* *adddf3_cconly */
                }
            }
          break;

        case E_SFmode:
          if (nonimmediate_operand (operands[1], E_SFmode)
              && general_operand (operands[2], E_SFmode))
            {
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (const0_operand (operands[3], E_SFmode)
                  && 
#line 6294 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                {
                  *pnum_clobbers = 1;
                  return 1893; /* *addsf3_cconly */
                }
            }
          break;

        case E_TDmode:
          if (nonimmediate_operand (operands[1], E_TDmode)
              && general_operand (operands[2], E_TDmode))
            {
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (const0_operand (operands[3], E_TDmode)
                  && (
#line 6294 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                {
                  *pnum_clobbers = 1;
                  return 1894; /* *addtd3_cconly */
                }
            }
          break;

        case E_DDmode:
          if (nonimmediate_operand (operands[1], E_DDmode)
              && general_operand (operands[2], E_DDmode))
            {
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (const0_operand (operands[3], E_DDmode)
                  && (
#line 6294 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                {
                  *pnum_clobbers = 1;
                  return 1895; /* *adddd3_cconly */
                }
            }
          break;

        default:
          break;
        }
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (pattern154 (x3))
        {
        case 0:
          if (!(
#line 6113 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1867; /* *adddi3_cconly */

        case 1:
          if (!
#line 6113 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
            return -1;
          *pnum_clobbers = 1;
          return 1868; /* *addsi3_cconly */

        default:
          return -1;
        }

    case PLUS:
      x6 = XEXP (x4, 0);
      operands[3] = x6;
      x8 = XEXP (x4, 1);
      operands[1] = x8;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          if (pattern187 (x4, 
E_DImode) != 0)
            return -1;
          x5 = XEXP (x2, 1);
          if (rtx_equal_p (x5, operands[1])
              && (
#line 6809 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            {
              *pnum_clobbers = 1;
              return 1940; /* *adddi3_alc_carry1_cconly */
            }
          if (!rtx_equal_p (x5, operands[2])
              || !(
#line 6843 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1944; /* *adddi3_alc_carry2_cconly */

        case E_SImode:
          if (pattern187 (x4, 
E_SImode) != 0)
            return -1;
          x5 = XEXP (x2, 1);
          if (rtx_equal_p (x5, operands[1])
              && 
#line 6809 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
            {
              *pnum_clobbers = 1;
              return 1941; /* *addsi3_alc_carry1_cconly */
            }
          if (!rtx_equal_p (x5, operands[2])
              || !
#line 6843 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
            return -1;
          *pnum_clobbers = 1;
          return 1945; /* *addsi3_alc_carry2_cconly */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTRACT:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x8 = XEXP (x5, 2);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      if (
#line 4162 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (1, INTVAL (operands[2]), 64)))
        return 1590; /* *extract1bitdi_nocc */
      if (pnum_clobbers == NULL
          || !
#line 4162 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (1, INTVAL (operands[2]), 64)))
        return -1;
      *pnum_clobbers = 1;
      return 1591; /* *extract1bitdi_clobbercc */

    case REG:
    case SUBREG:
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x5;
      if (!register_operand (operands[1], E_CCZ1mode)
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      *pnum_clobbers = 1;
      return 1960; /* sne */

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  switch (GET_MODE (x2))
    {
    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !nonimmediate_operand (operands[3], E_DImode))
        return -1;
      if ((
#line 4281 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (DImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 64) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return 1610; /* *insvdi_nocc */
      if (pnum_clobbers == NULL
          || !(
#line 4281 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (DImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 64) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      *pnum_clobbers = 1;
      return 1611; /* *insvdi_clobbercc */

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !nonimmediate_operand (operands[3], E_SImode))
        return -1;
      if (
#line 4281 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (SImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 32))
        return 1612; /* *insvsi_nocc */
      if (pnum_clobbers == NULL
          || !
#line 4281 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (SImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 32))
        return -1;
      *pnum_clobbers = 1;
      return 1613; /* *insvsi_clobbercc */

    default:
      return -1;
    }
}

 int
recog_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  operands[1] = x3;
  if (const_int_operand (operands[1], E_VOIDmode))
    {
      res = recog_38 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x5 = XEXP (x1, 1);
  if (!const_int_operand (x5, E_DImode))
    return -1;
  switch (XWINT (x3, 0))
    {
    case 16L:
      x6 = XEXP (x2, 2);
      operands[1] = x6;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      operands[2] = x5;
      if (!
#line 4696 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && EXTRACT_ARGS_IN_RANGE (16, INTVAL (operands[1]), 64)
   && INTVAL (operands[1]) >= 0
   && INTVAL (operands[1]) < BITS_PER_WORD
   && INTVAL (operands[1]) % 16 == 0))
        return -1;
      return 1663; /* *insvdi_reg_imm */

    case 32L:
      x6 = XEXP (x2, 2);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      operands[1] = x5;
      switch (XWINT (x6, 0))
        {
        case 0L:
          if (!
#line 4720 "../../gcc/config/s390/s390.md"
(TARGET_EXTIMM))
            return -1;
          return 1664; /* *insv_h_di_reg_extimm */

        case 32L:
          if (!
#line 4731 "../../gcc/config/s390/s390.md"
(TARGET_EXTIMM))
            return -1;
          return 1665; /* *insv_l_di_reg_extimm */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (pattern64 (x3, 
E_V1QImode) != 0
          || !
#line 1111 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 576; /* addv1qi3 */

    case E_V2QImode:
      if (pattern64 (x3, 
E_V2QImode) != 0
          || !
#line 1111 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 577; /* addv2qi3 */

    case E_V4QImode:
      if (pattern64 (x3, 
E_V4QImode) != 0
          || !
#line 1111 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 578; /* addv4qi3 */

    case E_V8QImode:
      if (pattern64 (x3, 
E_V8QImode) != 0
          || !
#line 1111 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 579; /* addv8qi3 */

    case E_V16QImode:
      if (pattern64 (x3, 
E_V16QImode) != 0
          || !
#line 1111 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 580; /* addv16qi3 */

    case E_V1HImode:
      if (pattern64 (x3, 
E_V1HImode) != 0
          || !
#line 1111 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 581; /* addv1hi3 */

    case E_V2HImode:
      if (pattern64 (x3, 
E_V2HImode) != 0
          || !
#line 1111 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 582; /* addv2hi3 */

    case E_V4HImode:
      if (pattern64 (x3, 
E_V4HImode) != 0
          || !
#line 1111 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 583; /* addv4hi3 */

    case E_V8HImode:
      if (pattern64 (x3, 
E_V8HImode) != 0
          || !
#line 1111 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 584; /* addv8hi3 */

    case E_V1SImode:
      if (pattern64 (x3, 
E_V1SImode) != 0
          || !
#line 1111 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 585; /* addv1si3 */

    case E_V2SImode:
      if (pattern64 (x3, 
E_V2SImode) != 0
          || !
#line 1111 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 586; /* addv2si3 */

    case E_V4SImode:
      if (pattern64 (x3, 
E_V4SImode) != 0
          || !
#line 1111 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 587; /* addv4si3 */

    case E_V1DImode:
      if (pattern64 (x3, 
E_V1DImode) != 0
          || !
#line 1111 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 588; /* addv1di3 */

    case E_V2DImode:
      if (pattern64 (x3, 
E_V2DImode) != 0
          || !
#line 1111 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 589; /* addv2di3 */

    case E_V1TImode:
      if (pattern64 (x3, 
E_V1TImode) != 0
          || !
#line 1111 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 590; /* addv1ti3 */

    case E_TImode:
      if (GET_MODE (x3) != E_TImode
          || !nonimmediate_operand (operands[1], E_TImode)
          || !general_operand (operands[2], E_TImode))
        return -1;
      if (nonimmediate_operand (operands[0], E_TImode)
          && 
#line 1111 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 591; /* *addti3 */
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_TImode)
          || !
#line 5840 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 1848; /* *addti3 */

    case E_V4SFmode:
      if (pattern3 (x3, 
E_V4SFmode) != 0
          || !(
#line 1686 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1083; /* addv4sf3 */

    case E_V2DFmode:
      if (pattern3 (x3, 
E_V2DFmode) != 0
          || !
#line 1686 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1084; /* addv2df3 */

    case E_V1TFmode:
      if (pattern3 (x3, 
E_V1TFmode) != 0
          || !(
#line 1686 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1085; /* addv1tf3 */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode)
        return -1;
      if (register_operand (operands[1], E_TFmode)
          && register_operand (operands[2], E_TFmode)
          && (
#line 1686 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return 1086; /* addtf3_vr */
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[1], E_TFmode)
          || !general_operand (operands[2], E_TFmode)
          || !(
#line 6258 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      *pnum_clobbers = 1;
      return 1878; /* addtf3_fpr */

    case E_FPRX2mode:
      if (pnum_clobbers == NULL
          || pattern174 (x3, 
E_FPRX2mode) != 0
          || !(
#line 6258 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      *pnum_clobbers = 1;
      return 1879; /* addfprx23 */

    case E_DFmode:
      if (pnum_clobbers == NULL
          || pattern174 (x3, 
E_DFmode) != 0
          || !
#line 6258 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      *pnum_clobbers = 1;
      return 1880; /* adddf3 */

    case E_SFmode:
      if (pnum_clobbers == NULL
          || pattern174 (x3, 
E_SFmode) != 0
          || !
#line 6258 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      *pnum_clobbers = 1;
      return 1881; /* addsf3 */

    case E_TDmode:
      if (pnum_clobbers == NULL
          || pattern174 (x3, 
E_TDmode) != 0
          || !(
#line 6258 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      *pnum_clobbers = 1;
      return 1882; /* addtd3 */

    case E_DDmode:
      if (pnum_clobbers == NULL
          || pattern174 (x3, 
E_DDmode) != 0
          || !(
#line 6258 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      *pnum_clobbers = 1;
      return 1883; /* adddd3 */

    default:
      return -1;
    }
}

 int
recog_51 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case PARALLEL:
          switch (XVECLEN (x4, 0))
            {
            case 1:
              x5 = XEXP (x1, 0);
              if (GET_CODE (x5) == MEM)
                {
                  res = recog_16 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              operands[0] = x5;
              operands[1] = x3;
              x6 = XVECEXP (x4, 0, 0);
              operands[2] = x6;
              if (!nonmemory_operand (operands[2], E_SImode))
                return -1;
              switch (pattern153 (x2))
                {
                case 0:
                  if (!nonmemory_operand (operands[1], E_V1QImode)
                      || !
#line 543 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 473; /* *vec_extractv1qi */

                case 1:
                  if (!nonmemory_operand (operands[1], E_V2QImode)
                      || !
#line 543 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 474; /* *vec_extractv2qi */

                case 2:
                  if (!nonmemory_operand (operands[1], E_V4QImode)
                      || !
#line 543 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 475; /* *vec_extractv4qi */

                case 3:
                  if (!nonmemory_operand (operands[1], E_V8QImode)
                      || !
#line 543 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 476; /* *vec_extractv8qi */

                case 4:
                  if (!nonmemory_operand (operands[1], E_V16QImode)
                      || !
#line 543 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 477; /* *vec_extractv16qi */

                case 5:
                  if (!nonmemory_operand (operands[1], E_V1HImode)
                      || !
#line 543 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 478; /* *vec_extractv1hi */

                case 6:
                  if (!nonmemory_operand (operands[1], E_V2HImode)
                      || !
#line 543 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 479; /* *vec_extractv2hi */

                case 7:
                  if (!nonmemory_operand (operands[1], E_V4HImode)
                      || !
#line 543 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 480; /* *vec_extractv4hi */

                case 8:
                  if (!nonmemory_operand (operands[1], E_V8HImode)
                      || !
#line 543 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 481; /* *vec_extractv8hi */

                case 9:
                  if (!nonmemory_operand (operands[1], E_V1SImode)
                      || !
#line 543 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 482; /* *vec_extractv1si */

                case 10:
                  if (!nonmemory_operand (operands[1], E_V2SImode)
                      || !
#line 543 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 483; /* *vec_extractv2si */

                case 11:
                  if (!nonmemory_operand (operands[1], E_V4SImode)
                      || !
#line 543 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 484; /* *vec_extractv4si */

                case 12:
                  if (!nonmemory_operand (operands[1], E_V1DImode)
                      || !
#line 543 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 485; /* *vec_extractv1di */

                case 13:
                  if (!nonmemory_operand (operands[1], E_V2DImode)
                      || !
#line 543 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 486; /* *vec_extractv2di */

                case 14:
                  if (!nonmemory_operand (operands[1], E_V1SFmode)
                      || !
#line 543 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 487; /* *vec_extractv1sf */

                case 15:
                  if (!nonmemory_operand (operands[1], E_V2SFmode)
                      || !
#line 543 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 488; /* *vec_extractv2sf */

                case 16:
                  if (!nonmemory_operand (operands[1], E_V4SFmode)
                      || !
#line 543 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 489; /* *vec_extractv4sf */

                case 17:
                  if (!nonmemory_operand (operands[1], E_V1DFmode)
                      || !
#line 543 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 490; /* *vec_extractv1df */

                case 18:
                  if (!nonmemory_operand (operands[1], E_V2DFmode)
                      || !
#line 543 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 491; /* *vec_extractv2df */

                default:
                  return -1;
                }

            case 8:
              if (pattern60 (x4, pnum_clobbers, 
4, 
5, 
6, 
7) != 0)
                return -1;
              x7 = XVECEXP (x4, 0, 4);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
                return -1;
              x8 = XVECEXP (x4, 0, 5);
              if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
                return -1;
              x9 = XVECEXP (x4, 0, 6);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x10 = XVECEXP (x4, 0, 7);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x5 = XEXP (x1, 0);
              operands[0] = x5;
              if (!nonimmediate_operand (operands[0], E_V8HImode)
                  || GET_MODE (x2) != E_V8HImode)
                return -1;
              operands[1] = x3;
              if (!nonimmediate_operand (operands[1], E_V8HImode)
                  || !
#line 1021 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 2;
              return 571; /* eltswapv8hi */

            case 4:
              if (pattern60 (x4, pnum_clobbers, 
0, 
1, 
2, 
3) != 0)
                return -1;
              x5 = XEXP (x1, 0);
              operands[0] = x5;
              operands[1] = x3;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (!nonimmediate_operand (operands[0], E_V4SImode)
                      || GET_MODE (x2) != E_V4SImode
                      || !nonimmediate_operand (operands[1], E_V4SImode)
                      || !
#line 1060 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  *pnum_clobbers = 1;
                  return 572; /* eltswapv4si */

                case E_V4SFmode:
                  if (!nonimmediate_operand (operands[0], E_V4SFmode)
                      || GET_MODE (x2) != E_V4SFmode
                      || !nonimmediate_operand (operands[1], E_V4SFmode)
                      || !
#line 1060 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  *pnum_clobbers = 1;
                  return 573; /* eltswapv4sf */

                default:
                  return -1;
                }

            case 2:
              x6 = XVECEXP (x4, 0, 0);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x11 = XVECEXP (x4, 0, 1);
              if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x5 = XEXP (x1, 0);
              operands[0] = x5;
              operands[1] = x3;
              switch (GET_MODE (operands[0]))
                {
                case E_V2DImode:
                  if (!nonimmediate_operand (operands[0], E_V2DImode)
                      || GET_MODE (x2) != E_V2DImode
                      || !nonimmediate_operand (operands[1], E_V2DImode)
                      || !
#line 1090 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 574; /* eltswapv2di */

                case E_V2DFmode:
                  if (!nonimmediate_operand (operands[0], E_V2DFmode)
                      || GET_MODE (x2) != E_V2DFmode
                      || !nonimmediate_operand (operands[1], E_V2DFmode)
                      || !
#line 1090 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 575; /* eltswapv2df */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x12 = XEXP (x4, 1);
          if (GET_CODE (x12) != PARALLEL
              || XVECLEN (x12, 0) != 1)
            return -1;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          operands[1] = x3;
          x13 = XEXP (x4, 0);
          operands[2] = x13;
          if (!nonmemory_operand (operands[2], E_SImode))
            return -1;
          x14 = XVECEXP (x12, 0, 0);
          operands[3] = x14;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          switch (pattern153 (x2))
            {
            case 0:
              if (!register_operand (operands[1], E_V1QImode)
                  || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 492; /* *vec_extractv1qi_plus */

            case 1:
              if (!register_operand (operands[1], E_V2QImode)
                  || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 493; /* *vec_extractv2qi_plus */

            case 2:
              if (!register_operand (operands[1], E_V4QImode)
                  || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 494; /* *vec_extractv4qi_plus */

            case 3:
              if (!register_operand (operands[1], E_V8QImode)
                  || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 495; /* *vec_extractv8qi_plus */

            case 4:
              if (!register_operand (operands[1], E_V16QImode)
                  || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 496; /* *vec_extractv16qi_plus */

            case 5:
              if (!register_operand (operands[1], E_V1HImode)
                  || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 497; /* *vec_extractv1hi_plus */

            case 6:
              if (!register_operand (operands[1], E_V2HImode)
                  || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 498; /* *vec_extractv2hi_plus */

            case 7:
              if (!register_operand (operands[1], E_V4HImode)
                  || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 499; /* *vec_extractv4hi_plus */

            case 8:
              if (!register_operand (operands[1], E_V8HImode)
                  || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 500; /* *vec_extractv8hi_plus */

            case 9:
              if (!register_operand (operands[1], E_V1SImode)
                  || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 501; /* *vec_extractv1si_plus */

            case 10:
              if (!register_operand (operands[1], E_V2SImode)
                  || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 502; /* *vec_extractv2si_plus */

            case 11:
              if (!register_operand (operands[1], E_V4SImode)
                  || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 503; /* *vec_extractv4si_plus */

            case 12:
              if (!register_operand (operands[1], E_V1DImode)
                  || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 504; /* *vec_extractv1di_plus */

            case 13:
              if (!register_operand (operands[1], E_V2DImode)
                  || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 505; /* *vec_extractv2di_plus */

            case 14:
              if (!register_operand (operands[1], E_V1SFmode)
                  || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 506; /* *vec_extractv1sf_plus */

            case 15:
              if (!register_operand (operands[1], E_V2SFmode)
                  || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 507; /* *vec_extractv2sf_plus */

            case 16:
              if (!register_operand (operands[1], E_V4SFmode)
                  || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 508; /* *vec_extractv4sf_plus */

            case 17:
              if (!register_operand (operands[1], E_V1DFmode)
                  || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 509; /* *vec_extractv1df_plus */

            case 18:
              if (!register_operand (operands[1], E_V2DFmode)
                  || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 510; /* *vec_extractv2df_plus */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case BSWAP:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != PARALLEL
          || XVECLEN (x4, 0) != 1)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x15 = XEXP (x3, 0);
      operands[1] = x15;
      x6 = XVECEXP (x4, 0, 0);
      operands[2] = x6;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern165 (x2, 
E_V8HImode, 
E_HImode) != 0
              || !
#line 2201 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode)))
            return -1;
          return 398; /* *vec_extract_bswap_vecv8hi */

        case E_SImode:
          if (pattern165 (x2, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 2201 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode)))
            return -1;
          return 399; /* *vec_extract_bswap_vecv4si */

        case E_SFmode:
          if (pattern165 (x2, 
E_V4SFmode, 
E_SFmode) != 0
              || !(
#line 2201 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 35 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 400; /* *vec_extract_bswap_vecv4sf */

        case E_DImode:
          if (pattern165 (x2, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 2201 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 401; /* *vec_extract_bswap_vecv2di */

        case E_DFmode:
          if (pattern165 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 2201 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 402; /* *vec_extract_bswap_vecv2df */

        default:
          return -1;
        }

    case VEC_CONCAT:
      return recog_17 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_67 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !(
#line 1749 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1099; /* sqrtv4sf2 */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 1749 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1100; /* sqrtv2df2 */

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || GET_MODE (x3) != E_V1TFmode
          || !register_operand (operands[1], E_V1TFmode)
          || !(
#line 1749 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1101; /* sqrtv1tf2 */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode)
        return -1;
      if (register_operand (operands[1], E_TFmode)
          && (
#line 1749 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return 1102; /* sqrttf2_vr */
      if (!general_operand (operands[1], E_TFmode)
          || !(
#line 9297 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      return 2153; /* sqrttf2_fpr */

    case E_FPRX2mode:
      if (!register_operand (operands[0], E_FPRX2mode)
          || GET_MODE (x3) != E_FPRX2mode
          || !general_operand (operands[1], E_FPRX2mode)
          || !(
#line 9297 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      return 2154; /* sqrtfprx22 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !general_operand (operands[1], E_DFmode)
          || !
#line 9297 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2155; /* sqrtdf2 */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !general_operand (operands[1], E_SFmode)
          || !
#line 9297 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2156; /* sqrtsf2 */

    default:
      return -1;
    }
}

 int
recog_72 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      switch (GET_CODE (x3))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
          res = recog_28 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (pnum_clobbers != NULL)
        {
          res = recog_29 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!s390_comparison (x3, E_VOIDmode))
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      operands[2] = x4;
      if (cc_reg_operand (operands[2], E_VOIDmode))
        {
          res = recog_30 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (REGNO (x4) != 33)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      operands[2] = x5;
      if (const_int_operand (operands[2], E_VOIDmode))
        {
          x6 = XEXP (x1, 0);
          if (GET_CODE (x6) == PC)
            {
              operands[1] = x3;
              x7 = XEXP (x2, 1);
              switch (GET_CODE (x7))
                {
                case LABEL_REF:
                  x8 = XEXP (x2, 2);
                  if (GET_CODE (x8) == PC)
                    {
                      x9 = XEXP (x7, 0);
                      operands[0] = x9;
                      return 2175; /* *cjump_64 */
                    }
                  break;

                case PC:
                  x8 = XEXP (x2, 2);
                  if (GET_CODE (x8) == LABEL_REF)
                    {
                      x10 = XEXP (x8, 0);
                      operands[0] = x10;
                      return 2179; /* *icjump_64 */
                    }
                  break;

                default:
                  break;
                }
            }
        }
      if (XWINT (x5, 0) != 0L)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_CODE (x6) != PC)
        return -1;
      x7 = XEXP (x2, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case PLUS:
        case MINUS:
        case MULT:
        case AND:
        case SIGN_EXTEND:
        case ZERO_EXTEND:
        case HIGH:
          operands[0] = x7;
          if (!address_operand (operands[0], E_VOIDmode))
            return -1;
          x8 = XEXP (x2, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          operands[1] = x3;
          if (!
#line 9548 "../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_JUMP))
            return -1;
          return 2176; /* *cjump_long */

        case RETURN:
          x8 = XEXP (x2, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          operands[0] = x3;
          if (!
#line 9571 "../../gcc/config/s390/s390.md"
(s390_can_use_return_insn ()))
            return -1;
          return 2177; /* *creturn */

        case SIMPLE_RETURN:
          x8 = XEXP (x2, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          operands[0] = x3;
          if (!
#line 9571 "../../gcc/config/s390/s390.md"
(s390_can_use_simple_return_insn ()))
            return -1;
          return 2178; /* *csimple_return */

        case PC:
          operands[1] = x3;
          x8 = XEXP (x2, 2);
          operands[0] = x8;
          if (!address_operand (operands[0], E_VOIDmode)
              || !
#line 9625 "../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_JUMP))
            return -1;
          return 2180; /* *icjump_long */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_86 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pattern38 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (pattern118 (x3, 
E_HImode) != 0)
        return -1;
      if (
#line 7921 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        return 2013; /* *andhi3_zarch */
      if (!
#line 7938 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        return -1;
      return 2014; /* *andhi3_esa */

    case E_QImode:
      if (pattern118 (x3, 
E_QImode) != 0)
        return -1;
      if (
#line 7966 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        return 2015; /* *andqi3_zarch */
      if (!
#line 7983 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        return -1;
      return 2016; /* *andqi3_esa */

    default:
      return -1;
    }
}

 int
recog_90 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pattern38 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (pattern212 (x3, 
E_TImode) != 0
              || !
#line 5840 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 1848; /* *addti3 */

        case E_DImode:
          if (pattern118 (x3, 
E_DImode) != 0)
            return -1;
          if (
#line 5931 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return 1853; /* *adddi3_31z */
          if (!
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 1855; /* *adddi3 */

        case E_SImode:
          if (pattern118 (x3, 
E_SImode) != 0)
            return -1;
          return 1856; /* *addsi3 */

        case E_TFmode:
          if (pattern212 (x3, 
E_TFmode) != 0
              || !(
#line 6258 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 1878; /* addtf3_fpr */

        case E_FPRX2mode:
          if (pattern212 (x3, 
E_FPRX2mode) != 0
              || !(
#line 6258 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 1879; /* addfprx23 */

        case E_DFmode:
          if (pattern212 (x3, 
E_DFmode) != 0
              || !
#line 6258 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 1880; /* adddf3 */

        case E_SFmode:
          if (pattern212 (x3, 
E_SFmode) != 0
              || !
#line 6258 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 1881; /* addsf3 */

        case E_TDmode:
          if (pattern212 (x3, 
E_TDmode) != 0
              || !(
#line 6258 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1882; /* addtd3 */

        case E_DDmode:
          if (pattern212 (x3, 
E_DDmode) != 0
              || !(
#line 6258 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1883; /* adddd3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          if (general_operand (operands[2], E_SImode)
              && 
#line 5880 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return 1849; /* *adddi3_sign */
          if (!memory_operand (operands[2], E_HImode)
              || !
#line 6166 "../../gcc/config/s390/s390.md"
(TARGET_Z14))
            return -1;
          return 1873; /* *adddi3_sign */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode
              || !memory_operand (operands[2], E_HImode)
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 1854; /* *addsi3_sign */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!general_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 5919 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 1852; /* *adddi3_zero */

    case PLUS:
      x6 = XEXP (x4, 0);
      operands[3] = x6;
      x7 = XEXP (x4, 1);
      operands[1] = x7;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern245 (x3, 
E_DImode) != 0
              || !
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 1948; /* *adddi3_alc */

        case E_SImode:
          if (pattern245 (x3, 
E_SImode) != 0)
            return -1;
          return 1949; /* *addsi3_alc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_97 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != USE)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  if (!permute_pattern_operand (x5, E_V16QImode))
    return -1;
  x6 = XEXP (x3, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case UNSPEC:
      switch (XVECLEN (x7, 0))
        {
        case 1:
          if (XINT (x7, 1) != 60)
            return -1;
          x8 = XVECEXP (x7, 0, 0);
          operands[1] = x8;
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern221 (x6, 
E_HImode, 
E_V8HImode) != 0
                  || !
#line 191 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 11; /* *vec_insert_and_zero_bswapv8hi */

            case E_V4SImode:
              if (pattern221 (x6, 
E_SImode, 
E_V4SImode) != 0
                  || !
#line 191 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 12; /* *vec_insert_and_zero_bswapv4si */

            case E_V4SFmode:
              if (pattern221 (x6, 
E_SFmode, 
E_V4SFmode) != 0
                  || !(
#line 191 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 35 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 13; /* *vec_insert_and_zero_bswapv4sf */

            case E_V2DImode:
              if (pattern221 (x6, 
E_DImode, 
E_V2DImode) != 0
                  || !
#line 191 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 14; /* *vec_insert_and_zero_bswapv2di */

            case E_V2DFmode:
              if (pattern221 (x6, 
E_DFmode, 
E_V2DFmode) != 0
                  || !
#line 191 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 15; /* *vec_insert_and_zero_bswapv2df */

            default:
              return -1;
            }

        case 3:
          if (XINT (x7, 1) != 90)
            return -1;
          x9 = XVECEXP (x7, 0, 2);
          if (GET_CODE (x9) != BSWAP)
            return -1;
          x8 = XVECEXP (x7, 0, 0);
          operands[1] = x8;
          x10 = XVECEXP (x7, 0, 1);
          operands[2] = x10;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x11 = XEXP (x9, 0);
          operands[3] = x11;
          operands[4] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern258 (x6, 
E_V8HImode, 
E_HImode) != 0
                  || !
#line 2189 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode)))
                return -1;
              return 393; /* *vec_set_bswap_vecv8hi */

            case E_V4SImode:
              if (pattern258 (x6, 
E_V4SImode, 
E_SImode) != 0
                  || !
#line 2189 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode)))
                return -1;
              return 394; /* *vec_set_bswap_vecv4si */

            case E_V4SFmode:
              if (pattern258 (x6, 
E_V4SFmode, 
E_SFmode) != 0
                  || !(
#line 2189 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 35 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 395; /* *vec_set_bswap_vecv4sf */

            case E_V2DImode:
              if (pattern258 (x6, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 2189 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode)))
                return -1;
              return 396; /* *vec_set_bswap_vecv2di */

            case E_V2DFmode:
              if (pattern258 (x6, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 2189 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode)))
                return -1;
              return 397; /* *vec_set_bswap_vecv2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x12 = XEXP (x7, 0);
      operands[1] = x12;
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern189 (x6, 
E_HImode, 
E_V8HImode) != 0
              || !
#line 617 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 525; /* *vec_splats_bswap_vecv8hi */

        case E_V4SImode:
          if (pattern189 (x6, 
E_SImode, 
E_V4SImode) != 0
              || !
#line 617 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 526; /* *vec_splats_bswap_vecv4si */

        case E_V4SFmode:
          if (pattern189 (x6, 
E_SFmode, 
E_V4SFmode) != 0
              || !(
#line 617 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 35 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 527; /* *vec_splats_bswap_vecv4sf */

        case E_V2DImode:
          if (pattern189 (x6, 
E_DImode, 
E_V2DImode) != 0
              || !
#line 617 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 528; /* *vec_splats_bswap_vecv2di */

        case E_V2DFmode:
          if (pattern189 (x6, 
E_DFmode, 
E_V2DFmode) != 0
              || !
#line 617 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 529; /* *vec_splats_bswap_vecv2df */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x7;
      operands[2] = x5;
      switch (pattern163 (x6))
        {
        case 0:
          if (!
#line 3189 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1409; /* *bswapv8hi */

        case 1:
          if (!
#line 3189 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1410; /* *bswapv4si */

        case 2:
          if (!
#line 3189 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1411; /* *bswapv4sf */

        case 3:
          if (!
#line 3189 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1412; /* *bswapv2di */

        case 4:
          if (!
#line 3189 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1413; /* *bswapv2df */

        case 5:
          if (!
#line 3189 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1414; /* *bswapv1ti */

        case 6:
          if (!
#line 3189 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1415; /* *bswapv1tf */

        case 7:
          if (!
#line 3189 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1416; /* *bswapti */

        case 8:
          if (!
#line 3189 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1417; /* *bswaptf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_104 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case VEC_SELECT:
      if (GET_MODE (x3) != E_V8HImode)
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != PARALLEL
          || XVECLEN (x4, 0) != 8)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x6 = XVECEXP (x4, 0, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x7 = XVECEXP (x4, 0, 2);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x8 = XVECEXP (x4, 0, 3);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x9 = XVECEXP (x4, 0, 4);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x10 = XVECEXP (x4, 0, 5);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x11 = XVECEXP (x4, 0, 6);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x12 = XVECEXP (x4, 0, 7);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != CLOBBER)
        return -1;
      x14 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x14) != CLOBBER
          || pattern264 (x1) != 0
          || !
#line 1021 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 571; /* eltswapv8hi */

    case UNSPEC:
      if (XVECLEN (x3, 0) != 4
          || XINT (x3, 1) != 31)
        return -1;
      x15 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x15) != MEM
          || GET_MODE (x15) != E_BLKmode)
        return -1;
      x16 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x16) != REG
          || REGNO (x16) != 0
          || GET_MODE (x16) != E_SImode)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != CLOBBER)
        return -1;
      x14 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x14) != CLOBBER)
        return -1;
      x17 = XEXP (x14, 0);
      if (GET_CODE (x17) != REG
          || REGNO (x17) != 33
          || GET_MODE (x17) != E_CCmode)
        return -1;
      x18 = XEXP (x2, 0);
      operands[0] = x18;
      x19 = XVECEXP (x3, 0, 0);
      operands[2] = x19;
      x20 = XEXP (x15, 0);
      operands[3] = x20;
      x21 = XVECEXP (x3, 0, 3);
      operands[4] = x21;
      if (!immediate_operand (operands[4], E_VOIDmode))
        return -1;
      x22 = XEXP (x13, 0);
      operands[1] = x22;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern288 (x3, 
E_DImode) != 0
              || !
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
            return -1;
          return 1540; /* *strlendi */

        case E_SImode:
          if (pattern288 (x3, 
E_SImode) != 0
              || !
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
            return -1;
          return 1541; /* *strlensi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      x18 = XEXP (x2, 0);
      switch (GET_CODE (x18))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x18;
          operands[1] = x3;
          x13 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x13))
            {
            case USE:
              if (pnum_clobbers == NULL)
                return -1;
              x14 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x14) != USE
                  || !memory_operand (operands[0], E_BLKmode)
                  || !memory_operand (operands[1], E_BLKmode))
                return -1;
              x22 = XEXP (x13, 0);
              operands[2] = x22;
              if (!nonmemory_operand (operands[2], E_VOIDmode))
                return -1;
              x17 = XEXP (x14, 0);
              operands[3] = x17;
              if (!immediate_operand (operands[3], E_VOIDmode))
                return -1;
              if ((
#line 3392 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 1546; /* *cpymem_short */
                }
              if (!(
#line 3392 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1547; /* *cpymem_short */

            case SET:
              x23 = XEXP (x13, 1);
              if (pattern152 (x23, 
E_TImode, 
9, 
UNSPEC_VOLATILE, 
3) != 0)
                return -1;
              x14 = XVECEXP (x1, 0, 2);
              if (pattern180 (x14) != 0
                  || !register_operand (operands[0], E_TImode)
                  || !nonsym_memory_operand (operands[1], E_TImode))
                return -1;
              x24 = XVECEXP (x23, 0, 1);
              operands[2] = x24;
              if (!register_operand (operands[2], E_TImode))
                return -1;
              x25 = XVECEXP (x23, 0, 2);
              operands[3] = x25;
              if (!register_operand (operands[3], E_TImode))
                return -1;
              x26 = XVECEXP (x23, 0, 0);
              if (!rtx_equal_p (x26, operands[1]))
                return -1;
              x22 = XEXP (x13, 0);
              if (!rtx_equal_p (x22, operands[1]))
                return -1;
              x27 = XEXP (x14, 1);
              x28 = XEXP (x27, 0);
              if (!rtx_equal_p (x28, operands[1]))
                return -1;
              x29 = XEXP (x27, 1);
              if (!rtx_equal_p (x29, operands[2])
                  || !
#line 11075 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && s390_match_ccmode (insn, CCZ1mode)))
                return -1;
              return 2247; /* *atomic_compare_and_swapti_1 */

            default:
              return -1;
            }

        case PC:
          x13 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x13) != USE)
            return -1;
          x22 = XEXP (x13, 0);
          if (GET_CODE (x22) != LABEL_REF)
            return -1;
          x14 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x14) != CLOBBER)
            return -1;
          x17 = XEXP (x14, 0);
          if (GET_CODE (x17) != REG
              || REGNO (x17) != 1)
            return -1;
          operands[0] = x3;
          x30 = XEXP (x22, 0);
          operands[1] = x30;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x17) != E_DImode
                  || !(
#line 10314 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 2210; /* casesi_jump_via_thunkdi */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x17) != E_SImode
                  || !(
#line 10314 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 2211; /* casesi_jump_via_thunksi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x3, 0) != 0L)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != USE)
        return -1;
      x18 = XEXP (x2, 0);
      operands[0] = x18;
      if (!memory_operand (operands[0], E_BLKmode))
        return -1;
      x22 = XEXP (x13, 0);
      operands[1] = x22;
      x14 = XVECEXP (x1, 0, 2);
      switch (GET_CODE (x14))
        {
        case USE:
          if (pnum_clobbers == NULL
              || !nonmemory_operand (operands[1], E_VOIDmode))
            return -1;
          x17 = XEXP (x14, 0);
          operands[2] = x17;
          if (!immediate_operand (operands[2], E_VOIDmode))
            return -1;
          if ((
#line 3644 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[1]) == Pmode || GET_MODE (operands[1]) == VOIDmode)) && 
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 2;
              return 1560; /* *clrmem_short */
            }
          if (!(
#line 3644 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[1]) == Pmode || GET_MODE (operands[1]) == VOIDmode)) && 
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 2;
          return 1561; /* *clrmem_short */

        case CLOBBER:
          x17 = XEXP (x14, 0);
          if (GET_CODE (x17) != REG
              || REGNO (x17) != 33
              || GET_MODE (x17) != E_CCmode
              || !const_int_operand (operands[1], E_VOIDmode)
              || !
#line 8773 "../../gcc/config/s390/s390.md"
(INTVAL (operands[1]) >= 1 && INTVAL (operands[1]) <= 256))
            return -1;
          return 2067; /* *xc_zero */

        default:
          return -1;
        }

    case COMPARE:
      if (pnum_clobbers == NULL
          || pattern73 (x1) != 0)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      x22 = XEXP (x13, 0);
      operands[2] = x22;
      if (!nonmemory_operand (operands[2], E_VOIDmode))
        return -1;
      x14 = XVECEXP (x1, 0, 2);
      x17 = XEXP (x14, 0);
      operands[3] = x17;
      if (!immediate_operand (operands[3], E_VOIDmode))
        return -1;
      if ((
#line 3838 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        {
          *pnum_clobbers = 1;
          return 1568; /* *cmpmem_short */
        }
      if (!(
#line 3838 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1569; /* *cmpmem_short */

    case UNSIGNED_FIX:
      if (pattern42 (x1) != 0)
        return -1;
      switch (pattern150 (x1))
        {
        case 0:
          if (
#line 5289 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
            return 1696; /* *fixuns_truncdfdi2_z13 */
          if (!(
#line 5304 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DFmode != DFmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1702; /* *fixuns_truncdfdi2_z196 */

        case 1:
          if (!(
#line 5304 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TFmode != DFmode)) && (((
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 1698; /* *fixuns_trunctfdi2_z196 */

        case 2:
          if (!(
#line 5304 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || FPRX2mode != DFmode)) && (((
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 1700; /* *fixuns_truncfprx2di2_z196 */

        case 3:
          if (!(
#line 5304 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || SFmode != DFmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1704; /* *fixuns_truncsfdi2_z196 */

        case 4:
          if (!(
#line 5304 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TDmode != DFmode)) && (((
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 1706; /* *fixuns_trunctddi2_z196 */

        case 5:
          if (!(
#line 5304 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DDmode != DFmode)) && (((
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 1708; /* *fixuns_truncdddi2_z196 */

        case 6:
          if (!(
#line 5289 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT) && 
#line 674 "../../gcc/config/s390/s390.md"
(TARGET_VXE2)))
            return -1;
          return 1697; /* *fixuns_truncsfsi2_z13 */

        case 7:
          if (!
#line 5304 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || SFmode != DFmode)))
            return -1;
          return 1705; /* *fixuns_truncsfsi2_z196 */

        case 8:
          if (!(
#line 5304 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TFmode != DFmode)) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 1699; /* *fixuns_trunctfsi2_z196 */

        case 9:
          if (!(
#line 5304 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || FPRX2mode != DFmode)) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 1701; /* *fixuns_truncfprx2si2_z196 */

        case 10:
          if (!
#line 5304 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DFmode != DFmode)))
            return -1;
          return 1703; /* *fixuns_truncdfsi2_z196 */

        case 11:
          if (!(
#line 5304 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TDmode != DFmode)) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1707; /* *fixuns_trunctdsi2_z196 */

        case 12:
          if (!(
#line 5304 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DDmode != DFmode)) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1709; /* *fixuns_truncddsi2_z196 */

        default:
          return -1;
        }

    case FIX:
      if (pattern42 (x1) != 0)
        return -1;
      switch (pattern151 (x1))
        {
        case 0:
          if (
#line 5327 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
            return 1710; /* *fix_truncdfdi2_bfp_z13 */
          if (!(
#line 5340 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DFmode != DFmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1716; /* *fix_truncdfdi2_bfp */

        case 1:
          if (!(
#line 5340 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TFmode != DFmode)) && (((
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 1712; /* *fix_trunctfdi2_bfp */

        case 2:
          if (!(
#line 5340 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || FPRX2mode != DFmode)) && (((
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 1714; /* *fix_truncfprx2di2_bfp */

        case 3:
          if (!(
#line 5340 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || SFmode != DFmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1718; /* *fix_truncsfdi2_bfp */

        case 4:
          if (!
#line 5374 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_DFP))
            return -1;
          return 1720; /* fix_trunctddi2_dfp */

        case 5:
          if (!
#line 5374 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_DFP))
            return -1;
          return 1721; /* fix_truncdddi2_dfp */

        case 6:
          if ((
#line 5327 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT) && 
#line 674 "../../gcc/config/s390/s390.md"
(TARGET_VXE2)))
            return 1711; /* *fix_truncsfsi2_bfp_z13 */
          if (!
#line 5340 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || SFmode != DFmode)))
            return -1;
          return 1719; /* *fix_truncsfsi2_bfp */

        case 7:
          if (!(
#line 5340 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TFmode != DFmode)) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 1713; /* *fix_trunctfsi2_bfp */

        case 8:
          if (!(
#line 5340 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || FPRX2mode != DFmode)) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 1715; /* *fix_truncfprx2si2_bfp */

        case 9:
          if (!
#line 5340 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DFmode != DFmode)))
            return -1;
          return 1717; /* *fix_truncdfsi2_bfp */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      if (GET_MODE (x3) != E_DDmode)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != UNSPEC
          || XVECLEN (x13, 0) != 1
          || XINT (x13, 1) != 0
          || GET_MODE (x13) != E_DImode)
        return -1;
      x14 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x14) != CLOBBER)
        return -1;
      x18 = XEXP (x2, 0);
      operands[0] = x18;
      if (!register_operand (operands[0], E_DDmode))
        return -1;
      x31 = XEXP (x3, 0);
      operands[1] = x31;
      if (!register_operand (operands[1], E_TDmode))
        return -1;
      x32 = XVECEXP (x13, 0, 0);
      operands[2] = x32;
      if (!const_mask_operand (operands[2], E_DImode))
        return -1;
      x17 = XEXP (x14, 0);
      operands[3] = x17;
      if (!scratch_operand (operands[3], E_TDmode)
          || !
#line 5510 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
        return -1;
      return 1751; /* *trunctddd2 */

    case AND:
      if (pattern43 (x1) != 0
          || !
#line 8033 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      return 2019; /* *nc */

    case IOR:
      if (pattern43 (x1) != 0
          || !
#line 8443 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      return 2057; /* *oc */

    case XOR:
      if (pattern43 (x1) != 0
          || !
#line 8716 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      return 2066; /* *xc */

    case IF_THEN_ELSE:
      x31 = XEXP (x3, 0);
      if (!s390_brx_operator (x31, E_VOIDmode))
        return -1;
      operands[6] = x31;
      x33 = XEXP (x31, 0);
      if (GET_CODE (x33) != PLUS)
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != LABEL_REF)
        return -1;
      x34 = XEXP (x3, 2);
      if (GET_CODE (x34) != PC)
        return -1;
      x18 = XEXP (x2, 0);
      if (GET_CODE (x18) != PC)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != SET)
        return -1;
      x23 = XEXP (x13, 1);
      if (GET_CODE (x23) != PLUS)
        return -1;
      x14 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x14) != CLOBBER)
        return -1;
      switch (pattern228 (x1))
        {
        case 0:
          if (!
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2189; /* *brx_stage1_di */

        case 1:
          return 2190; /* *brx_stage1_si */

        default:
          return -1;
        }

    case CALL:
      x31 = XEXP (x3, 0);
      if (GET_CODE (x31) != MEM
          || GET_MODE (x31) != E_QImode)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != CLOBBER)
        return -1;
      x18 = XEXP (x2, 0);
      operands[0] = x18;
      x33 = XEXP (x31, 0);
      operands[1] = x33;
      x4 = XEXP (x3, 1);
      operands[2] = x4;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x22 = XEXP (x13, 0);
      operands[3] = x22;
      if (!register_operand (operands[3], E_VOIDmode))
        return -1;
      switch (GET_CODE (operands[1]))
        {
        case REG:
        case SUBREG:
          res = recog_103 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case CONST:
        case SYMBOL_REF:
          if (bras_sym_operand (operands[1], E_VOIDmode))
            {
              x14 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x14) == USE)
                {
                  x17 = XEXP (x14, 0);
                  operands[4] = x17;
                  if (
#line 10842 "../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn)
   && TARGET_SMALL_EXEC
   && GET_MODE (operands[3]) == Pmode))
                    return 2239; /* *bras_tls */
                  if (
#line 10856 "../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn)

   && GET_MODE (operands[3]) == Pmode))
                    return 2240; /* *brasl_tls */
                }
            }
          break;

        default:
          break;
        }
      x14 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x14) != USE
          || !address_operand (operands[1], E_VOIDmode))
        return -1;
      x17 = XEXP (x14, 0);
      operands[4] = x17;
      if (!
#line 10871 "../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn) && GET_MODE (operands[3]) == Pmode))
        return -1;
      return 2241; /* *basr_tls */

    default:
      return -1;
    }
}
